Package: sccomp
Type: Package
Title: Differential Composition and Variability Analysis for
        Single-Cell Data
Version: 2.5.0
Date: 2024-01-15
Authors@R: c(person("Stefano", "Mangiola", email = "stefano.mangiola@unimelb.edu.au", role = c("aut", "cre")), person("Alexandra J.", "Roth-Schulze", role = "aut"), person("Marie", "Trussart", role = "aut"), person("Enrique", "Zozaya-Valdés", role = "aut"), person("Mengyao", "Ma", role = "aut"), person("Zijie", "Gao", role = "aut"), person("Alan F.", "Rubin", role = "aut"), person("Terence P.", "Speed", role = "aut"), person("Heejung", "Shim", role = "aut"), person("Anthony T.", "Papenfuss", role = "aut"))
Description: Comprehensive R package for differential composition and variability analysis in single-cell RNA sequencing, CyTOF, and microbiome data. Provides robust Bayesian modeling with outlier detection, random effects, and advanced statistical methods for cell type proportion analysis. Features include probabilistic outlier identification, mixed-effect modeling, differential variability testing, and comprehensive visualization tools. Perfect for cancer research, immunology, developmental biology, and single-cell genomics applications.
License: GPL-3
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
Depends: R (>= 4.3.0), instantiate (>= 0.2.3)
Imports: stats, boot, utils, scales, lifecycle, rlang, tidyselect,
        magrittr, crayon, cli, fansi, dplyr, tidyr, purrr, tibble,
        ggplot2, ggrepel, patchwork, forcats, readr, stringr, glue,
        SingleCellExperiment
Suggests: knitr, rmarkdown, BiocStyle, testthat (>= 3.0.0), markdown,
        loo, prettydoc, SeuratObject, tidyseurat,
        tidySingleCellExperiment, bayesplot, posterior
Additional_repositories: https://mc-stan.org/r-packages/
SystemRequirements: CmdStan
        (https://mc-stan.org/users/interfaces/cmdstan), C++14
biocViews: Bayesian, Regression, DifferentialExpression, SingleCell,
        Metagenomics, FlowCytometry, Spatial
LazyData: true
VignetteBuilder: knitr
URL: https://github.com/MangiolaLaboratory/sccomp
BugReports: https://github.com/MangiolaLaboratory/sccomp/issues
Config/testthat/edition: 3
Config/testthat/parallel: true
Config/testthat/snapshot/parallel: true
Config/testthat/snapshot/parallel/workers: 2
git_url: https://git.bioconductor.org/packages/sccomp
git_branch: devel
git_last_commit: 6711013
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:53:15 UTC; biocbuild
Author: Stefano Mangiola [aut, cre],
  Alexandra J. Roth-Schulze [aut],
  Marie Trussart [aut],
  Enrique Zozaya-Valdés [aut],
  Mengyao Ma [aut],
  Zijie Gao [aut],
  Alan F. Rubin [aut],
  Terence P. Speed [aut],
  Heejung Shim [aut],
  Anthony T. Papenfuss [aut]
Maintainer: Stefano Mangiola <stefano.mangiola@unimelb.edu.au>

sccomp: Differential Composition and Variability Analysis for
Single-Cell Data
================
Stefano Mangiola
2025-07-18

<!-- badges: start -->

[![Lifecycle:maturing](https://img.shields.io/badge/lifecycle-maturing-blue.svg)](https://www.tidyverse.org/lifecycle/#maturing)
[![R build
status](https://github.com/stemangiola/sccomp/workflows/R-CMD-check/badge.svg)](https://github.com/stemangiola/sccomp/actions/)
<!-- badges: end -->

# <img src="inst/logo-01.png" height="139px" width="120px"/>

**sccomp** is a powerful R package designed for comprehensive
differential composition and variability analysis in single-cell
genomics, proteomics, and microbiomics data.

## Why sccomp?

For cellular omic data, no method for differential variability analysis
exists, and methods for differential composition analysis only take a
few fundamental data properties into account. Here we introduce
**sccomp**, a generalised method for differential composition and
variability analyses capable of jointly modelling data count
distribution, compositionality, group-specific variability, and
proportion mean-variability association, while being robust to outliers.

<img src="inst/cartoon_methods.png" width="100%"/>

### Comprehensive Method Comparison

- **I**: Data are modelled as counts.
- **II**: Group proportions are modelled as compositional.
- **III**: The proportion variability is modelled as cell-type specific.
- **IV**: Information sharing across cell types, mean–variability
  association.
- **V**: Outlier detection or robustness.
- **VI**: Differential variability analysis.
- **VII** Mixed effect modelling
- **VIII** Removal unwanted effects

| Method | Year | Model | I | II | III | IV | V | VI | VII | VIII |
|----|----|----|----|----|----|----|----|----|----|----|
| **sccomp** | 2023 | Sum-constrained Beta-binomial | ● | ● | ● | ● | ● | ● | ● | ● |
| **scCODA** | 2021 | Dirichlet-multinomial | ● | ● |  |  |  |  |  |  |
| **quasi-binom.** | 2021 | Quasi-binomial | ● |  | ● |  |  |  |  |  |
| **rlm** | 2021 | Robust-log-linear |  | ● |  |  | ● |  |  |  |
| **propeller** | 2021 | Logit-linear + limma |  | ● | ● | ● |  |  |  |  |
| **ANCOM-BC** | 2020 | Log-linear |  | ● | ● |  |  |  |  |  |
| **corncob** | 2020 | Beta-binomial | ● |  | ● |  |  |  |  |  |
| **scDC** | 2019 | Log-linear |  | ● | ● |  |  |  |  |  |
| **dmbvs** | 2017 | Dirichlet-multinomial | ● | ● |  |  |  |  |  |  |
| **MixMC** | 2016 | Zero-inflated Log-linear |  | ● | ● |  |  |  |  |  |
| **ALDEx2** | 2014 | Dirichlet-multinomial | ● | ● |  |  |  |  |  |  |

### Scientific Citation

Mangiola, Stefano, Alexandra J. Roth-Schulze, Marie Trussart, Enrique
Zozaya-Valdés, Mengyao Ma, Zijie Gao, Alan F. Rubin, Terence P. Speed,
Heejung Shim, and Anthony T. Papenfuss. 2023. “Sccomp: Robust
Differential Composition and Variability Analysis for Single-Cell Data.”
Proceedings of the National Academy of Sciences of the United States of
America 120 (33): e2203828120. <https://doi.org/10.1073/pnas.2203828120>
[PNAS - sccomp: Robust differential composition and variability analysis
for single-cell
data](https://www.pnas.org/doi/full/10.1073/pnas.2203828120)

### Talk

<a href="https://www.youtube.com/watch?v=R_lt58We9nA&ab_channel=RConsortium" target="_blank">
<img src="https://img.youtube.com/vi/R_lt58We9nA/mqdefault.jpg" alt="Watch the video" width="280" height="180" border="10" />
</a>

# Installation Guide

`sccomp` is based on `cmdstanr` which provides the latest version of
`cmdstan` the Bayesian modelling tool. `cmdstanr` is not on CRAN, so we
need to have 3 simple step process (that will be prompted to the user is
forgot).

1.  R installation of `sccomp`
2.  R installation of `cmdstanr`
3.  `cmdstanr` call to `cmdstan` installation

**Bioconductor**

``` r
if (!requireNamespace("BiocManager")) install.packages("BiocManager")

# Step 1
BiocManager::install("sccomp")

# Step 2
install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

# Step 3
cmdstanr::check_cmdstan_toolchain(fix = TRUE) # Just checking system setting
cmdstanr::install_cmdstan()
```

**Github**

``` r
# Step 1
devtools::install_github("MangiolaLaboratory/sccomp")

# Step 2
install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

# Step 3
cmdstanr::check_cmdstan_toolchain(fix = TRUE) # Just checking system setting
cmdstanr::install_cmdstan()
```

## Core Functions

| Function | Description |
|----|----|
| `sccomp_estimate` | Fit the model onto the data, and estimate the coefficients |
| `sccomp_remove_outliers` | Identify outliers probabilistically based on the model fit, and exclude them from the estimation |
| `sccomp_test` | Calculate the probability that the coefficients are outside the H0 interval (i.e. test_composition_above_logit_fold_change) |
| `sccomp_replicate` | Simulate data from the model, or part of the model |
| `sccomp_predict` | Predicts proportions, based on the model, or part of the model |
| `sccomp_remove_unwanted_effects` | Removes the variability for unwanted factors |
| `plot` | Plots summary plots to assess significance |

# Analysis Tutorial

``` r
library(dplyr)
library(sccomp)
library(ggplot2)
library(forcats)
library(tidyr)
data("seurat_obj")
data("sce_obj")
data("counts_obj")
```

## Binary Factor Analysis

Of the output table, the estimate columns start with the prefix `c_`
indicate `composition`, or with `v_` indicate `variability` (when
formula_variability is set).

### From Seurat, SingleCellExperiment, metadata objects

``` r
sccomp_result = 
  sce_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample", 
    cell_group = "cell_group", 
    cores = 1,
    verbose = FALSE
  ) |> 
  sccomp_test()
```

### From counts

``` r
sccomp_result = 
  counts_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample",
    cell_group = "cell_group",
    abundance = "count", 
    cores = 1, verbose = FALSE
  ) |> 
  sccomp_test()
```

Here you see the results of the fit, the effects of the factor on
composition and variability. You also can see the uncertainty around
those effects.

The output is a tibble containing the **Following columns**

- `cell_group` - The cell groups being tested.
- `parameter` - The parameter being estimated from the design matrix
  described by the input `formula_composition` and
  `formula_variability`.
- `factor` - The covariate factor in the formula, if applicable (e.g.,
  not present for Intercept or contrasts).
- `c_lower` - Lower (2.5%) quantile of the posterior distribution for a
  composition (c) parameter.
- `c_effect` - Mean of the posterior distribution for a composition (c)
  parameter.
- `c_upper` - Upper (97.5%) quantile of the posterior distribution for a
  composition (c) parameter.
- `c_pH0` - Probability of the null hypothesis (no difference) for a
  composition (c). This is not a p-value.
- `c_FDR` - False-discovery rate of the null hypothesis for a
  composition (c).
- `v_lower` - Lower (2.5%) quantile of the posterior distribution for a
  variability (v) parameter.
- `v_effect` - Mean of the posterior distribution for a variability (v)
  parameter.
- `v_upper` - Upper (97.5%) quantile of the posterior distribution for a
  variability (v) parameter.
- `v_pH0` - Probability of the null hypothesis for a variability (v).
- `v_FDR` - False-discovery rate of the null hypothesis for a
  variability (v).
- `count_data` - Nested input count data.

``` r
sccomp_result
```

    ## sccomp model
    ## ============
    ## 
    ## Model specifications:
    ##   Family: multi_beta_binomial 
    ##   Composition formula: ~type 
    ##   Variability formula: ~1 
    ##   Inference method: pathfinder 
    ## 
    ## Data: Samples: 20   Cell groups: 36 
    ## 
    ## Column prefixes: c_ -> composition parameters  v_ -> variability parameters
    ## 
    ## Convergence diagnostics:
    ##   For each parameter, n_eff is the effective sample size and R_k_hat is the potential
    ##   scale reduction factor on split chains (at convergence, R_k_hat = 1).
    ## 
    ## # A tibble: 72 × 19
    ##    cell_group parameter  factor  c_lower c_effect c_upper   c_pH0   c_FDR c_rhat
    ##    <chr>      <chr>      <chr>     <dbl>    <dbl>   <dbl>   <dbl>   <dbl>  <dbl>
    ##  1 B1         (Intercep… <NA>    0.962      1.20   1.45   0       0        1.00 
    ##  2 B1         typecancer type   -0.924     -0.613 -0.308  1.00e-3 9.09e-5  1.00 
    ##  3 B2         (Intercep… <NA>    0.504      0.767  1.03   0       0        1.000
    ##  4 B2         typecancer type   -0.968     -0.671 -0.378  0       0        1.00 
    ##  5 B3         (Intercep… <NA>   -0.580     -0.327 -0.0643 4.22e-2 3.81e-3  1.00 
    ##  6 B3         typecancer type   -0.590     -0.281  0.0227 1.18e-1 2.38e-2  1.00 
    ##  7 BM         (Intercep… <NA>   -1.23      -0.971 -0.723  0       0        1.000
    ##  8 BM         typecancer type   -0.581     -0.286  0.0230 1.08e-1 1.56e-2  1.00 
    ##  9 CD4 1      (Intercep… <NA>    0.214      0.367  0.530  5.00e-4 2.00e-5  1.00 
    ## 10 CD4 1      typecancer type    0.00179    0.204  0.402  1.57e-1 2.91e-2  1.000
    ## # ℹ 62 more rows
    ## # ℹ 10 more variables: c_ess_bulk <dbl>, c_ess_tail <dbl>, v_lower <dbl>,
    ## #   v_effect <dbl>, v_upper <dbl>, v_pH0 <dbl>, v_FDR <dbl>, v_rhat <dbl>,
    ## #   v_ess_bulk <dbl>, v_ess_tail <dbl>

## Outlier Identification

`sccomp` can identify outliers probabilistically and exclude them from
the estimation.

``` r
sccomp_result = 
  counts_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample",
    cell_group = "cell_group",
    abundance = "count", 
    cores = 1, verbose = FALSE
  ) |> 
  
  # max_sampling_iterations is used her to not exceed the maximum file size for GitHub action of 100Mb
  sccomp_remove_outliers(cores = 1, verbose = FALSE, max_sampling_iterations = 2000) |> # Optional
  sccomp_test()
```

    ## Running standalone generated quantities after 1 MCMC chain, with 1 thread(s) per chain...
    ## 
    ## Chain 1 finished in 0.0 seconds.

    ## Running standalone generated quantities after 1 MCMC chain, with 1 thread(s) per chain...
    ## 
    ## Chain 1 finished in 0.0 seconds.

## Visualization and Summary Plots

A plot of group proportions, faceted by groups. The blue boxplots
represent the posterior predictive check. If the model is descriptively
adequate for the data, the blue boxplots should roughly overlay the
black boxplots, which represent the observed data. The outliers are
coloured in red. A boxplot will be returned for every (discrete)
covariate present in formula_composition. The colour coding represents
the significant associations for composition and/or variability.

``` r
sccomp_result |> 
  sccomp_boxplot(factor = "type")
```

    ## Running standalone generated quantities after 1 MCMC chain, with 1 thread(s) per chain...
    ## 
    ## Chain 1 finished in 0.0 seconds.

![](inst/figures/unnamed-chunk-8-1.png)<!-- -->

You can plot proportions adjusted for unwanted effects. This is helpful
especially for complex models, where multiple factors can significantly
impact the proportions.

``` r
sccomp_result |> 
  sccomp_boxplot(factor = "type", remove_unwanted_effects = TRUE)
```

    ## Running standalone generated quantities after 1 MCMC chain, with 1 thread(s) per chain...
    ## 
    ## Chain 1 finished in 0.0 seconds.

    ## Running standalone generated quantities after 1 MCMC chain, with 1 thread(s) per chain...
    ## 
    ## Chain 1 finished in 0.0 seconds.

    ## Running standalone generated quantities after 1 MCMC chain, with 1 thread(s) per chain...
    ## 
    ## Chain 1 finished in 0.0 seconds.

![](inst/figures/unnamed-chunk-9-1.png)<!-- -->

A plot of estimates of differential composition (c\_) on the x-axis and
differential variability (v\_) on the y-axis. The error bars represent
95% credible intervals. The dashed lines represent the minimal effect
that the hypothesis test is based on. An effect is labelled as
significant if it exceeds the minimal effect according to the 95%
credible interval. Facets represent the covariates in the model.

``` r
sccomp_result |> 
  plot_1D_intervals()
```

![](inst/figures/unnamed-chunk-10-1.png)<!-- -->

We can plot the relationship between abundance and variability. As we
can see below, they are positively correlated. sccomp models this
relationship to obtain a shrinkage effect on the estimates of both the
abundance and the variability. This shrinkage is adaptive as it is
modelled jointly, thanks to Bayesian inference.

``` r
sccomp_result |> 
  plot_2D_intervals()
```

![](inst/figures/unnamed-chunk-11-1.png)<!-- -->

You can produce the series of plots calling the `plot` method.

``` r
sccomp_result |> plot() 
```

## Model Proportions Directly (e.g. from deconvolution)

**Note:** If counts are available, we strongly discourage the use of
proportions, as an important source of uncertainty (i.e., for rare
groups/cell types) is not modeled.

The use of proportions is better suited for modelling deconvolution
results (e.g., of bulk RNA data), in which case counts are not
available.

Proportions should be greater than 0. Assuming that zeros derive from a
precision threshold (e.g., deconvolution), zeros are converted to the
smallest non-zero value.

``` r
sccomp_result = 
  counts_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample",
    cell_group = "cell_group",
    abundance = "proportion", 
    cores = 1, verbose = FALSE
  ) |> 
  sccomp_test()
```

## Continuous Factor Analysis

`sccomp` is able to fit arbitrary complex models. In this example we
have a continuous and binary covariate.

``` r
res =
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ type + continuous_covariate, 
      sample = "sample", 
      cell_group = "cell_group",
      cores = 1, verbose=FALSE
    )

res
```

    ## sccomp model
    ## ============
    ## 
    ## Model specifications:
    ##   Family: multi_beta_binomial 
    ##   Composition formula: ~type + continuous_covariate 
    ##   Variability formula: ~1 
    ##   Inference method: pathfinder 
    ## 
    ## Data: Samples: 20   Cell groups: 30 
    ## 
    ## Column prefixes: c_ -> composition parameters  v_ -> variability parameters
    ## 
    ## Convergence diagnostics:
    ##   For each parameter, n_eff is the effective sample size and R_k_hat is the potential
    ##   scale reduction factor on split chains (at convergence, R_k_hat = 1).
    ## 
    ## # A tibble: 90 × 15
    ##    cell_group        parameter factor c_lower c_effect c_upper c_rhat c_ess_bulk
    ##    <chr>             <chr>     <chr>    <dbl>    <dbl>   <dbl>  <dbl>      <dbl>
    ##  1 B immature        (Interce… <NA>     0.545   0.829    1.09   1.00       3485.
    ##  2 B immature        typeheal… type     1.03    1.34     1.68   1.00       3794.
    ##  3 B immature        continuo… conti…  -0.273   0.0520   0.370  1.00       3977.
    ##  4 B mem             (Interce… <NA>    -0.974  -0.673   -0.353  1.000      3953.
    ##  5 B mem             typeheal… type     1.23    1.58     1.94   1.000      3992.
    ##  6 B mem             continuo… conti…  -0.253   0.0691   0.408  1.000      4076.
    ##  7 CD4 cm S100A4     (Interce… <NA>     1.33    1.55     1.78   1.000      4277.
    ##  8 CD4 cm S100A4     typeheal… type     0.866   1.13     1.40   1.00       3885.
    ##  9 CD4 cm S100A4     continuo… conti…  -0.110   0.176    0.460  1.00       4275.
    ## 10 CD4 cm high cyto… (Interce… <NA>    -0.912  -0.585   -0.252  1.00       4033.
    ## # ℹ 80 more rows
    ## # ℹ 7 more variables: c_ess_tail <dbl>, v_lower <dbl>, v_effect <dbl>,
    ## #   v_upper <dbl>, v_rhat <dbl>, v_ess_bulk <dbl>, v_ess_tail <dbl>

## Random Effect Modeling (Mixed-Effect Modeling)

`sccomp` supports multilevel modeling by allowing the inclusion of
random effects in the compositional and variability formulas. This is
particularly useful when your data has hierarchical or grouped
structures, such as measurements nested within subjects, batches, or
experimental units. By incorporating random effects, sccomp can account
for variability at different levels of your data, improving model fit
and inference accuracy.

### Random Intercept Model

In this example, we demonstrate how to fit a random intercept model
using sccomp. We’ll model the cell-type proportions with both fixed
effects (e.g., treatment) and random effects (e.g., subject-specific
variability).

Here is the input data

``` r
seurat_obj[[]] |> as_tibble()
```

    ## # A tibble: 106,297 × 9
    ##    cell_group nCount_RNA nFeature_RNA group__ group__wrong sample type  group2__
    ##    <chr>           <dbl>        <int> <chr>   <chr>        <chr>  <chr> <chr>   
    ##  1 CD4 naive           0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ##  2 Mono clas…          0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ##  3 CD4 cm S1…          0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ##  4 B immature          0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ##  5 CD8 naive           0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ##  6 CD4 naive           0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ##  7 Mono clas…          0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ##  8 CD4 cm S1…          0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ##  9 CD4 cm hi…          0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ## 10 B immature          0            0 GROUP1  1            SI-GA… canc… GROUP21 
    ## # ℹ 106,287 more rows
    ## # ℹ 1 more variable: continuous_covariate <dbl>

``` r
res = 
  seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ type + (1 | group__), 
    sample = "sample",
    cell_group = "cell_group",
    bimodal_mean_variability_association = TRUE,
    cores = 1, verbose = FALSE
  ) 

res
```

    ## sccomp model
    ## ============
    ## 
    ## Model specifications:
    ##   Family: multi_beta_binomial 
    ##   Composition formula: ~type + (1 | group__) 
    ##   Variability formula: ~1 
    ##   Inference method: pathfinder 
    ## 
    ## Data: Samples: 20   Cell groups: 30 
    ## 
    ## Column prefixes: c_ -> composition parameters  v_ -> variability parameters
    ## 
    ## Convergence diagnostics:
    ##   For each parameter, n_eff is the effective sample size and R_k_hat is the potential
    ##   scale reduction factor on split chains (at convergence, R_k_hat = 1).
    ## 
    ## # A tibble: 180 × 15
    ##    cell_group parameter        factor c_lower c_effect c_upper c_rhat c_ess_bulk
    ##    <chr>      <chr>            <chr>    <dbl>    <dbl>   <dbl>  <dbl>      <dbl>
    ##  1 B immature (Intercept)      <NA>    0.504   0.849    1.22     1.00      173. 
    ##  2 B immature typehealthy      type    0.853   1.22     1.63     1.01      163. 
    ##  3 B immature (Intercept)___G… <NA>   -0.321   0.0192   0.414    1.00      174. 
    ##  4 B immature (Intercept)___G… <NA>   -0.127   0.207    0.638    1.05      136. 
    ##  5 B immature (Intercept)___G… <NA>   -0.0977  0.239    0.637    1.02       87.6
    ##  6 B immature (Intercept)___G… <NA>   -0.721  -0.274    0.0269   1.00      221. 
    ##  7 B mem      (Intercept)      <NA>   -0.849  -0.434   -0.0392   1.01      137. 
    ##  8 B mem      typehealthy      type    0.664   1.23     1.81     1.01       92.7
    ##  9 B mem      (Intercept)___G… <NA>   -0.495  -0.00476  0.537    1.00      108. 
    ## 10 B mem      (Intercept)___G… <NA>   -0.149   0.268    0.782    1.01      119. 
    ## # ℹ 170 more rows
    ## # ℹ 7 more variables: c_ess_tail <dbl>, v_lower <dbl>, v_effect <dbl>,
    ## #   v_upper <dbl>, v_rhat <dbl>, v_ess_bulk <dbl>, v_ess_tail <dbl>

### Random Effect Model (random slopes)

`sccomp` can model random slopes. We provide an example below.

``` r
res = 
  seurat_obj |>
  sccomp_estimate(
      formula_composition = ~ type + (type | group__),
      sample = "sample",
      cell_group = "cell_group",
      bimodal_mean_variability_association = TRUE,
      cores = 1, verbose = FALSE
    )

res
```

    ## sccomp model
    ## ============
    ## 
    ## Model specifications:
    ##   Family: multi_beta_binomial 
    ##   Composition formula: ~type + (type | group__) 
    ##   Variability formula: ~1 
    ##   Inference method: pathfinder 
    ## 
    ## Data: Samples: 20   Cell groups: 30 
    ## 
    ## Column prefixes: c_ -> composition parameters  v_ -> variability parameters
    ## 
    ## Convergence diagnostics:
    ##   For each parameter, n_eff is the effective sample size and R_k_hat is the potential
    ##   scale reduction factor on split chains (at convergence, R_k_hat = 1).
    ## 
    ## # A tibble: 240 × 15
    ##    cell_group parameter       factor c_lower c_effect  c_upper c_rhat c_ess_bulk
    ##    <chr>      <chr>           <chr>    <dbl>    <dbl>    <dbl>  <dbl>      <dbl>
    ##  1 B immature (Intercept)     <NA>    0.492    0.845   1.22      1.02       148.
    ##  2 B immature typehealthy     type    0.660    1.20    1.68      1.02       110.
    ##  3 B immature (Intercept)___… <NA>   -0.264    0.0485  0.376     1.00       171.
    ##  4 B immature typehealthy___… <NA>   -0.240    0.0265  0.323     1.00       133.
    ##  5 B immature (Intercept)___… <NA>   -0.211    0.155   0.499     1.01       135.
    ##  6 B immature typehealthy___… <NA>   -0.136    0.117   0.427     1.00       191.
    ##  7 B immature (Intercept)___… <NA>   -0.0360   0.214   0.608     1.00       162.
    ##  8 B immature (Intercept)___… <NA>   -0.661   -0.263   0.00149   1.01       127.
    ##  9 B mem      (Intercept)     <NA>   -0.894   -0.517  -0.128     1.00       136.
    ## 10 B mem      typehealthy     type    0.851    1.29    1.77      1.00       110.
    ## # ℹ 230 more rows
    ## # ℹ 7 more variables: c_ess_tail <dbl>, v_lower <dbl>, v_effect <dbl>,
    ## #   v_upper <dbl>, v_rhat <dbl>, v_ess_bulk <dbl>, v_ess_tail <dbl>

### Nested Random Effects

If you have a more complex hierarchy, such as measurements nested within
subjects and subjects nested within batches, you can include multiple
grouping variables. Here `group2__` is nested within `group__`.

``` r
res = 
  seurat_obj |>
  sccomp_estimate(
      formula_composition = ~ type + (type | group__) + (1 | group2__),
      sample = "sample",
      cell_group = "cell_group",
      bimodal_mean_variability_association = TRUE,
      cores = 1, verbose = FALSE
    )

res
```

    ## sccomp model
    ## ============
    ## 
    ## Model specifications:
    ##   Family: multi_beta_binomial 
    ##   Composition formula: ~type + (type | group__) + (1 | group2__) 
    ##   Variability formula: ~1 
    ##   Inference method: pathfinder 
    ## 
    ## Data: Samples: 20   Cell groups: 30 
    ## 
    ## Column prefixes: c_ -> composition parameters  v_ -> variability parameters
    ## 
    ## Convergence diagnostics:
    ##   For each parameter, n_eff is the effective sample size and R_k_hat is the potential
    ##   scale reduction factor on split chains (at convergence, R_k_hat = 1).
    ## 
    ## # A tibble: 300 × 15
    ##    cell_group parameter        factor c_lower c_effect c_upper c_rhat c_ess_bulk
    ##    <chr>      <chr>            <chr>    <dbl>    <dbl>   <dbl>  <dbl>      <dbl>
    ##  1 B immature (Intercept)      <NA>    0.426    0.836   1.28     1.03       80.3
    ##  2 B immature typehealthy      type    0.646    1.17    1.63     1.01       67.1
    ##  3 B immature (Intercept)___G… <NA>   -0.170    0.0594  0.547    1.08       90.4
    ##  4 B immature typehealthy___G… <NA>   -0.146    0.0401  0.389    1.01      157. 
    ##  5 B immature (Intercept)___G… <NA>   -0.286    0.0702  0.375    1.01      107. 
    ##  6 B immature typehealthy___G… <NA>   -0.198    0.0383  0.337    1.01      134. 
    ##  7 B immature (Intercept)___G… <NA>   -0.0961   0.156   0.580    1.01       58.2
    ##  8 B immature (Intercept)___G… <NA>   -0.827   -0.212   0.0411   1.05       39.2
    ##  9 B immature (Intercept)___G… <NA>   -0.437   -0.107   0.126    1.00      108. 
    ## 10 B immature (Intercept)___G… <NA>   -0.0928   0.238   0.604    1.01       72.0
    ## # ℹ 290 more rows
    ## # ℹ 7 more variables: c_ess_tail <dbl>, v_lower <dbl>, v_effect <dbl>,
    ## #   v_upper <dbl>, v_rhat <dbl>, v_ess_bulk <dbl>, v_ess_tail <dbl>

## Result Interpretation and Communication

The estimated effects are expressed in the unconstrained space of the
parameters, similar to differential expression analysis that expresses
changes in terms of log fold change. However, for differences in
proportion, logit fold change must be used, which is harder to interpret
and understand.

Therefore, we provide a more intuitive proportional fold change that can
be more easily understood. However, these cannot be used to infer
significance (use sccomp_test() instead), and a lot of care must be
taken given the nonlinearity of these measures (a 1-fold increase from
0.0001 to 0.0002 carries a different weight than a 1-fold increase from
0.4 to 0.8).

From your estimates, you can specify which effects you are interested in
(this can be a subset of the full model if you wish to exclude unwanted
effects), and the two points you would like to compare.

In the case of a categorical variable, the starting and ending points
are categories.

``` r
res |> 
   sccomp_proportional_fold_change(
     formula_composition = ~  type,
     from =  "healthy", 
     to = "cancer"
    ) |> 
  select(cell_group, statement)
```

    ## Running standalone generated quantities after 1 MCMC chain, with 1 thread(s) per chain...
    ## 
    ## Chain 1 finished in 0.0 seconds.

    ## # A tibble: 30 × 2
    ##    cell_group           statement                                
    ##    <chr>                <glue>                                   
    ##  1 B immature           1.9-fold decrease (from 0.1005 to 0.0528)
    ##  2 B mem                2.5-fold decrease (from 0.0346 to 0.0137)
    ##  3 CD4 cm high cytokine 7.8-fold increase (from 0.0016 to 0.0121)
    ##  4 CD4 cm ribosome      3.7-fold increase (from 0.0073 to 0.0271)
    ##  5 CD4 cm S100A4        1.6-fold decrease (from 0.1584 to 0.1)   
    ##  6 CD4 em high cytokine 5.1-fold increase (from 0.0021 to 0.0108)
    ##  7 CD4 naive            1.4-fold decrease (from 0.1092 to 0.0762)
    ##  8 CD4 ribosome         2.9-fold decrease (from 0.0839 to 0.029) 
    ##  9 CD8 em 1             1.2-fold increase (from 0.0479 to 0.0586)
    ## 10 CD8 em 2             3.6-fold increase (from 0.006 to 0.0213) 
    ## # ℹ 20 more rows

## Contrasts Analysis

``` r
seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ 0 + type, 
    sample = "sample",
    cell_group = "cell_group", 
    cores = 1, verbose = FALSE
  ) |> 
  sccomp_test( contrasts =  c("typecancer - typehealthy", "typehealthy - typecancer"))
```

    ## sccomp model
    ## ============
    ## 
    ## Model specifications:
    ##   Family: multi_beta_binomial 
    ##   Composition formula: ~0 + type 
    ##   Variability formula: ~1 
    ##   Inference method: pathfinder 
    ## 
    ## Data: Samples: 20   Cell groups: 30 
    ## 
    ## Column prefixes: c_ -> composition parameters  v_ -> variability parameters
    ## 
    ## Convergence diagnostics:
    ##   For each parameter, n_eff is the effective sample size and R_k_hat is the potential
    ##   scale reduction factor on split chains (at convergence, R_k_hat = 1).
    ## 
    ## # A tibble: 60 × 11
    ##    cell_group   parameter factor c_lower c_effect c_upper   c_pH0   c_FDR c_rhat
    ##    <chr>        <chr>     <chr>    <dbl>    <dbl>   <dbl>   <dbl>   <dbl>  <dbl>
    ##  1 B immature   typecanc… <NA>    -1.91    -1.36   -0.804 0       0           NA
    ##  2 B immature   typeheal… <NA>     0.804    1.36    1.91  0       0           NA
    ##  3 B mem        typecanc… <NA>    -2.24    -1.65   -1.06  0       0           NA
    ##  4 B mem        typeheal… <NA>     1.06     1.65    2.24  0       0           NA
    ##  5 CD4 cm S100… typecanc… <NA>    -1.50    -0.994  -0.521 5.00e-4 8.33e-5     NA
    ##  6 CD4 cm S100… typeheal… <NA>     0.521    0.994   1.50  5.00e-4 8.33e-5     NA
    ##  7 CD4 cm high… typecanc… <NA>     0.945    1.57    2.18  0       0           NA
    ##  8 CD4 cm high… typeheal… <NA>    -2.18    -1.57   -0.945 0       0           NA
    ##  9 CD4 cm ribo… typecanc… <NA>     0.352    0.943   1.56  3.50e-3 1.07e-3     NA
    ## 10 CD4 cm ribo… typeheal… <NA>    -1.56    -0.943  -0.352 3.50e-3 1.07e-3     NA
    ## # ℹ 50 more rows
    ## # ℹ 2 more variables: c_ess_bulk <dbl>, c_ess_tail <dbl>

## Categorical Factor Analysis (Bayesian ANOVA)

This is achieved through model comparison with `loo`. In the following
example, the model with association with factors better fits the data
compared to the baseline model with no factor association. For model
comparisons `sccomp_remove_outliers()` must not be executed as the
leave-one-out must work with the same amount of data, while outlier
elimination does not guarantee it.

If `elpd_diff` is away from zero of \> 5 `se_diff` difference of 5, we
are confident that a model is better than the other
[reference](https://discourse.mc-stan.org/t/interpreting-elpd-diff-loo-package/1628/2?u=stemangiola).
In this case, -79.9 / 11.5 = -6.9, therefore we can conclude that model
one, the one with factor association, is better than model two.

``` r
library(loo)

# Fit first model
model_with_factor_association = 
  seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample", 
    cell_group = "cell_group", 
    inference_method = "hmc",
    enable_loo = TRUE,
    verbose = FALSE
  )

# Fit second model
model_without_association = 
  seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ 1, 
    sample = "sample", 
    cell_group = "cell_group", 
    inference_method = "hmc",
    enable_loo = TRUE,
    verbose = FALSE
  )

# Compare models
loo_compare(
   attr(model_with_factor_association, "fit")$loo(),
   attr(model_without_association, "fit")$loo()
)
```

    ##        elpd_diff se_diff
    ## model1   0.0       0.0  
    ## model2 -82.8      10.5

## Differential Variability Analysis

We can model the cell-group variability also dependent on the type, and
so test differences in variability

``` r
res = 
  seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    formula_variability = ~ type,
    sample = "sample",
    cell_group = "cell_group",
    cores = 1, verbose = FALSE
  )

res
```

    ## sccomp model
    ## ============
    ## 
    ## Model specifications:
    ##   Family: multi_beta_binomial 
    ##   Composition formula: ~type 
    ##   Variability formula: ~type 
    ##   Inference method: pathfinder 
    ## 
    ## Data: Samples: 20   Cell groups: 30 
    ## 
    ## Column prefixes: c_ -> composition parameters  v_ -> variability parameters
    ## 
    ## Convergence diagnostics:
    ##   For each parameter, n_eff is the effective sample size and R_k_hat is the potential
    ##   scale reduction factor on split chains (at convergence, R_k_hat = 1).
    ## 
    ## # A tibble: 60 × 15
    ##    cell_group        parameter factor c_lower c_effect c_upper c_rhat c_ess_bulk
    ##    <chr>             <chr>     <chr>    <dbl>    <dbl>   <dbl>  <dbl>      <dbl>
    ##  1 B immature        (Interce… <NA>    0.509     0.819   1.14   1.00      2378. 
    ##  2 B immature        typeheal… type    1.02      1.38    1.72   1.00      1288. 
    ##  3 B mem             (Interce… <NA>   -1.06     -0.681  -0.286  1.00       285. 
    ##  4 B mem             typeheal… type    1.18      1.59    2.01   1.00       264. 
    ##  5 CD4 cm S100A4     (Interce… <NA>    1.44      1.71    1.98   1.00      1481. 
    ##  6 CD4 cm S100A4     typeheal… type    0.593     0.894   1.19   1.00       543. 
    ##  7 CD4 cm high cyto… (Interce… <NA>   -0.972    -0.595  -0.212  1.00      1304. 
    ##  8 CD4 cm high cyto… typeheal… type   -1.85     -1.20   -0.556  1.00        83.8
    ##  9 CD4 cm ribosome   (Interce… <NA>   -0.0723    0.310   0.681  1.00      2940. 
    ## 10 CD4 cm ribosome   typeheal… type   -1.33     -0.929  -0.513  1.000     1541. 
    ## # ℹ 50 more rows
    ## # ℹ 7 more variables: c_ess_tail <dbl>, v_lower <dbl>, v_effect <dbl>,
    ## #   v_upper <dbl>, v_rhat <dbl>, v_ess_bulk <dbl>, v_ess_tail <dbl>

**Plot 1D significance plot**

``` r
plots = res |> sccomp_test() |> plot()
```

    ## Running standalone generated quantities after 1 MCMC chain, with 1 thread(s) per chain...
    ## 
    ## Chain 1 finished in 0.0 seconds.

``` r
plots$credible_intervals_1D
```

![](inst/figures/unnamed-chunk-23-1.png)<!-- -->

**Plot 2D significance plot** Data points are cell groups. Error bars
are the 95% credible interval. The dashed lines represent the default
threshold fold change for which the probabilities (c_pH0, v_pH0) are
calculated. pH0 of 0 represent the rejection of the null hypothesis that
no effect is observed.

This plot is provided only if differential variability has been tested.
The differential variability estimates are reliable only if the linear
association between mean and variability for `(intercept)` (left-hand
side facet) is satisfied. A scatterplot (besides the Intercept) is
provided for each category of interest. For each category of interest,
the composition and variability effects should be generally
uncorrelated.

``` r
plots$credible_intervals_2D
```

![](inst/figures/unnamed-chunk-24-1.png)<!-- -->

# Recommended Settings for Different Data Types

## For Single-Cell RNA Sequencing

We recommend setting `bimodal_mean_variability_association  = TRUE`. The
bimodality of the mean-variability association can be confirmed from the
plots\$credible_intervals_2D (see below).

## For CyTOF and Microbiome Data

We recommend setting `bimodal_mean_variability_association  = FALSE`
(Default).

## MCMC Chain Visualization

It is possible to directly evaluate the posterior distribution. In this
example, we plot the Monte Carlo chain for the slope parameter of the
first cell type. We can see that it has converged and is negative with
probability 1.

``` r
library(cmdstanr)
library(posterior)
library(bayesplot)

# Assuming res contains the fit object from cmdstanr
fit <- res |> attr("fit")

# Extract draws for 'beta[2,1]'
draws <- as_draws_array(fit$draws("beta[2,1]"))

# Create a traceplot for 'beta[2,1]'
mcmc_trace(draws, pars = "beta[2,1]") + theme_bw()
```

![](inst/figures/unnamed-chunk-25-1.png)<!-- -->

``` r
sessionInfo()
```

    ## R version 4.5.0 (2025-04-11)
    ## Platform: x86_64-apple-darwin20
    ## Running under: macOS Sonoma 14.6.1
    ## 
    ## Matrix products: default
    ## BLAS:   /Library/Frameworks/R.framework/Versions/4.5-x86_64/Resources/lib/libRblas.0.dylib 
    ## LAPACK: /Library/Frameworks/R.framework/Versions/4.5-x86_64/Resources/lib/libRlapack.dylib;  LAPACK version 3.12.1
    ## 
    ## locale:
    ## [1] en_US.UTF-8/en_US.UTF-8/en_US.UTF-8/C/en_US.UTF-8/en_US.UTF-8
    ## 
    ## time zone: Australia/Adelaide
    ## tzcode source: internal
    ## 
    ## attached base packages:
    ## [1] stats     graphics  grDevices utils     datasets  methods   base     
    ## 
    ## other attached packages:
    ##  [1] bayesplot_1.12.0   posterior_1.6.1    cmdstanr_0.9.0     loo_2.8.0         
    ##  [5] tidyr_1.3.1        forcats_1.0.0      ggplot2_3.5.2.9001 sccomp_2.1.16     
    ##  [9] instantiate_0.2.3  dplyr_1.1.4       
    ## 
    ## loaded via a namespace (and not attached):
    ##  [1] tidyselect_1.2.1            farver_2.1.2               
    ##  [3] S7_0.2.0                    fastmap_1.2.0              
    ##  [5] SingleCellExperiment_1.30.1 tensorA_0.36.2.1           
    ##  [7] dotCall64_1.2               digest_0.6.37              
    ##  [9] lifecycle_1.0.4             SeuratObject_5.1.0         
    ## [11] processx_3.8.6              magrittr_2.0.3             
    ## [13] compiler_4.5.0              rlang_1.1.6                
    ## [15] tools_4.5.0                 utf8_1.2.6                 
    ## [17] yaml_2.3.10                 data.table_1.17.8          
    ## [19] knitr_1.50                  S4Arrays_1.8.1             
    ## [21] labeling_0.4.3              sp_2.2-0                   
    ## [23] DelayedArray_0.34.1         plyr_1.8.9                 
    ## [25] RColorBrewer_1.1-3          abind_1.4-8                
    ## [27] withr_3.0.2                 purrr_1.1.0                
    ## [29] BiocGenerics_0.54.0         grid_4.5.0                 
    ## [31] stats4_4.5.0                future_1.58.0              
    ## [33] progressr_0.15.1            globals_0.18.0             
    ## [35] scales_1.4.0                SummarizedExperiment_1.38.1
    ## [37] cli_3.6.5                   rmarkdown_2.29             
    ## [39] crayon_1.5.3                generics_0.1.4             
    ## [41] future.apply_1.20.0         reshape2_1.4.4             
    ## [43] httr_1.4.7                  tzdb_0.5.0                 
    ## [45] stringr_1.5.1               parallel_4.5.0             
    ## [47] XVector_0.48.0              matrixStats_1.5.0          
    ## [49] vctrs_0.6.5                 Matrix_1.7-3               
    ## [51] jsonlite_2.0.0              callr_3.7.6                
    ## [53] IRanges_2.42.0              hms_1.1.3                  
    ## [55] patchwork_1.3.1             S4Vectors_0.46.0           
    ## [57] ggrepel_0.9.6               listenv_0.9.1              
    ## [59] spam_2.11-1                 glue_1.8.0                 
    ## [61] parallelly_1.45.0           codetools_0.2-20           
    ## [63] ps_1.9.1                    distributional_0.5.0       
    ## [65] stringi_1.8.7               gtable_0.3.6               
    ## [67] GenomeInfoDb_1.44.0         GenomicRanges_1.60.0       
    ## [69] UCSC.utils_1.4.0            tibble_3.3.0               
    ## [71] pillar_1.11.0               htmltools_0.5.8.1          
    ## [73] GenomeInfoDbData_1.2.14     R6_2.6.1                   
    ## [75] evaluate_1.0.4              lattice_0.22-7             
    ## [77] Biobase_2.68.0              readr_2.1.5                
    ## [79] backports_1.5.0             Rcpp_1.1.0                 
    ## [81] SparseArray_1.8.0           checkmate_2.3.2            
    ## [83] xfun_0.52                   fs_1.6.6                   
    ## [85] MatrixGenerics_1.20.0       pkgconfig_2.0.3

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(
  fig.path = ifelse(knitr::pandoc_to() %in% c('html', 'html4'), 'inst/figures/', 'inst/figures/')
)

## ----eval=FALSE, message=FALSE------------------------------------------------
# if (!requireNamespace("BiocManager")) install.packages("BiocManager")
# 
# # Step 1
# BiocManager::install("sccomp")
# 
# # Step 2
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
# 
# # Step 3
# cmdstanr::check_cmdstan_toolchain(fix = TRUE) # Just checking system setting
# cmdstanr::install_cmdstan()

## ----eval=FALSE, message=FALSE------------------------------------------------
# 
# # Step 1
# devtools::install_github("MangiolaLaboratory/sccomp")
# 
# # Step 2
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
# 
# # Step 3
# cmdstanr::check_cmdstan_toolchain(fix = TRUE) # Just checking system setting
# cmdstanr::install_cmdstan()

## ----message=FALSE, warning=FALSE---------------------------------------------
library(dplyr)
library(sccomp)
library(ggplot2)
library(forcats)
library(tidyr)
data("seurat_obj")
data("sce_obj")
data("counts_obj")

## ----eval=FALSE, message=FALSE------------------------------------------------
# 
# sccomp_result =
#   sce_obj |>
#   sccomp_estimate(
#     formula_composition = ~ type,
#     sample = "sample",
#     cell_group = "cell_group",
#     cores = 1,
#     verbose = FALSE
#   ) |>
#   sccomp_test()
# 

## ----message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()----
# 
# sccomp_result =
#   counts_obj |>
#   sccomp_estimate(
#     formula_composition = ~ type,
#     sample = "sample",
#     cell_group = "cell_group",
#     abundance = "count",
#     cores = 1, verbose = FALSE
#   ) |>
#   sccomp_test()

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# sccomp_result

## ----message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()----
# 
# sccomp_result =
#   counts_obj |>
#   sccomp_estimate(
#     formula_composition = ~ type,
#     sample = "sample",
#     cell_group = "cell_group",
#     abundance = "count",
#     cores = 1, verbose = FALSE
#   ) |>
# 
#   # max_sampling_iterations is used her to not exceed the maximum file size for GitHub action of 100Mb
#   sccomp_remove_outliers(cores = 1, verbose = FALSE, max_sampling_iterations = 2000) |> # Optional
#   sccomp_test()

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# sccomp_result |>
#   sccomp_boxplot(factor = "type")

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# sccomp_result |>
#   sccomp_boxplot(factor = "type", remove_unwanted_effects = TRUE)

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# sccomp_result |>
#   plot_1D_intervals()

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# sccomp_result |>
#   plot_2D_intervals()

## ----out.height="200%", eval=FALSE, message=FALSE-----------------------------
# sccomp_result |> plot()

## ----message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()----
# 
# sccomp_result =
#   counts_obj |>
#   sccomp_estimate(
#     formula_composition = ~ type,
#     sample = "sample",
#     cell_group = "cell_group",
#     abundance = "proportion",
#     cores = 1, verbose = FALSE
#   ) |>
#   sccomp_test()

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# 
# res =
#     seurat_obj |>
#     sccomp_estimate(
#       formula_composition = ~ type + continuous_covariate,
#       sample = "sample",
#       cell_group = "cell_group",
#       cores = 1, verbose=FALSE
#     )
# 
# res

## ----message=FALSE------------------------------------------------------------
seurat_obj[[]] |> as_tibble()

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# res =
#   seurat_obj |>
#   sccomp_estimate(
#     formula_composition = ~ type + (1 | group__),
#     sample = "sample",
#     cell_group = "cell_group",
#     bimodal_mean_variability_association = TRUE,
#     cores = 1, verbose = FALSE
#   )
# 
# res

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# res =
#   seurat_obj |>
#   sccomp_estimate(
#       formula_composition = ~ type + (type | group__),
#       sample = "sample",
#       cell_group = "cell_group",
#       bimodal_mean_variability_association = TRUE,
#       cores = 1, verbose = FALSE
#     )
# 
# res

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# res =
#   seurat_obj |>
#   sccomp_estimate(
#       formula_composition = ~ type + (type | group__) + (1 | group2__),
#       sample = "sample",
#       cell_group = "cell_group",
#       bimodal_mean_variability_association = TRUE,
#       cores = 1, verbose = FALSE
#     )
# 
# res

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# res |>
#    sccomp_proportional_fold_change(
#      formula_composition = ~  type,
#      from =  "healthy",
#      to = "cancer"
#     ) |>
#   select(cell_group, statement)

## ----message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()----
# 
# seurat_obj |>
#   sccomp_estimate(
#     formula_composition = ~ 0 + type,
#     sample = "sample",
#     cell_group = "cell_group",
#     cores = 1, verbose = FALSE
#   ) |>
#   sccomp_test( contrasts =  c("typecancer - typehealthy", "typehealthy - typecancer"))
# 
# 

## ----message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()----
# library(loo)
# 
# # Fit first model
# model_with_factor_association =
#   seurat_obj |>
#   sccomp_estimate(
#     formula_composition = ~ type,
#     sample = "sample",
#     cell_group = "cell_group",
#     inference_method = "hmc",
#     enable_loo = TRUE,
#     verbose = FALSE
#   )
# 
# # Fit second model
# model_without_association =
#   seurat_obj |>
#   sccomp_estimate(
#     formula_composition = ~ 1,
#     sample = "sample",
#     cell_group = "cell_group",
#     inference_method = "hmc",
#     enable_loo = TRUE,
#     verbose = FALSE
#   )
# 
# # Compare models
# loo_compare(
#    attr(model_with_factor_association, "fit")$loo(),
#    attr(model_without_association, "fit")$loo()
# )
# 

## ----message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()----
# 
# res =
#   seurat_obj |>
#   sccomp_estimate(
#     formula_composition = ~ type,
#     formula_variability = ~ type,
#     sample = "sample",
#     cell_group = "cell_group",
#     cores = 1, verbose = FALSE
#   )
# 
# res
# 

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# plots = res |> sccomp_test() |> plot()
# 
# plots$credible_intervals_1D

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE-----------------
# plots$credible_intervals_2D

## ----eval = instantiate::stan_cmdstan_exists(), message=FALSE, warning=FALSE----
# 
# library(cmdstanr)
# library(posterior)
# library(bayesplot)
# 
# # Assuming res contains the fit object from cmdstanr
# fit <- res |> attr("fit")
# 
# # Extract draws for 'beta[2,1]'
# draws <- as_draws_array(fit$draws("beta[2,1]"))
# 
# # Create a traceplot for 'beta[2,1]'
# mcmc_trace(draws, pars = "beta[2,1]") + theme_bw()
# 

## ----message=FALSE------------------------------------------------------------
sessionInfo()

#' sccomp_boxplot
#'
#' @description
#' Creates a boxplot visualization of the model results from `sccomp`. This function plots the estimated cell proportions across samples, highlighting significant changes in cell composition according to a specified factor.
#'
#' @import ggplot2
#' @importFrom ggrepel geom_text_repel
#' @importFrom tidyr pivot_longer pivot_wider unite unnest
#' @importFrom dplyr select with_groups mutate left_join rename
#'
#' @param .data A tibble containing the results from `sccomp_estimate` and `sccomp_test`, including the columns: cell_group name, sample name, read counts, factor(s), p-values, and significance indicators.
#' @param factor A character string specifying the factor of interest included in the model for stratifying the boxplot.
#' @param significance_threshold A numeric value indicating the False Discovery Rate (FDR) threshold for labeling significant cell-groups. Defaults to 0.05.
#' @param test_composition_above_logit_fold_change A positive numeric value representing the effect size threshold used in the hypothesis test. A value of 0.2 corresponds to a change in cell proportion of approximately 10% for a cell type with a baseline proportion of 50% (e.g., from 45% to 55%). This threshold is consistent on the logit-unconstrained scale, even when the baseline proportion is close to 0 or 1.
#' @param remove_unwanted_effects A logical value indicating whether to remove unwanted variation from the data before plotting. Defaults to `FALSE`.
#'
#' @return A `ggplot` object representing the boxplot of cell proportions across samples, stratified by the specified factor.
#'
#' @export
#'
#' @examples
#' 
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#' if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'
#'     estimate <- sccomp_estimate(
#'       counts_obj,
#'       formula_composition = ~ type,
#'       formula_variability = ~ 1,
#'       sample = "sample",
#'       cell_group = "cell_group",
#'       abundance = "count",
#'       cores = 1
#'     ) |>
#'     sccomp_test()
#'
#'     # Plot the boxplot of estimated cell proportions
#'     sccomp_boxplot(
#'         .data = estimate,
#'         factor = "type",
#'         significance_threshold = 0.05
#'     )
#' }
#' }
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
sccomp_boxplot = function(
    .data, 
    factor, 
    significance_threshold = 0.05, 
    test_composition_above_logit_fold_change = .data |> attr("test_composition_above_logit_fold_change"),
    remove_unwanted_effects = FALSE
){
  
  
  .cell_group = attr(.data, ".cell_group")
  .count = attr(.data, ".count")
  .sample = attr(.data, ".sample")
  
  # Check if test have been done
  if(.data |> select(ends_with("FDR")) |> ncol() |> equals(0))
    stop("sccomp says: to produce plots, you need to run the function sccomp_test() on your estimates.")
  
  
  data_proportion =
    .data |>
    
    # Otherwise does not work
    select(-`factor`) |>
    
    pivot_wider(names_from = parameter, values_from = c(contains("c_"), contains("v_"))) |>
    left_join(
      attr(.data, "count_data") ,
      by = quo_name(.cell_group)
    ) |>
    with_groups(!!.sample, ~ mutate(.x, proportion = (!!.count)/sum(!!.count)) ) |> 
    mutate(is_zero = proportion==0) 
  
  if(remove_unwanted_effects){
    .data_adjusted = 
      .data |> 
      sccomp_remove_unwanted_effects(formula_composition_keep = as.formula("~ " |> paste(factor))) |> 
      rename(proportion = adjusted_proportion)
    
    data_proportion = 
      data_proportion |> 
      select(-proportion) |> 
      left_join(.data_adjusted, by = join_by(!!.cell_group, !!.sample))
  }
  else 
    message( "sccomp says: When visualising proportions, especially for complex models, consider setting `remove_unwanted_effects=TRUE`. This will adjust the proportions, preserving only the observed effect.")
  
  # If I don't have outliers add them
  if(!"outlier" %in% colnames(data_proportion)) data_proportion = data_proportion |> mutate(outlier = FALSE) 
  
  plot_boxplot(
    .data,
    data_proportion,
    factor,
    !!.cell_group,
    !!.sample,
    significance_threshold = significance_threshold,
    sccomp_theme(),
    remove_unwanted_effects = remove_unwanted_effects
  ) +
    ggtitle(sprintf("Grouped by %s (for multi-factor models, associations could be hardly observable with unidimensional data stratification)", factor))
  
  
}

#' Plot Boxplot of Cell-group Proportion
#'
#' This function creates a boxplot of cell-group proportions, optionally highlighting significant differences based on a given significance threshold.
#'
#' @param .data Data frame containing the main data.
#' @param data_proportion Data frame containing proportions of cell groups.
#' @param factor_of_interest Character string specifying the biological condition of interest.
#' @param .cell_group Character string specifying the cell group to be analyzed.
#' @param .sample Character string specifying the sample identifier.
#' @param significance_threshold Numeric value specifying the significance threshold for highlighting differences. Default is 0.05.
#' @param my_theme A ggplot2 theme object to be applied to the plot.
#' @param remove_unwanted_effects Logical value indicating whether to remove unwanted effects. Default is FALSE.
#' 
#' @importFrom scales trans_new
#' @importFrom stringr str_replace
#' @importFrom stats quantile
#'
#' @return A ggplot object representing the boxplot.
#' 
#' @examples
#' # Example usage:
#' # plot_boxplot(
#' #   .data, data_proportion, factor_of_interest = "condition",
#' #   .cell_group = "cell_group", .sample = "sample",
#' #   significance_threshold = 0.05, my_theme = theme_minimal(),
#' #   remove_unwanted_effects = FALSE
#' # )
#' 
#' @noRd
plot_boxplot = function(
    .data, data_proportion, factor_of_interest, .cell_group,
    .sample, 
    significance_threshold = 0.05, 
    my_theme, 
    remove_unwanted_effects = FALSE
){
  
  # Define the variables as NULL to avoid CRAN NOTES
  stats_name <- NULL
  parameter <- NULL
  stats_value <- NULL
  count_data <- NULL
  generated_proportions <- NULL
  proportion <- NULL
  name <- NULL
  outlier <- NULL
  
  # Function to calculate boxplot statistics
  calc_boxplot_stat <- function(x) {
    coef <- 1.5
    n <- sum(!is.na(x))
    
    # Calculate quantiles
    stats <- quantile(x, probs = c(0.0, 0.25, 0.5, 0.75, 1.0))
    names(stats) <- c("ymin", "lower", "middle", "upper", "ymax")
    iqr <- diff(stats[c(2, 4)])
    
    # Set whiskers
    outliers <- x < (stats[2] - coef * iqr) | x > (stats[4] + coef * iqr)
    if (any(outliers)) {
      stats[c(1, 5)] <- range(c(stats[2:4], x[!outliers]), na.rm = TRUE)
    }
    return(stats)
  }
  
  # Function to remove leading zero from labels
  dropLeadingZero <- function(l){  stringr::str_replace(l, '0(?=.)', '') }
  
  # Define square root transformation and its inverse
  S_sqrt <- function(x){sign(x)*sqrt(abs(x))}
  IS_sqrt <- function(x){x^2*sign(x)}
  S_sqrt_trans <- function() scales::trans_new("S_sqrt",S_sqrt,IS_sqrt)
  
  .cell_group = enquo(.cell_group)
  .sample = enquo(.sample)
  
  # Prepare significance colors
  significance_colors =
    .data %>%
    pivot_longer(
      c(contains("c_"), contains("v_")),
      names_pattern = "([cv])_([a-zA-Z0-9]+)",
      names_to = c("which", "stats_name"),
      values_to = "stats_value"
    ) %>%
    filter(stats_name == "FDR") %>%
    filter(parameter != "(Intercept)") %>%
    filter(stats_value < significance_threshold) %>%
    filter(`factor` == factor_of_interest) 
  
  if(nrow(significance_colors) > 0){
    
    if(.data |> attr("contrasts") |> is.null())
      significance_colors =
        significance_colors %>%
        unite("name", c(which, parameter), remove = FALSE) %>%
        distinct() %>%
        
        # Get clean parameter
        mutate(!!as.symbol(factor_of_interest) := str_replace(parameter, sprintf("^%s", `factor`), "")) %>%
        with_groups(c(!!.cell_group, !!as.symbol(factor_of_interest)), ~ .x %>% summarise(name = paste(name, collapse = ", ")))
    else
      significance_colors =
        significance_colors |>
        mutate(
          factor_values = attr(.data, "count_data") |>
            select(all_of(factor_of_interest)) |>
            distinct() |>
            pull(all_of(factor_of_interest))
        ) |>
        unnest(factor_values) |>
        
        # Filter relevant parameters
        mutate( !!as.symbol(factor_of_interest) := as.character(factor_values) ) |>
        filter(str_detect(parameter, !!as.symbol(factor_of_interest) )) |>
        
        # Rename
        select(!!.cell_group, !!as.symbol(factor_of_interest), name = parameter) |>
        
        # Merge contrasts
        with_groups(c(!!.cell_group, !!as.symbol(factor_of_interest)), ~ .x %>% summarise(name = paste(name, collapse = ", ")))
  }
  
  my_boxplot = ggplot()
  
  if("fit" %in% names(attributes(.data))){
    
    # Remove unwanted effects?
    if(remove_unwanted_effects) formula_composition = as.formula("~ " |> paste(factor_of_interest))
    else formula_composition = NULL
    
    simulated_proportion =
      .data |>
      sccomp_replicate(formula_composition = formula_composition, number_of_draws = 100) |>
      left_join(data_proportion %>% distinct(!!as.symbol(factor_of_interest), !!.sample, !!.cell_group, is_zero))
    
    my_boxplot = my_boxplot +
      
      # Add boxplot for simulated proportions
      stat_summary(
        aes(!!as.symbol(factor_of_interest), generated_proportions),
        fun.data = calc_boxplot_stat,
        geom = "boxplot",
        fatten = 0.5,
        lwd = 0.2,
        data = simulated_proportion %>%
          inner_join(data_proportion %>% distinct(!!as.symbol(factor_of_interest), !!.cell_group)),
        color = "blue"
      )
  }
  
  if(nrow(significance_colors) == 0 ||
     length(intersect(
       significance_colors |> pull(!!as.symbol(factor_of_interest)),
       data_proportion |> pull(!!as.symbol(factor_of_interest))
     )) == 0){
    
    my_boxplot=
      my_boxplot +
      
      # Add boxplot without significance colors
      geom_boxplot(
        aes(!!as.symbol(factor_of_interest), proportion,  group=!!as.symbol(factor_of_interest), fill = NULL),
        outlier.shape = NA, outlier.color = NA,outlier.size = 0,
        data =
          data_proportion |>
          mutate(!!as.symbol(factor_of_interest) := as.character(!!as.symbol(factor_of_interest))) ,
        fatten = 0.5,
        lwd=0.5
      )
  } else {
    my_boxplot=
      my_boxplot +
      # Add boxplot with significance colors
      geom_boxplot(
        aes(!!as.symbol(factor_of_interest), proportion,  group=!!as.symbol(factor_of_interest), fill = name),
        outlier.shape = NA, outlier.color = NA,outlier.size = 0,
        data =
          data_proportion |>
          mutate(!!as.symbol(factor_of_interest) := as.character(!!as.symbol(factor_of_interest))) %>%
          left_join(significance_colors, by = c(quo_name(.cell_group), factor_of_interest)),
        fatten = 0.5,
        lwd=0.5
      )
  }
  
  my_boxplot +
    
    # Add jittered points for individual data
    geom_jitter(
      aes(!!as.symbol(factor_of_interest), proportion, shape=is_zero, color=outlier,  group=!!as.symbol(factor_of_interest)),
      data = data_proportion,
      position=position_jitterdodge(jitter.height = 0, jitter.width = 0.2),
      size = 0.5
    ) +
    
    # Facet wrap by cell group
    facet_wrap(
      vars(!!.cell_group),
      scales = "free_y",
      nrow = 4
    ) +
    scale_color_manual(values = c("black", "#e11f28")) +
    scale_shape_manual(values = c(16, 21)) +
    scale_y_continuous(trans=S_sqrt_trans(), labels = dropLeadingZero) +
    scale_fill_discrete(na.value = "white") +
    xlab("Biological condition") +
    ylab("Cell-group proportion") +
    guides( alpha="none", size="none") +
    labs(fill="Significant difference") +
    my_theme +
    theme(axis.text.x =  element_text(angle=20, hjust = 1), title = element_text(size = 3))
}

#' @keywords internal
#' @noRd
#'
.subset <- 		function(.data,	 .column)	{
  # Make col names
  .column <- enquo(.column)

  # Check if column present
  if(quo_names(.column) %in% colnames(.data) %>% all %>% `!`)
    stop("sccomp says: some of the .column specified do not exist in the input data frame.")

  .data %>%

    # Selecting the right columns
    select(	!!.column,	all_of(get_specific_annotation_columns(.data, !!.column)	)) %>%
    distinct()

}

#' @importFrom dplyr distinct_at
#' @importFrom rlang enquo
#' @importFrom magrittr equals
#' @importFrom dplyr select
#'
#' @keywords internal
#' @noRd
#'
#'
get_specific_annotation_columns <- function(.data, .col){


  # Comply with CRAN NOTES
  . <- NULL

  # Make col names
  .col <- enquo(.col)

  # x-annotation df
  n_x <- .data %>% distinct(across(all_of(quo_names(.col)))) %>% nrow

  # element wise columns
  .data %>%
    select(-!!.col) %>%
    colnames %>%
    map(
      ~ {
        condition <- .data %>%
          distinct(across(all_of(c(quo_names(.col), .x)))) %>%
          nrow %>%
          equals(n_x)
        
        if (condition) {
          .x
        } else {
          NULL
        }
      }
    ) %>%

    # Drop NULL
    {	(.)[lengths((.)) != 0]	} %>%
    unlist

}

#' Convert array of quosure (e.g. c(col_a, col_b)) into character vector
#'
#' @keywords internal
#'
#' @importFrom rlang quo_name
#' @importFrom rlang quo_squash
#'
#' @keywords internal
#' @noRd
#'
#' @param v A array of quosures (e.g. c(col_a, col_b))
#'
#' @return A character vector
quo_names <- function(v) {

  v <- quo_name(quo_squash(v))
  gsub('^c\\(|`|\\)$', '', v) %>%
    strsplit(', ') %>%
    unlist
}

n_iterations = 1000

test_that("test NA factors with interactions",{
  skip_cmdstan()
  
  library(dplyr)

  formula = ~ group2__ * type
  
  # Test that sccomp_estimate and sccomp_predict work with NA values and expect the ESS warning
    res =
      seurat_obj |>
      sccomp_estimate(
        formula_composition = formula,
        formula_variability = ~ 1,
        "sample", "cell_group",
        cores = 1,
        mcmc_seed = 42,   
        max_sampling_iterations = n_iterations,
        inference_method = "hmc", verbose=FALSE
      )
    
    # Create new data using one sample and setting continuous covariate to NA
    new_data = 
      res |> 
      attr("count_data") |> 
      sccomp:::.subset(sample)  |>
      filter(sample == "SI-GA-H1") |>
      mutate(type = NA)
    
    result = sccomp_predict(
      res,
      new_data = bind_rows(
        res |> attr("count_data") |> sccomp:::.subset(sample) |> filter(sample != "SI-GA-H1"),
        new_data
      ),
      formula_composition = formula
    )
  
  # Check that the result is not NULL
  expect_false(is.null(result))
})

test_that("test NA in both variables",{
  skip_cmdstan()
  
  library(dplyr)
  
  formula = ~ group2__ * type
  
  # Test that sccomp_estimate and sccomp_predict work with NA values and expect the ESS warning
    res =
      seurat_obj |>
      sccomp_estimate(
        formula_composition = formula,
        formula_variability = ~ 1,
        "sample", "cell_group",
        cores = 1,
        mcmc_seed = 42,   
        max_sampling_iterations = n_iterations,
        inference_method = "hmc", verbose=FALSE
      )
    
    # Create new data with NA in both variables
    new_data = 
      res |> 
      attr("count_data") |> 
      sccomp:::.subset(sample)  |>
      filter(sample == "SI-GA-H1") |>
      mutate(
        sample = "NEW_SAMPLE_1",
        type = NA,
        group2__ = NA
      )
    
    result = sccomp_predict(
      res,
      new_data = bind_rows(
        res |> attr("count_data") |> sccomp:::.subset(sample) |> filter(sample != "SI-GA-H1"),
        new_data
      ),
      formula_composition = formula
    )
  
  # Check that the result is not NULL
  expect_false(is.null(result))
})

test_that("test NA in three-way interactions",{
  skip_cmdstan()
  
  library(dplyr)
  
  formula = ~ group2__ * type * continuous_covariate
  
  # Test that sccomp_estimate and sccomp_predict work with NA values and expect the ESS warning
    res =
      seurat_obj |>
      sccomp_estimate(
        formula_composition = formula,
        formula_variability = ~ 1,
        "sample", "cell_group",
        cores = 1,
        mcmc_seed = 42,   
        max_sampling_iterations = n_iterations,
        inference_method = "hmc", verbose=FALSE
      )
    
    # Create new data using one sample and setting continuous covariate to NA
    new_data = 
      res |> 
      attr("count_data") |> 
      sccomp:::.subset(sample)  |>
      filter(sample == "SI-GA-H1") |>
      mutate(
        sample = "NEW_SAMPLE_2",  # Use unique sample name
        type = NA,
        continuous_covariate = NA
      )
    
    result = sccomp_predict(
      res,
      new_data = bind_rows(
        res |> attr("count_data") |> sccomp:::.subset(sample) |> filter(sample != "SI-GA-H1"),
        new_data
      ),
      formula_composition = formula
    )

  
  # Check that the result is not NULL
  expect_false(is.null(result))
})

#' Print method for sccomp objects
#'
#' @description
#' Print method for sccomp objects.
#' 
#' The print method for sccomp objects provides a summary of the model specifications,
#' data dimensions, and convergence diagnostics.
#' 
#' The output is formatted to be easy to read and understand.
#' 
#' @importFrom magrittr "%$%"
#' @param x A sccomp object
#' @param ... Additional arguments passed to print
#'
#' @return The printed object
#' @export
#'
#' @examples
#' 
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#' if (instantiate::stan_cmdstan_exists()) {
#'   # Create a sccomp object
#'   data("counts_obj") 
#'   estimate <- sccomp_estimate(
#'     counts_obj,
#'     ~ type,
#'     ~1,
#'     "sample",
#'     "cell_group",
#'     "count",
#'     cores = 1
#'   )
#'   print(estimate)
#' }
#' }
#' 
print.sccomp_tbl <- function(x, ...) {
  
  # Get model information from attributes
  formula_composition <- attr(x, "formula_composition")
  formula_variability <- attr(x, "formula_variability")
  inference_method <- attr(x, "inference_method")
  noise_model <- attr(x, "noise_model")
  
  # Get data dimensions
  n_samples <- x |> attr("model_input") %$% N
  n_cell_groups <- x |> attr("model_input") %$% M 
  
  # Print header with model information
  cat("sccomp model\n")
  cat("============\n\n")
  
  cat("Model specifications:\n")
  cat("  Family:", noise_model, "\n")
  cat("  Composition formula:", deparse(formula_composition), "\n")
  cat("  Variability formula:", deparse(formula_variability), "\n")
  cat("  Inference method:", inference_method, "\n\n")
  
  cat("Data: Samples:", n_samples, "  Cell groups:", n_cell_groups, "\n\n")
  
  cat("Column prefixes: c_ -> composition parameters  v_ -> variability parameters\n\n")
  
  cat("Convergence diagnostics:\n")
  cat("  For each parameter, n_eff is the effective sample size and R_k_hat is the potential\n")
  cat("  scale reduction factor on split chains (at convergence, R_k_hat = 1).\n\n")
  
  # Print the tibble using pillar
  print(tibble::as_tibble(x), ...)
  
  # Return the object invisibly
  invisible(x)
} 

#' @importFrom readr write_file
fit_model = function(
    data_for_model, model_name, censoring_iteration = 1, cores = detectCores(), quantile = 0.95,
    warmup_samples = 300, approximate_posterior_inference = NULL, inference_method, verbose = TRUE,
    seed , pars = c("beta", "alpha", "prec_coeff","prec_sd"), output_samples = NULL, chains=NULL, max_sampling_iterations = 20000, 
    output_directory = "sccomp_draws_files",
    sig_figs = 9,
    cache_stan_model = sccomp_stan_models_cache_dir,
    ...
)
{
  
  # # if analysis approximated
  # # If posterior analysis is approximated I just need enough
  # how_many_posterior_draws_practical = ifelse(approximate_posterior_analysis, 1000, how_many_posterior_draws)
  # additional_parameters_to_save = additional_parameters_to_save %>% c("lambda_log_param", "sigma_raw") %>% unique
  
  
  # Find number of draws
  draws_supporting_quantile = 50
  if(is.null(output_samples)){
    
    output_samples =
      (draws_supporting_quantile/((1-quantile)/2)) %>% # /2 because I have two tails
      max(4000) 
    
    if(output_samples > max_sampling_iterations) {
      # message("sccomp says: the number of draws used to defined quantiles of the posterior distribution is capped to 20K.") # This means that for very low probability threshold the quantile could become unreliable. We suggest to limit the probability threshold between 0.1 and 0.01")
      output_samples = max_sampling_iterations
      
    }}
  
  # Find optimal number of chains
  if(is.null(chains))
    chains =
      find_optimal_number_of_chains(
        how_many_posterior_draws = output_samples,
        warmup = warmup_samples,
        parallelisation_start_penalty = 100
      ) %>%
      min(cores)
  
  # chains = 3
  
  init_list=list(
    prec_coeff = c(5,0),
    prec_sd = 1,
    alpha = matrix(c(rep(5, data_for_model$M), rep(0, (data_for_model$A-1) *data_for_model$M)), nrow = data_for_model$A, byrow = TRUE),
    beta_raw = matrix(0, data_for_model$C , data_for_model$M) ,
    mix_p = 0.1 
  )
  
  if(data_for_model$n_random_eff>0){
    init_list$random_effect_raw = matrix(0, data_for_model$ncol_X_random_eff[1]  , data_for_model$M)
    init_list$random_effect_sigma_raw = matrix(0, data_for_model$M , data_for_model$how_many_factors_in_random_design[1])
    init_list$sigma_correlation_factor = array(0, dim = c(
      data_for_model$M, 
      data_for_model$how_many_factors_in_random_design[1], 
      data_for_model$how_many_factors_in_random_design[1]
    ))
    
    # init_list$random_effect_sigma_mu = 0.5 |> as.array()
    # init_list$random_effect_sigma_sigma = 0.2 |> as.array()
    init_list$zero_random_effect = rep(0, size = 1) |> as.array()
    
  } 
  
  if(data_for_model$n_random_eff>1){
    init_list$random_effect_raw_2 = matrix(0, data_for_model$ncol_X_random_eff[2]  , data_for_model$M)
    init_list$random_effect_sigma_raw_2 = matrix(0, data_for_model$M , data_for_model$how_many_factors_in_random_design[2])
    init_list$sigma_correlation_factor_2 = array(0, dim = c(
      data_for_model$M, 
      data_for_model$how_many_factors_in_random_design[2], 
      data_for_model$how_many_factors_in_random_design[2]
    ))
    
  } 
  
  init = map(1:chains, ~ init_list) %>%
    setNames(as.character(1:chains))
  
  #output_directory = "sccomp_draws_files"
  dir.create(output_directory, showWarnings = FALSE)
  
  # Fit
  mod = load_model(model_name, threads = cores, cache_dir = cache_stan_model)
  
  # Avoid 0 proportions
  if(data_for_model$is_proportion && min(data_for_model$y_proportion)==0){
    warning("sccomp says: your proportion values include 0. Assuming that 0s derive from a precision threshold (e.g. deconvolution), 0s are converted to the smaller non 0 proportion value.")
    data_for_model$y_proportion[data_for_model$y_proportion==0] =
      min(data_for_model$y_proportion[data_for_model$y_proportion>0])
  }
  
  if(inference_method == "hmc"){
    
 # tryCatch({
    mod$sample(
        data = data_for_model ,
        chains = chains,
        parallel_chains = chains,
        threads_per_chain = ceiling(cores/chains),
        iter_warmup = warmup_samples,
        iter_sampling = as.integer(output_samples /chains),
        #refresh = ifelse(verbose, 1000, 0),
        seed = seed,
        save_warmup = FALSE,
        init = init,
        output_dir = output_directory,
        show_messages = verbose,
        sig_figs = sig_figs,
        show_exceptions = verbose,
        ...
      ) 
      
    # },
    # error = function(e) {
    # 
    #   # I don't know why thi is needed nd why the model sometimes is not compliled correctly
    #   if(e |> as.character() |>  str_detect("Model not compiled"))
    #     model = load_model(model_name, force=TRUE, threads = cores)
    #   else
    #     stop(e)
    # 
    # })

    
  } else{
    
    if(inference_method=="pathfinder") init = pf
    else if(inference_method=="variational") init = list(init_list)
    
    vb_iterative(
      mod,
      model_name = model_name,
      output_samples = output_samples ,
      iter = 10000,
      tol_rel_obj = 0.01,
      data = data_for_model, refresh = ifelse(verbose, 1000, 0),
      seed = seed,
      output_dir = output_directory,
      init = init,
      inference_method = inference_method, 
      cores = cores,
      psis_resample = FALSE, 
      verbose = verbose,
      sig_figs = sig_figs,
      cache_stan_model = cache_stan_model,
      show_exceptions = FALSE,
      ...
    ) 
    
  }
  
  
  
}

get_model_from_data = function(file_compiled_model, model_code){
  if(file.exists(file_compiled_model))
    readRDS(file_compiled_model)
  else {
    model_generate = stan_model(model_code = model_code)
    model_generate  %>% saveRDS(file_compiled_model)
    model_generate
    
  }
}

#' Load, Compile, and Cache a Stan Model
#'
#' This function attempts to load a precompiled Stan model using the `instantiate` package.
#' If the model is not found in the cache or force recompilation is requested, it will locate
#' the Stan model file within the `sccomp` package, compile it using `cmdstanr`, and save the 
#' compiled model to the cache directory for future use.
#'
#' @param name A character string representing the name of the Stan model (without the `.stan` extension).
#' @param cache_dir A character string representing the path to the cache directory where compiled models are saved. 
#' Defaults to `sccomp_stan_models_cache_dir`.
#' @param force A logical value. If `TRUE`, the model will be recompiled even if it exists in the cache. 
#' Defaults to `FALSE`.
#' @param threads An integer specifying the number of threads to use for compilation. 
#' Defaults to `1`.
# 
#' @return A compiled Stan model object from `cmdstanr`.
#' 
#' @importFrom instantiate stan_package_model
#' @importFrom instantiate stan_package_compile
#' 
#' @noRd
#' 
#' @examples
#' \donttest{
#'   model <- load_model("glm_multi_beta_binomial_", "~/cache", force = FALSE, threads = 1)
#' }
load_model <- function(name, cache_dir = sccomp_stan_models_cache_dir, force=FALSE, threads = 1) {
  
  
  # tryCatch({
  #   # Attempt to load a precompiled Stan model using the instantiate package
  #   instantiate::stan_package_model(
  #     name = name,
  #     package = "sccomp"
  #   )
  # }, error = function(e) {
  # Try to load the model from cache
  
  # Handle cache directory - always add version to ensure version isolation
  sccomp_version <- as.character(packageVersion("sccomp"))
  cache_dir <- file.path(cache_dir, sccomp_version)
  
  # RDS compiled model
  cache_dir |> dir.create(showWarnings = FALSE, recursive = TRUE)
  cache_file <- file.path(cache_dir, paste0(name, ".rds"))
  
  # .STAN raw model
  stan_model_path <- system.file("stan", paste0(name, ".stan"), package = "sccomp")
  
  if (file.exists(cache_file) & !force) {
    message("Loading model from cache...")
    return(readRDS(cache_file))
  }
  
  # If loading the precompiled model fails, find the Stan model file within the package
  message("Precompiled model not found. Compiling the model...")
  
  # Compile the Stan model using cmdstanr with threading support enabled
  instantiate::stan_package_compile(
    stan_model_path, 
    cpp_options = list(stan_threads = TRUE),
    force_recompile = TRUE, 
    threads = threads, 
    dir = system.file("stan", package = "sccomp")
  )
  mod = instantiate::stan_package_model(
    name = name, 
    package = "sccomp", 
    compile = TRUE,
    cpp_options = list(stan_threads = TRUE)
  ) |> suppressWarnings()
  
  # Save the compiled model object to cache
  saveRDS(mod, file = cache_file)
  message("Model compiled and saved to cache successfully.")
  
  return(mod)
  # })
  
}

#' Check and Install cmdstanr and CmdStan
#'
#' This function checks if the `cmdstanr` package (version 0.9.0 or higher) and CmdStan are installed. 
#' If they are not installed, it installs them automatically in non-interactive sessions
#' or asks for permission to install them in interactive sessions.
#' 
#' The function requires cmdstanr version 0.9.0 or higher for support of the new `sum_to_zero_vector` type.
#'
#' @importFrom instantiate stan_cmdstan_exists
#' @importFrom rlang check_installed
#' @importFrom rlang abort
#' @importFrom rlang check_installed
#' @return NULL
#' 
#' @noRd
check_and_install_cmdstanr <- function() {
  
  # Check if cmdstanr is installed
  # from https://github.com/wlandau/instantiate/blob/33989d74c26f349e292e5efc11c267b3a1b71d3f/R/utils_assert.R#L114
  
  # tryCatch(
    rlang::check_installed(
      pkg = "cmdstanr",
      version = "0.9.0",
      reason = paste(
        "The {cmdstanr} package is required in order to install",
        "CmdStan and run Stan models. Please install it manually using",
        "install.packages(pkgs = \"cmdstanr\",",
        "repos = c(\"https://mc-stan.org/r-packages/\", getOption(\"repos\"))"
      ),
      
      # I have to see if Bioconductor is compatible with this
      action = function(...) install.packages(..., repos = c('https://stan-dev.r-universe.dev', 'https://cloud.r-project.org'))
    )
  #   ,
  #   error = function(e) {
  #     clear_stan_model_cache()
  #     stan_error(conditionMessage(e))
  #   }
  # )


  # Check if CmdStan is installed
  if (!stan_cmdstan_exists()) {
    
    clear_stan_model_cache()
    
    stop(
      "cmdstan is required to proceed.\n\n",
      "You can install CmdStan by running the following command:\n",
      "cmdstanr::check_cmdstan_toolchain(fix = TRUE)\n",
      "cmdstanr::install_cmdstan()\n",
      "This will install the latest version of CmdStan. For more information, visit:\n",
      "https://mc-stan.org/users/interfaces/cmdstan"
    )
  }
}

#' vb_iterative
#'
#' @description Runs iteratively variational bayes until it suceeds
#'
#'
#' @keywords internal
#' @noRd
#'
#' @param model A Stan model
#' @param output_samples An integer of how many samples from posteriors
#' @param iter An integer of how many max iterations
#' @param tol_rel_obj A real
#' @param additional_parameters_to_save A character vector
#' @param data A data frame
#' @param seed An integer
#' @param sig_figs Number of significant figures to use for Stan model output. Default is 9.
#' @param ... List of paramaters for vb function of Stan
#'
#' @return A Stan fit object
#'
vb_iterative = function(model,
                        model_name,
                        output_samples,
                        iter,
                        tol_rel_obj,
                        additional_parameters_to_save = c(),
                        data,
                        output_dir = output_dir,
                        seed, 
                        init = "random",
                        inference_method,
                        cores = 1, 
                        verbose = TRUE,
                        psis_resample = FALSE,
                        sig_figs = 9,
                        cache_stan_model = sccomp_stan_models_cache_dir,
                        ...) {
  res = NULL
  i = 0
  while  (is.null(res) & i < 5) {
    res = tryCatch({
      
      if(inference_method=="pathfinder")
        my_res = model |> 
          sample_safe(
            pathfinder_fx,
            data = data,
            tol_rel_obj = tol_rel_obj,
            output_dir = output_dir,
            seed = seed+i,
            # init = init,
            num_paths=50, 
            num_threads = cores,
            single_path_draws = output_samples / 50 ,
            max_lbfgs_iters=100, 
            history_size = 100, 
            show_messages = verbose,
            psis_resample = psis_resample,
            sig_figs = sig_figs,
            ...
          )
      
      else if(inference_method=="variational")
        my_res = model |> 
          sample_safe(
            variational_fx,
            data = data,
            output_samples = output_samples,
            iter = iter,
            tol_rel_obj = tol_rel_obj,
            output_dir = output_dir,
            seed = seed+i,
            init = init,
            show_messages = verbose,
            threads = cores,
            sig_figs = sig_figs,
            ...
          )
      
      boolFalse <- TRUE
      return(my_res)
    },
    error = function(e) {
      if(e$message |> str_detect("The Stan file used to create the `CmdStanModel` object does not exist\\.")) {
        clear_stan_model_cache()
        model <<-  load_model(model_name, force=TRUE, threads = cores, cache_dir = cache_stan_model)
      }
      else writeLines(sprintf("Further attempt with Variational Bayes: %s", e))     
      
      return(NULL)
    },
    finally = {
    })
    i = i + 1
  }
  
  if(is.null(res)) stop(sprintf("sccomp says: variational Bayes did not converge after %s attempts. Please use variational_inference = FALSE for a HMC fitting.", i))
  
  return(res)
}

#' Choose the number of chains baed on how many draws we need from the posterior distribution
#' Because there is a fix cost (warmup) to starting a new chain,
#' we need to use the minimum amount that we can parallelise
#' @param how_many_posterior_draws A real number of posterior draws needed
#' @param max_number_to_check A sane upper plateau
#'
#' @keywords internal
#' @noRd
#'
#' @return A Stan fit object
find_optimal_number_of_chains = function(how_many_posterior_draws = 100,
                                         max_number_to_check = 100, warmup = 200, parallelisation_start_penalty = 100) {
  
  
  
  # Define the variables as NULL to avoid CRAN NOTES
  chains <- NULL
  
  
  chains_df =
    tibble(chains = seq_len(max_number_to_check)) %>%
    mutate(tot = (how_many_posterior_draws / chains) + warmup + (parallelisation_start_penalty * chains))
  
  d1 <- diff(chains_df$tot) / diff(seq_len(nrow(chains_df))) # first derivative
  abs(d1) %>% order() %>% .[1] # Find derivative == 0
  
  
}



sample_safe <- function(model, fx, ...) {
  tryCatch(
    {
      # Attempt to run the arbitrary fx with additional arguments
      result <- fx(model, ...)
      return(result)
    },
    error = function(e) {
      # Check if the error message is "model not compiled"
      if (grepl("Model not compiled", e$message)) {
        message("Model not compiled. Compiling.")
        # Load the model with force=TRUE
        model <- model$compile(cpp_options = list(stan_threads = TRUE)) # load_model("glm_multi_beta_binomial_generate_data", force = TRUE)
        # Retry the arbitrary fx with additional arguments
        result <- fx(model, ...)
        return(result)
      } else {
        # If a different error, rethrow the error
        stop(e)
      }
    }
  )
}


sample_fx <- function(model, ...) {
  model$sample(...)
}

pathfinder_fx <- function(model, ...) {
  model$pathfinder(...)
}

variational_fx <- function(model, ...) {
  model$variational(...)
}

generate_quantities_fx <- function(model, ...) {
  model$generate_quantities(...)
}

test_that("cache_stan_model parameter works correctly", {
  # Skip if cmdstanr is not available
  skip_if_not(instantiate::stan_cmdstan_exists())
  
  # Test that cache_stan_model parameter is available in all relevant functions
  expect_true("cache_stan_model" %in% names(formals(sccomp_estimate)))
  expect_true("cache_stan_model" %in% names(formals(sccomp_replicate)))
  expect_true("cache_stan_model" %in% names(formals(simulate_data)))
  expect_true("cache_stan_model" %in% names(formals(sccomp_remove_outliers)))
  
  # Test that cache_stan_model defaults to sccomp_stan_models_cache_dir
  expect_equal(formals(sccomp_estimate)$cache_stan_model, quote(sccomp_stan_models_cache_dir))
  expect_equal(formals(sccomp_replicate)$cache_stan_model, quote(sccomp_stan_models_cache_dir))
  expect_equal(formals(simulate_data)$cache_stan_model, quote(sccomp_stan_models_cache_dir))
  expect_equal(formals(sccomp_remove_outliers)$cache_stan_model, quote(sccomp_stan_models_cache_dir))
  
  # Test that sccomp:::load_model function handles cache_stan_model correctly
  # This is an internal test to verify the cache directory construction
  test_cache_dir <- tempdir()
  sccomp_version <- as.character(packageVersion("sccomp"))
  expected_cache_dir <- file.path(test_cache_dir, sccomp_version)
  
  # Test with default cache_stan_model (should use default)
  expect_no_error({
    model <- sccomp:::load_model("glm_multi_beta_binomial", threads = 1)
  })
  
  # Test with custom cache_stan_model
  expect_no_error({
    model <- sccomp:::load_model("glm_multi_beta_binomial", cache_dir = test_cache_dir, threads = 1)
  })
  
  # Verify that the cache directory was created with the sccomp version
  expect_true(dir.exists(expected_cache_dir))
  
  # Test that default cache directory includes version
  default_cache <- file.path(path.expand("~"), ".sccomp_models", packageVersion("sccomp"))
  expect_true(grepl(sccomp_version, default_cache))
  
  # Clean up
  unlink(expected_cache_dir, recursive = TRUE)
}) 

#' sccomp_test
#'
#' @description This function test contrasts from a sccomp result.
#'
#' @param .data A tibble. The result of sccomp_estimate.
#' @param contrasts A vector of character strings. For example if your formula is `~ 0 + treatment` and the factor treatment has values `yes` and `no`, your contrast could be "constrasts = c(treatmentyes - treatmentno)".
#' @param percent_false_positive A real between 0 and 100 non included. This used to identify outliers with a specific false positive rate.
#' @param test_composition_above_logit_fold_change A positive integer. It is the effect threshold used for the hypothesis test. A value of 0.2 correspond to a change in cell proportion of 10% for a cell type with baseline proportion of 50%. That is, a cell type goes from 45% to 50%. When the baseline proportion is closer to 0 or 1 this effect thrshold has consistent value in the logit uncontrained scale.
#' @param pass_fit A boolean. Whether to pass the Stan fit as attribute in the output. Because the Stan fit can be very large, setting this to FALSE can be used to lower the memory imprint to save the output.
#'
#' @return A tibble (`tbl`), with the following columns:
#' \itemize{
#'   \item cell_group - The cell groups being tested.
#'   \item parameter - The parameter being estimated from the design matrix described by the input formula_composition and formula_variability.
#'   \item factor - The covariate factor in the formula, if applicable (e.g., not present for Intercept or contrasts).
#'   \item c_lower - Lower (2.5%) quantile of the posterior distribution for a composition (c) parameter.
#'   \item c_effect - Mean of the posterior distribution for a composition (c) parameter.
#'   \item c_upper - Upper (97.5%) quantile of the posterior distribution for a composition (c) parameter.
#'   \item c_pH0 - Probability of the c_effect being smaller or bigger than the `test_composition_above_logit_fold_change` argument.
#'   \item c_FDR - False-discovery rate of the null hypothesis (no difference) for a composition (c).
#'   \item c_n_eff - Effective sample size - the number of independent draws in the sample, the higher the better.
#'   \item c_R_k_hat - R statistic, a measure of chain equilibrium, should be within 0.05 of 1.0.
#'   \item v_lower - Lower (2.5%) quantile of the posterior distribution for a variability (v) parameter.
#'   \item v_effect - Mean of the posterior distribution for a variability (v) parameter.
#'   \item v_upper - Upper (97.5%) quantile of the posterior distribution for a variability (v) parameter.
#'   \item v_pH0 - Probability of the null hypothesis (no difference) for a variability (v).
#'   \item v_FDR - False-discovery rate of the null hypothesis (no difference) for a variability (v).
#'   \item v_n_eff - Effective sample size for a variability (v) parameter.
#'   \item v_R_k_hat - R statistic for a variability (v) parameter.
#'   \item count_data - Nested input count data.
#' }
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
#' @export
#'
#' @examples
#'
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'
#'     estimates = sccomp_estimate(
#'       counts_obj,
#'       ~ 0 + type, ~1, "sample", "cell_group", "count",
#'       cores = 1
#'     ) |>
#'     sccomp_test("typecancer - typebenign")
#'   }
#' }
#'
sccomp_test <- function(.data,
                        contrasts = NULL,
                        percent_false_positive = 5,
                        test_composition_above_logit_fold_change = 0.1,
                        pass_fit = TRUE) {
  
  # Run the function
  check_and_install_cmdstanr()
  
  UseMethod("sccomp_test", .data)
}


#'
#' @importFrom dplyr any_of
#'
#' @export
#'
#'
sccomp_test.sccomp_tbl = function(.data,
                                  contrasts = NULL,
                                  percent_false_positive = 5,
                                  test_composition_above_logit_fold_change = 0.1,
                                  pass_fit = TRUE){
  

  .sample = .data |>  attr(".sample")
  .cell_group = .data |>  attr(".cell_group")
  .count = .data |>  attr(".count")
  model_input = .data |> attr("model_input")
  truncation_df2 =  .data |>  attr("truncation_df2")
  inference_method = .data |>  attr("inference_method")
  
  # Abundance
  abundance_CI =
    get_abundance_contrast_draws(.data, contrasts)
  
  # If my contrasts do not match my model. I have to do something more elegant.
  if ("parameter" %in% colnames(abundance_CI))
    abundance_CI =
    abundance_CI |>
    draws_to_statistics(
      percent_false_positive/100,
      test_composition_above_logit_fold_change,
      !!.cell_group,
      "c_"
    )
  
  variability_CI =
    get_variability_contrast_draws(.data, contrasts)
  
  # Variability
  if ("parameter" %in% colnames(variability_CI))
    variability_CI = 
    variability_CI |>
    draws_to_statistics(
      percent_false_positive / 100,
      test_composition_above_logit_fold_change,
      !!.cell_group,
      "v_"
    )
  
  # If I don't have factors (~1)
  if (!"factor" %in% colnames(model_input$factor_parameter_dictionary))
    factor_parameter_dictionary = tibble(`factor` = character(), design_matrix_col = character())
  else
    factor_parameter_dictionary =
    model_input$factor_parameter_dictionary |>
    select(`factor`, design_matrix_col)
  
  # Merge and parse
  result =
    abundance_CI |>
    
    # Add ALPHA
    left_join(variability_CI) |>
    suppressMessages() |>
    
    # Add easy to understand factor labels
    left_join(factor_parameter_dictionary,
              by = c("parameter" = "design_matrix_col")) |>
    select(parameter, `factor`, everything()) |>
    
    select(!!.cell_group, everything(),-M)
  
  if(pass_fit)
    result =
    result |>
    add_attr(.data |> attr("fit") , "fit")
  
  result |>
    
    # TEMPORARILY DROPPING KHAT
    # select(-contains("n_eff"), -contains("_hat")) |> 
    
    add_attr(test_composition_above_logit_fold_change, "test_composition_above_logit_fold_change") |>
    
    # Attach association mean concentration
    add_attr(.data |> attr("model_input") , "model_input") |>
    add_attr(.data |> attr("truncation_df2"), "truncation_df2") |>
    add_attr(.data |> attr("noise_model") , "noise_model") |>
    
    add_attr(.sample, ".sample") |>
    add_attr(.cell_group, ".cell_group") |>
    add_attr(.count, ".count") |>
    
    add_attr(.data |> attr("formula_composition"), "formula_composition") |>
    add_attr(.data |> attr("formula_variability"), "formula_variability") |>
    add_attr(inference_method, "inference_method" ) |> 
    
    # Add count data as attribute
    add_attr(.data |> attr("count_data"), "count_data") |>
    
    # Add class to the tbl
    add_class("sccomp_tbl") 
}

# this can be helpful if we want to draw PCA with uncertainty
get_abundance_contrast_draws = function(.data, contrasts){
  
  # Define the variables as NULL to avoid CRAN NOTES
  X <- NULL
  .value <- NULL
  X_random_effect <- NULL
  .variable <- NULL
  y <- NULL
  M <- NULL
  khat <- NULL
  parameter <- NULL
  n_eff <- NULL
  R_k_hat <- NULL
  
  
  .cell_group = .data |>  attr(".cell_group")
  
  # Beta
  beta_factor_of_interest = .data |> attr("model_input") %$% X |> colnames()
  # beta =
  #   .data |>
  #   attr("fit") %>%
  #   draws_to_tibble_x_y("beta", "C", "M") |>
  #   pivot_wider(names_from = C, values_from = .value) %>%
  #   setNames(colnames(.)[1:5] |> c(beta_factor_of_interest))
  
  if(contrasts |> is.null())
    draws = 
    .data |>
    attr("fit") %>%
    draws_to_tibble_x_y("beta", "C", "M") |> 
    pivot_wider(names_from = C, values_from = .value) %>%
    setNames(colnames(.)[1:5] |> c(beta_factor_of_interest))
  
  else if(
    (beta_factor_of_interest %in% contrasts_to_parameter_list(contrasts)) |> which() |> length() > 0
  )
    
    draws =
    .data |>
    attr("fit") %>%
    draws_to_tibble_x_y("beta", "C", "M") |> 
    left_join(
      beta_factor_of_interest |> enframe(name = "C", value = "parameters_name"),
      by = "C"
    )  |> 
    filter(parameters_name %in% contrasts_to_parameter_list(contrasts)) |> 
    select(-C) |> 
    pivot_wider(names_from = parameters_name, values_from = .value)
  
  else 
    draws = tibble()
  
  
  # Abundance
  draws = draws |> select(-.variable)
  
  
  # Random effect
  
  beta_random_effect_factor_of_interest = .data |> attr("model_input") %$% X_random_effect |> colnames()
  
  if(
    .data |> attr("model_input") %$% n_random_eff > 0 &&
    (
      contrasts |> is.null() || 
      (beta_random_effect_factor_of_interest %in% contrasts_to_parameter_list(contrasts)) |> which() |> length() > 0
    )  
  ){
    
    
    beta_random_effect =
      .data |>
      attr("fit") %>%
      draws_to_tibble_x_y("random_effect", "C", "M") 
    
    # Add last component
    other_group_random_effect = 
      beta_random_effect |> 
      with_groups(c(C, .chain, .iteration, .draw, .variable ), ~ .x |> summarise(.value = sum(.value))) |> 
      mutate(.value = -.value, M = beta_random_effect |> pull(M) |> max() + 1)
    
    # POST-MODEL CORRECTION COMMENTED OUT - Now using built-in sum_to_zero_vector in Stan
    # I HAVE TO REGULARISE THE LAST COMPONENT
    # mean_of_the_sd_of_the_point_estimates = 
    #   beta_random_effect |> 
    #   group_by(M, C) |> 
    #   summarise(point_estimate = mean(.value)) |> 
    #   group_by(M) |> 
    #   summarise(sd_of_point_estimates = sd(point_estimate)) |> 
    #   pull(sd_of_point_estimates) |> 
    #   mean()
    
    # other_sd_of_the_point_estimates = 
    #   other_group_random_effect |> 
    #   group_by(M, C) |> 
    #   summarise(point_estimate = mean(.value)) |> 
    #   group_by(M) |> 
    #   summarise(sd_of_point_estimates = sd(point_estimate)) |> 
    #   pull(sd_of_point_estimates)
    
    # other_group_random_effect = 
    #   other_group_random_effect |> 
    #   mutate(.value = .value / (other_sd_of_the_point_estimates / mean_of_the_sd_of_the_point_estimates))
    
    
    beta_random_effect = 
      beta_random_effect |> 
      bind_rows( other_group_random_effect )
    
    # mutate(is_treg = cell_type =="treg") |>
    #   nest(data = -is_treg) |>
    #   mutate(data = map2(
    #     data, is_treg,
    #     ~ {
    #       if(.y) .x |> mutate(c_effect = c_effect/5 )
    #       else(.x)
    #     }
    #   )) |>
    #   unnest(data) |>
    
    
    # Reshape
    # Speed up if I have contrasts
    if(!contrasts |> is.null())
      beta_random_effect = 
      beta_random_effect |> 
      left_join(
        beta_random_effect_factor_of_interest |> enframe(name = "C", value = "parameters_name"),
        by = "C"
      )  |> 
      filter(parameters_name %in% contrasts_to_parameter_list(contrasts)) |> 
      select(-C) |> 
      pivot_wider(names_from = parameters_name, values_from = .value)
    
    else
      beta_random_effect = 
      beta_random_effect |>
      pivot_wider(names_from = C, values_from = .value) %>%
      setNames(colnames(.)[1:5] |> c(beta_random_effect_factor_of_interest))
    
    # If I don't have fix nor 1st level random effect
    if(draws |> nrow() == 0)
      draws = select(beta_random_effect, -.variable)
    else 
      draws = draws |> 
      left_join(select(beta_random_effect, -.variable),
                by = c("M", ".chain", ".iteration", ".draw")
      )
    
  }  else {
    beta_random_effect_factor_of_interest = ""
  }
  
  # Second random effect. IN THE FUTURE THIS WILL BE VECTORISED TO ARBUTRARY GRI+OUING
  beta_random_effect_factor_of_interest_2 = .data |> attr("model_input") %$% X_random_effect_2 |> colnames()
  
  if(
    .data |> attr("model_input") %$% n_random_eff > 1 &&
    (
      contrasts |> is.null() || 
      (beta_random_effect_factor_of_interest_2 %in% contrasts_to_parameter_list(contrasts)) |> which() |> length() > 0
    )
  ){
    
    beta_random_effect_2 =
      .data |>
      attr("fit") %>%
      draws_to_tibble_x_y("random_effect_2", "C", "M") 
    
    # Add last component
    other_group_random_effect = 
      beta_random_effect_2 |> 
      with_groups(c(C, .chain, .iteration, .draw, .variable ), ~ .x |> summarise(.value = sum(.value))) |> 
      mutate(.value = -.value, M = beta_random_effect_2 |> pull(M) |> max() + 1)
    
    # POST-MODEL CORRECTION COMMENTED OUT - Now using built-in sum_to_zero_vector in Stan
    # I HAVE TO REGULARISE THE LAST COMPONENT
    # mean_of_the_sd_of_the_point_estimates = 
    #   beta_random_effect_2 |> 
    #   group_by(M, C) |> 
    #   summarise(point_estimate = mean(.value)) |> 
    #   group_by(M) |> 
    #   summarise(sd_of_point_estimates = sd(point_estimate)) |> 
    #   pull(sd_of_point_estimates) |> 
    #   mean()
    
    # other_sd_of_the_point_estimates = 
    #   other_group_random_effect |> 
    #   group_by(M, C) |> 
    #   summarise(point_estimate = mean(.value)) |> 
    #   group_by(M) |> 
    #   summarise(sd_of_point_estimates = sd(point_estimate)) |> 
    #   pull(sd_of_point_estimates)
    
    # other_group_random_effect = 
    #   other_group_random_effect |> 
    #   mutate(.value = .value / (other_sd_of_the_point_estimates / mean_of_the_sd_of_the_point_estimates))
    
    
    beta_random_effect_2 = 
      beta_random_effect_2 |> 
      bind_rows( other_group_random_effect )
    
    # Reshape
    # Speed up if I have contrasts
    if(!contrasts |> is.null())
      beta_random_effect_2 = 
      beta_random_effect_2 |> 
      left_join(
        beta_random_effect_factor_of_interest_2 |> enframe(name = "C", value = "parameters_name"),
        by = "C"
      )  |> 
      filter(parameters_name %in% contrasts_to_parameter_list(contrasts)) |> 
      select(-C) |> 
      pivot_wider(names_from = parameters_name, values_from = .value)
    
    else
      beta_random_effect_2 = 
      beta_random_effect_2 |>
      pivot_wider(names_from = C, values_from = .value) %>%
      setNames(colnames(.)[1:5] |> c(beta_random_effect_factor_of_interest_2))
    
    # If I don't have fix nor 1st level random effect
    if(draws |> nrow() == 0)
      draws = select(beta_random_effect_2, -.variable)
    else 
      draws = draws |> 
      left_join(select(beta_random_effect_2, -.variable),
                by = c("M", ".chain", ".iteration", ".draw")
      )
  } else {
    beta_random_effect_factor_of_interest_2 = ""
  }
  
  
  # If I have constrasts calculate
  if(!is.null(contrasts))
    draws = 
    draws |> 
    mutate_from_expr_list(contrasts, ignore_errors = FALSE) |>
    select(- any_of(c(beta_factor_of_interest, beta_random_effect_factor_of_interest) |> setdiff(contrasts)) ) 
  
  # Add cell name
  draws = draws |> 
    left_join(
      .data |>
        attr("model_input") %$%
        y %>%
        colnames() |>
        enframe(name = "M", value  = quo_name(.cell_group)),
      by = "M"
    ) %>%
    select(!!.cell_group, everything())
  
  
  # If no contrasts of interest just return an empty data frame
  if(ncol(draws)==5) return(draws |> distinct(M, !!.cell_group))
  
  # Get convergence for fixed effects
  convergence_df =
    .data |>
    attr("fit") |>
    summary_to_tibble("beta", "C", "M") |>
    
    # Add cell name
    left_join(
      .data |>
        attr("model_input") %$%
        y %>%
        colnames() |>
        enframe(name = "M", value  = quo_name(.cell_group)),
      by = "M"
    ) |>
    
    # factor names
    left_join(
      beta_factor_of_interest |>
        enframe(name = "C", value = "parameter"),
      by = "C"
    )
  
  # Get convergence for random effects if they exist
  if(.data |> attr("model_input") %$% n_random_eff > 0) {
    convergence_df_random =
      .data |>
      attr("fit") |>
      summary_to_tibble("random_effect", "C", "M") |>
      
      # Add cell name
      left_join(
        .data |>
          attr("model_input") %$%
          y %>%
          colnames() |>
          enframe(name = "M", value  = quo_name(.cell_group)),
        by = "M"
      ) |>
      
      # factor names
      left_join(
        beta_random_effect_factor_of_interest |>
          enframe(name = "C", value = "parameter"),
        by = "C"
      )
    
    # Combine fixed and random effects convergence
    convergence_df = bind_rows(convergence_df, convergence_df_random)
  }
  
  # Get convergence for second random effect if it exists
  if(.data |> attr("model_input") %$% n_random_eff > 1) {
    convergence_df_random_2 =
      .data |>
      attr("fit") |>
      summary_to_tibble("random_effect_2", "C", "M") |>
      
      # Add cell name
      left_join(
        .data |>
          attr("model_input") %$%
          y %>%
          colnames() |>
          enframe(name = "M", value  = quo_name(.cell_group)),
        by = "M"
      ) |>
      
      # factor names
      left_join(
        beta_random_effect_factor_of_interest_2 |>
          enframe(name = "C", value = "parameter"),
        by = "C"
      )
    
    # Combine with existing convergence data
    convergence_df = bind_rows(convergence_df, convergence_df_random_2)
  }
  
  # if ("Rhat" %in% colnames(convergence_df)) {
  #   convergence_df <- rename(convergence_df, R_k_hat = Rhat)
  # } else if ("khat" %in% colnames(convergence_df)) {
  #   convergence_df <- rename(convergence_df, R_k_hat = khat)
  # }
  
  
  convergence_df =
    convergence_df |> 
    select(!!.cell_group, parameter, any_of(c("n_eff", "R_k_hat", "rhat", "ess_bulk", "ess_tail"))) |>
    suppressWarnings()
  
  draws |>
    pivot_longer(-c(1:5), names_to = "parameter", values_to = ".value") |>
    
    # Attach convergence if I have no contrasts
    left_join(convergence_df, by = c(quo_name(.cell_group), "parameter")) |>
    
    # Reorder because pivot long is bad
    mutate(parameter = parameter |> fct_relevel(colnames(draws)[-c(1:5)])) |>
    arrange(parameter)
  
}

#' @importFrom forcats fct_relevel
#' @noRd
get_variability_contrast_draws = function(.data, contrasts){
  
  # Define the variables as NULL to avoid CRAN NOTES
  XA <- NULL
  .value <- NULL
  y <- NULL
  M <- NULL
  khat <- NULL
  parameter <- NULL
  n_eff <- NULL
  R_k_hat <- NULL
  
  .cell_group = .data |>  attr(".cell_group")
  
  variability_factor_of_interest = .data |> attr("model_input") %$% XA |> colnames()
  
  draws =
    
    .data |>
    attr("fit") %>%
    draws_to_tibble_x_y("alpha_normalised", "C", "M") |>
    
    # We want variability, not concentration
    mutate(.value = -.value) 
  
  # Reshape
  # Speed up if I have contrasts
  if(!contrasts |> is.null())
    draws = 
    draws |> 
    left_join(
      variability_factor_of_interest |> enframe(name = "C", value = "parameters_name"),
      by = "C"
    )  |> 
    filter(parameters_name %in% contrasts_to_parameter_list(contrasts)) |> 
    select(-C) |> 
    pivot_wider(names_from = parameters_name, values_from = .value) |> 
    select( -.variable) 
  
  else
    draws =
    draws |>  
    pivot_wider(names_from = C, values_from = .value) %>%
    setNames(colnames(.)[1:5] |> c(variability_factor_of_interest)) |>
    select( -.variable) 
  
  # If I have constrasts calculate
  if (!is.null(contrasts)) 
    draws <- mutate_from_expr_list(draws, contrasts, ignore_errors = TRUE)
  
  draws =  draws |>
    
    # Add cell name
    left_join(
      .data |> attr("model_input") %$%
        y %>%
        colnames() |>
        enframe(name = "M", value  = quo_name(.cell_group)),
      by = "M"
    ) %>%
    select(!!.cell_group, everything())
  
  # If no contrasts of interest just return an empty data frame
  if(ncol(draws)==5) return(draws |> distinct(M, !!.cell_group))
  
  # Get convergence
  convergence_df =
    .data |>
    attr("fit") |>
    summary_to_tibble("alpha_normalised", "C", "M") |>
    
    # Add cell name
    left_join(
      .data |>
        attr("model_input") %$%
        y %>%
        colnames() |>
        enframe(name = "M", value  = quo_name(.cell_group)),
      by = "M"
    ) |>
    
    # factor names
    left_join(
      variability_factor_of_interest |>
        enframe(name = "C", value = "parameter"),
      by = "C"
    )
  
  convergence_df =
    convergence_df |> 
    select(!!.cell_group, parameter, any_of(c("n_eff", "R_k_hat", "rhat", "ess_bulk", "ess_tail"))) |>
    suppressWarnings()
  
  
  draws |>
    pivot_longer(-c(1:5), names_to = "parameter", values_to = ".value") |>
    
    # Attach convergence if I have no contrasts
    left_join(convergence_df, by = c(quo_name(.cell_group), "parameter")) |>
    
    # Reorder because pivot long is bad
    mutate(parameter = parameter |> fct_relevel(colnames(draws)[-c(1:5)])) |>
    arrange(parameter)
  
}

#' Mutate Data Frame Based on Expression List
#'
#' @description
#' `mutate_from_expr_list` takes a data frame and a list of formula expressions, 
#' and mutates the data frame based on these expressions. It allows for ignoring 
#' errors during the mutation process.
#'
#' @param x A data frame to be mutated.
#' @param formula_expr A named list of formula expressions used for mutation.
#' @param ignore_errors Logical flag indicating whether to ignore errors during mutation.
#'
#' @return A mutated data frame with added or modified columns based on `formula_expr`.
#'
#' @details
#' The function performs various checks and transformations on the formula expressions,
#' ensuring that the specified transformations are valid and can be applied to the data frame.
#' It supports advanced features like handling special characters in column names and intelligent
#' parsing of formulas.
#'
#' @importFrom purrr map2_dfc
#' @importFrom tibble add_column
#' @importFrom tidyselect last_col
#' @importFrom dplyr mutate
#' @importFrom stringr str_subset
#' 
#' @noRd
#' 
mutate_from_expr_list = function(x, formula_expr, ignore_errors = TRUE){
  
  if(formula_expr |> names() |> is.null())
    names(formula_expr) = formula_expr
  
  # Creating a named vector where the names are the strings to be replaced
  # and the values are empty strings
  contrasts_elements = contrasts_to_parameter_list(formula_expr, drop_back_quotes = FALSE)
  
  # Check if all elements of contrasts are in the parameter
  parameter_names = x |> colnames()
  
  # Check is backquoted are not used
  require_back_quotes = !contrasts_elements |>  str_remove_all("`") |> contains_only_valid_chars_for_column() 
  has_left_back_quotes = contrasts_elements |>  str_detect("^`") 
  has_right_back_quotes = contrasts_elements |>  str_detect("`$") 
  if_true_not_good = require_back_quotes & !(has_left_back_quotes & has_right_back_quotes)
  
  if(any(if_true_not_good))
    warning(sprintf("sccomp says: for columns which have special characters e.g. %s, you need to use surrounding backquotes ``.", paste(contrasts_elements[!if_true_not_good], sep=", ")))
  
  # Check if columns exist
  contrasts_not_in_the_model = 
    contrasts_elements |> 
    str_remove_all("`") |> 
    setdiff(parameter_names)
  
  contrasts_not_in_the_model = contrasts_not_in_the_model[contrasts_not_in_the_model!=""]
  
  if(length(contrasts_not_in_the_model) > 0 & !ignore_errors)
    warning(sprintf("sccomp says: These components of your contrasts are not present in the model as parameters: %s. Factors including special characters, e.g. \"(Intercept)\" require backquotes e.g. \"`(Intercept)`\" ", paste(contrasts_not_in_the_model, sep = ", ")))
  
  # Calculate
  if(ignore_errors) my_mutate = mutate_ignore_error
  else my_mutate = mutate
  
  map2_dfc(
    formula_expr,
    names(formula_expr),
    ~  x |>
      my_mutate(!!.y := eval(rlang::parse_expr(.x))) |>
      # mutate(!!column_name := eval(rlang::parse_expr(.x))) |>
      select(any_of(.y))
  )  |>
    
    # I could drop this to just result contrasts
    add_column(x |> select(M, .chain, .iteration, .draw), .before = 1)
  
}

draws_to_statistics = function(draws, false_positive_rate, test_composition_above_logit_fold_change, .cell_group, prefix = ""){
  
  # Define the variables as NULL to avoid CRAN NOTES
  M <- NULL
  parameter <- NULL
  bigger_zero <- NULL
  smaller_zero <- NULL
  lower <- NULL
  effect <- NULL
  upper <- NULL
  pH0 <- NULL
  FDR <- NULL
  n_eff <- NULL
  R_k_hat <- NULL
  
  .cell_group = enquo(.cell_group)
  
  draws =
    draws %>%
    group_by(!!.cell_group, M, parameter, rhat, ess_bulk, ess_tail) %>%
    summarise(
      lower = quantile(.value, false_positive_rate / 2),
      effect = quantile(.value, 0.5),
      upper = quantile(.value, 1 - (false_positive_rate / 2)),
      bigger_zero = sum(.value > test_composition_above_logit_fold_change),
      smaller_zero = sum(.value < -test_composition_above_logit_fold_change),
      # R_k_hat = unique(R_k_hat),
      # n_eff = unique(n_eff),
      n = n(),
      .groups = "drop"  # To ungroup the output if needed
    ) |> 
    
    # Calculate probability non 0
    mutate(pH0 =  (1 - (pmax(bigger_zero, smaller_zero) / n))) |>
    with_groups(parameter, ~ mutate(.x, FDR = get_FDR(pH0))) |>
    
    select(!!.cell_group, M, parameter, lower, effect, upper, pH0, FDR, any_of(c("n_eff", "R_k_hat", "rhat", "ess_bulk", "ess_tail"))) |>
    suppressWarnings()
  
  # Setting up names separately because |> is not flexible enough
  draws |>
    setNames(c(colnames(draws)[1:3], sprintf("%s%s", prefix, colnames(draws)[4:ncol(draws)])))
}

mutate_ignore_error = function(x, ...){
  tryCatch(
    {  x |> mutate(...) },
    error=function(cond) {  x  }
  )
}

#' @importFrom dplyr cummean
#' @noRd
get_FDR = function(x){
  
  # Define the variables as NULL to avoid CRAN NOTES
  value <- NULL
  name <- NULL
  FDR <- NULL
  
  
  enframe(x) %>%
    arrange(value) %>%
    mutate(FDR = cummean(value)) %>%
    arrange(name) %>%
    pull(FDR)
}

test_that("convergence metrics are available for both fixed effects and random effects", {
  # Skip if cmdstanr is not available
  skip_if_not(instantiate::stan_cmdstan_exists(), "cmdstanr not available")
  
  # Load test data
  data("counts_obj")
  
  # Test 1: Model with only fixed effects (no random effects)
  # This should have convergence metrics for all parameters
  fixed_only_model <- sccomp_estimate(
    counts_obj,
    ~ type, ~ 1, "sample", "cell_group", "count",
    cores = 1, verbose = FALSE
  ) |> 
  sccomp_test()
  
  # Check that fixed effects have convergence metrics
  fixed_effects <- fixed_only_model |> 
    filter(!str_detect(parameter, "___")) # Exclude random effects (which shouldn't exist here)
  
  expect_true(all(c("c_rhat", "c_ess_bulk", "c_ess_tail") %in% colnames(fixed_effects)))
  expect_true(all(!is.na(fixed_effects$c_rhat)))
  expect_true(all(!is.na(fixed_effects$c_ess_bulk)))
  expect_true(all(!is.na(fixed_effects$c_ess_tail)))
  
  # Test 2: Model with random effects using existing data structure
  # Use the existing 'type' variable as a grouping factor for random effects
  random_effects_model <- sccomp_estimate(
    counts_obj,
    ~ type + (1 | type), ~ 1, "sample", "cell_group", "count",
    cores = 1, verbose = FALSE
  ) |> 
  sccomp_test()
  
  # Separate fixed and random effects
  fixed_effects_re <- random_effects_model |> 
    filter(!str_detect(parameter, "___"))
  
  random_effects_re <- random_effects_model |> 
    filter(str_detect(parameter, "___"))
  
  # Check that fixed effects have convergence metrics
  expect_true(all(c("c_rhat", "c_ess_bulk", "c_ess_tail") %in% colnames(fixed_effects_re)))
  expect_true(all(!is.na(fixed_effects_re$c_rhat)))
  expect_true(all(!is.na(fixed_effects_re$c_ess_bulk)))
  expect_true(all(!is.na(fixed_effects_re$c_ess_tail)))
  
  # Check that random effects NOW HAVE convergence metrics
  expect_true(all(c("c_rhat", "c_ess_bulk", "c_ess_tail") %in% colnames(random_effects_re)))
  expect_true(all(!is.na(random_effects_re$c_rhat)))
  expect_true(all(!is.na(random_effects_re$c_ess_bulk)))
  expect_true(all(!is.na(random_effects_re$c_ess_tail)))
  
  # Test 3: Verify this applies to both composition and variability parameters
  # Model with variability formula
  variability_model <- sccomp_estimate(
    counts_obj,
    ~ type + (1 | type), ~ type, "sample", "cell_group", "count",
    cores = 1, verbose = FALSE
  ) |> 
  sccomp_test()
  
  # Check composition fixed effects
  comp_fixed <- variability_model |> 
    filter(!str_detect(parameter, "___") & str_detect(parameter, "^type"))
  
  expect_true(all(!is.na(comp_fixed$c_rhat)))
  
  # Check composition random effects
  comp_random <- variability_model |> 
    filter(str_detect(parameter, "___"))
  
  expect_true(all(!is.na(comp_random$c_rhat)))
  
  # Check variability fixed effects (should have convergence metrics)
  var_fixed <- variability_model |> 
    filter(!str_detect(parameter, "___") & str_detect(parameter, "^type"))
  
  expect_true(all(!is.na(var_fixed$v_rhat)))
  
  # Summary of findings
  cat("\nTest Results Summary:\n")
  cat("- Fixed effects: Convergence metrics available (rhat, ess_bulk, ess_tail)\n")
  cat("- Random effects: Convergence metrics NOW available (rhat, ess_bulk, ess_tail)\n")
  cat("- This applies to both composition (c_) and variability (v_) parameters\n")
}) 

library(testthat)
test_that("old .sample/.cell_group argument style works with placeholders", {
  skip_cmdstan()
  
  suppressPackageStartupMessages({
    library(dplyr)
  })

  test_data <- tibble::tribble(
    ~orig.ident, ~micro_conf, ~sex, ~age, ~manual_fine, ~count,
    "NS031", "yes", "F", 31, "Memory B cells", 155L,
    "NS031", "yes", "F", 31, "Naïve B cells", 18L,
    "NS031", "yes", "F", 31, "IGHG1+ plasma cells", 45L,
    "NS031", "yes", "F", 31, "IGHM+ memory B cells", 36L,
    "NS031", "yes", "F", 31, "IGKC+ plasma cells", 56L,
    "NS031", "yes", "F", 31, "IGHA+ memory B cells", 41L,
    "NS031", "yes", "F", 31, "IGLC1+ memory B cells", 14L,
    "NS031", "yes", "F", 31, "Plasmablasts", 12L,
    "NS031", "yes", "F", 31, "IGHM+ plasma cells", 2L,
    "NS031", "yes", "F", 31, "IGHD+ memory B cells", 4L,
    "MP075", "no", "M", 25, "Memory B cells", 136L,
    "MP075", "no", "M", 25, "Naïve B cells", 40L,
    "MP075", "no", "M", 25, "IGHG1+ plasma cells", 25L,
    "MP075", "no", "M", 25, "IGHM+ memory B cells", 58L,
    "MP075", "no", "M", 25, "IGKC+ plasma cells", 0L,
    "MP075", "no", "M", 25, "IGHA+ memory B cells", 0L,
    "MP075", "no", "M", 25, "IGLC1+ memory B cells", 0L,
    "MP075", "no", "M", 25, "Plasmablasts", 0L,
    "MP075", "no", "M", 25, "IGHM+ plasma cells", 0L,
    "MP075", "no", "M", 25, "IGHD+ memory B cells", 0L
  )

  res <- test_data |> 
       sccomp_estimate(
             formula_composition = ~ micro_conf,
             .sample = orig.ident,
             .cell_group = manual_fine,
             abundance = "count",
             cores = 1, verbose = FALSE
           ) |>
      sccomp_test()

  expect_s3_class(res, "sccomp_tbl")
})

#' Calculate Proportional Fold Change from sccomp Estimated Effects
#'
#' @description 
#' This function calculates the proportional fold change between two conditions using the estimated effects from a sccomp model.
#' The fold changes are derived from the model's posterior predictions rather than raw counts, providing a more robust estimate
#' that accounts for the model's uncertainty and covariate effects.
#' 
#' Note! This statistic is descriptive and should not be used to define significance - use sccomp_test() for that. 
#' While fold changes in proportions are easier to interpret than changes in logit space, they are not linear 
#' (the same proportional change has different meaning for rare vs abundant cell types). In contrast, 
#' the logit scale used internally by sccomp provides linear effects that are more appropriate for statistical inference.
#'
#' @param .data A sccomp estimate object (of class 'sccomp_tbl') obtained from running sccomp_estimate().
#'              This object contains the fitted model and estimated effects.
#' @param formula_composition The formula specifying which model effects to use for calculating fold changes.
#'                          This should match or be a subset of the formula used in the original sccomp_estimate() call.
#' @param from Character string specifying the reference/control condition (e.g., "benign").
#' @param to Character string specifying the comparison condition (e.g., "cancer").
#'
#' @return A tibble with the following columns:
#' \itemize{
#'   \item cell_group - The cell group identifier
#'   \item proportion_fold_change - The estimated fold change in proportions between conditions.
#'                                 Positive values indicate increases, negative values indicate decreases.
#'   \item average_uncertainty - The average uncertainty in the fold change estimate, derived from the credible intervals
#'   \item statement - A text description of the fold change, including the direction and the estimated proportions
#' }
#'
#' @examples
#' 
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#'
#' \donttest{
#' if (instantiate::stan_cmdstan_exists()) {
#'   # Load example data
#'   data("counts_obj")
#'
#'   # First estimate the composition effects
#'   estimate <- sccomp_estimate(
#'       counts_obj,
#'       ~ type,
#'       ~1,
#'       "sample",
#'       "cell_group",
#'       "count",
#'       cores = 1
#'   )
#'  
#'   # Calculate proportional fold changes from the estimated effects
#'   estimate |> 
#'   sccomp_proportional_fold_change(
#'     formula_composition = ~  type, 
#'     from = "benign", 
#'     to = "cancer"
#'   ) 
#' }
#' }
#' @export
sccomp_proportional_fold_change <- function(.data, formula_composition, from, to) {
  UseMethod("sccomp_proportional_fold_change", .data)
}

#' @export
#' 
#' @importFrom glue glue
#' 
sccomp_proportional_fold_change.sccomp_tbl = function(.data, formula_composition, from, to){
  
  my_factor = parse_formula(formula_composition)
  
  # Predict the composition for the specified conditions
  .data |> 
    sccomp_predict(
      formula_composition = formula_composition, 
      new_data = 
        tibble(sample=as.character(c(to, from)), factor = c(to, from)) |> 
        rename(!!my_factor := `factor`)
    ) |> 
    
    # Nest the predicted data by cell group
    nest(data = -!!.data |> attr(".cell_group")) |> 
    
    
    # Calculate the ratio of proportions between 'to' and 'from' conditions
    mutate(
      ratio_mean = map_dbl(
        data, 
        ~ {
          x = .x |> arrange(sample != !!from) |> pull(proportion_mean); 
          x[2]/x[1] })
    ) |> 
    mutate(
      proportion_from = map_dbl(data, ~.x |> filter(sample==from) |> pull(proportion_mean)),
      proportion_to = map_dbl(data, ~.x |> filter(sample!=from) |> pull(proportion_mean))
    ) |> 
    
    # Calculate the proportional fold change
    mutate(proportion_fold_change = if_else(ratio_mean<1, (-1/ratio_mean) , ratio_mean)) |> 
    
    # Calculate the ratio of credible interval between 'to' and 'from' conditions
    mutate(
      ratio_upper = map_dbl(
        data,  
        ~ {
          x = .x |> arrange(sample != !!from) |> pull(proportion_upper); 
          x[2]/x[1] }),
      ratio_lower = map_dbl(
        data, 
        ~ {
          x = .x |> arrange(sample != !!from) |> pull(proportion_lower); 
          x[2]/x[1] })
    ) |> 
    
    # Calculate the proportional fold change
    mutate(
      difference_proportion_upper_fold_change = if_else(ratio_mean<1, (-1/ratio_upper) , ratio_upper) - proportion_fold_change,
      difference_proportion_lower_fold_change = if_else(ratio_mean<1, (-1/ratio_lower) , ratio_lower) - proportion_fold_change
    ) |> 
    mutate(average_uncertainty = (abs(difference_proportion_upper_fold_change) + abs(difference_proportion_lower_fold_change))/2) |> 
    
    # Print expression
    mutate(increase_decrease = if_else(proportion_fold_change>0, "increase", "decrease")) |> 
    mutate(statement = glue("{round(abs(proportion_fold_change),1)}-fold {increase_decrease} (from {round(proportion_from, 4)} to {round(proportion_to, 4)})")) |> 
    
    # Select and return the relevant columns
    select(
      !!.data |> attr(".cell_group"), 
      proportion_fold_change, 
      average_uncertainty, 
      statement
    ) 
  
  
}

#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).

#' sccomp_predict
#'
#' @description This function replicates counts from a real-world dataset.
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
#' @param fit The result of sccomp_estimate.
#' @param formula_composition A formula. The formula describing the model for differential abundance, for example ~treatment. This formula can be a sub-formula of your estimated model; in this case all other factor will be factored out.
#' @param new_data A sample-wise data frame including the column that represent the factors in your formula. If you want to predict proportions for 10 samples, there should be 10 rows. T
#' @param number_of_draws An integer. How may copies of the data you want to draw from the model joint posterior distribution.
#' @param mcmc_seed An integer. Used for Markov-chain Monte Carlo reproducibility. By default a random number is sampled from 1 to 999999. This itself can be controlled by set.seed()
#' @param summary_instead_of_draws Return the summary values (i.e. mean and quantiles) of the predicted proportions, or return single draws. Single draws can be helful to better analyse the uncertainty of the prediction.
#' @param robust A logical. If TRUE, use robust statistics (median and median absolute deviation) instead of classical statistics (mean and standard deviation) for the summary calculations.
#'
#' @return A tibble (`tbl`) with the following columns:
#' \itemize{
#'   \item \strong{cell_group} - A character column representing the cell group being tested.
#'   \item \strong{sample} - A factor column representing the sample name for which the predictions are made.
#'   \item \strong{proportion_mean} - A numeric column representing the predicted mean (or median when robust=TRUE) proportions from the model.
#'   \item \strong{proportion_lower} - A numeric column representing the lower bound (2.5%) of the 95% credible interval for the predicted proportions.
#'   \item \strong{proportion_upper} - A numeric column representing the upper bound (97.5%) of the 95% credible interval for the predicted proportions.
#' }
#' 
#' @export
#'
#' @examples
#'
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists() && .Platform$OS.type == "unix") {
#'     data("counts_obj")
#'
#'     sccomp_estimate(
#'       counts_obj,
#'       ~ type, ~1, "sample", "cell_group", "count",
#'       cores = 1
#'     ) |>
#'     sccomp_predict()
#'   }
#' }
#' 
#'
sccomp_predict <- function(fit,
                           formula_composition = NULL,
                           new_data = NULL,
                           number_of_draws = 500,
                           mcmc_seed = sample_seed(),
                           summary_instead_of_draws = TRUE,
                           robust = FALSE) {
  
  
  # Run the function
  check_and_install_cmdstanr()
  
  
  UseMethod("sccomp_predict", fit)
}

#' @export
#'
sccomp_predict.sccomp_tbl = function(fit,
                                     formula_composition = NULL,
                                     new_data = NULL,
                                     number_of_draws = 500,
                                     mcmc_seed = sample_seed(),
                                     summary_instead_of_draws = TRUE,
                                     robust = FALSE){
  
  
  
  model_input = attr(fit, "model_input")
  .sample = attr(fit, ".sample")
  .cell_group = attr(fit, ".cell_group")
  
  rng =
    replicate_data(
      fit,
      formula_composition = formula_composition,
      formula_variability = ~ 1,
      new_data = new_data,
      number_of_draws = number_of_draws,
      mcmc_seed = mcmc_seed
    )
  
  # New data
  if(new_data |> is.null())
    new_data =
    fit |>
    attr("count_data") |>
    distinct() |> 
    .subset(!!.sample)
  
  # If seurat
  else if(new_data |> is("Seurat")) 
    new_data = new_data[[]] 
  
  sample_names =
    new_data |>
    distinct(!!.sample) |> 
    pull(!!.sample)
  
  # mean generated
  if(summary_instead_of_draws){
    
    prediction_df = 
      rng |>
      summary_to_tibble("mu", "M", "N", robust = robust) |>
      select(M, N, 
             
             # This is not great, consider making proportion_mean more general such as proportion_point_estimate
             proportion_mean = any_of(c("mean", "median")), 
             proportion_lower = `2.5%`, 
             proportion_upper = `97.5%`) 
  }

  else
    prediction_df = 
    rng |>
    draws_to_tibble_x_y("mu", "M", "N") |> 
    select(M, N, proportion = .value, .draw) 
  
  prediction_df = 
    prediction_df |>
    
    # Get sample name
    nest(data = -N) |>
    arrange(N) |>
    mutate(!!.sample := sample_names) |>
    unnest(data) |>
    
    # get cell type name
    nest(data = -M) |>
    mutate(!!.cell_group := colnames(model_input$y)) |>
    unnest(data) |>
    
    select(-N, -M) |>
    select(!!.cell_group, !!.sample, everything())
  
  new_data |> 
    left_join(prediction_df, by = join_by(!!.sample))
}

# Define global variable
# sccomp_stan_models_cache_dir = file.path(path.expand("~"), ".sccomp_models", packageVersion("sccomp"))



# Define global variable (without version - version will be added in load_model when needed)
#' Default cache directory for Stan models
#' 
#' A global variable that defines the default cache directory for Stan models used by the sccomp package.
#' This directory is used to store compiled Stan models to avoid recompilation on subsequent runs.
#' 
#' @details
#' The cache directory is set to \code{~/.sccomp_models} by default. This location is used by
#' various sccomp functions to store and retrieve compiled Stan models, improving performance
#' by avoiding unnecessary recompilation of models that have already been compiled.
#' 
#' Users can override this default by specifying a different cache directory in function calls
#' that accept a \code{cache_stan_model} parameter.
#' 
#' @return A character string containing the path to the default cache directory.
#' 
#' @examples
#' # View the default cache directory
#' sccomp_stan_models_cache_dir
#' 
#' # Use a custom cache directory in a function call
#' # sccomp_estimate(data, cache_stan_model = "/path/to/custom/cache")
#' 
#' @seealso
#' \code{\link{sccomp_estimate}}, \code{\link{sccomp_replicate}}, \code{\link{clear_stan_model_cache}}
#' 
#' @export
sccomp_stan_models_cache_dir = file.path(path.expand("~"), ".sccomp_models")

#' Add attribute to abject
#'
#' @keywords internal
#' @noRd
#'
#'
#' @param var A tibble
#' @param attribute An object
#' @param name A character name of the attribute
#'
#' @return A tibble with an additional attribute
add_attr = function(var, attribute, name) {
  attr(var, name) <- attribute
  var
}


#' Formula parser
#'
#' @param fm A formula
#'
#' @importFrom stringr str_subset
#' @importFrom magrittr extract2
#' @importFrom stats terms
#'
#' @return A character vector
#'
#' @keywords internal
#' @noRd
parse_formula <- function(fm) {
  stopifnot("The formula must be of the kind \"~ factors\" " = attr(terms(fm), "response") == 0)
  
  as.character(attr(terms(fm), "variables")) |>
    str_subset("\\|", negate = TRUE) %>%
    
    # Does not work the following
    # |>
    # extract2(-1)
    .[-1]
}


#' Formula parser
#'
#' @param fm A formula
#'
#' @importFrom stringr str_subset
#' @importFrom stringr str_split
#' @importFrom stringr str_remove_all
#' @importFrom rlang set_names
#' @importFrom purrr map_dfr
#' @importFrom stringr str_trim
#'
#' @importFrom magrittr extract2
#'
#' @return A character vector
#'
#' @keywords internal
#' @noRd
formula_to_random_effect_formulae <- function(fm) {
  
  # Define the variables as NULL to avoid CRAN NOTES
  formula <- NULL
  
  stopifnot("The formula must be of the kind \"~ factors\" " = attr(terms(fm), "response") == 0)
  
  random_effect_elements =
    as.character(attr(terms(fm), "variables")) |>
    
    # Select random intercept part
    str_subset("\\|")
  
  if(length(random_effect_elements) > 0){
    
    random_effect_elements |>
      
      # Divide grouping from factors
      str_split("\\|") |>
      
      # Set name
      map_dfr(~ .x |> set_names(c("formula", "grouping"))) |>
      
      # Create formula
      mutate(formula = map(formula, ~ formula(glue("~ {.x}")))) |>
      mutate(grouping = grouping |> str_trim())
    
  }
  
  else
    tibble(`formula` = list(), grouping = character())
  
}

#' Formula parser
#'
#' @param fm A formula
#'
#' @importFrom stringr str_subset
#' @importFrom stringr str_split
#' @importFrom stringr str_remove_all
#' @importFrom rlang set_names
#' @importFrom purrr map_dfr
#'
#' @importFrom magrittr extract2
#'
#' @return A character vector
#'
#' @keywords internal
#' @noRd
parse_formula_random_effect <- function(fm) {
  
  # Define the variables as NULL to avoid CRAN NOTES
  formula <- NULL
  
  stopifnot("The formula must be of the kind \"~ factors\" " = attr(terms(fm), "response") == 0)
  
  random_effect_elements =
    as.character(attr(terms(fm), "variables")) |>
    
    # Select random intercept part
    str_subset("\\|")
  
  if(length(random_effect_elements) > 0){
    
    formula_to_random_effect_formulae(fm) |>
      
      # Divide factors
      mutate(factor = map(
        formula,
        ~
          # Attach intercept
          .x |>
          terms() |>
          attr("intercept") |>
          str_replace("^1$", "(Intercept)") |>
          str_subset("0", negate = TRUE) |>
          
          # Attach variables
          c(
            .x |>
              terms() |>
              attr("variables") |>
              as.character() |>
              str_split("\\+") |>
              as.character() %>%
              .[-1]
          )
      )) |>
      unnest(factor)
    
  }
  
  else
    tibble(factor = character(), grouping = character())
  
}

#' Get matrix from tibble
#'
#' @import dplyr
#'
#' @keywords internal
#' @noRd
#'
#' @import dplyr
#' @importFrom purrr as_mapper
#'
#' @param .x A tibble
#' @param .p A boolean
#' @param .f1 A function
#' @param .f2 A function
#'
#' @return A tibble
# REMOVED: ifelse_pipe function, conditional_apply function, and as_matrix function




#' draws_to_tibble_x_y
#'
#' @importFrom tidyr pivot_longer
#' @importFrom rlang :=
#'
#' @param fit A fit object
#' @param par A character vector. The parameters to extract.
#' @param x A character. The first index.
#' @param y A character. The first index.
#'
#' @keywords internal
#' @noRd
draws_to_tibble_x_y = function(fit, par, x, y, number_of_draws = NULL) {
  
  # Define the variables as NULL to avoid CRAN NOTES
  dummy <- NULL
  .variable <- NULL
  .chain <- NULL
  .iteration <- NULL
  .draw <- NULL
  .value <- NULL

  
  fit$draws(variables = par, format = "draws_df") %>%
    mutate(.iteration = seq_len(n())) %>%
    
    pivot_longer(
      names_to = "parameter", # c( ".chain", ".variable", x, y),
      cols = contains(par),
      #names_sep = "\\.?|\\[|,|\\]|:",
      # names_ptypes = list(
      #   ".variable" = character()),
      values_to = ".value"
    ) %>%
    tidyr::extract(parameter, c(".chain", ".variable", x, y), "([1-9]+)?\\.?([a-zA-Z0-9_\\.]+)\\[([0-9]+),([0-9]+)") |> 
    
    # Warning message:
    # Expected 5 pieces. Additional pieces discarded
    suppressWarnings() %>%
    
    mutate(
      !!as.symbol(x) := as.integer(!!as.symbol(x)),
      !!as.symbol(y) := as.integer(!!as.symbol(y))
    ) %>%
    arrange(.variable, !!as.symbol(x), !!as.symbol(y), .chain) %>%
    group_by(.variable, !!as.symbol(x), !!as.symbol(y)) %>%
    mutate(.draw = seq_len(n())) %>%
    ungroup() %>%
    select(!!as.symbol(x), !!as.symbol(y), .chain, .iteration, .draw ,.variable ,     .value) %>%
    filter(.variable == par)
  
}


#' @importFrom tidyr separate
#' @importFrom purrr when
#' 
#' @param fit A fit object from a statistical model from 'cmdstanr' package.
#' @param par A character vector specifying the parameters to extract from the fit object.
#' @param x A character string specifying the first index variable name in the parameter names.
#' @param y A character string specifying the second index variable name in the parameter names (optional). If NULL, the function will attempt to parse both indices from the parameter names.
#' @param probs A numerical vector specifying the quantiles to extract. Default is c(0.025, 0.25, 0.50, 0.75, 0.975).
#' @param robust A logical value indicating whether to use robust statistics (median and MAD) instead of mean and standard deviation. Default is FALSE.
#' 
#' @return A tibble containing the summary statistics for the specified parameters, with separate columns for the parsed indices.
#' 
#' @details This function extracts summary statistics from a fitted model and parses parameter names 
#' that contain indices (e.g., "beta[1,2]") into separate columns. It supports both classical 
#' (mean/sd) and robust (median/mad) summary statistics.
#' 
#' @keywords internal
#' @noRd
summary_to_tibble = function(fit, par, x, y = NULL, probs = c(0.025, 0.25, 0.50, 0.75, 0.975), robust = FALSE) {
  
  # Avoid bug
  #if(fit@stan_args[[1]]$method %>% is.null) fit@stan_args[[1]]$method = "hmc"
  
  # Choose between robust and classical summary statistics
  if(!robust)
    # Use classical statistics: mean, standard deviation, and quantiles
    summary = 
      fit$summary(variables = par, "mean", "sd", ~ quantile(.x, probs = probs,  na.rm=TRUE), "rhat", "ess_bulk", "ess_tail") %>%
      rename(.variable = variable ) 
  else
    # Use robust statistics: median, median absolute deviation, and quantiles
    summary = 
      fit$summary(variables = par, "median", "mad", ~ quantile(.x, probs = probs,  na.rm=TRUE), "rhat", "ess_bulk", "ess_tail") %>%
      rename(.variable = variable ) 
  
  # Parse parameter names that contain indices (e.g., "beta[1,2]")
  if(is.null(y))
    # If y is not provided, extract both x and y indices from parameter names
    summary |> 
      tidyr::separate(col = .variable,  into = c(".variable", x, y), sep="\\[|,|\\]", convert = TRUE, extra="drop")
  else
    # If y is provided, still extract both indices (y parameter is ignored in this case)
    # This maintains consistency in the output format regardless of whether y is provided
    summary |> 
      tidyr::separate(col = .variable,  into = c(".variable", x, y), sep="\\[|,|\\]", convert = TRUE, extra="drop")

  
}


#' Get Random Intercept Design 3
#'
#' This function processes the formula composition elements in the data and creates design matrices
#' for random intercept models.
#'
#' @param .data_ A data frame containing the data.
#' @param .sample A quosure representing the sample variable.
#' @param formula_composition A data frame containing the formula composition elements.
#' 
#' @return A data frame with the processed design matrices for random intercept models.
#' 
#' @importFrom glue glue
#' @importFrom magrittr subtract
#' @importFrom purrr map2
#' @importFrom dplyr mutate
#' @importFrom dplyr select
#' @importFrom dplyr pull
#' @importFrom dplyr filter
#' @importFrom dplyr left_join
#' @importFrom dplyr mutate_all
#' @importFrom dplyr mutate_if
#' @importFrom dplyr as_tibble
#' @importFrom tidyr pivot_longer
#' @importFrom rlang enquo
#' @importFrom rlang quo_name
#' @importFrom tidyselect all_of
#' @importFrom readr type_convert
#' @importFrom tibble rownames_to_column
#' @importFrom tidyr pivot_longer
#' @importFrom magrittr not
#' @importFrom tibble deframe
#' @importFrom tibble column_to_rownames
#' @noRd
get_random_effect_design3 = function(
  .data_, formula, grouping, .sample, 
  accept_NA_as_average_effect = FALSE 
){
  
  # Define the variables as NULL to avoid CRAN NOTES
  .sample = enquo(.sample)
  
  mydesign = .data_ |> get_design_matrix(formula, !!.sample, accept_NA_as_average_effect = accept_NA_as_average_effect)
  
  # Create a matrix of group assignments
  group_matrix = .data_ |> 
    select(all_of(grouping)) |> 
    pull(1) |> 
    rep(ncol(mydesign)) |> 
    matrix(ncol = ncol(mydesign))
  
  # Create a mask where design matrix has non-zero values
  mask = mydesign != 0
  
  # Apply mask to group matrix (setting non-masked values to "")
  group_matrix[!mask] = ""
  
  # Handle NAs in group matrix
  if(accept_NA_as_average_effect) {
    # For rows with NA in grouping, set group to "NA"
    group_matrix[is.na(group_matrix)] = "NA"
  }
  
  colnames(group_matrix) = colnames(mydesign)
  rownames(group_matrix) = rownames(mydesign)
  
  # Create the result matrix
  result = matrix(0, nrow = nrow(mydesign), ncol = ncol(mydesign))
  rownames(result) = rownames(mydesign)
  colnames(result) = colnames(mydesign)
  
  # For each column in the design matrix
  for(col in seq_len(ncol(mydesign))) {
    # Get the non-zero values and their corresponding groups
    non_zero = mydesign[, col] != 0
    if(any(non_zero)) {
      # Set the values in the result matrix
      result[non_zero, col] = mydesign[non_zero, col]
    }
  }
  
  # Convert to long format with the correct column names
  result_long = result |>
    as.data.frame() |>
    rownames_to_column(quo_name(.sample)) |>
    pivot_longer(-!!.sample, names_to = "factor", values_to = "value") |>
    filter(value != 0) |>
    mutate(
      group___label = paste0(factor, "___", group_matrix[cbind(!!.sample, factor)]),
      group___numeric = as.integer(factor(group___label)),
      factor___numeric = as.integer(factor(factor))
    ) |>
    select(!!.sample, group___label, group___numeric, value)
  
  result_long
}

#' @importFrom glue glue
#' @importFrom dplyr select
#' @importFrom dplyr mutate
#' @importFrom dplyr across
#' @importFrom dplyr pull
#' @importFrom dplyr where
#' @importFrom rlang enquo
#' @noRd
get_design_matrix = function(.data_spread, formula, .sample, accept_NA_as_average_effect = FALSE){
  
  .sample = enquo(.sample)
  
  .data_spread = .data_spread %>%
    
    select(!!.sample, parse_formula(formula)) |>
    mutate(across(where(is.numeric),  scale)) 

  # Check for NAs in the data
  has_na = any(is.na(.data_spread |> select(parse_formula(formula))))
  
  # If NAs are present and we don't accept them as average effects, throw an error
  if(has_na && !accept_NA_as_average_effect){
    stop("sccomp says: NA values are present in the design matrix factors. Set accept_NA_as_average_effect = TRUE to handle NAs as average effects across factor levels.")
  }

  # Check if we should handle NAs as average effects
  if(accept_NA_as_average_effect && has_na){
    return(get_design_matrix_with_na_handling(.data_spread, formula, !!.sample))
  }
  
  design_matrix =
    .data_spread |>
    model.matrix(formula, data=_)
  
  rownames(design_matrix) = .data_spread |> pull(!!.sample)
  
  design_matrix
}

#' @description
#' This function handles NA values in a special way for design matrices.
#' When NA values are present in categorical variables (factors or characters), they are treated as a separate
#' level "NA" initially, but then this level is removed from the design matrix. For rows with NA values,
#' the function sets equal weights (0.5) across all remaining factor levels. This approach allows for modeling
#' the average effect across all levels of a factor when the specific level is unknown or missing, rather than
#' excluding these observations or treating NA as its own distinct category. This is particularly useful when
#' you want to include observations with missing factor values but don't want to bias the model toward any
#' particular level of that factor.
#' 
#' @param .data_spread A data frame containing the data.
#' @param formula The formula to use for creating the design matrix.
#' @param .sample A quosure representing the sample variable.
#' 
#' @return A design matrix with rows named by the sample variable.
#' 
#' @importFrom dplyr select
#' @importFrom dplyr mutate
#' @importFrom dplyr across
#' @importFrom dplyr pull
#' @importFrom dplyr where
#' @importFrom rlang enquo
#' @noRd
get_design_matrix_with_na_handling = function(.data_spread, formula, .sample){
  
  .sample = enquo(.sample)
  
  # Convert NA to a factor level "NA" for categorical variables
  data_with_na <- handle_missing_values(.data_spread)
  
  # Create design matrix
  design_matrix = model.matrix(formula, data = data_with_na, na.action = NULL)
  
  # Here I get
 # design_matrix |> tail()
 #  (Intercept) group2__GROUP22 typehealthy typeNA group2__GROUP22:typehealthy group2__GROUP22:typeNA
 # 16           1               0           0      0                           0                      0
 # 17           1               1           0      0                           0                      0
 # 18           1               0           0      0                           0                      0
 # 19           1               0           1      0                           0                      0
 # 20           1               0           1      0                           0                      0
 # 21           1               0           0      1                           0                      0

# Split the design matrix into two parts:
# 1. The part that is not affected by NA values
# 2. The columns that are affected by NA values


na_rows = which(rowSums(design_matrix[, grep("NA$|NA:", colnames(design_matrix)), drop=FALSE]) > 0) |> unique()

# Loop over na_rows and calculate the fraction contribution for each row
for(row in na_rows) { 

  # Select the columns that are affected by NA values and also have a non-zero value in the design matrix
  na_cols = grep("NA$|NA:", colnames(design_matrix[row, , drop = FALSE]))
  na_cols = na_cols[design_matrix[row, na_cols] != 0]
  
  if(length(na_cols) == 0) next
  
  my_design_matrix = design_matrix[row,, drop = FALSE]
 
  fraction_contribution = calculate_na_fraction_contribution(my_design_matrix, na_cols, design_matrix, data_with_na)

  # Now for every row in fraction_contribution, I want to add the fraction contribution to the design matrix according to the factor_name
  for(fraction_contribution_row in 1:nrow(fraction_contribution)) {
    my_col = which(colnames(design_matrix) == (fraction_contribution[fraction_contribution_row,,drop=FALSE] |> select(all_of("factor_name")) |> pull(1)))
    design_matrix[row, my_col] = design_matrix[row, my_col] + (fraction_contribution[fraction_contribution_row,,drop=FALSE] |> select(all_of("fraction_contribution")) |> pull(1))
  }
}

rownames(design_matrix) = .data_spread |> pull(!!.sample)
design_matrix[,grep("NA$|NA:", colnames(design_matrix), invert = TRUE), drop=FALSE]

}

#' Calculate fraction contribution for NA values in design matrix
#'
#' This function calculates how to distribute the effect of NA values across all possible factor levels.
#' For each column in the design matrix that contains NA values (either directly or in interactions),
#' it:
#' 1. Splits the column name into its components
#' 2. For each component containing "NA", replaces it with all possible factor levels
#' 3. Creates all possible combinations of these levels
#' 4. Calculates the fraction of the effect that should be attributed to each combination
#' 5. Filters to only keep combinations that exist in the original design matrix
#'
#' @param design_with_na A matrix containing columns with NA values
#' @param design_matrix The original design matrix
#' @param data_with_na The data frame containing the original data with NA values handled
#'
#' @importFrom stringr str_remove
#' @importFrom stringr str_split
#' @importFrom stringr str_replace_all
#' @importFrom tidyr crossing
#' @importFrom tibble enframe
#' @importFrom dplyr rowwise
#' @importFrom dplyr c_across
#' @importFrom dplyr filter
#' @importFrom dplyr select
#' @importFrom dplyr matches
#' @importFrom dplyr all_of
#' @importFrom purrr map
#' @importFrom purrr reduce
#' 
#' @return A list of tibbles, each containing the factor combinations and their fraction contributions
#' @noRd
calculate_na_fraction_contribution = function(my_design_matrix, na_cols, design_matrix, data_with_na) {
  
  design_with_na = my_design_matrix[, na_cols, drop = FALSE]
  
  map(colnames(design_with_na), function(col) {
    
    list_of_contributions = 
      str_split(col, ":", simplify = TRUE) |>
      map(function(x) {

        factor_name = x[1] |> str_remove("NA$")
        
        # Now I want to count the possible values of the factor in the input data
        if(data_with_na[[factor_name]] |> is.numeric())
          factor_levels = factor_name
        else{
          factor_levels = levels(factor(data_with_na[[factor_name]]))
          factor_levels = factor_levels[factor_levels != "NA"]
          if(factor_levels |> length() == 0) factor_levels = ""
        }
       
        
        str_replace_all(x, "NA", factor_levels) |> 
          enframe(value = "factor_name") |> 
          select(-name) |> 
          mutate(fraction_contribution = 1/n()) |> 
          mutate(fraction_contribution = fraction_contribution * my_design_matrix[,x ])
      }) 
    
    # Parse contribution
    list_of_contributions |>
      
      purrr::reduce(crossing,  .name_repair = "unique")  |> 
      suppressMessages() |> 
      rowwise() |> 
      mutate(
        fraction_contribution = prod( c_across(matches("fraction_contribution")) ),
        factor_name = paste0( c_across(matches("factor_name")), collapse=":" )
      ) |> 
      
      filter(factor_name %in% colnames(design_matrix)) |> 
      select(factor_name, fraction_contribution)
  }) |>
    
    bind_rows()
}



#' @importFrom purrr when
#' @importFrom stats model.matrix
#' @importFrom tidyr expand_grid
#' @importFrom stringr str_detect
#' @importFrom stringr str_remove_all
#' @importFrom purrr reduce
#' @importFrom purrr map_int
#' @importFrom stats as.formula
#'
#' @keywords internal
#' @noRd
#'
data_spread_to_model_input =
  function(
    .data_spread, formula, .sample, .cell_group, .count,
    truncation_ajustment = 1, approximate_posterior_inference,
    formula_variability = ~ 1,
    contrasts = NULL,
    bimodal_mean_variability_association = FALSE,
    use_data = TRUE,
    random_effect_elements,
    accept_NA_as_average_effect = FALSE){
    
    # Define the variables as NULL to avoid CRAN NOTES
    exposure <- NULL
    design <- NULL
    mat <- NULL
    factor___numeric <- NULL
    mean_idx <- NULL
    design_matrix <- NULL
    minus_sum <- NULL
    group___numeric <- NULL
    idx <- NULL
    group___label <- NULL
    parameter <- NULL
    group <- NULL
    design_matrix_col <- NULL
    
    # Prepare column same enquo
    .sample = enquo(.sample)
    .cell_group = enquo(.cell_group)
    .count = enquo(.count)
    .grouping_for_random_effect =
      random_effect_elements |>
      pull(grouping) |>
      unique() 
    
    if (length(.grouping_for_random_effect)==0 ) .grouping_for_random_effect = "random_effect"
    
    
    X  =
      
      .data_spread |>
      get_design_matrix(
        # Drop random intercept
        formula |>
          as.character() |>
          str_remove_all("\\+ ?\\(.+\\|.+\\)") |>
          paste(collapse="") |>
          as.formula(),
        !!.sample,
        accept_NA_as_average_effect = accept_NA_as_average_effect
      )
    
    Xa  =
      .data_spread |>
      get_design_matrix(
        # Drop random intercept
        formula_variability |>
          as.character() |>
          str_remove_all("\\+ ?\\(.+\\|.+\\)") |>
          paste(collapse="") |>
          as.formula() ,
        !!.sample,
        accept_NA_as_average_effect = accept_NA_as_average_effect
      )
    
    XA = Xa %>%
      as_tibble() %>%
      distinct()
    
    A = ncol(XA);
    Ar = nrow(XA);
    
    factor_names = parse_formula(formula)
    factor_names_variability = parse_formula(formula_variability)
    cell_cluster_names = .data_spread %>% select(-!!.sample, -any_of(factor_names), -exposure, -!!.grouping_for_random_effect) %>% colnames()
    
    # Random intercept
    if(nrow(random_effect_elements)>0 ) {
      
      
      #check_random_effect_design(.data_spread, any_of(factor_names), random_effect_elements, formula, X)
      random_effect_grouping = formula |>
        formula_to_random_effect_formulae() |>
        mutate(design = map2(
          formula, grouping,
          ~ {
            get_random_effect_design3(.data_spread, .x, .y, !!.sample )
          }))
      
      # Actual parameters, excluding for the sum to one parameters
      is_random_effect = 1
      
      random_effect_grouping =
        random_effect_grouping |>
        mutate(design_matrix = map(
          design,
          ~ ..1 |>
            select(!!.sample, group___label, value) |>
            pivot_wider(names_from = group___label, values_from = value) |>
            mutate(across(everything(), ~ .x |> replace_na(0)))
        )) 
      
      
      X_random_effect = 
        random_effect_grouping |> 
        pull(design_matrix) |> 
        _[[1]]  |>  
        column_to_rownames(quo_name(.sample))
      
      # Separate NA group column into X_random_effect_unseen
      X_random_effect_unseen = X_random_effect[, colnames(X_random_effect) |> str_detect("___NA$"), drop = FALSE]
      X_random_effect = X_random_effect[, !colnames(X_random_effect) |> str_detect("___NA$"), drop = FALSE]
      
      # For now that stan does not have tuples, I just allow max two levels
      if(random_effect_grouping |> nrow() > 2) stop("sccomp says: at the moment sccomp allow max two groupings")
      # This will be modularised with the new stan
      if(random_effect_grouping |> nrow() > 1){
        X_random_effect_2 =   
          random_effect_grouping |> 
          pull(design_matrix) |> 
          _[[2]] |>  
          column_to_rownames(quo_name(.sample))
        
        # Separate NA group column into X_random_effect_2_unseen  
        X_random_effect_2_unseen = X_random_effect_2[, colnames(X_random_effect_2) |> str_detect("___NA$"), drop = FALSE]
        X_random_effect_2 = X_random_effect_2[, !colnames(X_random_effect_2) |> str_detect("___NA$"), drop = FALSE]
      }
      
      else X_random_effect_2 =  X_random_effect[,0,drop=FALSE]
      
      n_random_eff = random_effect_grouping |> nrow()
      
      ncol_X_random_eff = c(ncol(X_random_effect), ncol(X_random_effect_2))
      
      # TEMPORARY
      group_factor_indexes_for_covariance = 
        X_random_effect |> 
        colnames() |> 
        enframe(value = "parameter", name = "order")  |> 
        separate(parameter, c("factor", "group"), "___", remove = FALSE) |> 
        complete(factor, group, fill = list(order=0)) |> 
        select(-parameter) |> 
        pivot_wider(names_from = group, values_from = order)  |> 
        column_to_rownames("factor") |> as.matrix()

      
      
      n_groups = group_factor_indexes_for_covariance |> ncol()
      
      # This will be modularised with the new stan
      if(random_effect_grouping |> nrow() > 1)
        group_factor_indexes_for_covariance_2 = 
        X_random_effect_2 |> 
        colnames() |> 
        enframe(value = "parameter", name = "order")  |> 
        separate(parameter, c("factor", "group"), "___", remove = FALSE) |> 
        complete(factor, group, fill = list(order=0)) |> 
        select(-parameter) |> 
        pivot_wider(names_from = group, values_from = order)  |> 
        column_to_rownames("factor") |> as.matrix()
      else group_factor_indexes_for_covariance_2 = matrix()[0,0, drop=FALSE]
      
      n_groups = n_groups |> c(group_factor_indexes_for_covariance_2 |> ncol())
      
      how_many_factors_in_random_design = list(group_factor_indexes_for_covariance, group_factor_indexes_for_covariance_2) |> map_int(nrow)
      
      
    } else {
      X_random_effect = matrix(rep(1, nrow(.data_spread)))[,0, drop=FALSE]
      X_random_effect_2 = matrix(rep(1, nrow(.data_spread)))[,0, drop=FALSE] # This will be modularised with the new stan
      is_random_effect = 0
      ncol_X_random_eff = c(0,0)
      n_random_eff = 0
      n_groups = c(0,0)
      how_many_factors_in_random_design = c(0,0)
      group_factor_indexes_for_covariance = matrix()[0,0, drop=FALSE]
      group_factor_indexes_for_covariance_2 = matrix()[0,0, drop=FALSE] # This will be modularised with the new stan
    }
    
    
    y = .data_spread %>% select(-any_of(factor_names), -exposure, -!!.grouping_for_random_effect) %>% column_to_rownames(quo_name(.sample)) %>% as.matrix()
    
    # If proportion ix 0 issue
    is_proportion = y |> as.numeric() |> max()  |> between(0,1) |> all()
    if(is_proportion){
      y_proportion = y
      y = y[0,,drop = FALSE]
    }
    else{
      y = y
      y_proportion = y[0,,drop = FALSE]
    }
    
    data_for_model =
      list(
        N = .data_spread %>% nrow(),
        M = .data_spread %>% select(-!!.sample, -any_of(factor_names), -exposure, -!!.grouping_for_random_effect) %>% ncol(),
        exposure = .data_spread$exposure,
        is_proportion = is_proportion,
        y = y,
        y_proportion = y_proportion,
        X = X,
        XA = XA,
        Xa = Xa,
        C = ncol(X),
        A = A,
        Ar = Ar,
        truncation_ajustment = truncation_ajustment,
        is_vb = as.integer(approximate_posterior_inference),
        bimodal_mean_variability_association = bimodal_mean_variability_association,
        use_data = use_data,
        
        # Random intercept
        is_random_effect = is_random_effect,
        ncol_X_random_eff = ncol_X_random_eff,
        n_random_eff = n_random_eff,
        n_groups  = n_groups,
        X_random_effect = X_random_effect,
        X_random_effect_2 = X_random_effect_2,
        group_factor_indexes_for_covariance = group_factor_indexes_for_covariance,
        group_factor_indexes_for_covariance_2 = group_factor_indexes_for_covariance_2,
        how_many_factors_in_random_design = how_many_factors_in_random_design,
        
        # For parallel chains
        grainsize = 1,
        
        ## LOO
        enable_loo = FALSE
      )
    
    # Add censoring
    data_for_model$is_truncated = 0
    data_for_model$truncation_up = matrix(rep(-1, data_for_model$M * data_for_model$N), ncol = data_for_model$M)
    data_for_model$truncation_down = matrix(rep(-1, data_for_model$M * data_for_model$N), ncol = data_for_model$M)
    data_for_model$truncation_not_idx = seq_len(data_for_model$M*data_for_model$N)
    data_for_model$TNS = length(data_for_model$truncation_not_idx)
    data_for_model$truncation_not_idx_minimal = matrix(c(1,1), nrow = 1)[0,,drop=FALSE]
    data_for_model$TNIM = 0
    
    # Add parameter factor dictionary
    data_for_model$factor_parameter_dictionary = tibble()
    
    if(.data_spread  |> select(any_of(parse_formula(formula))) |> lapply(class) %in% c("factor", "character") |> any())
      data_for_model$factor_parameter_dictionary =
      data_for_model$factor_parameter_dictionary |> bind_rows(
        # For discrete
        .data_spread  |>
          select(any_of(parse_formula(formula)))  |>
          distinct()  |>
          
          # Drop numerical
          select_if(function(x) !is.numeric(x)) |>
          pivot_longer(everything(), names_to =  "factor", values_to = "parameter") %>%
          unite("design_matrix_col", c(`factor`, parameter), sep="", remove = FALSE)  |>
          select(-parameter) |>
          filter(design_matrix_col %in% colnames(data_for_model$X)) %>%
          distinct()
        
      )
    
    # For continuous
    if(.data_spread  |> select(all_of(parse_formula(formula))) |> lapply(class) |> equals("numeric") |> any())
      data_for_model$factor_parameter_dictionary =
      data_for_model$factor_parameter_dictionary |>
      bind_rows(
        tibble(
          design_matrix_col =  .data_spread  |>
            select(all_of(parse_formula(formula)))  |>
            distinct()  |>
            
            # Drop numerical
            select_if(function(x) is.numeric(x)) |>
            names()
        ) |>
          mutate(`factor` = design_matrix_col)
      )
    
    # If constrasts is set it is a bit more complicated
    if(! is.null(contrasts))
      data_for_model$factor_parameter_dictionary =
      data_for_model$factor_parameter_dictionary |>
      distinct() |>
      expand_grid(parameter=contrasts) |>
      filter(str_detect(parameter, design_matrix_col )) |>
      select(-design_matrix_col) |>
      rename(design_matrix_col = parameter) |>
      distinct()
    
    data_for_model$intercept_in_design = X[,1] |> unique() |> identical(1)
    
    
    if (data_for_model$intercept_in_design | length(factor_names_variability) == 0) {
      data_for_model$A_intercept_columns = 1
    } else {
      data_for_model$A_intercept_columns = 
        .data_spread |> 
        select(any_of(factor_names[1])) |> 
        distinct() |> 
        nrow()
    }
    
    
    if (data_for_model$intercept_in_design ) {
      data_for_model$B_intercept_columns = 1
    } else {
      data_for_model$B_intercept_columns = 
        .data_spread |> 
        select(any_of(factor_names[1])) |> 
        distinct() |> 
        nrow()
    }
    
    # Default all grouping known. This is used for data generation to estimate unknown groupings.
    data_for_model$unknown_grouping = c(FALSE, FALSE)
    
    
    # Return
    data_for_model
  }



contrasts_to_parameter_list = function(contrasts, drop_back_quotes = TRUE){
  
  if(is.null(names(contrasts)))
    names(contrasts) <- contrasts
  
  contrast_list <-
    contrasts |>
    
    # Remove fractions used in multiplication before or after '*'
    str_remove_all_ignoring_if_inside_backquotes("([0-9]+/[0-9]+ ?\\* ?)|(\\* ?[0-9]+/[0-9]+)") |>
    
    # Remove decimals used in multiplication before or after '*'
    str_remove_all_ignoring_if_inside_backquotes("([-+]?[0-9]+\\.[0-9]+ ?\\* ?)|(\\* ?[-+]?[0-9]+\\.[0-9]+)") |>
    
    # Remove fractions used in divisions
    str_remove_all_ignoring_if_inside_backquotes("/ ?[0-9]+") |>
    
    # Remove standalone numerical constants not inside backquotes
    str_remove_all_ignoring_if_inside_backquotes("\\b[0-9]+\\b") |>
    
    # Split by "+", "-", "*", "/"
    str_split_ignoring_if_inside_backquotes("\\+|-|\\*|/") |>
    unlist() |>
    
    # Remove parentheses and spaces
    str_remove_all_ignoring_if_inside_backquotes("[\\(\\) ]") |>
    
    # Remove empty strings
    {\(x) x[x != ""]}()
  
  if(drop_back_quotes)
    contrast_list <-
    contrast_list |>
    str_remove_all("`")
  
  contrast_list |> unique()
}








#' chatGPT - Remove Specified Regex Pattern from Each String in a Vector
#'
#' This function takes a vector of strings and a regular expression pattern.
#' It removes occurrences of the pattern from each string, except where the pattern
#' is found inside backticks. The function returns a vector of cleaned strings.
#'
#' @param text_vector A character vector with the strings to be processed.
#' @param regex A character string containing a regular expression pattern to be removed
#' from the text.
#'
#' @return A character vector with the regex pattern removed from each string.
#' Occurrences of the pattern inside backticks are not removed.
#'
#' @examples
#' texts <- c("A string with (some) parentheses and `a (parenthesis) inside` backticks",
#'            "Another string with (extra) parentheses")
#' cleaned_texts <- str_remove_all_ignoring_if_inside_backquotes(texts, "\\(")
#' print(cleaned_texts)
#' 
#' @noRd
str_remove_all_ignoring_if_inside_backquotes <- function(text_vector, regex) {
  # Nested function to handle regex removal for a single string
  remove_regex_chars <- function(text, regex) {
    inside_backticks <- FALSE
    result <- ""
    skip <- 0
    
    chars <- strsplit(text, "")[[1]]
    for (i in seq_along(chars)) {
      if (skip > 0) {
        skip <- skip - 1
        next
      }
      
      char <- chars[i]
      if (char == "`") {
        inside_backticks <- !inside_backticks
        result <- paste0(result, char)
      } else if (!inside_backticks) {
        # Check the remaining text against the regex
        remaining_text <- paste(chars[i:length(chars)], collapse = "")
        match <- regexpr(regex, remaining_text)
        
        if (attr(match, "match.length") > 0 && match[1] == 1) {
          # Skip the length of the matched text
          skip <- attr(match, "match.length") - 1
          next
        } else {
          result <- paste0(result, char)
        }
      } else {
        result <- paste0(result, char)
      }
    }
    
    return(result)
  }
  
  # Apply the function to each element in the vector
  sapply(text_vector, remove_regex_chars, regex)
}


#' chatGPT - Split Each String in a Vector by a Specified Regex Pattern
#'
#' This function takes a vector of strings and a regular expression pattern. It splits
#' each string based on the pattern, except where the pattern is found inside backticks.
#' The function returns a list, with each element being a vector of the split segments
#' of the corresponding input string.
#'
#' @param text_vector A character vector with the strings to be processed.
#' @param regex A character string containing a regular expression pattern used for splitting
#' the text.
#'
#' @return A list of character vectors. Each list element corresponds to an input string
#' from `text_vector`, split according to `regex`, excluding occurrences inside backticks.
#'
#' @examples
#' texts <- c("A string with, some, commas, and `a, comma, inside` backticks",
#'            "Another string, with, commas")
#' split_texts <- split_regex_chars_from_vector(texts, ",")
#' print(split_texts)
#' 
#' @noRd
str_split_ignoring_if_inside_backquotes <- function(text_vector, regex) {
  # Nested function to handle regex split for a single string
  split_regex_chars <- function(text, regex) {
    inside_backticks <- FALSE
    result <- c()
    current_segment <- ""
    
    chars <- strsplit(text, "")[[1]]
    for (i in seq_along(chars)) {
      char <- chars[i]
      if (char == "`") {
        inside_backticks <- !inside_backticks
        current_segment <- paste0(current_segment, char)
      } else if (!inside_backticks) {
        # Check the remaining text against the regex
        remaining_text <- paste(chars[i:length(chars)], collapse = "")
        match <- regexpr(regex, remaining_text)
        
        if (attr(match, "match.length") > 0 && match[1] == 1) {
          # Add current segment to result and start a new segment
          result <- c(result, current_segment)
          current_segment <- ""
          # Skip the length of the matched text
          skip <- attr(match, "match.length") - 1
          i <- i + skip
        } else {
          current_segment <- paste0(current_segment, char)
        }
      } else {
        current_segment <- paste0(current_segment, char)
      }
    }
    
    # Add the last segment to the result
    result <- c(result, current_segment)
    return(result)
  }
  
  # Apply the function to each element in the vector
  lapply(text_vector, split_regex_chars, regex)
}

#' Convert array of quosure (e.g. c(col_a, col_b)) into character vector
#'
#' @keywords internal
#' @noRd
#'
#' @importFrom rlang quo_name
#' @importFrom rlang quo_squash
#'
#' @param v A array of quosures (e.g. c(col_a, col_b))
#'
#' @return A character vector
quo_names <- function(v) {
  
  v = quo_name(quo_squash(v))
  gsub('^c\\(|`|\\)$', '', v) |>
    strsplit(', ') |>
    unlist()
}

#' Add class to abject
#'
#' @keywords internal
#' @noRd
#'
#' @param var A tibble
#' @param name A character name of the attribute
#'
#' @return A tibble with an additional attribute
add_class = function(var, name) {
  
  if(!name %in% class(var)) class(var) <- append(class(var),name, after = 0)
  
  var
}

drop_environment <- function(obj) {
  # Check if the object has an environment
  if (!is.null(environment(obj))) {
    environment(obj) <- new.env()
  }
  return(obj)
}


#' Print Tibble in Red
#'
#' This function captures the console output of printing a tibble,
#' colours it in red and returns the coloured text.
#'
#' @param tbl A data frame or tibble to be printed and coloured in red.
#'
#' @return A character string containing the coloured tibble output.
#'
#' @importFrom crayon red
#' @noRd
print_red_tibble <- function(tbl) {
  # Capture the console output of printing the tibble
  example_text <- capture.output(print(tbl))
  
  # Combine all lines into one block and colour it in red
  red(paste(example_text, collapse = "\n"))
}


# This is needed because I have a `sample` argument, that when it is not defined affects the sample() function
sample_seed = function(){
  sample(1e5, 1)
}

#' Handle missing values in a data frame
#' 
#' @param data A data frame to process
#' @return A data frame with missing values handled:
#'   - For categorical variables (factor/character): NA values are converted to a factor level "NA"
#'   - For numeric variables: NA values are replaced with the mean of the column
handle_missing_values <- function(data) {
  data %>%
    mutate(
      # 1) Handle factor/character: turn NA into a real "NA" level, last in the ordering
      across(
        where(~ is.factor(.x) || is.character(.x)),
        ~{
          if (any(is.na(.x))) {
            x_char <- as.character(.x)
            x_char[is.na(x_char)] <- "NA"
            f <- factor(x_char)
            non_na_levels <- setdiff(levels(f), "NA")
            new_levels <- c(non_na_levels, "NA")
            factor(f, levels = new_levels)
          } else {
            .x
          }
        }
      ),
      # 2) Handle numeric: replace NA by the (non-NA) mean of that column
      across(
        where(is.numeric),
        ~{
          if (any(is.na(.x))) {
            mean_val <- mean(.x, na.rm = TRUE) 
            ifelse(is.na(.x), mean_val, .x)  # Only replace NAs, keep original values
          } else {
            .x
          }
        }
      )
    )
}

library(testthat)
library(tibble)
library(dplyr)
library(tidyr)
library(rlang)
library(sccomp)

test_that("get_random_effect_design3 with new NA groups", {
  skip_cmdstan()
  # Create test input data
  test_data <- tibble(
    sample = c("sample1", "sample2", "sample3", "sample4"),
    type = c("healthy", "healthy", "cancer", NA),
    group__ = c("GROUP1", "GROUP2", "GROUP1", "GROUP2")
  )
  
  formula <- ~ type
  grouping <- "group__"
  
  # Expect an error because NAs are present and accept_NA_as_average_effect is FALSE
  expect_error(
    sccomp:::get_random_effect_design3(test_data, formula, grouping, sample),
    "sccomp says: NA values are present in the design matrix factors. Set accept_NA_as_average_effect = TRUE to handle NAs as average effects across factor levels."
  )
})

test_that("get_random_effect_design3 handles NA values in design matrix correctly", {
  skip_cmdstan()
  test_data <- tibble(
    sample = c("sample1", "sample2", "sample3", "sample4", "sample5"),
    type = c("healthy", "healthy", "cancer", "cancer", NA),
    group__ = c("GROUP1", "GROUP2", "GROUP1", "GROUP2", "GROUP1")
  )
  
  formula <- ~ type
  grouping <- "group__"
  
  result <- sccomp:::get_random_effect_design3(test_data, formula, grouping, sample, accept_NA_as_average_effect = TRUE)
  
  design_matrix <- 
    result |> 
    select(sample, group___label, value) |>
    pivot_wider(names_from = group___label, values_from = value) |>
    mutate(across(everything(), ~ .x |> replace_na(0)))
  
  print("Actual output:")
  print(design_matrix)
  
  expected_matrix <- tibble(
    sample = c("sample1", "sample2", "sample3", "sample4", "sample5"),
    `(Intercept)___GROUP1` = c(1, 0, 1, 0, 1),
    `typehealthy___GROUP1` = c(1, 0, 0, 0, 0.5),
    `(Intercept)___GROUP2` = c(0, 1, 0, 1, 0),
    `typehealthy___GROUP2` = c(0, 1, 0, 0, 0)
  )
  
  print("Expected output:")
  print(expected_matrix)
  
  expect_equal(design_matrix, expected_matrix)
})

test_that("get_random_effect_design3 throws error when NAs present and accept_NA_as_average_effect is FALSE", {
  skip_cmdstan()
  test_data <- tibble(
    sample = c("sample1", "sample2", "sample3", "sample4", "sample5"),
    type = c("healthy", "healthy", "cancer", "cancer", NA),
    group__ = c("GROUP1", "GROUP2", "GROUP1", "GROUP2", "GROUP1")
  )
  
  formula <- ~ type
  grouping <- "group__"
  
  # Test that an error is thrown with default accept_NA_as_average_effect = FALSE
  expect_error(
    sccomp:::get_random_effect_design3(test_data, formula, grouping, sample),
    "sccomp says: NA values are present in the design matrix factors. Set accept_NA_as_average_effect = TRUE to handle NAs as average effects across factor levels."
  )
  
  # Test that an error is thrown with explicit accept_NA_as_average_effect = FALSE
  expect_error(
    sccomp:::get_random_effect_design3(test_data, formula, grouping, sample, accept_NA_as_average_effect = FALSE),
    "sccomp says: NA values are present in the design matrix factors. Set accept_NA_as_average_effect = TRUE to handle NAs as average effects across factor levels."
  )
})

test_that("get_random_effect_design3 handles complex formulas with multiple factors", {
  skip_cmdstan()
  # Create test data with multiple factors (scaled continuous variables)
  age_raw <- c(25, 30, NA, 35, 40, 45)
  age_scaled <- as.numeric(scale(age_raw, center = TRUE, scale = TRUE))
  sex <- c("M", "F", "M", NA, "F", "M")
  type <- c("healthy", "healthy", "cancer", "cancer", NA, "healthy")
  group__ <- c("GROUP1", "GROUP2", "GROUP1", "GROUP2", "GROUP1", "GROUP2")
  test_data <- tibble(
    sample = c("sample1", "sample2", "sample3", "sample4", "sample5", "sample6"),
    type = type,
    age = age_scaled,
    sex = sex,
    group__ = group__
  )
  
  # Test with main effects and interactions
  formula <- ~ type + age + sex + type:age
  grouping <- "group__"
  
  result <- sccomp:::get_random_effect_design3(test_data, formula, grouping, sample, accept_NA_as_average_effect = TRUE)
  
  design_matrix <- result |> 
    select(sample, group___label, value) |>
    pivot_wider(names_from = group___label, values_from = value) |>
    mutate(across(everything(), ~ .x |> replace_na(0)))
  
  print("Actual output (complex formulas with multiple factors):")
  print(design_matrix)
  
  # Verify the structure of the output
  expect_true(all(c("(Intercept)___GROUP1", "typehealthy___GROUP1", "age___GROUP1") %in% colnames(design_matrix)))
  expect_true(all(c("(Intercept)___GROUP2", "typehealthy___GROUP2", "age___GROUP2") %in% colnames(design_matrix)))
  
  # Verify specific values
  print("age___GROUP1 for sample1:")
  print(design_matrix$`age___GROUP1`[design_matrix$sample == "sample1"])
  print("typehealthy___GROUP1 for sample1:")
  print(design_matrix$`typehealthy___GROUP1`[design_matrix$sample == "sample1"])
  print("age___GROUP1 for sample5:")
  print(design_matrix$`age___GROUP1`[design_matrix$sample == "sample5"])
  expect_equal(design_matrix$`age___GROUP1`[design_matrix$sample == "sample1"], age_scaled[1])
  expect_equal(design_matrix$`typehealthy___GROUP1`[design_matrix$sample == "sample1"], 1)
  expect_equal(design_matrix$`age___GROUP1`[design_matrix$sample == "sample5"], age_scaled[5])
})

test_that("get_random_effect_design3 handles continuous variables with NAs", {
  skip_cmdstan()
  age_raw <- c(25, NA, 35, 40)
  age_scaled <- as.numeric(scale(age_raw, center = TRUE, scale = TRUE))
  weight_raw <- c(70, 75, NA, 80)
  weight_scaled <- as.numeric(scale(weight_raw, center = TRUE, scale = TRUE))
  test_data <- tibble(
    sample = c("sample1", "sample2", "sample3", "sample4"),
    age = age_scaled,
    weight = weight_scaled,
    group__ = c("GROUP1", "GROUP2", "GROUP1", "GROUP2")
  )
  
  formula <- ~ age + weight
  grouping <- "group__"
  
  result <- sccomp:::get_random_effect_design3(test_data, formula, grouping, sample, accept_NA_as_average_effect = TRUE)
  
  design_matrix <- result |> 
    select(sample, group___label, value) |>
    pivot_wider(names_from = group___label, values_from = value) |>
    mutate(across(everything(), ~ .x |> replace_na(0)))
  
  print("Actual output (continuous variables with NAs):")
  print(design_matrix)
  
  # Verify that NAs are handled correctly for continuous variables
  print("age___GROUP1 for sample1:")
  print(design_matrix$`age___GROUP1`[design_matrix$sample == "sample1"])
  print("age___GROUP2 for sample2:")
  print(design_matrix$`age___GROUP2`[design_matrix$sample == "sample2"])
  print("weight___GROUP1 for sample3:")
  print(design_matrix$`weight___GROUP1`[design_matrix$sample == "sample3"])
  expect_equal(design_matrix$`age___GROUP1`[design_matrix$sample == "sample1"], age_scaled[1])
  expect_equal(design_matrix$`age___GROUP2`[design_matrix$sample == "sample2"], 0) # NA replaced with 0
  expect_equal(design_matrix$`weight___GROUP1`[design_matrix$sample == "sample3"], 0) # NA replaced with 0
})

test_that("get_random_effect_design3 handles complex interactions with NAs", {
  skip_cmdstan()
  age_raw <- c(25, NA, 35, 40, 45)
  age_scaled <- as.numeric(scale(age_raw, center = TRUE, scale = TRUE))
  test_data <- tibble(
    sample = c("sample1", "sample2", "sample3", "sample4", "sample5"),
    type = c("healthy", "healthy", "cancer", NA, "healthy"),
    age = age_scaled,
    sex = c("M", "F", NA, "M", "F"),
    group__ = c("GROUP1", "GROUP2", "GROUP1", "GROUP2", "GROUP1")
  )
  
  # Test with three-way interaction
  formula <- ~ type * age * sex
  grouping <- "group__"
  
  result <- sccomp:::get_random_effect_design3(test_data, formula, grouping, sample, accept_NA_as_average_effect = TRUE)
  
  design_matrix <- result |> 
    select(sample, group___label, value) |>
    pivot_wider(names_from = group___label, values_from = value) |>
    mutate(across(everything(), ~ .x |> replace_na(0)))
  
  print("Actual output (complex interactions with NAs):")
  print(design_matrix)
  
  # Verify that interaction terms are present
  print("Column names:")
  print(colnames(design_matrix))
  expect_true(any(grepl("typehealthy:age:sexM", colnames(design_matrix))))
  
  # Verify specific interaction values
  print("typehealthy:age:sexM___GROUP1 for sample1:")
  print(design_matrix$`typehealthy:age:sexM___GROUP1`[design_matrix$sample == "sample1"])
  # These values are now scaled
  # Use the scaled value for age in the interaction
  expect_equal(design_matrix$`typehealthy:age:sexM___GROUP1`[design_matrix$sample == "sample1"], age_scaled[1])
})

test_that("get_random_effect_design3 handles multiple groups with complex factors", {
  skip_cmdstan()
  age_raw <- c(25, 30, 35, 40, 45, 50)
  age_scaled <- as.numeric(scale(age_raw, center = TRUE, scale = TRUE))
  test_data <- tibble(
    sample = c("sample1", "sample2", "sample3", "sample4", "sample5", "sample6"),
    type = c("healthy", "healthy", "cancer", "cancer", NA, "healthy"),
    age = age_scaled,
    group__ = c("GROUP1", "GROUP2", "GROUP3", "GROUP1", "GROUP2", "GROUP3")
  )
  
  formula <- ~ type + age
  grouping <- "group__"
  
  result <- sccomp:::get_random_effect_design3(test_data, formula, grouping, sample, accept_NA_as_average_effect = TRUE)
  
  design_matrix <- result |> 
    select(sample, group___label, value) |>
    pivot_wider(names_from = group___label, values_from = value) |>
    mutate(across(everything(), ~ .x |> replace_na(0)))
  
  print("Actual output (multiple groups with complex factors):")
  print(design_matrix)
  
  # Verify that all groups are present
  print("Groups present:")
  print(unique(gsub(".*___", "", colnames(design_matrix))))
  expect_true(all(c("GROUP1", "GROUP2", "GROUP3") %in% unique(gsub(".*___", "", colnames(design_matrix)))))
  
  # Verify specific values for each group
  print("age___GROUP1 for sample1:")
  print(design_matrix$`age___GROUP1`[design_matrix$sample == "sample1"])
  print("age___GROUP2 for sample2:")
  print(design_matrix$`age___GROUP2`[design_matrix$sample == "sample2"])
  print("age___GROUP3 for sample3:")
  print(design_matrix$`age___GROUP3`[design_matrix$sample == "sample3"])
  expect_equal(design_matrix$`age___GROUP1`[design_matrix$sample == "sample1"], age_scaled[1])
  expect_equal(design_matrix$`age___GROUP2`[design_matrix$sample == "sample2"], age_scaled[2])
  expect_equal(design_matrix$`age___GROUP3`[design_matrix$sample == "sample3"], age_scaled[3])
})

library(testthat)
library(dplyr)
library(tidyr)
library(sccomp)

test_that("replicate_data works correctly", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas
  formula_composition = ~ type
  formula_variability = ~ type
  
  # Create .data object
  model_input = 
    counts_obj |> 
      mutate(random_effect = "1") |> 
       sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = "random_effect"
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = tibble(factor = character(), grouping = character())
    )
 

  # Prepare replicate data
  result = sccomp:::prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!rlang::quo(sample),
    .cell_group = !!rlang::quo(cell_group),
    .count = !!rlang::quo(count),
    formula_composition = formula_composition,
    original_formula_composition = formula_composition,
    formula_variability = formula_variability,
    new_data = NULL,
    original_count_data = counts_obj |> sccomp:::.subset(!!quo(sample))
  )

  # Check structure
  print("names(result):"); print(names(result))
  expect_type(result, "list")
  print('"X_which" %in% names(result):'); print("X_which" %in% names(result))
  expect_true("X_which" %in% names(result))
  print('"XA_which" %in% names(result):'); print("XA_which" %in% names(result))
  expect_true("XA_which" %in% names(result))
  print('"create_intercept" %in% names(result):'); print("create_intercept" %in% names(result))
  expect_true("create_intercept" %in% names(result))
  
  # Check dimensions
  print('nrow(result$X):'); print(nrow(result$X))
  print('nrow(model_input$X):'); print(nrow(model_input$X))
  expect_equal(nrow(result$X), nrow(model_input$X))
  print('ncol(result$X):'); print(ncol(result$X))
  print('ncol(model_input$X):'); print(ncol(model_input$X))
  expect_equal(ncol(result$X), ncol(model_input$X))

  # Print key objects for debugging
  print("colnames(result$X_random_effect):")
  print(colnames(result$X_random_effect))
  print("rownames(result$X_random_effect):")
  print(rownames(result$X_random_effect))
  print("result$X_random_effect:")
  print(result$X_random_effect)
  print("colnames(result$X_random_effect_unseen):")
  print(colnames(result$X_random_effect_unseen))
  print("result$X_random_effect_unseen:")
  print(result$X_random_effect_unseen)
})

test_that("replicate_data works with random intercept model", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas with random intercept
  formula_composition = ~ type + (1 | group__)
  formula_variability = ~ type
  
  # Create test data with group information
  test_data = 
    counts_obj |> 
    group_by(sample) |>
    mutate(group__ = sample(c("GROUP1", "GROUP2"), 1)) |>
    ungroup()
  
  # Create .data object
  model_input = 
    test_data |> 
    sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = "group__"
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = tibble(factor = "(Intercept)", grouping = "group__"),
      accept_NA_as_average_effect = TRUE
    )

  # Prepare replicate data
  result = sccomp:::prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!rlang::quo(sample),
    .cell_group = !!rlang::quo(cell_group),
    .count = !!rlang::quo(count),
    formula_composition = formula_composition,
    original_formula_composition = formula_composition,
    formula_variability = formula_variability,
    new_data = NULL,
    original_count_data = test_data |> sccomp:::.subset(!!quo(sample))
  )

  # Check structure
  print("names(result):"); print(names(result))
  expect_type(result, "list")
  print('"model_input" %in% names(result):'); print("model_input" %in% names(result))
  print('"X_which" %in% names(result):'); print("X_which" %in% names(result))
  expect_true("X_which" %in% names(result))
  print('"XA_which" %in% names(result):'); print("XA_which" %in% names(result))
  expect_true("XA_which" %in% names(result))
  print('"create_intercept" %in% names(result):'); print("create_intercept" %in% names(result))
  expect_true("create_intercept" %in% names(result))
  
  # Check random effect design matrix
  print('is.null(result$X_random_effect):'); print(is.null(result$X_random_effect))
  expect_true(!is.null(result$X_random_effect))
  print('ncol(result$X_random_effect):'); print(ncol(result$X_random_effect))
  expect_true(ncol(result$X_random_effect) > 0)

  # Print key objects for debugging
  print("colnames(result$X_random_effect):")
  print(colnames(result$X_random_effect))
  print("rownames(result$X_random_effect):")
  print(rownames(result$X_random_effect))
  print("result$X_random_effect:")
  print(result$X_random_effect)
  print("colnames(result$X_random_effect_unseen):")
  print(colnames(result$X_random_effect_unseen))
  print("result$X_random_effect_unseen:")
  print(result$X_random_effect_unseen)
})

test_that("replicate_data works with random slope model", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas with random slope
  formula_composition = ~ type + (type | group__)
  formula_variability = ~ type
  
  # Create test data with group information
  test_data = 
    counts_obj |> 
    group_by(sample) |>
    mutate(
      group__ = sample(c("GROUP1", "GROUP2"), 1),
      group2__ = paste0(group__, "_", sample(1:2, 1))
    ) |>
    ungroup()
  
  # Create .data object
  model_input = 
    test_data |> 
    sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = "group__"
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = tibble(
        factor = c("(Intercept)", "type"),
        grouping = c("group__", "group__")
      ),
      accept_NA_as_average_effect = TRUE
    )

  # Prepare replicate data
  result = sccomp:::prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!rlang::quo(sample),
    .cell_group = !!rlang::quo(cell_group),
    .count = !!rlang::quo(count),
    formula_composition = formula_composition,
    original_formula_composition = formula_composition,
    formula_variability = formula_variability,
    new_data = NULL,
    original_count_data = test_data |> sccomp:::.subset(!!quo(sample))
  )

  # Check structure
  print("names(result):"); print(names(result))
  expect_type(result, "list")
  print('"model_input" %in% names(result):'); print("model_input" %in% names(result))
  print('"X_which" %in% names(result):'); print("X_which" %in% names(result))
  expect_true("X_which" %in% names(result))
  print('"XA_which" %in% names(result):'); print("XA_which" %in% names(result))
  expect_true("XA_which" %in% names(result))
  print('"create_intercept" %in% names(result):'); print("create_intercept" %in% names(result))
  expect_true("create_intercept" %in% names(result))
  
  # Check random effect design matrix
  print('is.null(result$X_random_effect):'); print(is.null(result$X_random_effect))
  expect_true(!is.null(result$X_random_effect))
  print('ncol(result$X_random_effect):'); print(ncol(result$X_random_effect))
  expect_true(ncol(result$X_random_effect) > 0)

  # Print key objects for debugging
  print("colnames(result$X_random_effect):")
  print(colnames(result$X_random_effect))
  print("rownames(result$X_random_effect):")
  print(rownames(result$X_random_effect))
  print("result$X_random_effect:")
  print(result$X_random_effect)
  print("colnames(result$X_random_effect_unseen):")
  print(colnames(result$X_random_effect_unseen))
  print("result$X_random_effect_unseen:")
  print(result$X_random_effect_unseen)
})

test_that("replicate_data works with random slope model and type NA", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas with random slope
  formula_composition = ~ type + (type | group__)
  formula_variability = ~ type

  # test data 
  test_data = 
    counts_obj |> 
    left_join(
      tibble(
        sample = unique(counts_obj$sample),
        group__ = case_when(
          sample %in% unique(sample)[1:10] ~ "GROUP1",
          TRUE ~ "GROUP2"
        )
      )
    )


  # Create test data with group information and type NA
  

  # Create .data object
  model_input = 
    test_data |> 
    sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = "group__"
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = tibble(
        factor = c("(Intercept)", "type"),
        grouping = c("group__", "group__")
      ),
      accept_NA_as_average_effect = TRUE
    )



new_data = 
    test_data |> 
    sccomp:::.subset(!!quo(sample)) |> 
    mutate(type = NA_character_)



  # Prepare replicate data
  result = sccomp:::prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!rlang::quo(sample),
    .cell_group = !!rlang::quo(cell_group),
    .count = !!rlang::quo(count),
    formula_composition = formula_composition,
    original_formula_composition = formula_composition,
    formula_variability = formula_variability,
    new_data = new_data,
    original_count_data = test_data |> sccomp:::.subset(!!quo(sample))
  )

  # Check structure
  print("names(result):"); print(names(result))
  expect_type(result, "list")
  print('"model_input" %in% names(result):'); print("model_input" %in% names(result))
  print('"X_which" %in% names(result):'); print("X_which" %in% names(result))
  expect_true("X_which" %in% names(result))
  print('"XA_which" %in% names(result):'); print("XA_which" %in% names(result))
  expect_true("XA_which" %in% names(result))
  print('"create_intercept" %in% names(result):'); print("create_intercept" %in% names(result))
  expect_true("create_intercept" %in% names(result))
  
  # Check random effect design matrix
  print('is.null(result$X_random_effect):'); print(is.null(result$X_random_effect))
  expect_true(!is.null(result$X_random_effect))

  # Find a column with 'type' in its name
  col_type <- grep("type", colnames(result$X_random_effect), value = TRUE)[1]
  col_intercept <- grep("Intercept", colnames(result$X_random_effect), value = TRUE)[1]
  print(paste('result$X_random_effect[1,', col_type, ']:')); print(result$X_random_effect[1, col_type])
  print(paste('result$X_random_effect[1,', col_intercept, ']:')); print(result$X_random_effect[1, col_intercept])
  expect_equal(result$X_random_effect[1, col_type], 0.5)
  expect_equal(result$X_random_effect[1, col_intercept], 1)

  # Check that X_random_effect_unseen has the expected number of 1s
  print('result$X_random_effect_unseen[rownames(result$X_random_effect_unseen) == sample_with_na, "(Intercept)___NA"]:')
  
  # Check if X_random_effect_unseen has the expected column
  expect_equal(ncol(result$X_random_effect_unseen), 0)
})

test_that("replicate_data works with nested random effects", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas with nested random effects
  formula_composition = ~ type + (type | group__) + (1 | group2__)
  formula_variability = ~ type
  
  # Create test data with nested group information
  test_data = 
    counts_obj |> 
    group_by(sample) |>
    mutate(
      group__ = sample(c("GROUP1", "GROUP2"), 1),
      group2__ = paste0(group__, "_", sample(1:2, 1))
    ) |>
    ungroup()
  
  # Create .data object
  model_input = 
    test_data |> 
    sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = c("group__", "group2__")
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = tibble(
        factor = c("(Intercept)", "type", "(Intercept)"),
        grouping = c("group__", "group__", "group2__")
      ),
      accept_NA_as_average_effect = TRUE
    )

  # Prepare replicate data
  result = sccomp:::prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!rlang::quo(sample),
    .cell_group = !!rlang::quo(cell_group),
    .count = !!rlang::quo(count),
    formula_composition = formula_composition,
    original_formula_composition = formula_composition,
    formula_variability = formula_variability,
    new_data = NULL,
    original_count_data = test_data |> sccomp:::.subset(!!quo(sample))
  )

  # Check structure
  print("names(result):"); print(names(result))
  expect_type(result, "list")
  print('"model_input" %in% names(result):'); print("model_input" %in% names(result))
  print('"X_which" %in% names(result):'); print("X_which" %in% names(result))
  expect_true("X_which" %in% names(result))
  print('"XA_which" %in% names(result):'); print("XA_which" %in% names(result))
  expect_true("XA_which" %in% names(result))
  print('"create_intercept" %in% names(result):'); print("create_intercept" %in% names(result))
  expect_true("create_intercept" %in% names(result))
  
  # Check random effect design matrices
  print('is.null(result$X_random_effect):'); print(is.null(result$X_random_effect))
  expect_true(!is.null(result$X_random_effect))
  print('is.null(result$X_random_effect_2):'); print(is.null(result$X_random_effect_2))
  expect_true(!is.null(result$X_random_effect_2))
  print('ncol(result$X_random_effect):'); print(ncol(result$X_random_effect))
  expect_true(ncol(result$X_random_effect) > 0)
  print('ncol(result$X_random_effect_2):'); print(ncol(result$X_random_effect_2))
  expect_true(ncol(result$X_random_effect_2) > 0)

  # Print key objects for debugging
  print("colnames(result$X_random_effect):")
  print(colnames(result$X_random_effect))
  print("rownames(result$X_random_effect):")
  print(rownames(result$X_random_effect))
  print("result$X_random_effect:")
  print(result$X_random_effect)
  print("colnames(result$X_random_effect_unseen):")
  print(colnames(result$X_random_effect_unseen))
  print("result$X_random_effect_unseen:")
  print(result$X_random_effect_unseen)
})

test_that("replicate_data works with NA values in grouping", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas with random intercept
  formula_composition = ~ type + (1 | group__)
  formula_variability = ~ type
  
  # Pick one sample to have NA group__
  unique_samples <- unique(counts_obj$sample)
  sample_with_na <- unique_samples[1]
  
  # Create test data with group information including NA values
  test_data = 
    counts_obj |> 
    mutate(
      group__ = if_else(
        sample == sample_with_na,
        NA_character_,
        sample(c("GROUP1", "GROUP2"), 1)
      ),
      count = if_else(is.na(group__), count, count)
    )

  # Assert only one unique sample has NA in group__
  expect_equal(
    test_data |> filter(is.na(group__)) |> distinct(sample) |> nrow(),
    1
  )
  
  # Use parse_formula_random_effect for random_effect_elements
  random_effect_elements = sccomp:::parse_formula_random_effect(formula_composition)

  # Create .data object
  model_input = 
    test_data |> 
    sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = "group__"
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = random_effect_elements,
      accept_NA_as_average_effect = TRUE
    )

  # Prepare replicate data
  result = sccomp:::prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!rlang::quo(sample),
    .cell_group = !!rlang::quo(cell_group),
    .count = !!rlang::quo(count),
    formula_composition = formula_composition,
    original_formula_composition = formula_composition,
    formula_variability = formula_variability,
    new_data = NULL,
    original_count_data = test_data |> sccomp:::.subset(!!quo(sample))
  )

  # Check structure
  print("names(result):"); print(names(result))
  expect_type(result, "list")
  print('"model_input" %in% names(result):'); print("model_input" %in% names(result))
  print('"X_which" %in% names(result):'); print("X_which" %in% names(result))
  expect_true("X_which" %in% names(result))
  print('"XA_which" %in% names(result):'); print("XA_which" %in% names(result))
  expect_true("XA_which" %in% names(result))
  print('"create_intercept" %in% names(result):'); print("create_intercept" %in% names(result))
  expect_true("create_intercept" %in% names(result))
  
  # Check random effect design matrix
  print('is.null(result$X_random_effect):'); print(is.null(result$X_random_effect))
  expect_true(!is.null(result$X_random_effect))
  print('ncol(result$X_random_effect):'); print(ncol(result$X_random_effect))
  expect_true(ncol(result$X_random_effect) > 0)
  
  # Check that NA values are handled correctly
  print('all(!is.na(result$X_random_effect))'); print(all(!is.na(result$X_random_effect)))
  expect_true(all(!is.na(result$X_random_effect)))
  
  # Check that the design matrix dimensions are correct
  print('nrow(result$X_random_effect):'); print(nrow(result$X_random_effect))
  print('nrow(distinct(test_data, sample))'); print(nrow(test_data |> distinct(sample)))
  expect_equal(nrow(result$X_random_effect), nrow(test_data |> distinct(sample)))

  # Check that X_random_effect has only one 0 for the expected sample
  group1_samples <- test_data |> filter(group__ == "GROUP1") |> distinct(sample) |> pull(sample)
  if ("(Intercept)___GROUP1" %in% colnames(result$X_random_effect)) {
    print('result$X_random_effect[group1_samples, "(Intercept)___GROUP1"]:')
    print(result$X_random_effect[group1_samples, "(Intercept)___GROUP1"])
    expect_true(all(result$X_random_effect[group1_samples, "(Intercept)___GROUP1"] == 1))
  }
  
  # Check that X_random_effect_unseen has the expected number of 1s
  print('result$X_random_effect_unseen[rownames(result$X_random_effect_unseen) == sample_with_na, "(Intercept)___NA"]:')
  
  # Check if X_random_effect_unseen has the expected column
  expect_equal(ncol(result$X_random_effect_unseen), 0)

  # Print key objects for debugging
  print("colnames(result$X_random_effect):")
  print(colnames(result$X_random_effect))
  print("rownames(result$X_random_effect):")
  print(rownames(result$X_random_effect))
  print("result$X_random_effect:")
  print(result$X_random_effect)
  print("colnames(result$X_random_effect_unseen):")
  print(colnames(result$X_random_effect_unseen))
  print("result$X_random_effect_unseen:")
  print(result$X_random_effect_unseen)
})

test_that("replicate_data works with NA values in grouping and random effects", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas with random intercept and slope
  formula_composition = ~ type + (type | group__)
  formula_variability = ~ type
  
  # Pick one sample to have NA group__
  unique_samples <- unique(counts_obj$sample)
  sample_with_na <- unique_samples[c(1, 9)]
  
  # Create test data with group information including NA values and random effects
  test_data = 
    counts_obj |> 
    group_by(sample) |>
    mutate(
      group__ = case_when(
        sample == sample_with_na[1] ~ NA_character_,
        sample == sample_with_na[2] ~ NA_character_,
        sample %in% unique_samples[3:10] ~ "GROUP1",
        TRUE ~ "GROUP2"
      ),
      count = if_else(is.na(group__), count, count)
    ) |>
    ungroup()
  
  # Verify we have all three groups
  expect_equal(
    test_data |> distinct(group__) |> pull(group__) |> sort(),
    c("GROUP1", "GROUP2", NA_character_) |> sort()
  )
  
  # Use parse_formula_random_effect for random_effect_elements
  random_effect_elements = sccomp:::parse_formula_random_effect(formula_composition)

  # Create .data object
  model_input = 
    test_data |> 
    sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = "group__"
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = random_effect_elements,
      accept_NA_as_average_effect = TRUE
    )

  # Prepare replicate data
  result = sccomp:::prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!rlang::quo(sample),
    .cell_group = !!rlang::quo(cell_group),
    .count = !!rlang::quo(count),
    formula_composition = formula_composition,
    original_formula_composition = formula_composition,
    formula_variability = formula_variability,
    new_data = NULL,
    original_count_data = test_data |> sccomp:::.subset(!!quo(sample))
  )

  # Check structure
  print("names(result):"); print(names(result))
  expect_type(result, "list")
  print('"X_which" %in% names(result):'); print("X_which" %in% names(result))
  expect_true("X_which" %in% names(result))
  print('"XA_which" %in% names(result):'); print("XA_which" %in% names(result))
  expect_true("XA_which" %in% names(result))
  print('"create_intercept" %in% names(result):'); print("create_intercept" %in% names(result))
  expect_true("create_intercept" %in% names(result))
  
  # Check random effect design matrix
  print('is.null(result$X_random_effect):'); print(is.null(result$X_random_effect))
  expect_true(!is.null(result$X_random_effect))
  print('ncol(result$X_random_effect):'); print(ncol(result$X_random_effect))
  expect_true(ncol(result$X_random_effect) > 0)
  
  # Check that NA values are handled correctly in random effects
  print('all(!is.na(result$X_random_effect))'); print(all(!is.na(result$X_random_effect)))
  expect_true(all(!is.na(result$X_random_effect)))
  
  # Check that the design matrix dimensions are correct
  print('nrow(result$X_random_effect):'); print(nrow(result$X_random_effect))
  print('nrow(distinct(test_data, sample))'); print(nrow(test_data |> distinct(sample)))
  expect_equal(nrow(result$X_random_effect), nrow(test_data |> distinct(sample)))
  
  # Check that the random effect design matrix has the correct structure
  print('any(grepl("type", colnames(result$X_random_effect)))'); print(any(grepl("type", colnames(result$X_random_effect))))
  expect_true(any(grepl("type", colnames(result$X_random_effect))))
  print('any(grepl("Intercept", colnames(result$X_random_effect)))'); print(any(grepl("Intercept", colnames(result$X_random_effect))))
  expect_true(any(grepl("Intercept", colnames(result$X_random_effect))))
  
  # Test the properties of X_random_effect_unseen
  print('all(!is.na(result$X_random_effect_unseen))'); print(all(!is.na(result$X_random_effect_unseen)))
  expect_true(all(!is.na(result$X_random_effect_unseen)))
  print('nrow(result$X_random_effect_unseen):'); print(nrow(result$X_random_effect_unseen))
  print('nrow(distinct(test_data, sample)):'); print(nrow(test_data |> distinct(sample)))
  expect_equal(nrow(result$X_random_effect_unseen), nrow(test_data |> distinct(sample)))
  print('ncol(result$X_random_effect_unseen):'); print(ncol(result$X_random_effect_unseen))
  
  # When new_data is NULL, X_random_effect_unseen should be empty (0 columns)
  # even if the original data has NA values in grouping
  expect_equal(ncol(result$X_random_effect_unseen), 0)
  print('rownames(result$X_random_effect_unseen):'); print(rownames(result$X_random_effect_unseen))
  print('rownames(result$X_random_effect):'); print(rownames(result$X_random_effect))
  expect_equal(rownames(result$X_random_effect_unseen), rownames(result$X_random_effect))
  
  # Since X_random_effect_unseen is empty, we can't check for NA columns
  # print('all(grepl("___NA$", colnames(result$X_random_effect_unseen)))'); print(all(grepl("___NA$", colnames(result$X_random_effect_unseen))))
  # expect_true(all(grepl("___NA$", colnames(result$X_random_effect_unseen))))
  print('all(grepl("___GROUP", colnames(result$X_random_effect)))'); print(all(grepl("___GROUP", colnames(result$X_random_effect))))
  expect_true(all(grepl("___GROUP", colnames(result$X_random_effect))))
  
  # Since X_random_effect_unseen is empty, we can't check sums of NA columns
  # print('sum(result$X_random_effect_unseen[, "typecancer___NA"]):'); print(sum(as.vector(result$X_random_effect_unseen[, "typecancer___NA"])))
  # expect_equal(
  #   as.vector(result$X_random_effect_unseen[, "typecancer___NA"]) |> sum(),
  #   1
  # )
  # 
  # print('sum(result$X_random_effect_unseen[, "(Intercept)___NA"]):'); print(sum(as.vector(result$X_random_effect_unseen[, "(Intercept)___NA"])))
  # expect_equal(
  #   as.vector(result$X_random_effect_unseen[, "(Intercept)___NA"]) |> sum(),
  #   2
  # )

  # Robust per-sample checks for random effect matrices
  for (s in rownames(result$X_random_effect)) {
    group_val <- test_data |> filter(sample == s) |> distinct(group__) |> pull(group__)
    if (length(group_val) > 0 && !is.na(group_val)) {
      colname <- paste0("(Intercept)___", group_val)
      if (colname %in% colnames(result$X_random_effect)) {
        expect_equal(result$X_random_effect[s, colname], 1)
      }
    }
  }
  
  # Since X_random_effect_unseen is empty, we can't check for NA samples
  # for (s in rownames(result$X_random_effect_unseen)) {
  #   group_val <- test_data |> filter(sample == s) |> distinct(group__) |> pull(group__)
  #   if (length(group_val) > 0 && is.na(group_val)) {
  #     expect_equal(result$X_random_effect_unseen[s, "(Intercept)___NA"], 1)
  #   }
  # }

  # Print key objects for debugging
  print("colnames(result$X_random_effect):")
  print(colnames(result$X_random_effect))
  print("rownames(result$X_random_effect):")
  print(rownames(result$X_random_effect))
  print("result$X_random_effect:")
  print(result$X_random_effect)
  print("colnames(result$X_random_effect_unseen):")
  print(colnames(result$X_random_effect_unseen))
  print("result$X_random_effect_unseen:")
  print(result$X_random_effect_unseen)
}) 

test_that("replicate_data works with type NA and group__ NA", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas with random intercept and slope
  formula_composition = ~ type + (type | group__)
  formula_variability = ~ type

  # Create original data with group information and type NA
  test_data = 
    counts_obj |> 
    left_join(
      tibble(
        sample = unique(counts_obj$sample),
        group__ = case_when(
          sample %in% unique(sample)[1:10] ~ "GROUP1",
          TRUE ~ "GROUP2"
        )
      )
    )   

  # New data is the same as test data but with type = NA and group__ = NA
  new_data = 
    test_data |>
    sccomp:::.subset(!!quo(sample)) |>
    mutate(
      type = NA_character_,
      group__ = NA_character_,
      sample = paste0("new_", sample)  # Give new samples unique names
    )

  # Use parse_formula_random_effect for random_effect_elements
  random_effect_elements = sccomp:::parse_formula_random_effect(formula_composition)

  # Create .data object
  model_input =   
    test_data |> 
    sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = "group__"
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = random_effect_elements,
      accept_NA_as_average_effect = TRUE
    )

  # Prepare replicate data
  result = sccomp:::prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!rlang::quo(sample),
    .cell_group = !!rlang::quo(cell_group),
    .count = !!rlang::quo(count),
    formula_composition = formula_composition,
    original_formula_composition = formula_composition,
    formula_variability = formula_variability,
    new_data = new_data,
    original_count_data = test_data |> sccomp:::.subset(!!quo(sample))
  )

  # Check structure
  print("names(result):"); print(names(result))
  expect_type(result, "list")
  expect_true("X_which" %in% names(result))
  expect_true("XA_which" %in% names(result))
  expect_true("create_intercept" %in% names(result))
  
  # Check random effect design matrix
  expect_true(!is.null(result$X_random_effect))
  expect_true(ncol(result$X_random_effect) > 0)
  
  # Check that NA values are handled correctly
  expect_true(all(!is.na(result$X_random_effect)))
  
  # Check that the design matrix dimensions are correct
  expect_equal(nrow(result$X_random_effect), nrow(new_data |> distinct(sample)))
  
  # Check that X_random_effect_unseen has the expected structure
  expect_true(!is.null(result$X_random_effect_unseen))
  expect_true(all(!is.na(result$X_random_effect_unseen)))
  expect_equal(nrow(result$X_random_effect_unseen), nrow(new_data |> distinct(sample)))
  expect_true(all(grepl("___NA$", colnames(result$X_random_effect_unseen))))
}) 

test_that("replicate_data works with new data containing only NA groups", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas with random intercept and slope
  formula_composition = ~ type + (type | group__)
  formula_variability = ~ type
  
  # Create original data with group information
  original_data = 
    counts_obj |> 
    left_join(
      tibble(
        sample = unique(counts_obj$sample),
        group__ = case_when(
          sample %in% unique(sample)[1:10] ~ "GROUP1",
          TRUE ~ "GROUP2"
        )
      )
    ) 

  # Create sccomp estimate object
  estimate = sccomp_estimate(
    original_data,
    formula_composition = formula_composition,
    formula_variability = formula_variability,
    .sample = sample,
    .cell_group = cell_group,
    .abundance = count,
    cores = 1,
    max_sampling_iterations = 1000,
    verbose = FALSE
  )

  # Create new data with only NA groups
  new_data = 
    counts_obj |>
    sccomp:::.subset(!!quo(sample)) |> 
    slice(1, 10) |> 
    mutate(
      group__ = NA_character_,  # Set all groups to NA
      sample = paste0("new_", sample)  # Give them new sample names
    )
  
  
  # Test
  result = sccomp:::replicate_data(estimate,
                formula_composition = formula_composition,
                formula_variability = formula_variability,
                new_data = new_data,
                number_of_draws = 1,
                mcmc_seed = sample(1e5, 1),
                cores = 1)  

  print(result)
  print(result$summary())
  expect_s3_class(result, "CmdStanGQ")
  expect_true(any(grepl("counts_uncorrected", result$summary()$variable)))
}) 

test_that("prepare_replicate_data handles complex design with NAs and prints new X and random effect design matrices", {
  skip_cmdstan()
  # Create test data with complex factors and NAs
  age_raw <- c(25, 20, 35, 40, 45)
  age_scaled <- as.numeric(scale(age_raw, center = TRUE, scale = TRUE))

  # Test data without NAs
  test_data <- tibble(
    sample = c("sample1", "sample1", "sample2", "sample2", "sample3", "sample3", "sample4", "sample4", "sample5", "sample5"),
    type = c("healthy", "healthy", "healthy", "healthy", "cancer", "cancer", "cancer", "cancer", "healthy", "healthy"),
    age = rep(age_scaled, each = 2),
    sex = c("M", "M", "F", "F", "M", "M", "F", "F", "M", "M"),
    group__ = c("GROUP1", "GROUP1", "GROUP2", "GROUP2", "GROUP1", "GROUP1", "GROUP2", "GROUP2", "GROUP1", "GROUP1"),
    count = c(10, 12, 15, 17, 20, 22, 25, 27, 30, 32),
    cell_group = c("A", "B", "A", "B", "A", "B", "A", "B", "A", "B")
  )

  # New data - only sample-related columns
  new_data = tibble(
    sample = c("sample1", "sample2", "sample3", "sample4", "sample5"),
    type = c("healthy", "healthy", "cancer", NA, "healthy"),
    age = c(age_scaled[1], age_scaled[2], NA, age_scaled[4], age_scaled[5]),
    sex = c("M", "F", NA, "M", "F"),
    group__ = c("GROUP1", "GROUP2", "GROUP1", "GROUP2", "GROUP1")
  )

  # Define formulas
  formula_composition <- ~ type * age * sex + (1 + age | group__)
  formula_variability <- ~ type

  # Use parse_formula_random_effect for random_effect_elements
  random_effect_elements <- sccomp:::parse_formula_random_effect(formula_composition)
  
  # Create .data object
  model_input =   
    test_data |> 
    sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = "group__"
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = random_effect_elements
    )
  
  # Create original_count_data using .subset()
  original_count_data = test_data |>
    sccomp:::.subset(!!quo(sample)) |>
    distinct(sample, type, age, sex, group__)
  
  # Prepare replicate data
  result <- sccomp:::prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!rlang::quo(sample),
    .cell_group = !!rlang::quo(cell_group),
    .count = !!rlang::quo(count),
    formula_composition = formula_composition,
    original_formula_composition = formula_composition,
    formula_variability = formula_variability,
    new_data = new_data,
    original_count_data = original_count_data
  )

  # Print the new fixed effect design matrix (X)
  cat("\nNew fixed effect design matrix (X):\n")
  print(result$X)

  # Print the new random effect design matrix (X_random_effect)
  cat("\nNew random effect design matrix (X_random_effect):\n")
  print(result$X_random_effect)

  # Print the new random effect design matrix 2 (if present)
  if (!is.null(result$X_random_effect_2)) {
    cat("\nNew random effect design matrix 2 (X_random_effect_2):\n")
    print(result$X_random_effect_2)
  }

  # Evaluate structure
  expect_true(is.matrix(result$X) || is.data.frame(result$X))
  expect_true(is.matrix(result$X_random_effect) || is.data.frame(result$X_random_effect))
  expect_equal(nrow(result$X), nrow(original_count_data))
  expect_equal(nrow(result$X_random_effect), nrow(original_count_data))
  # Check that NAs are handled (no NA in design matrices)
  expect_true(all(!is.na(result$X)))
  expect_true(all(!is.na(result$X_random_effect)))
})

test_that("prepare_replicate_data throws error for duplicate sample names", {
  skip_cmdstan()
  # Load test data
  data("counts_obj")
  
  # Create formulas
  formula_composition = ~ type
  formula_variability = ~ type
  
  # Create .data object
  model_input = 
    counts_obj |> 
    mutate(random_effect = "1") |> 
    sccomp:::data_to_spread(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      .grouping_for_random_effect = "random_effect"
    ) |>
    sccomp:::data_spread_to_model_input(
      formula = formula_composition,
      .sample = !!quo(sample),
      .cell_group = !!quo(cell_group),
      .count = !!quo(count),
      truncation_ajustment = 1.1,
      approximate_posterior_inference = FALSE,
      formula_variability = formula_variability,
      contrasts = NULL,
      bimodal_mean_variability_association = FALSE,
      use_data = TRUE,
      random_effect_elements = tibble(factor = character(), grouping = character())
    )

  # Test case 1: Duplicate samples in original_count_data
  original_count_data_duplicates = 
    counts_obj |>
    sccomp:::.subset(!!quo(sample)) 
  
  original_count_data_duplicates = 
    original_count_data_duplicates |>
    bind_rows(
      original_count_data_duplicates |> filter(sample == first(sample))  # Duplicate first sample
    ) 

  expect_error(
    sccomp:::prepare_replicate_data(
      X = model_input$X,
      Xa = model_input$Xa,
      N = model_input$N,
      intercept_in_design = model_input$intercept_in_design,
      X_random_effect = model_input$X_random_effect,
      X_random_effect_2 = model_input$X_random_effect_2,
      .sample = !!rlang::quo(sample),
      .cell_group = !!rlang::quo(cell_group),
      .count = !!rlang::quo(count),
      formula_composition = formula_composition,
      original_formula_composition = formula_composition,
      formula_variability = formula_variability,
      new_data = NULL,
      original_count_data = original_count_data_duplicates
    ),
    "sccomp says: your original_count_data has duplicated sample names"
  )

  # Test case 2: Duplicate samples in new_data
  new_data_duplicates = 
    counts_obj |>
    sccomp:::.subset(!!quo(sample)) |> 
    bind_rows(
      counts_obj |> sccomp:::.subset(!!quo(sample)) |> filter(sample == first(sample))  # Duplicate first sample
    ) 

  expect_error(
    sccomp:::prepare_replicate_data(
      X = model_input$X,
      Xa = model_input$Xa,
      N = model_input$N,
      intercept_in_design = model_input$intercept_in_design,
      X_random_effect = model_input$X_random_effect,
      X_random_effect_2 = model_input$X_random_effect_2,
      .sample = !!rlang::quo(sample),
      .cell_group = !!rlang::quo(cell_group),
      .count = !!rlang::quo(count),
      formula_composition = formula_composition,
      original_formula_composition = formula_composition,
      formula_variability = formula_variability,
      new_data = new_data_duplicates,
      original_count_data = counts_obj |> sccomp:::.subset(!!quo(sample))
    ),
    "sccomp says: your new_data has duplicated sample names"
  )
})

library(dplyr)
library(tidyr)
library(sccomp)
data("seurat_obj")
data("sce_obj")
data("counts_obj")

counts_obj = 
  counts_obj |>
  mutate(count = count+1) |> 
  with_groups("sample", ~ .x |> mutate(proportion = count/sum(count))) 

set.seed(42)

n_iterations = 1000

if (instantiate::stan_cmdstan_exists()){
  
  my_estimate = 
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ continuous_covariate * type ,
      formula_variability = ~ 1,
      "sample", "cell_group",
      
      cores = 1, 
      inference_method = "pathfinder",
      # mcmc_seed = 42,
      max_sampling_iterations = n_iterations, verbose=FALSE
    )
  
  my_estimate_inverse_factor = 
    seurat_obj[[]] |>
    mutate(type = type |> forcats::fct_relevel("healthy")) |> 
    sccomp_estimate(
      formula_composition = ~ continuous_covariate * type ,
      formula_variability = ~ 1,
      "sample", "cell_group",
      
      cores = 1, 
      inference_method = "pathfinder",
      # mcmc_seed = 42,
      max_sampling_iterations = n_iterations, verbose=FALSE
    )
  
  my_estimate_full_bayes = 
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ continuous_covariate * type ,
      formula_variability = ~ 1,
      "sample", "cell_group",
      cores = 1, 
      inference_method = "hmc",
      mcmc_seed = 42,
      max_sampling_iterations = n_iterations, verbose=FALSE
    )
  
  my_estimate_no_intercept = 
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ 0 + type + continuous_covariate,
      formula_variability = ~ 1,
      "sample", "cell_group",
      cores = 1,
      mcmc_seed = 42,
      max_sampling_iterations = n_iterations, verbose=FALSE
    )
  
  my_estimate_random = 
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ type + (type | group__),
      
      formula_variability = ~ 1,
      "sample", "cell_group",
      cores = 1,
      mcmc_seed = 42,     
      max_sampling_iterations = n_iterations, verbose=FALSE
    )
  
  
  
}

test_that("correct columns",{
  skip_cmdstan()
  
  my_estimate = 
    seurat_obj |>
    sccomp_estimate(
      sample = "sampleX", 
      cell_group = "cell_group"
    ) |> 
    expect_error("Can't select columns that don't exist") |> 
    expect_warning("please check typos in your")
  
  my_estimate = 
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ typeX,
      sample = "sample", 
      cell_group = "cell_group"
    ) |> 
    expect_error("Can't subset elements that don't exist") |> 
    expect_warning("please check typos in your")
  
  
})

test_that("Generate data",{
  skip_cmdstan()

  my_estimate |>

    sccomp_replicate() |>
    nrow() |>
    expect_equal(600)

  # With grouping
  my_estimate_random |>

    sccomp_replicate(~ 1 + type) |>
    nrow() |>
    expect_equal(600)


})

test_that("Predict data",{
  skip_cmdstan()
  library(stringr)
  
  new_data_seurat = seurat_obj[, seurat_obj[[]]$sample %in% c("10x_8K", "SI-GA-E5")] 
  new_data_seurat[[]]$sample = new_data_seurat[[]]$sample |> str_replace("SI", "AB") |>  str_replace("10x", "9x") 
  new_data_tibble = new_data_seurat[[]] |> distinct(sample, type, continuous_covariate, group__)
  
  # With new tibble data
  my_estimate |>
    
    sccomp_predict(
      formula_composition = ~ type,
      new_data = new_data_tibble
    ) |>
    nrow() |>
    expect_equal(60)

  
  # With new covariates
  new_data_tibble$continuous_covariate  =  c(1, 2)
  
  my_estimate |>
    
    sccomp_predict(
      formula_composition = ~ continuous_covariate,
      new_data = new_data_tibble
    ) |>
    nrow() |>
    expect_equal(60)
  
  # With random effects
  my_estimate_random |>
    sccomp_predict(~ 1 + type) |>
    nrow() |>
    expect_equal(600)
  
  # With new seurat data if you ever need this
  my_estimate |>
    
    sccomp_predict(
      formula_composition = ~ type,
      new_data = new_data_tibble, 
      number_of_draws = 1
    ) |>
    nrow() |>
    expect_equal(60)
  
  
  # Predict random
  
  my_estimate_random |> 
    sccomp_predict(
      formula_composition = ~ type + (1 | group__),
      new_data = new_data_tibble, 
      number_of_draws = 1
    )
  
  # Test robust parameter
  prediction_robust = 
    my_estimate |>
    sccomp_predict(
      formula_composition = ~ type,
      new_data = new_data_tibble,
      robust = TRUE,
      number_of_draws = 1
    )
  
  # Test that robust prediction works and returns expected columns
  expect_true("proportion_mean" %in% colnames(prediction_robust))
  expect_true("proportion_lower" %in% colnames(prediction_robust))
  expect_true("proportion_upper" %in% colnames(prediction_robust))
  expect_equal(nrow(prediction_robust), 60)
  
})

test_that("outliers",{
  
  skip_cmdstan()
  
  my_estimate |>
    sccomp_remove_outliers(
      cores = 1, 
      max_sampling_iterations = n_iterations,
      inference_method = "hmc",
       verbose=FALSE
    )
  
})

test_that("multilevel multi beta binomial from Seurat",{
  
  skip_cmdstan()
  
 res =
    seurat_obj |>
    ## filter(cell_group %in% c("NK cycling", "B immature")) |>
    sccomp_estimate(
      formula_composition = ~ type + (1 | group__),
      formula_variability = ~ 1,
      "sample", "cell_group",
      cores = 1,
      mcmc_seed = 42,     
      max_sampling_iterations = n_iterations, verbose=FALSE
    )

  # # Check order
  # res |>
  #   filter(parameter == "typehealthy") |>
  #   arrange(desc(abs(c_effect))) |>
  #   slice(1:3) |>
  #   pull(cell_group) |>
  #   sort() |> 
  #   expect_equal(c("CD4 cm high cytokine", "CD4 ribosome", "Mono NKG7 2"  ) |> sort())

  # Check convergence
  # res |>
  #   filter(c_R_k_hat > 4) |>
  #   nrow() |>
  #   expect_equal(0)

  # res |>
  #   filter(parameter == "typecancer - typehealthy") |>
  #   arrange(desc(abs(c_effect))) |>
  #   slice(1:3) |>
  #   pull(cell_group) |>
  #   sort() |>
  #   expect_equal(c("B mem"  ,  "CD4 cm high cytokine" ,"CD4 ribosome"         ))

  # Check convergence
  # res |>
  #   filter(c_R_k_hat > 4) |>
  #   nrow() |>
  #   expect_equal(0)

})

test_that("multilevel nested",{
  
  skip_cmdstan()
  
  library(tidyseurat)
  library(sccomp)

  res =
    seurat_obj |>
    dplyr::left_join(
      tibble(
        sample = c("SI-GA-H1", "SI-GA-H3", "SI-GA-H4", "SI-GA-G6", "SI-GA-G7",
                   "SI-GA-G8", "SI-GA-E5", "SI-GA-G9", "SI-GA-E7", "SI-GA-E8",
                   "GSE115189", "10x_6K", "10x_8K", "SRR11038995", "SRR7244582",
                   "SCP345_580", "SCP345_860", "SCP424_pbmc1", "SCP424_pbmc2", "SCP591"),
        group__ = c("GROUP1", "GROUP1", "GROUP1", "GROUP1", "GROUP1",
                    "GROUP2", "GROUP2", "GROUP2", "GROUP2", "GROUP2",
                    "GROUP3", "GROUP3", "GROUP3", "GROUP3", "GROUP3",
                    "GROUP4", "GROUP4", "GROUP4", "GROUP4", "GROUP4"),
        nested_group = c("GROUP1_Group_1", "GROUP1_Group_2", "GROUP1_Group_1", 
                         "GROUP1_Group_2", "GROUP1_Group_1", "GROUP2_Group_1", 
                         "GROUP2_Group_2", "GROUP2_Group_1", "GROUP2_Group_2", 
                         "GROUP2_Group_1", "GROUP3_Group_1", "GROUP3_Group_2", 
                         "GROUP3_Group_1", "GROUP3_Group_2", "GROUP3_Group_1", 
                         "GROUP4_Group_1", "GROUP4_Group_2", "GROUP4_Group_1", 
                         "GROUP4_Group_2", "GROUP4_Group_1")
      )
    ) |> 
    sccomp_estimate(
      formula_composition = ~ type + (1 | group__) + (1 | nested_group),
      formula_variability = ~ 1,
      "sample", "cell_group",
      cores = 1,
      mcmc_seed = 42,     
      max_sampling_iterations = n_iterations, verbose=FALSE
    ) |> 
    expect_no_error()
  
  res |> 
    sccomp_predict() |> 
    expect_no_error()
  
  res |> 
    sccomp_predict(formula_composition = ~ type + (1 | nested_group)) |> 
    expect_no_error()
  
})


test_that("multilevel multi beta binomial from Seurat with intercept and continuous covariate",{

  skip_cmdstan()
  
  library(sccomp)

  res =
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ continuous_covariate + (1 + continuous_covariate | group__),
      formula_variability = ~ 1,
      "sample", "cell_group",
      cores = 1,
      mcmc_seed = 42,   
      max_sampling_iterations = n_iterations,
      inference_method = "hmc", verbose=FALSE
    )

    expect(
      "CD8 em 1" %in%
      (res |>
        filter(parameter == "continuous_covariate") |>
        arrange(desc(abs(c_effect))) |>
        slice(1:3) |>
        pull(cell_group)),
      TRUE
    )


  # Check convergence
  # res |>
  #   filter(c_R_k_hat > 4) |>
  #   nrow() |>
  #   expect_equal(0)


})

# test_that("wrongly-set groups",{
#
#   # library(tidyseurat)
#   # seurat_obj =
#   #   seurat_obj |>
#   #   nest(data = -c("sample", type)) |>
#   #   mutate(group__wrong = c(1,1,1,1,1, 2,2,2,2,2) |> as.character()) |>
#   #   unnest(data)
#
#     expect_error(
#       object =
#         seurat_obj |>
#         ## filter(cell_group %in% c("NK cycling", "B immature")) |>
#         sccomp_estimate(
#           formula_composition = ~ 0 + type + (type | group__wrong),
#           formula_variability = ~ 1,
#           "sample", "cell_group",
#           contrasts = c("typecancer - typehealthy", "typehealthy - typecancer"),
#           cores = 1,
#           mcmc_seed = 42,       max_sampling_iterations = n_iterations
#         ) ,
#       regexp = "should not be shared"
#     )
#
# })

test_that("multi beta binomial from Seurat",{

  skip_cmdstan()
  
  my_estimate |>
    filter(parameter == "typehealthy") |>
    arrange(desc(abs(c_effect))) |>
    slice(1) |>
    pull(cell_group) |>
    expect_in(c("B mem", "CD4 cm high cytokine"))
  
  my_estimate_full_bayes |>
    filter(parameter == "typehealthy") |>
    arrange(desc(abs(c_effect))) |>
    slice(1) |>
    pull(cell_group) |>
    expect_in(c("B mem", "CD4 cm high cytokine"))
  
  # Check convergence
  # my_estimate |>
  #   filter(c_R_k_hat > 4) |>
  #   nrow() |>
  #   expect_equal(0)

})

test_that("calculate residuals",{

  skip_cmdstan()
  library(dplyr)
  
  my_estimate_random |> 
    sccomp:::sccomp_calculate_residuals() |> 
    pull(residuals) |> 
    max() |> 
    expect_lt(1)
  
})

test_that("remove unwanted effects",{

  skip_cmdstan()
  
  library(tidyseurat)
  
  data =
    seurat_obj |>
    
    # Add batch
    nest(data = -c("sample", type)) |>
    mutate(batch = rep(c(0,1), 10)) |>
    unnest(data)
  
  # Estimate
  estimate =
    data |>
    sccomp_estimate(
      formula_composition = ~ type + batch,
      formula_variability = ~ 1,
      "sample", "cell_group",
      cores = 1,
      mcmc_seed = 43,    
      max_sampling_iterations = n_iterations, verbose = FALSE
    )

})

test_that("multi beta binomial from SCE",{

  skip_cmdstan()
  
    res =
      sce_obj |>
    sccomp_estimate(
      formula_composition = ~ type,
      formula_variability = ~ 1,
      sample = "sample",
      cell_group = "cell_group",
      cores = 1,
      mcmc_seed = 42,      
      max_sampling_iterations = n_iterations, verbose = FALSE
    )

  # res |>
  #   filter(parameter == "typehealthy") |>
  #   arrange(desc(abs(c_effect))) |>
  #   slice(1) |>
  #   pull(cell_group) |>
  #   expect_equal(c("B mem"  ))

  # Check convergence
  # res |>
  #   filter(c_R_k_hat > 4) |>
  #   nrow() |>
  #   expect_equal(0)
})

if (instantiate::stan_cmdstan_exists()){
res_composition =
  seurat_obj[[]] |>
  sccomp_estimate(
    formula_composition = ~ type,
    formula_variability = ~ 1,
    "sample",
    "cell_group",
    cores = 1,
    mcmc_seed = 42,   
    max_sampling_iterations = n_iterations, verbose = FALSE
  )

res_composition_variability =
  seurat_obj[[]] |>
  sccomp_estimate(
    formula_composition = ~ type,
    formula_variability = ~ type,
    "sample",
    "cell_group",
    cores = 1,
    mcmc_seed = 42,    
    max_sampling_iterations = n_iterations, verbose = FALSE
  )
}

test_that("multi beta binomial from metadata",{

  skip_cmdstan()
  
  # res_composition  |>
  #   filter(parameter == "typehealthy") |>
  #   arrange(desc(abs(c_effect))) |>
  #   slice(1) |>
  #   pull(cell_group) |>
  #   expect_equal(c("B mem"  ))

  # Check convergence
  # res_composition |>
  #   filter(c_R_k_hat > 4) |>
  #   nrow() |>
  #   expect_equal(0)

})

test_that("plot test composition",{

  skip_cmdstan()
  
  my_estimate |> 
    sccomp_test() |> 
    plot()

  my_estimate |> 
    plot() |> 
    expect_error("sccomp says: to produce plots, you need to run the function sccomp_test")
  
})

test_that("plot test variability",{

  skip_cmdstan()
  
  res_composition_variability |> 
    sccomp_test() |> 
    plot()


})

# Test for plot_boxplot function
test_that("plot_boxplot function works correctly", {
  
  skip_cmdstan()
  
  my_estimate |> 
    sccomp_test() |> 
    sccomp_boxplot("type", significance_threshold = 0.025) |> 
  expect_s3_class( "ggplot")
  
  # With removal unwanted variation
  my_estimate |> 
    sccomp_test() |> 
    sccomp_boxplot("type", significance_threshold = 0.025, remove_unwanted_effects = TRUE) |> 
    expect_s3_class( "ggplot")
})

test_that("test constrasts",{

  skip_cmdstan()
  
  new_test =
    my_estimate |>
    sccomp_test() 
  
  # Right and wrong contrasts
  my_estimate |> 
    sccomp_test(contrasts = c("a" = "`(Intercept)`", "b" = "typehealthy")) |> 
    expect_s3_class("tbl")
  
  my_estimate |> 
    sccomp_test(contrasts = "(Intercept)") |> 
    expect_error() |> 
    expect_warning("sccomp says: These components of your contrasts")
  
  my_estimate |> 
    sccomp_test(contrasts = "typehealthy_") |> 
    expect_error() |> 
    expect_warning("These components of your contrasts are not present")
  
  
  res = my_estimate_no_intercept |> 
    sccomp_test(contrasts = c("1/2*typecancer - 1/2*typehealthy", "1/2*typehealthy - 1/2*typecancer") )
  
  
  expect_equal(
    res[1,"c_effect"] |> as.numeric(),
    -res[2,"c_effect"] |> as.numeric()
  )
  
  # Interaction
  my_estimate |> 
    sccomp_test(contrasts = c("(1/2*`continuous_covariate:typehealthy` + 1/2*`continuous_covariate:typehealthy`) -  `continuous_covariate:typehealthy`") ) |> 
    expect_s3_class("tbl")
  
  # Wrong interaction
  my_estimate |> 
    sccomp_test(contrasts = c("(1/2*continuous_covariate:typehealthy + 1/2*`continuous_covariate:typehealthy`) -  `continuous_covariate:typehealthy`") ) |> 
    expect_error() |> 
    expect_warning("sccomp says: for columns which have special characters") 
  

})

# test_that("proportions",{
#   
#   skip_cmdstan()
#   
#   counts_obj |>
#       sccomp_estimate(
#       formula_composition = ~ type, 
#       sample = "sample",  
#       cell_group = "cell_group", 
#       abundance = "proportion",
#       cores = 1,
#       mcmc_seed = 42,
#       max_sampling_iterations = n_iterations, verbose = FALSE
#     ) |> 
#       expect_warning("sccomp says: your proportion values include 0")
#  
#   # counts_obj |>
#   #   sccomp_estimate(
#   #     formula_composition = ~ type ,
#   #     sample = "sample",
#   #     cell_group = "cell_group",
#   #     abundance = "proportion",
#   #     cores = 1,
#   #     mcmc_seed = 42,
#   #     max_sampling_iterations = n_iterations
#   #   ) |>
#   #   expect_warning("sccomp says: your proportion values include 0.*")
#   
# })

test_that("sccomp_proportional_fold_change",{
  
  skip_cmdstan()
  
  
  my_estimate |> 
    sccomp_proportional_fold_change(formula_composition = ~  type, from =  "healthy", to = "cancer") |> 
    expect_no_error()
  
  
  my_estimate_inverse_factor |> 
    sccomp_proportional_fold_change(formula_composition = ~  type, from =  "healthy", to = "cancer") |> 
    pull(proportion_fold_change) |> 
    unique() |> 
    length() |> 
    expect_equal(1)
  
})

test_that("plotting for no significance",{
  
  skip_cmdstan()
  
  
  no_significance_df |>
    mutate(count = count |> as.integer()) |> 
    sccomp_estimate(formula_composition = ~ condition,
                    sample = "sample",
                    cell_group = "cell_group",abundance = "count",
                    bimodal_mean_variability_association = TRUE,      
                    cores = 1, max_sampling_iterations = n_iterations, verbose = FALSE
) |>
    sccomp_test() |> 
    sccomp_boxplot("condition") |> 
    expect_warning() |> 
    expect_no_error()
  
  
  
  
})

# Load necessary libraries
library(testthat)
library(stringr)

# Define helper functions (assuming they are already defined as before)

# Begin unit tests
test_that("contrasts_to_parameter_list handles various contrasts correctly", {
  skip_cmdstan()
  # Define a variety of contrasts
  contrasts <- c(
    # Simple contrast without special characters
    "GroupA - GroupB",
    
    # Contrast with variable names containing spaces (requires backquotes)
    "`Variable with spaces` - `Another variable`",
    
    # Contrast with special characters in variable names
    "`Variable#1` + `Variable-2` - `Variable.3`",
    
    # Contrast with multiplication and division
    "0.5 * Treatment / Control",
    
    # Contrast with fractions
    "(1/2) * (`Var1` + `Var2`) - (`Var3` / 2)",
    
    # Contrast with fractions used in multiplication after '*'
    "(`Variable1` + `Variable2`) * 1/2",
    
    # Contrast with nested backquotes and special characters
    "`age_bin_sex_specificSenior___adipose tissue` + `age_bin_sex_specificSenior:sexmale___adipose tissue`",
    
    # Complex contrast provided earlier
    "((`age_bin_sex_specificSenior___adipose tissue` + `age_bin_sex_specificSenior:sexmale___adipose tissue` + `age_bin_sex_specificMiddle Age___adipose tissue` + `age_bin_sex_specificMiddle Age:sexmale___adipose tissue`) / 2) - ((`age_bin_sex_specificYoung Adulthood___adipose tissue` + `age_bin_sex_specificYoung Adulthood:sexmale___adipose tissue`) / 1)"
  )
  
  # Apply the function to extract parameters
  extracted_params <- contrasts_to_parameter_list(contrasts, drop_back_quotes = FALSE)
  
  # Expected parameters after extraction
  expected_params <- c(
    "GroupA", "GroupB",
    "`Variable with spaces`", "`Another variable`",
    "`Variable#1`", "`Variable-2`", "`Variable.3`",
    "Treatment", "Control",
    "`Var1`", "`Var2`", "`Var3`",
    "`Variable1`", "`Variable2`",
    "`age_bin_sex_specificSenior___adipose tissue`", "`age_bin_sex_specificSenior:sexmale___adipose tissue`",
    "`age_bin_sex_specificMiddle Age___adipose tissue`", "`age_bin_sex_specificMiddle Age:sexmale___adipose tissue`",
    "`age_bin_sex_specificYoung Adulthood___adipose tissue`", "`age_bin_sex_specificYoung Adulthood:sexmale___adipose tissue`"
  )

  # Remove duplicates from expected_params
  expected_params <- unique(expected_params)

  # Check if the extracted parameters match the expected parameters
  expect_equal(sort(extracted_params), sort(expected_params))

  # Now, check if backquotes are correctly applied where necessary
  contrasts_elements <- extracted_params

  # Function to check for valid column characters
  contains_only_valid_chars_for_column <- function(string){
    return(all(str_detect(string, "^[A-Za-z\\.][A-Za-z0-9\\._]*$")))
  }

  # # Check if backquotes are required
  # require_back_quotes <- !str_remove_all(contrasts_elements, "`") |> contains_only_valid_chars_for_column()
  #
  # # Check if backquotes are correctly placed
  # has_left_back_quotes <- str_detect(contrasts_elements, "^`")
  # has_right_back_quotes <- str_detect(contrasts_elements, "`$")
  #
  # # Identify elements that require backquotes but don't have them correctly
  # if_true_not_good <- require_back_quotes & !(has_left_back_quotes & has_right_back_quotes)
  #
  # # Expect that all elements either don't require backquotes or have them correctly placed
  # expect_true(all(!if_true_not_good))

})

test_that("sample ID malformed", {
  
  skip_cmdstan()

  counts_obj |>
  mutate(sample = if_else(sample %in% c("SCP424_pbmc1", "SCP424_pbmc2", "SCP345_860"), "SCP424_pbmc1", sample)) |>
    mutate(count = count |> as.integer()) |> 
  sccomp_estimate(
    formula_composition = ~ type ,
    sample = "sample",
    cell_group = "cell_group",
    abundance = "count",
    cores = 1, verbose = FALSE
  ) |>
  expect_warning("sccomp says: the input data frame does not have the same number") |>
    expect_error("sccomp says: You have duplicated")


  # Generate counts from negative binomial
  # From https://github.com/MangiolaLaboratory/sccomp/issues/178
  n_samples <- 100
  n_taxa <- 5
  dispersion = 0.3
  base_means <- rexp(n_taxa, rate = 1/100)
  counts <- matrix(
    rnbinom(
      n = n_samples * n_taxa,
      mu = rep(base_means, each = n_samples),
      size = 1 / 0.3
    ),
    nrow = n_samples
  )
  colnames(counts) <- paste0("taxon_", 1:n_taxa)
  
  counts_df <- as.data.frame(counts) %>%
    mutate(
      condition = rep(c("control", "treatment"), each = n_samples/2),
      sample = paste0("s", 1:n())
    ) %>%
    pivot_longer(
      -c("sample", condition),
      names_to = "taxon", values_to = "count")
  
  counts_df |> 
    mutate(count = count |> as.integer()) |> 
    sccomp_estimate(
      formula_composition = ~ condition,
      cell_group = "taxon",
      sample = "sample",
      abundance = "count", verbose = FALSE
    ) |> 
    expect_no_error()
  
  # For ~ 1 formula do not expect error
  model_without_association = 
    seurat_obj |>
    sccomp_estimate( 
      formula_composition = ~ 1, 
      sample = "sample", 
      cell_group = "cell_group", verbose = FALSE
    ) |> 
    expect_no_error()

})

test_that("LOO", {
  skip_cmdstan()
  
  library(loo)
  
  # Fit first model
  model_with_factor_association = 
    seurat_obj |>
    sccomp_estimate( 
      formula_composition = ~ type, 
      sample = "sample", 
      cell_group = "cell_group", 
      inference_method = "hmc",
      cores = 1, 
      enable_loo = TRUE, max_sampling_iterations = n_iterations, verbose = FALSE
    ) |> 
    expect_no_error()
  
  # Fit second model
  model_without_association = 
    seurat_obj |>
    sccomp_estimate( 
      formula_composition = ~ 1, 
      sample = "sample", 
      cell_group = "cell_group", 
      inference_method = "hmc",
      cores = 1, 
      enable_loo = TRUE, max_sampling_iterations = n_iterations, verbose = FALSE
    ) |> 
    expect_no_error()
  
  # Compare models
  loo_compare(
    attr(model_with_factor_association, "fit")$loo(),
    attr(model_without_association, "fit")$loo()
  ) |> 
    suppressWarnings() |> 
    expect_no_error()
  
})

test_that("use two methods", {

  skip_cmdstan()

    seurat_obj |>
    sccomp_estimate( 
      formula_composition = ~ 1, 
      sample = "sample", 
      cell_group = "cell_group", 
      inference_method = "hmc",
      cores = 1, max_sampling_iterations = n_iterations, verbose = FALSE
    ) |> 
    sccomp_remove_outliers(inference_method = "pathfinder", cores = 1, max_sampling_iterations = n_iterations) |> 
    expect_no_error()
  
})

test_that("get_design_matrix_with_na_handling properly handles NA values", {
  skip_cmdstan()
  # Create a test dataset with NA values in categorical variables
  test_data <- tibble(
    sample = paste0("sample_", 1:10),
    type = c("A", "B", "A", "B", "A", NA, NA, "C", "C", "B"),
    numeric_var = c(1.2, 0.8, 1.5, 0.6, 1.0, 0.9, 1.1, 1.3, 0.7, 0.5)
  )
  test_data$type <- as.factor(test_data$type)
  
  # Create a test dataset with NA at the beginning
  test_data_na_first <- tibble(
    sample = paste0("sample_", 1:10),
    type = c(NA, NA, "A", "B", "A", "B", "A", "C", "C", "B"),
    numeric_var = c(0.9, 1.1, 1.2, 0.8, 1.5, 0.6, 1.0, 1.3, 0.7, 0.5)
  )
  test_data_na_first$type <- as.factor(test_data_na_first$type)
  
  # Create the formula
  formula <- ~ type + numeric_var
  
  # Call the function for both datasets
  design_matrix <- sccomp:::get_design_matrix_with_na_handling(test_data, formula, sample)
  design_matrix_na_first <- sccomp:::get_design_matrix_with_na_handling(test_data_na_first, formula, sample)
  
  # Test colnames of design_matrix_na_first
  expect_equal(colnames(design_matrix_na_first), colnames(design_matrix))
  
  # Test dimensions
  expect_equal(nrow(design_matrix), 10)
  
  # Test that NA column is removed
  expect_false(any(grepl("typeNA", colnames(design_matrix))))
  
  # Test that rows with NA values get equal distribution across factor levels
  # Get row indices with NA in original data
  na_rows <- which(is.na(test_data$type))
  
  # Get type columns in design matrix
  type_cols <- grep("^type", colnames(design_matrix))
  
  # Number of visible levels in design matrix
  n_visible_levels <- length(type_cols)
  
  # Expected value accounting for reference level: 1/(n_visible_levels+1)
  # This matches current implementation which considers reference level
  expected_value <- 1/(n_visible_levels + 1)
  
  # For NA rows, each type column should have the expected value
  for (row in na_rows) {
    for (col in type_cols) {
      expect_equal(design_matrix[row, col], expected_value, 
                   tolerance = 1e-6,
                   info = paste("Row", row, "Column", col))
    }
  }
  
  # Test multiclass factor with 3 levels
  test_data2 <- tibble(
    sample = paste0("sample_", 1:10),
    type3 = c("X", "Y", "Z", "X", "Y", NA, NA, "Z", "X", "Y"),
    numeric_var = c(1.2, 0.8, 1.5, 0.6, 1.0, 0.9, 1.1, 1.3, 0.7, 0.5)
  )
  test_data2$type3 <- as.factor(test_data2$type3)
  
  formula2 <- ~ type3 + numeric_var
  
  design_matrix2 <- get_design_matrix_with_na_handling(test_data2, formula2, sample)
  
  # Test dimensions
  expect_equal(nrow(design_matrix2), 10)
  
  # Test that NA column is removed
  expect_false(any(grepl("type3NA", colnames(design_matrix2))))
  
  # Get NA rows
  na_rows2 <- which(is.na(test_data2$type3))
  
  # Get type columns in design matrix
  type_cols2 <- grep("^type3", colnames(design_matrix2))
  
  # Number of visible levels in design matrix
  n_visible_levels2 <- length(type_cols2)
  
  # For a 3-level factor with one reference level, each visible column should get 1/3
  expected_value2 <- 1/(n_visible_levels2 + 1)
  
  # For NA rows, each type column should have the expected value
  for (row in na_rows2) {
    for (col in type_cols2) {
      expect_equal(design_matrix2[row, col], expected_value2, 
                   tolerance = 1e-6,
                   info = paste("Row", row, "Column", col))
    }
  }
  
  # Test mix of categorical and numeric variables
  test_data3 <- tibble(
    sample = paste0("sample_", 1:10),
    type = c("A", "B", "A", "B", "A", NA, NA, "C", "C", "B"),
    numeric_var = c(1.2, 0.8, 1.5, 0.6, 1.0, NA, 1.1, 1.3, 0.7, 0.5)
  )
  test_data3$type <- as.factor(test_data3$type)
  
  formula3 <- ~ type + numeric_var
  
  # This should handle both NA in factors and numerics
  expect_error(design_matrix3 <- get_design_matrix_with_na_handling(test_data3, formula3, sample), NA)
})

test_that("renamed columns in Seurat input", {
  skip_cmdstan()
  
  # Create a copy of seurat_obj with renamed columns
  renamed_seurat = seurat_obj
  colnames(renamed_seurat[[]])[colnames(renamed_seurat[[]]) == "sample"] = "a"
  colnames(renamed_seurat[[]])[colnames(renamed_seurat[[]]) == "cell_group"] = "b"
  
  # Test that sccomp_estimate works with renamed columns
  renamed_estimate = 
    renamed_seurat |>
    sccomp_estimate(
      formula_composition = ~ type,
      formula_variability = ~ 1,
      sample = "a",
      cell_group = "b",
      cores = 1,
      mcmc_seed = 42,
      max_sampling_iterations = n_iterations,
      verbose = FALSE
    ) |>
    expect_no_error()
  
  # Verify the results contain the expected columns and data
  expect_true("b" %in% (renamed_estimate |> attr(".cell_group") |> as.character()))
  expect_true(all(c("a", "b") %in% colnames(renamed_seurat[[]])))
  
  # Test that we can still use the renamed columns for predictions
  renamed_estimate |>
    sccomp_predict(
      formula_composition = ~ type,
      new_data = renamed_seurat[[]] |> distinct(a, type),
      number_of_draws = 1
    ) |>
    expect_no_error()
})

#' Calculate Residuals Between Observed and Predicted Proportions
#'
#' @description
#' `sccomp_calculate_residuals` computes the residuals between observed cell group proportions and the predicted proportions from a fitted `sccomp` model. This function is useful for assessing model fit and identifying cell groups or samples where the model may not adequately capture the observed data. The residuals are calculated as the difference between the observed proportions and the predicted mean proportions from the model.
#'
#' @param .data A tibble of class `sccomp_tbl`, which is the result of `sccomp_estimate()`. This tibble contains the fitted model and associated data necessary for calculating residuals.
#'
#' @return A tibble (`tbl`) with the following columns:
#' \itemize{
#'   \item \strong{sample} - A character column representing the sample identifiers.
#'   \item \strong{cell_group} - A character column representing the cell group identifiers.
#'   \item \strong{residuals} - A numeric column representing the residuals, calculated as the difference between observed and predicted proportions.
#'   \item \strong{exposure} - A numeric column representing the total counts (sum of counts across cell groups) for each sample.
#' }
#'
#' @details
#' The function performs the following steps:
#' \enumerate{
#'   \item Extracts the predicted mean proportions for each cell group and sample using `sccomp_predict()`.
#'   \item Calculates the observed proportions from the original count data.
#'   \item Computes residuals by subtracting the predicted proportions from the observed proportions.
#'   \item Returns a tibble containing the sample, cell group, residuals, and exposure (total counts per sample).
#' }
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
#' @importFrom dplyr select
#' @importFrom dplyr mutate
#' @importFrom dplyr left_join
#' @importFrom dplyr distinct
#' @importFrom dplyr with_groups
#' @importFrom tidyr pivot_longer
#' @importFrom tibble as_tibble
#' @importFrom magrittr %$%
#' @importFrom sccomp sccomp_predict
#'
#' @export
#'
#' @examples
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists() && .Platform$OS.type == "unix") {
#' # Load example data
#' data("counts_obj")
#'
#' # Fit the sccomp model
#' estimates <- sccomp_estimate(
#'   counts_obj,
#'   formula_composition = ~ type,
#'   formula_variability = ~1,
#'   sample = "sample",
#'   cell_group = "cell_group",
#'   abundance = "count",
#'   approximate_posterior_inference = "all",
#'   cores = 1
#' )
#'
#' # Calculate residuals
#' residuals <- sccomp_calculate_residuals(estimates)
#'
#' # View the residuals
#' print(residuals)
#' }}
#'
sccomp_calculate_residuals <- function(.data) {
  UseMethod("sccomp_calculate_residuals", .data)
}

#' @export
sccomp_calculate_residuals.sccomp_tbl = function(.data){
  
  
  
  model_input = attr(.data, "model_input")
  .sample = attr(.data, ".sample")
  .cell_group = attr(.data, ".cell_group")
  .grouping_for_random_intercept = attr(.data, ".grouping_for_random_intercept")
  .count = attr(.data, ".count")
  
  # Residuals
  residual = 
    .data |>
    sccomp_predict( 
      number_of_draws = 
        .data |>
        attr("fit") |>
        dim() |>
        _[1] |> 
        min(500) 
    ) |>
    distinct(!!.sample, !!.cell_group, proportion_mean) 
  
  if(.data |> attr("model_input") %$% is_proportion)
    y = .data |> attr("model_input") %$% y_proportion
  else
    y = .data |> attr("model_input") %$% y
  
  y = 
    y |> 
    as_tibble(rownames = quo_name(.sample)) |>
    pivot_longer(-!!.sample, names_to = quo_name(.cell_group), values_to = quo_name(.count)) |>
    with_groups(!!.sample,  ~ .x |> mutate(observed_proportion := !!.count / sum(!!.count ))) |>
    with_groups(!!.sample,  ~ .x |>  mutate(exposure := sum(!!.count))  )
  
  
  residual |>
    left_join(
      y,
      by = c(quo_name(.sample), quo_name(.cell_group))
    ) |>
    mutate(residuals = observed_proportion - proportion_mean) |>
    select(!!.sample, !!.cell_group, residuals, exposure)
  
}

#' counts_obj
#'
#' @description
#' A tidy example dataset containing cell counts per cell group (cluster), sample, and phenotype for differential analysis. This dataset represents the counts of cells in various phenotypes and cell groups across multiple samples.
#'
#' @return A `tibble` representing cell counts per cluster, with columns for sample, type, phenotype, cell group, and counts.
#' 
#' @format A tidy data frame with the following columns:
#' \itemize{
#'   \item \strong{sample}: Factor, representing the sample identifier.
#'   \item \strong{type}: Factor, indicating the sample type (e.g., benign, cancerous).
#'   \item \strong{phenotype}: Factor, representing the cell phenotype (e.g., B_cell, HSC, etc.).
#'   \item \strong{count}: Integer, representing the number of cells for each cell group within each sample.
#'   \item \strong{cell_group}: Factor, representing the cell group (e.g., BM, B1, Dm, etc.).
#' }
#' @usage data(counts_obj)
#' 
#' @importFrom utils data
"counts_obj"


#' seurat_obj
#'
#' @description
#' Example `Seurat` object containing gene expression data for 106,297 cells across a single assay. The object includes RNA counts and data layers, but no variable features are defined. This dataset can be directly used with functions like `sccomp_glm` for differential abundance analysis.
#'
#' @return A `Seurat` object containing single-cell RNA expression data.
#'
#' @format A `Seurat` object with the following structure:
#' \itemize{
#'   \item \strong{assays}: Contains gene expression data. The active assay is `RNA`, with 1 feature and no variable features.
#'   \item \strong{layers}: Two layers: counts and data, representing raw and processed RNA expression values, respectively.
#'   \item \strong{samples}: 106,297 samples (cells) within the RNA assay.
#' }
#' @usage data(seurat_obj)
#' 
#' @importFrom utils data
"seurat_obj"


#' sce_obj
#'
#' @description
#' Example `SingleCellExperiment` object containing gene expression data for 106,297 cells across two assays: counts and logcounts. The object includes metadata and assay data for RNA expression, which can be used directly in differential analysis functions like `sccomp_glm`.
#'
#' @return A `SingleCellExperiment` object containing single-cell RNA expression data.
#'
#' @format A `SingleCellExperiment` object with the following structure:
#' \itemize{
#'   \item \strong{assays}: Two assays: counts (raw RNA counts) and logcounts (log-transformed counts).
#'   \item \strong{rowData}: No additional row-level metadata is present.
#'   \item \strong{colData}: Metadata for each cell, including six fields: sample, type, nFeature_RNA, ident, and others.
#'   \item \strong{dim}: 1 feature and 106,297 cells.
#'   \item \strong{colnames}: Cell identifiers for all 106,297 cells.
#' }
#' @usage data(sce_obj)
#' 
#' @importFrom utils data
"sce_obj"


#' Create a multipanel theme compatible with ggplot2 4.0.0 S7 system
#'
#' @description
#' Creates a multipanel theme that is compatible with the new ggplot2 4.0.0 S7 system.
#' This function creates a fresh theme object using the new S7 system instead of relying
#' on the saved S3 theme object.
#'
#' @return A `ggplot2` theme object compatible with ggplot2 4.0.0
#'
#' @export
sccomp_theme <- function() {
  ggplot2::theme_bw() +
    ggplot2::theme(
      panel.border = ggplot2::element_rect(colour = "black", fill = NA, linewidth = 0.5),
      axis.line = ggplot2::element_line(linewidth = 0.5, colour = "black"),
      panel.grid.major = ggplot2::element_blank(),
      panel.grid.minor = ggplot2::element_blank(),
      legend.position = "bottom",
      strip.background = ggplot2::element_blank(),
      axis.title.y = ggplot2::element_text(margin = ggplot2::margin(t = 0, r = 0, b = 0, l = 0), size = 7, colour = "black"),
      axis.title.x = ggplot2::element_text(margin = ggplot2::margin(t = 0, r = 0, b = 0, l = 0), size = 7, colour = "black"),
      panel.spacing.x = ggplot2::unit(0.1, "lines"),
      axis.text.x = ggplot2::element_text(size = 6, colour = "grey30"),
      axis.text.y = ggplot2::element_text(size = 6, colour = "grey30"),
      strip.text.x = ggplot2::element_text(size = 7, colour = "grey10"),
      strip.text.y = ggplot2::element_text(size = 7, colour = "grey10"),
      legend.key.size = ggplot2::unit(5, 'mm'),
      legend.title = ggplot2::element_text(size = 7, colour = "black"),
      legend.text = ggplot2::element_text(size = 6, colour = "black"),
      strip.clip = "off",
      plot.title = ggplot2::element_text(size = 7, colour = "black"),
      axis.line.x = ggplot2::element_line(linewidth = 0.2, colour = "black"),
      axis.line.y = ggplot2::element_line(linewidth = 0.2, colour = "black"),
      axis.ticks.x = ggplot2::element_line(linewidth = 0.2, colour = "grey20"),
      axis.ticks.y = ggplot2::element_line(linewidth = 0.2, colour = "grey20"),
      axis.ticks.length = ggplot2::unit(2.75, "pt")
    )
}


#' no_significance_df
#'
#' @description
#' A small example dataset containing cell counts across samples, conditions, and cell groups. This dataset is used to demonstrate the use of `sccomp` functions in scenarios where there is no significant difference in cell composition between conditions.
#'
#' @return A tibble with 34 rows and 4 columns: \code{sample}, \code{condition}, \code{cell_group}, and \code{count}.
#'
#' @format A tibble with the following columns:
#' \itemize{
#'   \item \strong{sample}: Character. Identifier for each sample.
#'   \item \strong{condition}: Character. Experimental condition or group (e.g., "X" or "Y").
#'   \item \strong{cell_group}: Character. Cell group or cell type (e.g., "A", "B").
#'   \item \strong{count}: Numeric. Count of cells in the given sample, condition, and cell group.
#' }
#'
#' @usage data(no_significance_df)
#'
#' @examples
#' data(no_significance_df)
#' head(no_significance_df)
#'
#' @importFrom utils data
#' 
"no_significance_df"

#' DEPRECATED: Remove Unwanted Variation from sccomp Estimates
#'
#' @description This function is DEPRECATED. Please use \code{\link{sccomp_remove_unwanted_effects}} instead.
#' This function uses the model to remove unwanted variation from a dataset using the estimates of the model. 
#' For example, if you fit your data with the formula `~ factor_1 + factor_2` and use the formula `~ factor_1` 
#' to remove unwanted variation, the `factor_2` effect will be factored out.
#'
#' @param .data A tibble. The result of `sccomp_estimate`.
#' @param formula_composition_keep A formula. The formula describing the model for differential abundance, for example `~type`. In this case, only the effect of the `type` factor will be preserved, while all other factors will be factored out.
#' @param formula_composition DEPRECATED. Use `formula_composition_keep` instead.
#' @param formula_variability DEPRECATED. Use `formula_variability_keep` instead.
#' @param cores Integer, the number of cores to be used for parallel calculations.
#' 
#' @return A tibble (`tbl`) with the following columns:
#' \itemize{
#'   \item \strong{sample} - A character column representing the sample name for which data was adjusted.
#'   \item \strong{cell_group} - A character column representing the cell group being tested.
#'   \item \strong{adjusted_proportion} - A numeric column representing the adjusted proportion after removing unwanted variation.
#'   \item \strong{adjusted_counts} - A numeric column representing the adjusted counts after removing unwanted variation.
#'   \item \strong{logit_residuals} - A numeric column representing the logit residuals calculated after adjustment.
#' }
#'
#' @export
#'
#' @examples
#'
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'
#'     estimates = sccomp_estimate(
#'       counts_obj,
#'       ~ type, ~1, "sample", "cell_group", "count",
#'       cores = 1
#'     ) |>
#'     sccomp_remove_unwanted_variation()
#'   }
#' }
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
sccomp_remove_unwanted_variation <- function(.data,
                                             formula_composition_keep = NULL,
                                             formula_composition = NULL,
                                             formula_variability = NULL,
                                             cores = detectCores()) {
  lifecycle::deprecate_warn(
    "1.99.20",
    "sccomp::sccomp_remove_unwanted_variation()",
    details = "sccomp says: sccomp_remove_unwanted_variation is deprecated. Please use sccomp_remove_unwanted_effects() instead."
  )
  
  sccomp_remove_unwanted_effects(
    .data = .data,
    formula_composition_keep = formula_composition_keep,
    formula_composition = formula_composition,
    cores = cores
  )
}

#' simulate_data
#'
#' @description This function simulates data from a fitted model.
#'
#' @import dplyr
#' @importFrom magrittr %$%
#' @importFrom magrittr divide_by
#' @importFrom magrittr multiply_by
#' @importFrom magrittr equals
#' @importFrom rlang quo_is_null
#' @importFrom SingleCellExperiment colData
#' @importFrom parallel detectCores
#'
#' @param .data A tibble including a cell_group name column | sample name column | read counts column | factor columns | Pvalue column | a significance column
#' @param .estimate_object The result of sccomp_estimate execution. This is used for sampling from real-data properties.
#' @param formula_composition A formula. The formula describing the model for differential abundance, for example ~treatment
#' @param formula_variability A formula. The formula describing the model for differential variability, for example ~treatment
#' @param .sample A column name as symbol. The sample identifier
#' @param .cell_group A column name as symbol. The cell_group identifier
#' @param .coefficients The column names for coefficients, for example, c(b_0, b_1)
#' @param variability_multiplier A real scalar. This can be used for artificially increasing the variability of the simulation for benchmarking purposes.
#' @param number_of_draws An integer. How may copies of the data you want to draw from the model joint posterior distribution.
#' @param mcmc_seed An integer. Used for Markov-chain Monte Carlo reproducibility. By default a random number is sampled from 1 to 999999. This itself can be controlled by set.seed()#' @param cores Integer, the number of cores to be used for parallel calculations.
#' @param cores Integer, the number of cores to be used for parallel calculations.
#' @param sig_figs Number of significant figures to use for Stan model output. Default is 9.
#' @param cache_stan_model A character string specifying the cache directory for compiled Stan models. 
#'                        The sccomp version will be automatically appended to ensure version isolation.
#'                        Default is `sccomp_stan_models_cache_dir` which points to `~/.sccomp_models`.
#' 
#' @return A tibble (`tbl`) with the following columns:
#' \itemize{
#'   \item \strong{sample} - A character column representing the sample name.
#'   \item \strong{type} - A factor column representing the type of the sample.
#'   \item \strong{phenotype} - A factor column representing the phenotype in the data.
#'   \item \strong{count} - An integer column representing the original cell counts.
#'   \item \strong{cell_group} - A character column representing the cell group identifier.
#'   \item \strong{b_0} - A numeric column representing the first coefficient used for simulation.
#'   \item \strong{b_1} - A numeric column representing the second coefficient used for simulation.
#'   \item \strong{generated_proportions} - A numeric column representing the generated proportions from the simulation.
#'   \item \strong{generated_counts} - An integer column representing the generated cell counts from the simulation.
#'   \item \strong{replicate} - An integer column representing the replicate number for each draw from the posterior distribution.
#' }
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
#' @export
#'
#' @examples
#'
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'     library(dplyr)
#'
#'     estimate = sccomp_estimate(
#'       counts_obj,
#'       ~ type, ~1, "sample", "cell_group", "count",
#'       cores = 1
#'     )
#'
#'     # Set coefficients for cell_groups. In this case all coefficients are 0 for simplicity.
#'     counts_obj = counts_obj |> mutate(b_0 = 0, b_1 = 0)
#'
#'     # Simulate data
#'     simulate_data(counts_obj, estimate, ~type, ~1, sample, cell_group, c(b_0, b_1))
#'   }
#' }
#'
simulate_data <- function(.data,
                          .estimate_object,
                          formula_composition,
                          formula_variability = NULL,
                          .sample = NULL,
                          .cell_group = NULL,
                          .coefficients = NULL,
                          variability_multiplier = 5,
                          number_of_draws = 1,
                          mcmc_seed = sample_seed(),
                          cores = detectCores(),
                          sig_figs = 9,
                          cache_stan_model = sccomp_stan_models_cache_dir) {
  
  # Run the function
  check_and_install_cmdstanr()
  
  UseMethod("simulate_data", .data)
}

#' @export
#' @importFrom magrittr divide_by
#' @importFrom magrittr multiply_by
#' @importFrom SingleCellExperiment counts
#' @importFrom purrr map_dbl
#' @importFrom purrr pmap
#' @importFrom readr read_file
#' @importFrom tibble column_to_rownames
#'
simulate_data.tbl = function(.data,
                             .estimate_object,
                             formula_composition,
                             formula_variability = NULL,
                             .sample = NULL,
                             .cell_group = NULL,
                             .coefficients = NULL,
                             variability_multiplier = 5,
                             number_of_draws = 1,
                             mcmc_seed = sample_seed(),
                             cores = detectCores(),
                             sig_figs = 9,
                             cache_stan_model = sccomp_stan_models_cache_dir) {
  
  
  .sample = enquo(.sample)
  .cell_group = enquo(.cell_group)
  .coefficients = enquo(.coefficients)
  
  #Check column class
  check_if_columns_right_class(.data, !!.sample, !!.cell_group)
  
  model_data = attr(.estimate_object, "model_input")
  
  # # Select model based on noise model
  # if(attr(.estimate_object, "noise_model") == "multi_beta_binomial") my_model = stanmodels$glm_multi_beta_binomial_simulate_data
  # else if(attr(.estimate_object, "noise_model") == "dirichlet_multinomial") my_model = get_model_from_data("model_glm_dirichlet_multinomial_generate_quantities.rds", glm_dirichlet_multinomial_generate_quantities)
  # else if(attr(.estimate_object, "noise_model") == "logit_normal_multinomial") my_model = get_model_from_data("glm_multinomial_logit_linear_simulate_data.stan", read_file("~/PostDoc/sccomp/dev/stan_models/glm_multinomial_logit_linear_simulate_data.stan"))
  
  
  data_for_model =
    .data |>
    nest(data___ = -!!.sample) |>
    mutate(.exposure = sample(model_data$exposure, size = n(), replace = TRUE )) |>
    unnest(data___) |>
    data_simulation_to_model_input(
      formula_composition,
      #formula_variability,
      !!.sample, !!.cell_group, .exposure, !!.coefficients
    )
  names(data_for_model)  = names(data_for_model) |> stringr::str_c("_simulated")
  
  # Drop data from old input
  original_data = .estimate_object |> attr("model_input")
  original_data = original_data[(names(original_data) %in% c("C", "M", "A", "ncol_X_random_eff", "is_random_effect", "how_many_factors_in_random_design"  ))]
  
  # [1]  5.6260004 -0.6940178
  # prec_sd  = 0.816423129
  
  mod_rng = load_model("glm_multi_beta_binomial_simulate_data", threads = cores, cache_dir = cache_stan_model)
  
  fit = mod_rng |> sample_safe(
    generate_quantities_fx,
    attr(.estimate_object , "fit")$draws(format = "matrix"),
    
    # This is for the new data generation with selected factors to do adjustment
    data = data_for_model |> c(original_data) |> c(list(variability_multiplier = variability_multiplier)),
    seed = mcmc_seed,
    parallel_chains = attr(.estimate_object , "fit")$metadata()$threads_per_chain, 
    threads_per_chain = cores,
    sig_figs = sig_figs
  )
  
  parsed_fit =
    fit |>
    parse_generated_quantities(number_of_draws = number_of_draws) |>
    
    # Get sample name
    nest(data = -N) |>
    arrange(N) |>
    mutate(!!.sample := rownames(data_for_model$X_simulated)) |>
    unnest(data) |>
    
    # get cell type name
    nest(data = -M) |>
    mutate(!!.cell_group := colnames(data_for_model$beta_simulated)) |>
    unnest(data) |>
    
    select(-N, -M)
  
  .data |>
    left_join(
      parsed_fit,
      by = c(quo_name(.sample), quo_name(.cell_group))
    )
  
  
}

#' @importFrom purrr when
#' @importFrom stats model.matrix
#'
#' @keywords internal
#' @noRd
#'
data_simulation_to_model_input =
  function(.data, formula, .sample, .cell_type, .exposure, .coefficients, truncation_ajustment = 1, approximate_posterior_inference ){
    
    # Define the variables as NULL to avoid CRAN NOTES
    sd <- NULL
    . <- NULL
    
    
    # Prepare column same enquo
    .sample = enquo(.sample)
    .cell_type = enquo(.cell_type)
    .exposure = enquo(.exposure)
    .coefficients = enquo(.coefficients)
    
    factor_names = parse_formula(formula)
    
    sample_data =
      .data %>%
      select(!!.sample, any_of(factor_names)) %>%
      distinct() %>%
      arrange(!!.sample)
    X =
      sample_data %>%
      model.matrix(formula, data=.) %>%
      apply(2, function(x) {
        
        if(sd(x)==0 ) x
        else x |> scale(scale=FALSE)
        
      } ) %>%
      {
        .x = (.)
        rownames(.x) = sample_data %>% pull(!!.sample)
        .x
      }
    
    if(factor_names == "1") XA = X[,1, drop=FALSE]
    else XA = X[,c(1,2), drop=FALSE]
    
    XA = XA |> 
      as_tibble()  |> 
      distinct()
    
    cell_cluster_names =
      .data %>%
      distinct(!!.cell_type) %>%
      arrange(!!.cell_type) %>%
      pull(!!.cell_type)
    
    coefficients =
      .data %>%
      select(!!.cell_type, !!.coefficients) %>%
      unnest(!!.coefficients) %>%
      distinct() %>%
      arrange(!!.cell_type) %>%
      pivot_wider(names_from = quo_name(.cell_type), values_from = !!.coefficients) %>%
      column_to_rownames(quo_name(.cell_type)) %>%
      t()
    
    list(
      N = .data %>% distinct(!!.sample) %>% nrow(),
      M = .data %>% distinct(!!.cell_type) %>% nrow(),
      exposure = .data %>% distinct(!!.sample, !!.exposure) %>% arrange(!!.sample) %>% pull(!!.exposure),
      X = X,
      XA = XA,
      C = ncol(X),
      A =  ncol(XA),
      beta = coefficients
    )
    
  }

#' plot
#'
#' @description This function plots a summary of the results of the model.
#'
#' @importFrom ggrepel geom_text_repel
#' @importFrom tidyr pivot_longer
#' @import ggplot2
#' @importFrom tidyr unite
#' @importFrom tidyr pivot_longer
#' @importFrom dplyr with_groups
#' @importFrom magrittr equals
#'
#' @param x A tibble including a cell_group name column | sample name column | read counts column | factor columns | Pvalue column | a significance column
#' @param significance_threshold Numeric value specifying the significance threshold for highlighting differences. Default is 0.025.
#' @param test_composition_above_logit_fold_change A positive integer. It is the effect threshold used for the hypothesis test. A value of 0.2 correspond to a change in cell proportion of 10% for a cell type with baseline proportion of 50%. That is, a cell type goes from 45% to 50%. When the baseline proportion is closer to 0 or 1 this effect thrshold has consistent value in the logit uncontrained scale.
#' @param significance_statistic Character vector indicating which statistic to highlight. Default is "FDR".
#' @param show_fdr_message Logical. Whether to show the Bayesian FDR interpretation message on the plot. Default is TRUE.
#' @param ... For internal use 
#'
#' @return A `ggplot`
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
#' @export
#'
#' @examples
#'
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'
#'     estimate = sccomp_estimate(
#'       counts_obj,
#'       ~ type, ~1, "sample", "cell_group", "count",
#'       cores = 1
#'     )
#'
#'     # estimate |> plot()
#'   }
#' }
#'
plot.sccomp_tbl <- function(x,  significance_threshold = 0.05, test_composition_above_logit_fold_change = .data |> attr("test_composition_above_logit_fold_change"), significance_statistic = c("FDR", "pH0"), show_fdr_message = TRUE, ...) {
  
  # Define the variables as NULL to avoid CRAN NOTES
  parameter <- NULL
  count_data <- x |> attr("count_data")
  v_effect <- NULL
  
  .cell_group = attr(x, ".cell_group")
  .count = attr(x, ".count")
  .sample = attr(x, ".sample")
  
  plots = list()
  
  # Check if test have been done
  if(x |> select(ends_with("FDR")) |> ncol() |> equals(0))
    stop("sccomp says: to produce plots, you need to run the function sccomp_test() on your estimates.")
  
  data_proportion =
    x |>
    
    # Otherwise does not work
    select(-`factor`) |>
    
    pivot_wider(names_from = parameter, values_from = c(contains("c_"), contains("v_"))) |>
    left_join(
      count_data, by = join_by(!!.cell_group)
    ) |> 
    with_groups(!!.sample, ~ mutate(.x, proportion = (!!.count)/sum(!!.count)) )
  
  
  # If I don't have outliers add them
  if(!"outlier" %in% colnames(data_proportion)) data_proportion = data_proportion |> mutate(outlier = FALSE) 
  
  # Select the factors to plot  
  my_factors =
    x |>
    filter(!is.na(`factor`)) |>
    distinct(`factor`) |>
    pull(`factor`) 
  
  if(length(my_factors)==0)
    message("sccomp says: the contrasts you have tested do not represent factors. Therefore, plot of the the posterior predictive check will be omitted.")
  else {
    # Boxplot
    plots$boxplot =
      
      my_factors |>
      map(
        ~ {
          
          # If variable is continuous
          if(data_proportion |> select(all_of(.x)) |> pull(1) |> is("numeric"))
            my_plot = 
              plot_scatterplot(
                .data = x,
                data_proportion = data_proportion,
                factor_of_interest = .x,
                .cell_group = !!.cell_group,
                .sample =  !!.sample,
                my_theme = sccomp_theme(),
                significance_threshold = significance_threshold
              )
          
          # If discrete
          else 
            my_plot = 
              sccomp_boxplot(
                .data = x,
                factor = .x,
                significance_threshold = significance_threshold
              ) 
          
          # Return
          my_plot +
            ggtitle(sprintf("Grouped by %s (for multi-factor models, associations could be hardly observable with unidimensional data stratification)", .x))
        } )
    
  }
  
  # 1D intervals
  plots$credible_intervals_1D = plot_1D_intervals(
    .data = x, 
    significance_threshold = significance_threshold,
    significance_statistic = significance_statistic,
    show_fdr_message = show_fdr_message
  )
  
  # 2D intervals
  if("v_effect" %in% colnames(x) && (x |> filter(!is.na(v_effect)) |> nrow()) > 0)  plots$credible_intervals_2D = plot_2D_intervals(
    .data = x, 
    significance_threshold = significance_threshold,
    significance_statistic = significance_statistic,
    show_fdr_message = show_fdr_message
  )
  
  plots
  
}

#' Plot 1D Intervals for Cell-group Effects
#'
#' This function creates a series of 1D interval plots for cell-group effects, highlighting significant differences based on a given significance threshold.
#'
#' @param .data Data frame containing the main data.
#' @param significance_threshold Numeric value specifying the significance threshold for highlighting differences. 
#' @param test_composition_above_logit_fold_change A positive integer. It is the effect threshold used for the hypothesis test. A value of 0.2 correspond to a change in cell proportion of 10% for a cell type with baseline proportion of 50%. That is, a cell type goes from 45% to 50%. When the baseline proportion is closer to 0 or 1 this effect thrshold has consistent value in the logit uncontrained scale.
#' @param show_fdr_message Logical. Whether to show the Bayesian FDR interpretation message on the plot. Default is TRUE.
#' @param significance_statistic Character vector indicating which statistic to highlight. Default is "FDR".
#' @importFrom patchwork wrap_plots
#' @importFrom forcats fct_reorder
#' @importFrom tidyr drop_na
#' 
#' @export
#' 
#' @return A combined plot of 1D interval plots.
#' @examples
#' 
#' print("cmdstanr is needed to run this example.")
#' 
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'
#'     estimate <- sccomp_estimate(
#'       counts_obj,
#'       ~ type,
#'       ~1,
#'       "sample",
#'       "cell_group",
#'       "count",
#'       cores = 1
#'     ) |> 
#'     sccomp_test()
#'     
#'   # Example usage:
#'   my_plot = plot_1D_intervals(estimate)
#'     
#'   }
#' }
#'
#' 
plot_1D_intervals = function(
  .data, 
  significance_threshold = 0.05, 
  test_composition_above_logit_fold_change = .data |> attr("test_composition_above_logit_fold_change"), 
  show_fdr_message = TRUE,
  significance_statistic = c("FDR", "pH0")
) {
  significance_statistic <- match.arg(significance_statistic)
  
  # Define the variables as NULL to avoid CRAN NOTES
  parameter <- NULL
  estimate <- NULL
  value <- NULL
  pH0 <- NULL
  FDR <- NULL
  
  .cell_group = attr(.data, ".cell_group")
  
  # Check if test have been done
  if(.data |> select(ends_with("FDR")) |> ncol() |> equals(0))
    stop("sccomp says: to produce plots, you need to run the function sccomp_test() on your estimates.")
  
  plot_list = 
    .data |>
    filter(parameter != "(Intercept)") |>
    
    # Reshape data
    select(-contains("n_eff"), -contains("R_k_hat"), -contains("_ess"), -contains("_rhat")) |> 
    pivot_longer(c(contains("c_"), contains("v_")), names_sep = "_", names_to = c("which", "estimate")) |>
    pivot_wider(names_from = estimate, values_from = value) |>
    
    # Nest data by parameter and which
    nest(data = -c(parameter, which)) |>
    mutate(plot = pmap(
      list(data, which, parameter),
      ~  {
        plot_data <- ..1
        # Check if there are any statistics to plot
        if(plot_data |> filter(!effect |> is.na()) |> nrow() |> equals(0))
          return(NA)
        
        # Choose color variable and legend
        if (significance_statistic == "FDR") {
          color_var <- plot_data$FDR < significance_threshold
          color_aes <- aes(xmin = lower, xmax = upper, color = FDR < significance_threshold)
          color_scale <- scale_color_manual(values = c("grey40", "red"))
          legend_title <- "FDR < significance_threshold"
        } else {
          color_var <- plot_data$pH0 < significance_threshold
          color_aes <- aes(xmin = lower, xmax = upper, color = pH0 < significance_threshold)
          color_scale <- scale_color_manual(values = c("grey40", "red"))
          legend_title <- "pH0 < significance_threshold"
        }
        
        ggplot(plot_data, aes(x = effect, y = fct_reorder(!!.cell_group, effect))) +
          geom_vline(xintercept = test_composition_above_logit_fold_change, colour = "grey") +
          geom_vline(xintercept = -test_composition_above_logit_fold_change, colour = "grey") +
          geom_errorbar(color_aes) +
          geom_point() +
          color_scale +
          xlab("Credible interval of the slope") +
          ylab("Cell group") +
          ggtitle(sprintf("%s %s", ..2, ..3)) +
          sccomp_theme() +
          theme(legend.position = "bottom") +
          guides(color = guide_legend(title = legend_title))
      }
    )) %>%
    
    # Filter out NA plots
    filter(!plot |> is.na()) |> 
    pull(plot) 
  
  # Combine all individual plots into one plot
  combined_plot <- plot_list |>
    wrap_plots(ncol = plot_list |> length() |> sqrt() |> ceiling())

  # Only show the FDR message if significance_statistic == "FDR" and show_fdr_message is TRUE
  if (significance_statistic == "FDR" && show_fdr_message) {
    combined_plot <- combined_plot + theme(plot.caption = ggplot2::element_text(hjust = 0))
    combined_plot <- combined_plot + patchwork::plot_annotation(
      caption = paste(
        "Bayesian FDR: Stephens' method (doi: 10.1093/biostatistics/kxw041)",
        "\nFDR-significant populations may cross fold change thresholds because Bayesian FDR considers posterior probabilities rather than p-values.",
        "\nThe method sorts null hypothesis probabilities in ascending order and calculates cumulative averages for robust false discovery control.",
        sep = ""
      )
    )
  }
  combined_plot
}


#' Plot 2D Intervals for Mean-Variance Association
#'
#' This function creates a 2D interval plot for mean-variance association, highlighting significant differences based on a given significance threshold.
#'
#' @param .data Data frame containing the main data.
#' @param significance_threshold Numeric value specifying the significance threshold for highlighting differences. Default is 0.025.
#' @param test_composition_above_logit_fold_change A positive integer. It is the effect threshold used for the hypothesis test. A value of 0.2 correspond to a change in cell proportion of 10% for a cell type with baseline proportion of 50%. That is, a cell type goes from 45% to 50%. When the baseline proportion is closer to 0 or 1 this effect thrshold has consistent value in the logit uncontrained scale.
#' @param show_fdr_message Logical. Whether to show the Bayesian FDR interpretation message on the plot. Default is TRUE.
#' @param significance_statistic Character vector indicating which statistic to highlight. Default is "FDR".
#' 
#' 
#' @importFrom dplyr filter arrange mutate if_else row_number
#' @importFrom ggplot2 ggplot geom_vline geom_hline geom_errorbar geom_point annotate aes facet_wrap
#' @importFrom ggrepel geom_text_repel
#' @importFrom scales trans_new
#' @importFrom stringr str_replace
#' @importFrom stats quantile
#' @importFrom magrittr equals
#' 
#' @export
#' 
#' @return A ggplot object representing the 2D interval plot.
#' 
#' @examples
#' 
#' print("cmdstanr is needed to run this example.")
#' 
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'
#'     estimate <- sccomp_estimate(
#'       counts_obj,
#'       ~ type,
#'       ~type,
#'       "sample",
#'       "cell_group",
#'       "count",
#'       cores = 1
#'     ) |> 
#'     sccomp_test()
#'     
#'   # Example usage:
#'   my_plot = plot_2D_intervals(estimate)
#'     
#'   }
#' }
#' 
plot_2D_intervals = function(
    .data, 
    significance_threshold = 0.05, 
    test_composition_above_logit_fold_change = 
      .data |> attr("test_composition_above_logit_fold_change"),
    show_fdr_message = TRUE,
    significance_statistic = c("FDR", "pH0")
){
  significance_statistic <- match.arg(significance_statistic)
  
  # Define the variables as NULL to avoid CRAN NOTES
  v_effect <- NULL
  parameter <- NULL
  c_effect <- NULL
  c_lower <- NULL
  c_upper <- NULL
  c_FDR <- NULL
  v_lower <- NULL
  v_upper <- NULL
  v_FDR <- NULL
  cell_type_label <- NULL
  pH0 <- NULL
  FDR <- NULL
  
  .cell_group = attr(.data, ".cell_group")
  
  # Check if test have been done
  if(.data |> select(ends_with("FDR")) |> ncol() |> equals(0))
    stop("sccomp says: to produce plots, you need to run the function sccomp_test() on your estimates.")
  
  # Extract prec_coeff parameters from the fitted model for regression line
  fit = attr(.data, "fit")
  prec_coeff_summary = fit$summary("prec_coeff")
  prec_coeff_intercept = prec_coeff_summary$mean[1]
  prec_coeff_slope = prec_coeff_summary$mean[2]
  
  # Add adjusted intercept (unbiased variability) as a new facet
  .data_adjusted <- .data %>%
    filter(parameter == "(Intercept)") %>%
    mutate(
      v_effect = v_effect + prec_coeff_slope * c_effect,
      v_lower = v_lower + prec_coeff_slope * c_effect,
      v_upper = v_upper + prec_coeff_slope * c_effect,
      parameter = "(Intercept, adjusted)"
    )
  
  # Bind adjusted data to original (uncorrected comes first)
  .data_plot <- bind_rows(.data, .data_adjusted)
  
  # Always set parameter factor levels to only those present in the data
  if ("parameter" %in% colnames(.data_plot)) {
    .data_plot$parameter <- factor(.data_plot$parameter, levels = unique(.data_plot$parameter))
  }

  # Use .data_plot instead of .data in the rest of the function
  plot <- .data_plot %>%
    # Filter where variance is inferred
    filter(!is.na(v_effect)) %>%
    
    # Add labels for significant cell groups
    with_groups(
      parameter,
      ~ .x %>%
        arrange(c_FDR) %>%
        mutate(cell_type_label = if_else(row_number() <= 3 & c_FDR < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)"), !!.cell_group, ""))
    ) %>%
    with_groups(
      parameter,
      ~ .x %>%
        arrange(v_FDR) %>%
        mutate(cell_type_label = if_else((row_number() <= 3 & v_FDR < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)") ), !!.cell_group, cell_type_label))
    ) %>%
    {
      .x = (.)
      
      # Choose color variable and legend
      if (significance_statistic == "FDR") {
        color_c_aes <- aes(xmin = c_lower, xmax = c_upper, color = c_FDR < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)"), alpha = c_FDR < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)"))
        color_v_aes <- aes(ymin = v_lower, ymax = v_upper, color = v_FDR < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)"), alpha = v_FDR < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)"))
        color_scale <- scale_color_manual(values = c("#D3D3D3", "#E41A1C"))
        alpha_scale <- scale_alpha_manual(values = c(0.4, 1))
        legend_title <- "FDR < significance_threshold"
      } else {
        color_c_aes <- aes(xmin = c_lower, xmax = c_upper, color = c_pH0 < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)"), alpha = c_pH0 < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)"))
        color_v_aes <- aes(ymin = v_lower, ymax = v_upper, color = v_pH0 < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)"), alpha = v_pH0 < significance_threshold & !parameter %in% c("(Intercept)", "(Intercept, adjusted)"))
        color_scale <- scale_color_manual(values = c("#D3D3D3", "#377EB8"))
        alpha_scale <- scale_alpha_manual(values = c(0.4, 1))
        legend_title <- "pH0 < significance_threshold"
      }
      
      # Calculate range for regression line
      c_range = range(.x$c_effect, na.rm = TRUE)
      c_seq = seq(c_range[1], c_range[2], length.out = 100)
      v_pred = -(prec_coeff_intercept + prec_coeff_slope * c_seq)
      
      # Create regression line data only for (Intercept)
      regression_data = data.frame(
        c_effect = c_seq,
        v_effect = v_pred,
        parameter = "(Intercept)"
      )
      
      # Plot
      p <- ggplot(.x, aes(c_effect, v_effect)) +
        # Add vertical and horizontal lines
        geom_vline(xintercept = c(-test_composition_above_logit_fold_change, test_composition_above_logit_fold_change), colour = "grey", linetype = "dashed", linewidth = 0.3) +
        geom_hline(yintercept = c(-test_composition_above_logit_fold_change, test_composition_above_logit_fold_change), colour = "grey", linetype = "dashed", linewidth = 0.3)
      
       # Add regression line only for (Intercept) facet
      p <- p + geom_line(
        data = regression_data,
        mapping = aes(c_effect, v_effect),
        color = "#0072B2", linewidth = 0.5, alpha = 0.8,
        inherit.aes = FALSE
      )

      # Add horizontal line for (Intercept, adjusted) facet
      if ("(Intercept, adjusted)" %in% unique(.x$parameter)) {
        mean_adjusted <- mean(.x$v_effect[.x$parameter == "(Intercept, adjusted)"])
        c_range_adjusted <- range(.x$c_effect[.x$parameter == "(Intercept, adjusted)"], na.rm = TRUE)
        
        # Create horizontal line data for adjusted intercept only
        horizontal_line_data <- data.frame(
          c_effect = c_range_adjusted,
          v_effect = rep(mean_adjusted, 2),
          parameter = "(Intercept, adjusted)"
        )
        
        p <- p +
          geom_line(
            data = horizontal_line_data,
            mapping = aes(c_effect, v_effect),
            color = "#0072B2", linewidth = 0.5, alpha = 0.8,
            inherit.aes = FALSE
          )
      }
    
      p <- p +
        # Add error bars
        geom_errorbar(color_c_aes, linewidth = 0.2) +
        geom_errorbar(color_v_aes, linewidth = 0.2) +
        # Add points
        geom_point(size = 0.2) +
        # Add annotations
        # annotate("text", x = 0, y = 3.5, label = "Variability", size = 2) + # Disabled temporarily; revisit if annotations are needed for variability.
        # annotate("text", x = 5, y = 0, label = "Abundance", size = 2, angle = 270) + # Disabled temporarily; revisit if annotations are needed for abundance.
        # Add text labels for significant cell groups
        geom_text_repel(aes(c_effect, -v_effect, label = cell_type_label), size = 2.5, data = .x %>% filter(cell_type_label != "")) +
        # Set color and alpha scales
        color_scale +
        alpha_scale +
        # Facet by parameter
        facet_wrap(
          ~ fct_relevel(parameter, c("(Intercept)", "(Intercept, adjusted)")) |>
            
            # I have to understand why this works but throws warning
            suppressWarnings(),
          scales = "free"
        ) +
        xlab("c_effect (Abundance effect)") +
        ylab("v_effect (Variability effect)") +
        # Apply custom theme
        sccomp_theme() +
        theme(legend.position = "bottom") +
        guides(color = guide_legend(title = legend_title), alpha = "none")
      p
    }

  # Only show the FDR message if significance_statistic == "FDR" and show_fdr_message is TRUE
  if (significance_statistic == "FDR" && show_fdr_message) {
    plot <- plot + theme(plot.caption = ggplot2::element_text(hjust = 0))
    plot <- plot + patchwork::plot_annotation(
      caption = paste(
        "Bayesian FDR: Stephens' method (doi: 10.1093/biostatistics/kxw041)",
        "\nFDR-significant populations may cross fold change thresholds because Bayesian FDR considers posterior probabilities rather than p-values.",
        "\nThe method sorts null hypothesis probabilities in ascending order and calculates cumulative averages for robust false discovery control.",
        sep = ""
      )
    )
  }
  plot
}




#' Plot Scatterplot of Cell-group Proportion
#'
#' This function creates a scatterplot of cell-group proportions, optionally highlighting significant differences based on a given significance threshold.
#'
#' @param .data Data frame containing the main data.
#' @param data_proportion Data frame containing proportions of cell groups.
#' @param factor_of_interest A factor indicating the biological condition of interest.
#' @param .cell_group The cell group to be analysed.
#' @param .sample The sample identifier.
#' @param significance_threshold Numeric value specifying the significance threshold for highlighting differences. Default is 0.025.
#' @param my_theme A ggplot2 theme object to be applied to the plot.
#' @importFrom scales trans_new
#' @importFrom stringr str_replace
#' @importFrom stats quantile
#' @importFrom magrittr equals
#' 
#' 
#' @return A ggplot object representing the scatterplot.
#' @examples
#' # Example usage:
#' # plot_scatterplot(.data, data_proportion, "condition", "cell_group", "sample", 0.025, theme_minimal())
plot_scatterplot = function(
    .data, data_proportion, factor_of_interest, .cell_group,
    .sample, significance_threshold = 0.05, my_theme
){
  
  # Define the variables as NULL to avoid CRAN NOTES
  stats_name <- NULL
  parameter <- NULL
  stats_value <- NULL
  count_data <- NULL
  generated_proportions <- NULL
  proportion <- NULL
  name <- NULL
  outlier <- NULL
  
  # Function to remove leading zero from labels
  dropLeadingZero <- function(l){  stringr::str_replace(l, '0(?=.)', '') }
  
  # Define square root transformation and its inverse
  S_sqrt <- function(x){sign(x)*sqrt(abs(x))}
  IS_sqrt <- function(x){x^2*sign(x)}
  S_sqrt_trans <- function() scales::trans_new("S_sqrt",S_sqrt,IS_sqrt)
  
  .cell_group = enquo(.cell_group)
  .sample = enquo(.sample)
  
  # Prepare significance colors
  significance_colors =
    .data %>%
    pivot_longer(
      c(contains("c_"), contains("v_")),
      names_pattern = "([cv])_([a-zA-Z0-9]+)",
      names_to = c("which", "stats_name"),
      values_to = "stats_value"
    ) %>%
    filter(stats_name == "FDR") %>%
    filter(parameter != "(Intercept)") %>%
    filter(stats_value < significance_threshold) %>%
    filter(`factor` == factor_of_interest) 
  
  if(nrow(significance_colors) > 0){
    
    if(.data |> attr("contrasts") |> is.null())
      significance_colors =
        significance_colors %>%
        unite("name", c(which, parameter), remove = FALSE) %>%
        distinct() %>%
        
        # Get clean parameter
        mutate(!!as.symbol(factor_of_interest) := str_replace(parameter, sprintf("^%s", `factor`), "")) %>%
        with_groups(c(!!.cell_group, !!as.symbol(factor_of_interest)), ~ .x %>% summarise(name = paste(name, collapse = ", ")))
    else
      significance_colors =
        significance_colors |>
        mutate(
          factor_values = attr(.data, "count_data") |>
            select(all_of(factor_of_interest)) |>
            distinct() |>
            pull(all_of(factor_of_interest))
        ) |>
        unnest(factor_values) |>
        
        # Filter relevant parameters
        mutate( !!as.symbol(factor_of_interest) := as.character(factor_values) ) |>
        filter(str_detect(parameter, !!as.symbol(factor_of_interest) )) |>
        
        # Rename
        select(!!.cell_group, !!as.symbol(factor_of_interest), name = parameter) |>
        
        # Merge contrasts
        with_groups(c(!!.cell_group, !!as.symbol(factor_of_interest)), ~ .x %>% summarise(name = paste(name, collapse = ", ")))
  }
  
  my_scatterplot = ggplot()
  
  if("fit" %in% names(attributes(.data))){
    
    simulated_proportion =
      .data |>
      sccomp_replicate(number_of_draws = 1000) |>
      left_join(data_proportion %>% distinct(!!as.symbol(factor_of_interest), !!.sample, !!.cell_group))
    
    my_scatterplot = 
      my_scatterplot +
      
      # Add smoothed line for simulated proportions
      geom_smooth(
        aes(!!as.symbol(factor_of_interest), (generated_proportions)),
        lwd=0.2,
        data =
          simulated_proportion %>%
          inner_join(data_proportion %>% distinct(!!as.symbol(factor_of_interest), !!.cell_group, !!.sample)) ,
        color="blue", fill="blue",
        span = 1
      )
  }
  
  if(
    nrow(significance_colors)==0 ||
    
    significance_colors |> 
    pull(!!as.symbol(factor_of_interest)) |> 
    intersect(
      data_proportion |> 
      pull(!!as.symbol(factor_of_interest))
    ) |> 
    length() |> 
    equals(0)
  ) {
    
    my_scatterplot=
      my_scatterplot +
      
      # Add smoothed line without significance colors
      geom_smooth(
        aes(!!as.symbol(factor_of_interest), proportion, fill = NULL),
        data =
          data_proportion ,
        lwd=0.5,
        color = "black",
        span = 1
      )
  } else {
    my_scatterplot=
      my_scatterplot +
      
      # Add smoothed line with significance colors
      geom_smooth(
        aes(!!as.symbol(factor_of_interest), proportion, fill = name),
        data = data_proportion ,
        fatten = 0.5,
        lwd=0.5,
        color = "black",
        span = 1
      )
  }
  
  my_scatterplot +
    
    # Add jittered points for individual data
    geom_point(
      aes(!!as.symbol(factor_of_interest), proportion, shape=outlier, color=outlier),
      data = data_proportion,
      position=position_jitterdodge(jitter.height = 0, jitter.width = 0.2),
      size = 0.5
    ) +
    
    # Facet wrap by cell group
    facet_wrap(
      vars(!!.cell_group),
      scales = "free_y",
      nrow = 4
    ) +
    scale_color_manual(values = c("black", "#e11f28")) +
    scale_y_continuous(trans=S_sqrt_trans(), labels = dropLeadingZero) +
    scale_fill_discrete(na.value = "white") +
    xlab("Biological condition") +
    ylab("Cell-group proportion") +
    guides(color="none", alpha="none", size="none") +
    labs(fill="Significant difference") +
    ggtitle("Note: Be careful judging significance (or outliers) visually for lowly abundant cell groups. \nVisualising proportion hides the uncertainty characteristic of count data, that a count-based statistical model can estimate.") +
    my_theme +
    theme(axis.text.x =  element_text(angle=20, hjust = 1), title = element_text(size = 3))
}

library(dplyr)
library(tidyr)
library(sccomp)
data("seurat_obj")
data("sce_obj")
data("counts_obj")

counts_obj = 
  counts_obj |>
  mutate(count = count+1) |> 
  with_groups("sample", ~ .x |> mutate(proportion = count/sum(count))) 

set.seed(42)

n_iterations = 1000

if (instantiate::stan_cmdstan_exists()){
  
  my_estimate = 
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ continuous_covariate * type ,
      formula_variability = ~ 1,
      "sample", "cell_group",
      
      cores = 1, 
      inference_method = "pathfinder",
      max_sampling_iterations = n_iterations, verbose=FALSE
    )
  
  my_estimate_with_variance = 
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ type,
      formula_variability = ~ type,
      "sample", "cell_group",
      
      cores = 1, 
      inference_method = "pathfinder",
      max_sampling_iterations = n_iterations, verbose=FALSE
    )
}

# Test for plot_1d_intervals function
test_that("plot_1d_intervals function works correctly", {
   skip_cmdstan()
  
  my_estimate |> 
    sccomp_test() |> 
    plot_1D_intervals(
      significance_threshold = 0.025
    ) |> 
    expect_s3_class("patchwork")
})

# Test for plot_2d_intervals function
test_that("plot_2d_intervals function works correctly", {
   skip_cmdstan()
  
  my_estimate_with_variance |> 
    sccomp_test() |> 
    plot_2D_intervals(
      significance_threshold = 0.025
    ) |>
    expect_s3_class("ggplot")
})

# Test for show_fdr_message parameter in plot functions
test_that("show_fdr_message parameter works correctly in plot_1D_intervals", {
   skip_cmdstan()
  
  # Test with show_fdr_message = TRUE (default)
  plot_with_message <- my_estimate |> 
    sccomp_test() |> 
    plot_1D_intervals(
      significance_threshold = 0.025,
      show_fdr_message = TRUE
    )
  
  expect_s3_class(plot_with_message, "patchwork")
  
  # Test with show_fdr_message = FALSE
  plot_without_message <- my_estimate |> 
    sccomp_test() |> 
    plot_1D_intervals(
      significance_threshold = 0.025,
      show_fdr_message = FALSE
    )
  
  expect_s3_class(plot_without_message, "patchwork")
  
  # Verify that both plots are created successfully (no errors)
  expect_no_error(plot_with_message)
  expect_no_error(plot_without_message)
})

test_that("show_fdr_message parameter works correctly in plot_2D_intervals", {
   skip_cmdstan()
  
  # Test with show_fdr_message = TRUE (default)
  plot_with_message <- my_estimate_with_variance |> 
    sccomp_test() |> 
    plot_2D_intervals(
      significance_threshold = 0.025,
      show_fdr_message = TRUE
    )
  
  expect_s3_class(plot_with_message, "ggplot")
  
  # Test with show_fdr_message = FALSE
  plot_without_message <- my_estimate_with_variance |> 
    sccomp_test() |> 
    plot_2D_intervals(
      significance_threshold = 0.025,
      show_fdr_message = FALSE
    )
  
  expect_s3_class(plot_without_message, "ggplot")
  
  # Verify that both plots are created successfully (no errors)
  expect_no_error(plot_with_message)
  expect_no_error(plot_without_message)
})

test_that("show_fdr_message parameter accepts logical values", {
   skip_cmdstan()
  
  # Test with TRUE
  expect_no_error(
    my_estimate |> 
      sccomp_test() |> 
      plot_1D_intervals(show_fdr_message = TRUE)
  )
  
  # Test with FALSE
  expect_no_error(
    my_estimate |> 
      sccomp_test() |> 
      plot_1D_intervals(show_fdr_message = FALSE)
  )
  
  # Test with TRUE for 2D plots
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(show_fdr_message = TRUE)
  )
  
  # Test with FALSE for 2D plots
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(show_fdr_message = FALSE)
  )
})

test_that("plot functions work with different significance thresholds", {
   skip_cmdstan()
  
  # Test plot_1D_intervals with different thresholds
  expect_no_error(
    my_estimate |> 
      sccomp_test() |> 
      plot_1D_intervals(significance_threshold = 0.01)
  )
  
  expect_no_error(
    my_estimate |> 
      sccomp_test() |> 
      plot_1D_intervals(significance_threshold = 0.1)
  )
  
  # Test plot_2D_intervals with different thresholds
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(significance_threshold = 0.01)
  )
  
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(significance_threshold = 0.1)
  )
})

test_that("significance_statistic argument works for plot_1D_intervals", {
   skip_cmdstan()
  
  expect_no_error(
    my_estimate |> 
      sccomp_test() |> 
      plot_1D_intervals(significance_statistic = "FDR")
  )
  expect_no_error(
    my_estimate |> 
      sccomp_test() |> 
      plot_1D_intervals(significance_statistic = "pH0")
  )
})

test_that("significance_statistic argument works for plot_2D_intervals", {
   skip_cmdstan()
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(significance_statistic = "FDR")
  )
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(significance_statistic = "pH0")
  )
})

test_that("show_fdr_message argument works for plot_1D_intervals and plot_2D_intervals", {
   skip_cmdstan()
  expect_no_error(
    my_estimate |> 
      sccomp_test() |> 
      plot_1D_intervals(significance_statistic = "FDR", show_fdr_message = TRUE)
  )
  expect_no_error(
    my_estimate |> 
      sccomp_test() |> 
      plot_1D_intervals(significance_statistic = "FDR", show_fdr_message = FALSE)
  )
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(significance_statistic = "FDR", show_fdr_message = TRUE)
  )
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(significance_statistic = "FDR", show_fdr_message = FALSE)
  )
})

test_that("significance_statistic and show_fdr_message work via plot() S3 method", {
   skip_cmdstan()
  expect_no_error(
    plot(
      my_estimate |> sccomp_test(),
      significance_statistic = "FDR",
      show_fdr_message = TRUE
    )
  )
  expect_no_error(
    plot(
      my_estimate |> sccomp_test(),
      significance_statistic = "pH0",
      show_fdr_message = TRUE
    )
  )
  expect_no_error(
    plot(
      my_estimate |> sccomp_test(),
      significance_statistic = "FDR",
      show_fdr_message = FALSE
    )
  )
  expect_no_error(
    plot(
      my_estimate |> sccomp_test(),
      significance_statistic = "pH0",
      show_fdr_message = FALSE
    )
  )
})

test_that("plot_2D_intervals includes regression line from prec_coeff parameters", {
   skip_cmdstan()
  
  # Create a 2D plot and check that it has the regression line
  plot_2d <- my_estimate_with_variance |> 
    sccomp_test() |> 
    plot_2D_intervals(
      significance_threshold = 0.025
    )
  
  # Check that the plot is created successfully
  expect_s3_class(plot_2d, "ggplot")
  
  # Extract the fitted model to verify prec_coeff parameters exist
  fit <- attr(my_estimate_with_variance |> sccomp_test(), "fit")
  prec_coeff_summary <- fit$summary("prec_coeff")
  
  # Verify that prec_coeff parameters are available
  expect_true(nrow(prec_coeff_summary) >= 2)
  expect_true(all(c("prec_coeff[1]", "prec_coeff[2]") %in% prec_coeff_summary$variable))
  
  # Check that the plot data includes the regression line
  plot_data <- ggplot_build(plot_2d)$data
  
  # Look for the red line in the plot data
  has_correct_line_color <- FALSE
  for (layer_data in plot_data) {
    if ("colour" %in% names(layer_data)) {
      if (any(layer_data$colour == "#0072B2")) {
        has_correct_line_color <- TRUE
        break
      }
    }
  }
  
  # The regression line should be present
  expect_true(has_correct_line_color)
  
  # Test that the plot works with different significance statistics
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(
        significance_threshold = 0.025,
        significance_statistic = "pH0"
      )
  )
  
  expect_no_error(
    my_estimate_with_variance |> 
      sccomp_test() |> 
      plot_2D_intervals(
        significance_threshold = 0.025,
        show_fdr_message = FALSE
      )
  )
}) 

#' Remove unwanted effects from a sccomp_tbl object
#'
#' @description This method removes unwanted effects from a dataset using the model estimates. For example, if you fit your data with the formula `~ factor_1 + factor_2` and use the formula `~ factor_1` to remove unwanted variation, the `factor_2` effect will be factored out.
#'
#' @param .data A `sccomp_tbl` object. The result of `sccomp_estimate`.
#' @param formula_composition_keep A formula. The formula describing the model for differential abundance, for example `~type`. In this case, only the effect of the `type` factor will be preserved, while all other factors will be factored out.
#' @param formula_composition DEPRECATED. Use `formula_composition_keep` instead.
#' @param cores Integer, the number of cores to be used for parallel calculations.
#' 
#' @return A tibble (`tbl`) with the following columns:
#' \itemize{
#'   \item \strong{sample} - A character column representing the sample name for which data was adjusted.
#'   \item \strong{cell_group} - A character column representing the cell group being tested.
#'   \item \strong{adjusted_proportion} - A numeric column representing the adjusted proportion after removing unwanted variation.
#'   \item \strong{adjusted_counts} - A numeric column representing the adjusted counts after removing unwanted variation.
#'   \item \strong{logit_residuals} - A numeric column representing the logit residuals calculated after adjustment.
#' }
#'
#' @export
#'
#' @examples
#'
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'
#'     estimates = sccomp_estimate(
#'       counts_obj,
#'       ~ type, ~1, "sample", "cell_group", "count",
#'       cores = 1
#'     ) |>
#'     sccomp_remove_unwanted_effects()
#'   }
#' }
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
sccomp_remove_unwanted_effects <- function(.data,
                                           formula_composition_keep = NULL,
                                           formula_composition = NULL,
                                           cores = detectCores()) {
  # Check for deprecated arguments
  if (!is.null(formula_composition)) {
    warning("The argument 'formula_composition' is deprecated. Please use 'formula_composition_keep' instead.", call. = FALSE)
    formula_composition_keep <- formula_composition
  }

  check_and_install_cmdstanr()
  UseMethod("sccomp_remove_unwanted_effects", .data)
}

#' @importFrom readr write_file
#' @export
#'
sccomp_remove_unwanted_effects.sccomp_tbl = function(.data,
                                                       formula_composition_keep = NULL,
                                                       formula_composition = NULL,
                                                       cores = detectCores()){
  
  
  model_input = attr(.data, "model_input")
  .sample = attr(.data, ".sample")
  .cell_group = attr(.data, ".cell_group")
  .grouping_for_random_effect = attr(.data, ".grouping_for_random_effect")
  .count = attr(.data, ".count")
  
  # Calculate residuals from the model
  message("sccomp says: calculating residuals")
  residuals = .data |> sccomp_calculate_residuals()

  # Predict proportions using only the factors we want to keep
  message("sccomp says: regressing out unwanted factors")
  .data |>

    # Generate predictions using the specified formula
    sccomp_predict(
      formula_composition = formula_composition_keep,
      # Use up to 500 samples from the fit for prediction
      number_of_draws = attr(.data, "fit") |>  get_output_samples() |> min(500)
    ) |>
    # Keep only unique sample-cell_group combinations with their mean proportions
    distinct(!!.sample, !!.cell_group, proportion_mean) |>

    # Join with residuals to combine predicted proportions with residual effects
    left_join(residuals,  by = c(quo_name(.sample), quo_name(.cell_group))) |>

    # Calculate adjusted proportions by adding residuals to predicted means
    mutate(adjusted_proportion = proportion_mean + residuals) |>

    # Ensure proportions are non-negative
    mutate(adjusted_proportion = adjusted_proportion |> pmax(0)) |> 

    # Calculate adjusted counts based on adjusted proportions and exposure
    mutate(adjusted_counts = adjusted_proportion * exposure) |>

    # Select final columns for output
    select(!!.sample, !!.cell_group, adjusted_proportion, adjusted_counts, residuals)
}

check_columns_exist = function(.data, ...){

  tryCatch({
    .data |> select(...)   # Try selecting the column
    TRUE  # If successful, the column exists
  }, error = function(e) {
    # Print a warning with additional context
    warning(
      "sccomp says: please check typos in your formula_composition, formula_variability (if applicable), \n",
      "and your .sample, .cell_group, .count (if applicable) arguments \n",
      e$message
    )
   
    .data |> select(...)
  })
  
  

}

check_if_count_integer = function(.data, .count){
  .count = enquo(.count)

  # Check if the counts column is an integer
  if (!.data %>% pull(!!.count) %>% is("integer"))
    stop(
      sprintf(
        "The column %s must be of class integer. You can do as mutate(`%s` = as.integer(`%s`))",
        quo_name(.count),
        quo_name(.count),
        quo_name(.count)
      )
    )
}

#' Check if NA
#'
#' @importFrom tidyr drop_na
#' @importFrom dplyr enquo
#'
#' @param .data A tibble including a gene name column | sample name column | read counts column | factors column
#' @param columns Columns to check
#'
#' @keywords internal
#' @noRd
check_if_any_NA = function(.data, ...){


  if(

    .data |>
    drop_na(...) |>
    nrow() < ( .data |> nrow() )

  )
    stop(sprintf("There are NA values in you tibble for any of the column %s", paste(columns, collapse=", ")))
}

check_if_within_posterior = function(.data, my_df, .do_check, .count){

  # Define the variables as NULL to avoid CRAN NOTES
  .lower <- NULL
  .upper <- NULL
  ppc <- NULL
  
  writeLines(sprintf("executing %s", "check_if_within_posterior"))

  .data %>%
    left_join(my_df, by = c("S", "G")) %>%
    filter((!!.do_check)) %>% # Filter only DE genes
    rowwise() %>%
    mutate(`ppc` = !!.count %>% between(`.lower`, `.upper`)) %>%
    mutate(`is higher than mean` = (!`ppc`) &
             (!!.count > mean)) %>%
    ungroup
}

check_if_columns_right_class = function(.data, .sample, .cell_group){

  .sample = enquo(.sample)
  .cell_group = enquo(.cell_group)

  # Check that sample and cell_type is chr of factor
  if(
    !(
      .data %>% pull(!!.sample) %>% is("character") |
      .data %>% pull(!!.sample) %>% is("factor")
    ) |
    !(
      .data %>% pull(!!.cell_group) %>% is("character") |
      .data %>% pull(!!.cell_group) %>% is("factor")
    )
  ) stop(sprintf("sccomp says: the columns %s and %s must be of class character or factor", quo_name(.sample), quo_name(.cell_group)))


}

#' Check if a Sample Column is a Unique Identifier
#'
#' This function checks if the `.sample` column in a wide dataset is truly
#' a unique identifier. If not, it throws an error containing the problematic
#' rows in red text.
#'
#' @param data_wide A data frame or tibble in wide format.
#' @param .sample   An unquoted column name indicating the sample column to check.
#'
#' @return Returns the original `data_wide` if `.sample` is unique. Otherwise,
#'   throws an error showing the problematic rows in red.
#'
#' @importFrom rlang enquo
#' @importFrom rlang quo_name
#' @importFrom dplyr count
#' @importFrom dplyr add_count
#' @importFrom dplyr filter
#' @importFrom dplyr pull
#' @importFrom dplyr select
#' @importFrom glue glue
#' @noRd
check_if_sample_is_a_unique_identifier <- function(data_wide, .sample) {
  .sample <- enquo(.sample)
  
  if (
    data_wide |>
    count(!!.sample) |>
    pull(n) |>
    max() > 1
  ) {
    stop(
      paste(
        glue("sccomp says: .sample column `{quo_name(.sample)}` should be a unique identifier, with a unique combination of factors. For example Sample_A cannot have both treated and untreated conditions in your input"),
        data_wide |>
          add_count(!!.sample, name = "n___") |>
          filter(n___ > 1) |>
          select(-n___) |>
          print_red_tibble(),
        sep = "\n\n"
      )
    )
  } else {
    return(data_wide)
  }
}

check_missing_parameters <- function(effects, model_effects) {
  # Find missing parameters
  
  missing_parameters <- 
    effects |> 
    setdiff(model_effects)
  
  # If there are any missing parameters, stop and show an error message
  if (length(missing_parameters) > 0) {
    stop(
      "sccomp says: Some of the parameters present in the data provided were not present when the model was fitted. For example:\n",
      paste(missing_parameters[1:min(3, length(missing_parameters))], collapse = "\n"),
      if (length(missing_parameters) > 3) "\n..."
    )
  }
  
}

#' Check Sample Consistency of Factors
#'
#' This function checks for each sample in the provided data frame if the number of unique
#' covariate values from a specified formula matches the number of samples. It is useful for
#' verifying data consistency before statistical analysis. The function stops and throws an
#' error if inconsistencies are found.
#'
#' @importFrom dplyr select
#' @importFrom dplyr filter
#' @importFrom dplyr mutate
#' @importFrom dplyr pull
#' @importFrom dplyr distinct
#' @importFrom dplyr group_by
#' @importFrom dplyr summarise
#' @importFrom dplyr arrange
#' @importFrom dplyr n_distinct
#' @importFrom dplyr all_of
#' @importFrom tidyr pivot_longer
#' @importFrom purrr map_lgl
#'
#' @param .data A data frame containing the samples and covariates.
#' @param my_formula A formula object specifying the covariates to check (e.g., ~Timepoint*Response_binary+Patient_ID).
#' @param sample A character string specifying the sample column name.
#' @param cell_group A character string specifying the cell group column name.
#'
#' @details The function selects the sample and covariates based on `my_formula`, pivots
#' the data longer so each row represents a unique sample-covariate combination, nests
#' the data by covariate name, and checks if the number of unique sample-covariate
#' pairs matches the number of samples for each covariate.
#'
#' @return This function does not return a value; it stops with an error message if any
#' inconsistencies are found.
#'
#' @noRd
#' @keywords internal
check_sample_consistency_of_factors = function(.data, my_formula, sample, cell_group){
  
  # Convert character parameters to quos like the main methods
  .sample = sym(sample)
  .cell_group = sym(cell_group)
  
  # Check that I have one set of covariates per sample
  first_cell_group = .data |> pull(!!.cell_group) |> _[[1]]
  
  # If the formula is intercept only -> ~ 1 this test does not apply
  if(my_formula |> parse_formula() |> length() == 0)
    return(TRUE)
  
  # Get the formula variables
  formula_vars = parse_formula(my_formula)
  
  # Check for inconsistencies by finding samples with multiple values for the same factor
  # Convert all factor variables to character to avoid type conflicts in pivot_longer
  data_for_check = 
    .data |> 
    filter(!!.cell_group == first_cell_group) |> 
    select(!!.sample, all_of(formula_vars)) |>
    mutate(across(all_of(formula_vars), as.character))
  
  inconsistent_samples = 
    data_for_check |>
    pivot_longer(-!!.sample, names_to = "factor_name", values_to = "factor_value") |>
    group_by(!!.sample, factor_name) |>
    summarise(
      n_unique_values = n_distinct(factor_value),
      unique_values = paste(sort(unique(factor_value)), collapse = " vs "),
      .groups = "drop"
    ) |>
    filter(n_unique_values > 1) |>
    arrange(!!.sample, factor_name)
  
  if(inconsistent_samples |> nrow() > 0) {
    
    # Create a more informative error message
    error_msg = "sccomp says: your factors are mismatched across samples. Each sample should have consistent factor values across all cell groups.\n\n"
    error_msg = paste0(error_msg, "Problematic samples and their conflicting values:\n")
    
    # Group by sample for better readability
    for(sample_name in unique(inconsistent_samples |> pull(!!.sample))) {
      sample_issues = inconsistent_samples |> filter(!!.sample == sample_name)
      error_msg = paste0(error_msg, "\nSample: ", sample_name, "\n")
      for(i in seq_len(nrow(sample_issues))) {
        row = sample_issues[i, ]
        error_msg = paste0(error_msg, "  - ", row$factor_name, ": ", row$unique_values, "\n")
      }
    }
    
    error_msg = paste0(error_msg, "\nTo fix this issue, ensure each sample has consistent factor values across all cell groups.")
    
    stop(error_msg)
  }
  
}

#' chatGPT - Check for Valid Column Names in Tidyverse Context
#'
#' This function checks if each given column name in a vector contains only valid characters 
#' (letters, numbers, periods, and underscores) and does not start with a digit 
#' or an underscore, which are the conditions for a valid column name in `tidyverse`.
#'
#' @param column_names A character vector representing the column names to be checked.
#'
#' @return A logical vector: `TRUE` for each column name that contains only valid characters 
#' and does not start with a digit or an underscore; `FALSE` otherwise.
#'
#' @examples
#' contains_only_valid_chars_for_column(c("valid_column", "invalid column", "valid123", 
#' "123startWithNumber", "_startWithUnderscore"))
#'
#' @noRd
contains_only_valid_chars_for_column <- function(column_names) {
  # Function to check a single column name
  check_validity <- function(column_name) {
    # Regex pattern for valid characters (letters, numbers, periods, underscores)
    valid_char_pattern <- "[A-Za-z0-9._]"
    
    # Check if all characters in the string match the valid pattern
    all_chars_valid <- stringr::str_detect(column_name, paste0("^", valid_char_pattern, "+$"))
    
    # Check for leading digits or underscores
    starts_with_digit_or_underscore <- stringr::str_detect(column_name, "^[0-9_]")
    
    return(all_chars_valid && !starts_with_digit_or_underscore)
  }
  
  # Apply the check to each element of the vector
  sapply(column_names, check_validity)
}

#' function that check is there are NAs in the count column
#'
#' @param .data A tibble containing the data
#' @param .count Column containing count data
#'
#' @return A tibble with NAs in the count column
#' @keywords internal
#' @noRd
check_if_NAs_in_count = function(.data, .count){
  .count = enquo(.count)
  if(.data |> pull(!!.count) |> is.na() |> any())
    stop("sccomp says: the input data frame has NAs in the count column")
}

#' Clear Stan Model Cache
#'
#' @description
#' This function removes the Stan model cache directory and all its contents. The cache is used by cmdstanr to store compiled Stan models.
#' Clearing the cache can be useful when:
#' \itemize{
#'   \item You're experiencing issues with cached models
#'   \item You want to force recompilation of models
#'   \item You're switching between different versions of Stan
#' }
#'
#' @details
#' The function uses `unlink()` with `recursive = TRUE` to remove the directory and all its contents.
#' If the cache directory doesn't exist, the function will simply print a message and continue.
#' This is a safe operation as cmdstanr will recreate the cache directory when needed.
#'
#' @param cache_dir A character string representing the path of the cache directory to delete.
#'   Defaults to `sccomp_stan_models_cache_dir`, which is the default cache location used by sccomp.
#'
#' @return NULL invisibly. The function is called for its side effect of removing the cache directory.
#'
#' @examples
#' # Clear the default sccomp cache directory
#' clear_stan_model_cache()
#'
#' # Clear a specific cache directory
#' clear_stan_model_cache("path/to/custom/cache")
#'
#' # Example of when you might want to clear the cache
#' \dontrun{
#' # If you're experiencing issues with model compilation
#' clear_stan_model_cache()
#' # Then try running your model again
#' }
#'
#' @seealso
#' \itemize{
#'   \item \code{\link[cmdstanr]{cmdstan_path}} for information about cmdstanr's cache management
#'   \item \code{\link[base]{unlink}} for details about the underlying file removal function
#' }
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
#' @export
clear_stan_model_cache <- function(cache_dir = sccomp_stan_models_cache_dir) {
  
  # Check if the directory exists
  if (dir.exists(cache_dir)) {
    # Attempt to delete the directory and its contents
    unlink(cache_dir, recursive = TRUE)
    message("Cache deleted: ", cache_dir)
  } else {
    message("Cache does not exist: ", cache_dir)
  }
}

#' Main Function for SCCOMP Estimate
#'
#' @description
#' The `sccomp_estimate` function performs linear modeling on a table of cell counts or proportions,
#' which includes a cell-group identifier, sample identifier, abundance (counts or proportions), and factors
#' (continuous or discrete). The user can define a linear model using an R formula,
#' where the first factor is the factor of interest. Alternatively, `sccomp` accepts
#' single-cell data containers (e.g., Seurat, SingleCellExperiment, cell metadata, or
#' group-size) and derives the count data from cell metadata.
#'
#' @import dplyr
#' @importFrom magrittr %$%
#' @importFrom magrittr divide_by
#' @importFrom magrittr multiply_by
#' @importFrom magrittr equals
#' @importFrom rlang quo_is_null
#' @importFrom SingleCellExperiment colData
#' @importFrom parallel detectCores
#' @importFrom rlang inform
#' @importFrom lifecycle is_present
#' @importFrom lifecycle deprecate_warn
#' @importFrom rlang is_symbolic
#' @importFrom rlang quo_get_expr
#' @importFrom rlang enquo
#' @importFrom magrittr not
#'
#' @param .data A tibble including cell_group name column, sample name column,
#'              abundance column (counts or proportions), and factor columns.
#' @param formula_composition A formula describing the model for differential abundance.
#' @param formula_variability A formula describing the model for differential variability.
#' @param sample A column name as a character string for the sample identifier. Replaces the deprecated `.sample`.
#' @param cell_group A column name as a character string for the cell-group identifier. Replaces the deprecated `.cell_group`.
#' @param abundance A column name as a character string for the cell-group abundance, which can be counts (> 0) or proportions (between 0 and 1, summing to 1 across `cell_group`). Replaces the deprecated `.abundance` and `.count`.
#' @param cores Number of cores to use for parallel calculations.
#' @param bimodal_mean_variability_association Logical, whether to model mean-variability as bimodal.
#' @param prior_mean A list specifying prior knowledge about the mean distribution, including intercept and coefficients.
#' @param prior_overdispersion_mean_association A list specifying prior knowledge about mean/variability association.
#' @param percent_false_positive A real number between 0 and 100 for outlier identification.
#' @param inference_method Character string specifying the inference method to use ('pathfinder', 'hmc', or 'variational'). Replaces the deprecated `approximate_posterior_inference` and `variational_inference`.
#' @param .sample_cell_group_pairs_to_exclude A column name indicating sample/cell-group pairs to exclude.
#' @param output_directory A character string specifying the output directory for Stan draws.
#' @param verbose Logical, whether to print progression details.
#' @param enable_loo Logical, whether to enable model comparison using the LOO package.
#' @param noise_model A character string specifying the noise model (e.g., 'multi_beta_binomial').
#' @param exclude_priors Logical, whether to run a prior-free model.
#' @param use_data Logical, whether to run the model data-free.
#' @param mcmc_seed An integer seed for MCMC reproducibility.
#' @param max_sampling_iterations Integer to limit the maximum number of iterations for large datasets.
#' @param pass_fit Logical, whether to include the Stan fit as an attribute in the output.
#' @param sig_figs Number of significant figures to use for Stan model output. Default is 9.
#' @param cache_stan_model A character string specifying the cache directory for compiled Stan models. 
#'                        The sccomp version will be automatically appended to ensure version isolation.
#'                        Default is `sccomp_stan_models_cache_dir` which points to `~/.sccomp_models`.
#' @param .count **DEPRECATED**. Use `abundance` instead.
#' @param approximate_posterior_inference **DEPRECATED**. Use `inference_method` instead.
#' @param variational_inference **DEPRECATED**. Use `inference_method` instead.
#' @param .sample **DEPRECATED**. Use `sample` instead.
#' @param .cell_group **DEPRECATED**. Use `cell_group` instead.
#' @param .abundance **DEPRECATED**. Use `abundance` instead.
#' @param ... Additional arguments passed to the `cmdstanr::sample` function.
#'
#' @return A tibble (`tbl`), with the following columns:
#' \itemize{
#'   \item cell_group - The cell groups being tested.
#'   \item parameter - The parameter being estimated from the design matrix described by the input formula_composition and formula_variability.
#'   \item factor - The covariate factor in the formula, if applicable (e.g., not present for Intercept or contrasts).
#'   \item c_lower - Lower (2.5%) quantile of the posterior distribution for a composition (c) parameter.
#'   \item c_effect - Mean of the posterior distribution for a composition (c) parameter.
#'   \item c_upper - Upper (97.5%) quantile of the posterior distribution for a composition (c) parameter.
#'   \item c_pH0 - Probability of the c_effect being smaller or bigger than the `test_composition_above_logit_fold_change` argument.
#'   \item c_FDR - False discovery rate of the c_effect being smaller or bigger than the `test_composition_above_logit_fold_change` argument. False discovery rate for Bayesian models is calculated differently from frequentists models, as detailed in Mangiola et al, PNAS 2023. 
#'   \item c_n_eff - Effective sample size, the number of independent draws in the sample. The higher, the better.
#'   \item c_R_k_hat - R statistic, a measure of chain equilibrium, should be within 0.05 of 1.0.
#'   \item v_lower - Lower (2.5%) quantile of the posterior distribution for a variability (v) parameter.
#'   \item v_effect - Mean of the posterior distribution for a variability (v) parameter.
#'   \item v_upper - Upper (97.5%) quantile of the posterior distribution for a variability (v) parameter.
#'   \item v_pH0 - Probability of the v_effect being smaller or bigger than the `test_composition_above_logit_fold_change` argument.
#'   \item v_FDR - False discovery rate of the v_effect being smaller or bigger than the `test_composition_above_logit_fold_change` argument. False discovery rate for Bayesian models is calculated differently from frequentists models, as detailed in Mangiola et al, PNAS 2023. 
#'   \item v_n_eff - Effective sample size for a variability (v) parameter.
#'   \item v_R_k_hat - R statistic for a variability (v) parameter, a measure of chain equilibrium.
#' }
#'
#' The function also attaches several attributes to the result:
#' \itemize{
#'   \item count_data - The original count data used in the analysis, stored as an attribute for efficient access.
#'   \item model_input - The model input data used for fitting.
#'   \item formula_composition - The formula used for composition modeling.
#'   \item formula_variability - The formula used for variability modeling.
#'   \item fit - The Stan fit object (if pass_fit = TRUE).
#' }
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
#' @examples
#'
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'
#'     estimate <- sccomp_estimate(
#'       counts_obj,
#'       ~ type,
#'       ~1,
#'       "sample",
#'       "cell_group",
#'       "count",
#'       cores = 1
#'     )
#'     
#'    # Note! 
#'    # If counts are available, do not use proportion.
#'    # Using proportion ignores the high uncertainty of low counts
#'    
#'    estimate_proportion <- sccomp_estimate(
#'       counts_obj,
#'       ~ type,
#'       ~1,
#'       "sample",
#'       "cell_group",
#'       "proportion",
#'       cores = 1
#'     )
#'     
#'   }
#' }
#'
#' @export
sccomp_estimate <- function(.data,
                            formula_composition = ~1,
                            formula_variability = ~1,
                            
                            sample,
                            cell_group,
                            abundance = NULL,
                            
                            # Secondary arguments
                            cores = detectCores(),
                            bimodal_mean_variability_association = FALSE,
                            percent_false_positive = 5,
                            inference_method = "pathfinder",
                            prior_mean = list(intercept = c(0, 1), coefficients = c(0, 1)),
                            prior_overdispersion_mean_association = list(
                              intercept = c(5, 2),
                              slope = c(0, 0.6),
                              standard_deviation = c(10, 20)
                            ),
                            .sample_cell_group_pairs_to_exclude = NULL,
                            output_directory = "sccomp_draws_files",
                            verbose = TRUE,
                            enable_loo = FALSE,
                            noise_model = "multi_beta_binomial",
                            exclude_priors = FALSE,
                            use_data = TRUE,
                            mcmc_seed = sample_seed(),
                            max_sampling_iterations = 20000,
                            pass_fit = TRUE,
                            sig_figs = 9,
                            cache_stan_model = sccomp_stan_models_cache_dir,
                            ...,
                            
                            # DEPRECATED
                            .count = NULL,
                            approximate_posterior_inference = NULL,
                            variational_inference = NULL,
                            .sample = NULL,
                            .cell_group = NULL,
                            .abundance = NULL) {
  
  # Run the function
  check_and_install_cmdstanr()
  
  UseMethod("sccomp_estimate", .data)
}

#' @importFrom purrr map2_lgl
#' @importFrom tidyr pivot_wider
#' @importFrom tidyr spread
#' @importFrom stats C
#' @importFrom rlang :=
#' @importFrom tibble enframe
#' @importFrom purrr map_int
data_to_spread = function(.data, formula, .sample, .cell_group, .count, .grouping_for_random_effect){
  
  .sample = enquo(.sample)
  .cell_group = enquo(.cell_group)
  .count = enquo(.count)

  is_proportion = .data |> pull(!!.count) |> max() <= 1
  
  .data = 
    .data |>
    nest(data = -!!.sample) 
  
  # If proportions exposure = 1
  if(is_proportion) .data = .data |> mutate(exposure = 1)
  else
    .data = 
    .data |>
    mutate(exposure = map_int(data, ~ .x |> pull(!!.count) |> sum() )) 
  
  .data_to_spread = 
    .data |>
    unnest(data) |>
    select(!!.sample, !!.cell_group, exposure, !!.count, parse_formula(formula), any_of(.grouping_for_random_effect)) 
  
  # Check if duplicated samples
  if(
    .data_to_spread |> distinct(!!.sample, !!.cell_group) |> nrow() <
    .data_to_spread |> nrow()
  ) stop("sccomp says: You have duplicated .sample IDs in your input dataset. A .sample .cell_group combination must be unique")
  
  .data_to_spread |>
    spread(!!.cell_group, !!.count)
  
  
}

#' @importFrom rlang is_symbolic
#' @export
sccomp_estimate.Seurat <- function(.data,
                                   formula_composition = ~1,
                                   formula_variability = ~1,
                                   
                                   sample,
                                   cell_group,
                                   abundance = NULL,
                                   
                                   # Secondary arguments
                                   cores = detectCores(),
                                   bimodal_mean_variability_association = FALSE,
                                   percent_false_positive = 5,
                                   inference_method = "pathfinder",
                                   prior_mean = list(intercept = c(0, 1), coefficients = c(0, 1)),
                                   prior_overdispersion_mean_association = list(
                                     intercept = c(5, 2),
                                     slope = c(0, 0.6),
                                     standard_deviation = c(10, 20)
                                   ),
                                   .sample_cell_group_pairs_to_exclude = NULL,
                                   output_directory = "sccomp_draws_files",
                                   verbose = TRUE,
                                   enable_loo = FALSE,
                                   noise_model = "multi_beta_binomial",
                                   exclude_priors = FALSE,
                                   use_data = TRUE,
                                   mcmc_seed = sample_seed(),
                                   max_sampling_iterations = 20000,
                                   pass_fit = TRUE,
                                   sig_figs = 9,
                                   cache_stan_model = sccomp_stan_models_cache_dir,
                                   ...,
                                   
                                   # DEPRECATED
                                   .count = NULL,
                                   approximate_posterior_inference = NULL,
                                   variational_inference = NULL,
                                   .sample = NULL,
                                   .cell_group = NULL,
                                   .abundance = NULL) {
  
  .count <- enquo(.count)
  .sample <- enquo(.sample)
  .cell_group <- enquo(.cell_group)
  .abundance <- enquo(.abundance)
  
  if (!quo_is_null(.abundance))
    stop("sccomp says: .abundance argument can be used only for data frame input")
  
  if (!quo_is_null(.count))
    stop("sccomp says: .count argument can be used only for data frame input")
  
  
  # Prepare column names
  
  .sample_cell_group_pairs_to_exclude <- enquo(.sample_cell_group_pairs_to_exclude)
  
  .data[[]] |>
    sccomp_estimate(
      formula_composition = formula_composition,
      formula_variability = formula_variability,
      
      sample = sample,
      cell_group = cell_group,
      
      # Secondary arguments
      cores = cores,
      bimodal_mean_variability_association = bimodal_mean_variability_association,
      percent_false_positive = percent_false_positive,
      inference_method = inference_method,
      prior_mean = prior_mean,
      prior_overdispersion_mean_association = prior_overdispersion_mean_association,
      .sample_cell_group_pairs_to_exclude = !!.sample_cell_group_pairs_to_exclude,
      output_directory = output_directory,
      verbose = verbose,
      enable_loo = enable_loo,
      noise_model = noise_model,
      exclude_priors = exclude_priors,
      use_data = use_data,
      mcmc_seed = mcmc_seed,
      max_sampling_iterations = max_sampling_iterations,
      pass_fit = pass_fit,
      sig_figs = sig_figs,
      cache_stan_model = cache_stan_model,
      ...,
      .count = !!.count,
      approximate_posterior_inference = approximate_posterior_inference,
      variational_inference = variational_inference,
      .sample = !!.sample,
      .cell_group = !!.cell_group,
      .abundance = !!.abundance
    )
}

#' @importFrom rlang is_symbolic
#' @export
sccomp_estimate.SingleCellExperiment <- function(.data,
                                                 formula_composition = ~1,
                                                 formula_variability = ~1,
                                                 sample,
                                                 cell_group,
                                                 abundance = NULL,
                                                 
                                                 # Secondary arguments
                                                 cores = detectCores(),
                                                 bimodal_mean_variability_association = FALSE,
                                                 percent_false_positive = 5,
                                                 inference_method = "pathfinder",
                                                 prior_mean = list(intercept = c(0, 1), coefficients = c(0, 1)),
                                                 prior_overdispersion_mean_association = list(
                                                   intercept = c(5, 2),
                                                   slope = c(0, 0.6),
                                                   standard_deviation = c(10, 20)
                                                 ),
                                                 .sample_cell_group_pairs_to_exclude = NULL,
                                                 output_directory = "sccomp_draws_files",
                                                 verbose = TRUE,
                                                 enable_loo = FALSE,
                                                 noise_model = "multi_beta_binomial",
                                                 exclude_priors = FALSE,
                                                 use_data = TRUE,
                                                 mcmc_seed = sample_seed(),
                                                 max_sampling_iterations = 20000,
                                                 pass_fit = TRUE,
                                                 sig_figs = 9,
                                                 cache_stan_model = sccomp_stan_models_cache_dir,
                                                 ...,
                                                 
                                                 # DEPRECATED
                                                 .count = NULL,
                                                 approximate_posterior_inference = NULL,
                                                 variational_inference = NULL,
                                                 .sample = NULL,
                                                 .cell_group = NULL,
                                                 .abundance = NULL) {
  
  
  .count <- enquo(.count)
  .sample <- enquo(.sample)
  .cell_group <- enquo(.cell_group)
  .abundance <- enquo(.abundance)
  
  .sample_cell_group_pairs_to_exclude <- enquo(.sample_cell_group_pairs_to_exclude)
  
  if (!quo_is_null(.abundance))
    stop("sccomp says: .abundance argument can be used only for data frame input")
  
  if (!quo_is_null(.count))
    stop("sccomp says: .count argument can be used only for data frame input")
  
  
  
  .data |>
    colData() |>
    
    sccomp_estimate(
      formula_composition = formula_composition,
      formula_variability = formula_variability,
      sample = sample,
      cell_group = cell_group,
      
      # Secondary arguments
      cores = cores,
      bimodal_mean_variability_association = bimodal_mean_variability_association,
      percent_false_positive = percent_false_positive,
      inference_method = inference_method,
      prior_mean = prior_mean,
      prior_overdispersion_mean_association = prior_overdispersion_mean_association,
      .sample_cell_group_pairs_to_exclude = !!.sample_cell_group_pairs_to_exclude,
      output_directory = output_directory,
      verbose = verbose,
      enable_loo = enable_loo,
      noise_model = noise_model,
      exclude_priors = exclude_priors,
      use_data = use_data,
      mcmc_seed = mcmc_seed,
      max_sampling_iterations = max_sampling_iterations,
      pass_fit = pass_fit,
      sig_figs = sig_figs,
      cache_stan_model = cache_stan_model,
      ...,
      .count = !!.count,
      approximate_posterior_inference = approximate_posterior_inference,
      variational_inference = variational_inference,
      .sample = !!.sample,
      .cell_group = !!.cell_group,
      .abundance = !!.abundance
    )
}

#' @importFrom rlang is_symbolic
#' @export
sccomp_estimate.DFrame <- function(.data,
                                   formula_composition = ~1,
                                   formula_variability = ~1,
                                   sample,
                                   cell_group,
                                   abundance = NULL,
                                   
                                   # Secondary arguments
                                   cores = detectCores(),
                                   bimodal_mean_variability_association = FALSE,
                                   percent_false_positive = 5,
                                   inference_method = "pathfinder",
                                   prior_mean = list(intercept = c(0, 1), coefficients = c(0, 1)),
                                   prior_overdispersion_mean_association = list(
                                     intercept = c(5, 2),
                                     slope = c(0, 0.6),
                                     standard_deviation = c(10, 20)
                                   ),
                                   .sample_cell_group_pairs_to_exclude = NULL,
                                   output_directory = "sccomp_draws_files",
                                   verbose = TRUE,
                                   enable_loo = FALSE,
                                   noise_model = "multi_beta_binomial",
                                   exclude_priors = FALSE,
                                   use_data = TRUE,
                                   mcmc_seed = sample_seed(),
                                   max_sampling_iterations = 20000,
                                   pass_fit = TRUE,
                                   sig_figs = 9,
                                   cache_stan_model = sccomp_stan_models_cache_dir,
                                   ...,
                                   
                                   # DEPRECATED
                                   .count = NULL,
                                   approximate_posterior_inference = NULL,
                                   variational_inference = NULL,
                                   .sample = NULL,
                                   .cell_group = NULL,
                                   .abundance = NULL) {
  
  .count <- enquo(.count)
  .sample <- enquo(.sample)
  .cell_group <- enquo(.cell_group)
  .abundance <- enquo(.abundance)
  
  .sample_cell_group_pairs_to_exclude <- enquo(.sample_cell_group_pairs_to_exclude)
  
  .data %>%
    as.data.frame() %>%
    sccomp_estimate(
      formula_composition = formula_composition,
      formula_variability = formula_variability,
      sample = sample,
      cell_group = cell_group,
      abundance = abundance,
      
      # Secondary arguments
      cores = cores,
      bimodal_mean_variability_association = bimodal_mean_variability_association,
      percent_false_positive = percent_false_positive,
      inference_method = inference_method,
      prior_mean = prior_mean,
      prior_overdispersion_mean_association = prior_overdispersion_mean_association,
      .sample_cell_group_pairs_to_exclude = !!.sample_cell_group_pairs_to_exclude,
      output_directory = output_directory,
      verbose = verbose,
      enable_loo = enable_loo,
      noise_model = noise_model,
      exclude_priors = exclude_priors,
      use_data = use_data,
      mcmc_seed = mcmc_seed,
      max_sampling_iterations = max_sampling_iterations,
      pass_fit = pass_fit,
      cache_stan_model = cache_stan_model,
      ...,
      .count = !!.count,
      approximate_posterior_inference = approximate_posterior_inference,
      variational_inference = variational_inference,
      .sample = !!.sample,
      .cell_group = !!.cell_group,
      .abundance = !!.abundance
    )
}


#' @importFrom purrr when
#' @importFrom rlang is_symbolic
#' @export
sccomp_estimate.data.frame <- function(.data,
                                       formula_composition = ~1,
                                       formula_variability = ~1,
                                       
                                       sample,
                                       cell_group,
                                       abundance = NULL,
                                       
                                       # Secondary arguments
                                       cores = detectCores(),
                                       bimodal_mean_variability_association = FALSE,
                                       percent_false_positive = 5,
                                       inference_method = "pathfinder",
                                       prior_mean = list(intercept = c(0, 1), coefficients = c(0, 1)),
                                       prior_overdispersion_mean_association = list(
                                         intercept = c(5, 2),
                                         slope = c(0, 0.6),
                                         standard_deviation = c(10, 20)
                                       ),
                                       .sample_cell_group_pairs_to_exclude = NULL,
                                       output_directory = "sccomp_draws_files",
                                       verbose = TRUE,
                                       enable_loo = FALSE,
                                       noise_model = "multi_beta_binomial",
                                       exclude_priors = FALSE,
                                       use_data = TRUE,
                                       mcmc_seed = sample_seed(),
                                       max_sampling_iterations = 20000,
                                       pass_fit = TRUE,
                                       sig_figs = 9,
                                       cache_stan_model = sccomp_stan_models_cache_dir,
                                       ...,
                                       
                                       # DEPRECATED
                                       .count = NULL,
                                       approximate_posterior_inference = NULL,
                                       variational_inference = NULL,
                                       .sample = NULL,
                                       .cell_group = NULL,
                                       .abundance = NULL) {
  
  
  .count <- enquo(.count)
  .sample <- enquo(.sample)
  .cell_group <- enquo(.cell_group)
  .abundance <- enquo(.abundance)
  
  .sample_cell_group_pairs_to_exclude <- enquo(.sample_cell_group_pairs_to_exclude)
  
  
  # Handle deprecated inference method arguments
  if (lifecycle::is_present(approximate_posterior_inference) && !is.null(approximate_posterior_inference)) {
    lifecycle::deprecate_warn("1.7.7", "sccomp::sccomp_estimate(approximate_posterior_inference = )", 
                              details = "The argument approximate_posterior_inference is now deprecated. Please use inference_method. By default, inference_method value is inferred from approximate_posterior_inference.")
    inference_method <- ifelse(approximate_posterior_inference == "all", "variational", "hmc")
  }
  
  if (lifecycle::is_present(variational_inference) && !is.null(variational_inference)) {
    lifecycle::deprecate_warn("1.7.11", "sccomp::sccomp_estimate(variational_inference = )", 
                              details = "The argument variational_inference is now deprecated. Please use inference_method. By default, inference_method value is inferred from variational_inference")
    inference_method <- ifelse(variational_inference, "variational", "hmc")
  }
  
  # Handle deprecated column arguments
  if (lifecycle::is_present(.sample) && 
      !rlang::quo_is_null(.sample) && 
      rlang::is_symbolic(.sample)) {
    lifecycle::deprecate_warn("2.1.1", "sccomp::sccomp_estimate(.sample)", 
                              details = ".sample argument (which were tidy evaluations, i.e. .sample = my_sample) have been deprecated in favour of sample (without trailing dot, and which is now a character string, i.e. sample = \"my_sample\")")
    sample = quo_name(.sample)
  } else {
    # Capture the quosure for sample using a symbol
    if(
      sample |>
      is.character() |>
      not() 
    ) {
      stop("sccomp says: sample must be of character type")
    }
  }
  
  if (lifecycle::is_present(.cell_group) && 
      !rlang::quo_is_null(.cell_group) && 
      rlang::is_symbolic(.cell_group) ) {
    lifecycle::deprecate_warn("2.1.1", "sccomp::sccomp_estimate(.cell_group)", 
                              details = ".cell_group argument (which were tidy evaluations, i.e. .cell_group = my_cell_group) have been deprecated in favour of cell_group (without trailing dot, and which is now a character string, i.e. cell_group = \"my_cell_group\")")
    cell_group = quo_name(.cell_group)
  } else {
    if(
      cell_group |>
      is.character() |>
      not() 
    ) {
      stop("sccomp says: cell_group must be of character type")
    }
  }
  
  # Handle deprecated .count argument
  if (lifecycle::is_present(.count) && 
      !rlang::quo_is_null(.count) && 
      rlang::is_symbolic(.count) ) {
    rlang::warn("The argument '.count' is deprecated in favour of abundance (without trailing dot, and which is now a character string, i.e. abundance = \"my_abundance\")")
    abundance <- quo_name(.count)
  }
  
  if (lifecycle::is_present(.abundance) && 
      !rlang::quo_is_null(.abundance) && 
      rlang::is_symbolic(.abundance) ) {
    lifecycle::deprecate_warn("2.1.1", "sccomp::sccomp_estimate(.abundance)", 
                              details = ".abundance argument (which were tidy evaluations, i.e. .abundance = my_abundance) have been deprecated in favour of abundance (without trailing dot, and which is now a character string, i.e. abundance = \"my_abundance\")")
    abundance = quo_name(.abundance)
  } else {
    if(
      !is.null(abundance) &&
      abundance  |>
      is.character() |>
      not() 
    ) {
      stop("sccomp says: abundance must be of character type")
    }
  }
  
  
  
  if (abundance |> is.null())
    res <- sccomp_glm_data_frame_raw(
      .data,
      formula_composition = formula_composition,
      formula_variability = formula_variability,
      
      sample = sample,
      cell_group = cell_group,
      
      # Secondary arguments
      cores = cores,
      bimodal_mean_variability_association = bimodal_mean_variability_association,
      percent_false_positive = percent_false_positive,
      inference_method = inference_method,
      prior_mean = prior_mean,
      prior_overdispersion_mean_association = prior_overdispersion_mean_association,
      .sample_cell_group_pairs_to_exclude = !!.sample_cell_group_pairs_to_exclude,
      output_directory = output_directory,
      verbose = verbose,
      enable_loo = enable_loo,
      exclude_priors = exclude_priors,
      use_data = use_data,
      mcmc_seed = mcmc_seed,
      max_sampling_iterations = max_sampling_iterations,
      pass_fit = pass_fit,
      sig_figs = sig_figs,
      cache_stan_model = cache_stan_model,
      ...
    )
  
  else 
    res = sccomp_glm_data_frame_counts(
      .data,
      formula_composition = formula_composition,
      formula_variability = formula_variability,
      
      sample = sample,
      cell_group = cell_group,
      abundance = abundance,
      
      # Secondary arguments
      cores = cores,
      bimodal_mean_variability_association = bimodal_mean_variability_association,
      percent_false_positive = percent_false_positive,
      inference_method = inference_method,
      prior_mean = prior_mean,
      prior_overdispersion_mean_association = prior_overdispersion_mean_association,
      .sample_cell_group_pairs_to_exclude = !!.sample_cell_group_pairs_to_exclude,
      output_directory = output_directory,
      verbose = verbose,
      enable_loo = enable_loo,
      exclude_priors = exclude_priors,
      use_data = use_data,
      mcmc_seed = mcmc_seed,
      max_sampling_iterations = max_sampling_iterations,
      pass_fit = pass_fit,
      sig_figs = sig_figs,
      cache_stan_model = cache_stan_model,
      ...
    )
  
  message("sccomp says: to do hypothesis testing run `sccomp_test()`,
  the `test_composition_above_logit_fold_change` = 0.1 equates to a change of ~10%, and
  0.7 equates to ~100% increase, if the baseline is ~0.1 proportion.
  Use `sccomp_proportional_fold_change` to convert c_effect (linear) to proportion difference (non-linear).")
  
  res |>
    
    # Track input parameters
    add_attr(noise_model, "noise_model")
}

#' @importFrom tidyr complete
#' @importFrom tidyr nesting
#' @importFrom tidyr replace_na
sccomp_glm_data_frame_raw = function(.data,
                                     formula_composition = ~ 1 ,
                                     formula_variability = ~ 1,
                                     
                                     sample,
                                     cell_group,
                                     abundance = NULL,
                                     
                                     
                                     # Secondary arguments
                                     contrasts = NULL,
                                     prior_mean = list(intercept = c(0,1), coefficients = c(0,1)),                        
                                     prior_overdispersion_mean_association = list(intercept = c(5, 2), slope = c(0,  0.6), standard_deviation = c(20, 40)),
                                     percent_false_positive =  5,
                                     check_outliers = TRUE,
                                     variational_inference = NULL,
                                     inference_method = "variational",
                                     test_composition_above_logit_fold_change = 0.1, .sample_cell_group_pairs_to_exclude = NULL,
                                     output_directory = "sccomp_draws_files",
                                     verbose = FALSE,
                                     exclude_priors = FALSE,
                                     bimodal_mean_variability_association = FALSE,
                                     enable_loo = FALSE,
                                     use_data = TRUE,
                                     cores = 4,
                                     mcmc_seed = sample_seed(),
                                     max_sampling_iterations = 20000,
                                     pass_fit = TRUE,
                                     sig_figs = 9,
                                     cache_stan_model = sccomp_stan_models_cache_dir,
                                     ...) {
  
  # See https://community.rstudio.com/t/how-to-make-complete-nesting-work-with-quosures-and-tidyeval/16473
  # See https://github.com/tidyverse/tidyr/issues/506
  
  
  # Prepare column same enquo
  .sample = as.symbol(sample)
  .cell_group = as.symbol(cell_group)
  .sample_cell_group_pairs_to_exclude = enquo(.sample_cell_group_pairs_to_exclude)
  
  # Check if columns exist
  check_columns_exist(.data, c(
    !!.sample,
    !!.cell_group,
    all_of(parse_formula(formula_composition))
  ))
  
  # Check if any column is NA or null
  check_if_any_NA(.data, c(
    !!.sample,
    !!.cell_group,
    all_of(parse_formula(formula_composition))
  ))
  
  .grouping_for_random_effect = parse_formula_random_effect(formula_composition) |> pull(grouping) |> unique()
  
  # Make counts
  .data %>%
    
    class_list_to_counts(!!.sample, !!.cell_group) %>%
    
    # Add formula_composition information
    add_formula_columns(.data, !!.sample,formula_composition) |>
    
    # Attach possible exclusion of data points
    left_join(.data %>%
                as_tibble() |>
                select(
                  !!.sample, !!.cell_group, any_of(quo_name(.sample_cell_group_pairs_to_exclude))
                ) %>%
                distinct(),
              by = c(quo_name(.sample), quo_name(.cell_group))
    ) |>
    mutate(
      across(!!.sample_cell_group_pairs_to_exclude, ~replace_na(.x, 0))
    ) |>
    
    # Return
    sccomp_glm_data_frame_counts(
      formula_composition = formula_composition,
      formula_variability = formula_variability,
      
      sample = sample,
      cell_group = cell_group,
      abundance = "count",
      
      contrasts = contrasts,
      #.grouping_for_random_effect = !! .grouping_for_random_effect,
      prior_mean = prior_mean,
      prior_overdispersion_mean_association = prior_overdispersion_mean_association,
      percent_false_positive =  percent_false_positive,
      check_outliers = check_outliers,
      inference_method = inference_method,
      exclude_priors = exclude_priors,
      bimodal_mean_variability_association = bimodal_mean_variability_association,
      enable_loo = enable_loo,
      use_data = use_data,
      cores = cores,
      test_composition_above_logit_fold_change = test_composition_above_logit_fold_change, .sample_cell_group_pairs_to_exclude = !!.sample_cell_group_pairs_to_exclude,
      verbose = verbose,
      output_directory = output_directory,
      mcmc_seed = mcmc_seed,
      max_sampling_iterations = max_sampling_iterations,
      pass_fit = pass_fit,
      sig_figs = sig_figs,
      cache_stan_model = cache_stan_model,
      ...
    )
}



sccomp_glm_data_frame_counts = function(.data,
                                        formula_composition = ~ 1 ,
                                        formula_variability = ~ 1,
                                        
                                        sample,
                                        cell_group,
                                        abundance = NULL,
                                        
                                        # Secondary arguments
                                        contrasts = NULL,
                                        #.grouping_for_random_effect = NULL,
                                        prior_mean = list(intercept = c(0,1), coefficients = c(0,1)),                        
                                        prior_overdispersion_mean_association = list(intercept = c(5, 2), slope = c(0,  0.6), standard_deviation = c(20, 40)),
                                        percent_false_positive = 5,
                                        check_outliers = TRUE,
                                        variational_inference = NULL,
                                        inference_method = "variational",
                                        test_composition_above_logit_fold_change = 0.1, .sample_cell_group_pairs_to_exclude = NULL,
                                        output_directory = "sccomp_draws_files",
                                        verbose = FALSE,
                                        exclude_priors = FALSE,
                                        bimodal_mean_variability_association = FALSE,
                                        enable_loo = FALSE,
                                        use_data = TRUE,
                                        cores = 4,
                                        mcmc_seed = sample_seed(),
                                        max_sampling_iterations = 20000,
                                                                                 pass_fit = TRUE,
                                         sig_figs = 9,
                                         cache_stan_model = sccomp_stan_models_cache_dir,
                                        ...) {
  
  # Prepare column same enquo
  .sample = as.symbol(sample)
  .cell_group = as.symbol(cell_group)
  .count = as.symbol(abundance)
  
  .sample_cell_group_pairs_to_exclude = enquo(.sample_cell_group_pairs_to_exclude)
  #.grouping_for_random_effect = enquo(.grouping_for_random_effect)
  
  # Check Sample Consistency of Factors
  check_sample_consistency_of_factors(.data, formula_composition, sample, cell_group)
  
  #Check column class
  check_if_columns_right_class(.data, !!.sample, !!.cell_group)
  
  # Check that count is integer
  if(.data %>% pull(!!.count) %>% is("integer")) message(sprintf("sccomp says: %s column is an integer. The sum-constrained beta binomial model will be used", quo_name(.count)))
  else if(.data %>% pull(!!.count) %>% is("integer") |> not() & .data %>% pull(!!.count) |> dplyr::between(0, 1) |> all()) message(sprintf("sccomp says: %s column is a proportion. The sum-constrained beta model will be used. When possible using counts is preferred as the binomial noise component is often dominating for rare groups (e.g. rare cell types).", quo_name(.count)))
  else stop(sprintf("sccomp: `%s` column must be an integer or a proportion", quo_name(.count)))
  
  # Check if columns exist
  check_columns_exist(.data, c(
    !!.sample,
    !!.cell_group,
    !!.count,
    all_of(parse_formula(formula_composition))
    
  ))
  
  # Check that NAs are not in counts
  check_if_NAs_in_count(.data, !!.count)
  
  
  # Make rectangular data
  .data = .data |> make_rectangular_data(!!.sample, !!.cell_group, !!.count, formula_composition)
  
  # Check if test_composition_above_logit_fold_change is 0, as the Bayesian FDR does not allow it
  if(test_composition_above_logit_fold_change <= 0)
    stop("sccomp says: test_composition_above_logit_fold_change should be > 0 for the FDR to be calculated in the Bayesian context (doi: 10.1093/biostatistics/kxw041). Also, testing for > 0 differences avoids significant but meaningless (because of the small magnitude) estimates.")
  
  
  # Check if any column is NA or null
  check_if_any_NA(.data, c(
    quo_name(.sample),
    quo_name(.cell_group),
    quo_name(.count),
    parse_formula(formula_composition)
  ))
  
  # Return
  
  # Credible interval
  CI = 1 - (percent_false_positive/100)
  
  # Produce data list
  factor_names = parse_formula(formula_composition)
  
  # Random intercept
  random_effect_elements = parse_formula_random_effect(formula_composition)
  
  # Variational only if no random intercept
  if(inference_method=="variational" & random_effect_elements |> filter(factor != "(Intercept)") |> nrow() > 0)
    stop("sccomp says: for random effect modelling plese use `inference_method` = \"hmc\", for the full Bayes HMC inference.")
  
  # If no random intercept fake it
  if(nrow(random_effect_elements)>0){
    .grouping_for_random_effect = random_effect_elements |> pull(grouping) |> unique() |>   map(~ quo(!! sym(.x)))
    
  } else{
    .grouping_for_random_effect = list(quo(!! sym("random_effect")))
    .data = .data |> mutate(!!.grouping_for_random_effect[[1]] := "1")
  }
  
  # If .sample_cell_group_pairs_to_exclude 
  if(quo_is_symbolic(.sample_cell_group_pairs_to_exclude)){
    
    # Error if not logical
    if(.data |> pull(!!.sample_cell_group_pairs_to_exclude) |> is("logical") |> not())
      stop(glue("sccomp says: {quo_name(.sample_cell_group_pairs_to_exclude)} must be logical"))
    
    # Error if not consistent to sample/cell group
    if(.data |> count(!!.sample, !!.cell_group, name = "n") |> filter(n>1) |> nrow() |> gt(0))
      stop(glue("sccomp says: {quo_name(.sample_cell_group_pairs_to_exclude)} must be unique with .sample/.cell_group pairs. You might have a .sample/.cell_group pair with both TRUE and FALSE {quo_name(.sample_cell_group_pairs_to_exclude)}."))
    
  } else {
    
    # If no .sample_cell_group_pairs_to_exclude fake it
    .sample_cell_group_pairs_to_exclude = quo(!! sym(".sample_cell_group_pairs_to_exclude"))
    .data = .data |> mutate(!!.sample_cell_group_pairs_to_exclude := FALSE)
  }
  
  
  # Original - old
  # prec_sd ~ normal(0,2);
  # prec_coeff ~ normal(0,5);
  
  message("sccomp says: estimation")
  
  data_for_model =
    .data %>%
    data_to_spread(
      formula_composition, 
      !!.sample, !!.cell_group, !!.count, 
      .grouping_for_random_effect |> map(~ .x |> quo_name() ) |> unlist()
    ) |>
    
    # This emerged with
    # https://github.com/MangiolaLaboratory/sccomp/issues/175#issuecomment-2622749180
    check_if_sample_is_a_unique_identifier(!!.sample) |> 
    
    # Create input for Stan
    data_spread_to_model_input(
      formula_composition, !!.sample, !!.cell_group, !!.count,
      truncation_ajustment = 1.1,
      approximate_posterior_inference = inference_method %in% c("variational", "pathfinder"),
      formula_variability = formula_variability,
      contrasts = contrasts,
      bimodal_mean_variability_association = bimodal_mean_variability_association,
      use_data = use_data,
      random_effect_elements
    )
  
  # Print design matrix
  message(sprintf("sccomp says: the composition design matrix has columns: %s", data_for_model$X %>% colnames %>% paste(collapse=", ")))
  message(sprintf("sccomp says: the variability design matrix has columns: %s", data_for_model$Xa %>% colnames %>% paste(collapse=", ")))
  
  # Force outliers, Get the truncation index
  data_for_model$user_forced_truncation_not_idx = 
    .data |> 
    select(!!.sample, !!.cell_group, !!.sample_cell_group_pairs_to_exclude) |>
    left_join( data_for_model$X |> rownames() |> enframe(name="N", value=quo_name(.sample)), by = join_by(!!.sample) ) |>  
    left_join( data_for_model$y |> colnames() |> enframe(name="M", value=quo_name(.cell_group)), by = join_by(!!.cell_group) ) |> 
    select(!!.sample_cell_group_pairs_to_exclude, N, M) |>
    arrange(N, M) |>
    pull(!!.sample_cell_group_pairs_to_exclude) |>
    not() |>
    which()
  
  data_for_model$truncation_not_idx = data_for_model$user_forced_truncation_not_idx
  data_for_model$TNS = length(data_for_model$truncation_not_idx)
  
  # Prior
  data_for_model$prior_prec_intercept = prior_overdispersion_mean_association$intercept
  data_for_model$prior_prec_slope  = prior_overdispersion_mean_association$slope
  data_for_model$prior_prec_sd = prior_overdispersion_mean_association$standard_deviation
  data_for_model$prior_mean_intercept = prior_mean$intercept
  data_for_model$prior_mean_coefficients = prior_mean$coefficients
  data_for_model$exclude_priors = exclude_priors
  data_for_model$enable_loo = enable_loo
  
  # # Check that design matrix is not too big
  # if(ncol(data_for_model$X)>20)
  #   message("sccomp says: the design matrix has more than 20 columns. Possibly some numerical factors are erroneously of type character/factor.")
  
  fit =
    data_for_model %>%
    
    # Run the first discovery phase with permissive false discovery rate
    fit_model(
      "glm_multi_beta_binomial",
      cores= cores,
      quantile = CI,
      inference_method = inference_method,
      verbose = verbose,
      output_directory = output_directory,
      seed = mcmc_seed,
      max_sampling_iterations = max_sampling_iterations,
      pars = c(
        "beta", "alpha", "prec_coeff","prec_sd",   "alpha_normalised", 
        "random_effect", "random_effect_2", 
        "random_effect_sigma", "random_effect_sigma_2", 
        "log_lik"
      ),
      sig_figs = sig_figs,
      cache_stan_model = cache_stan_model,
      ...
    )
  
  # # Make the fit standalone
  # temp_rds_file <- tempfile(fileext = ".rds")
  # fit$save_object(file = temp_rds_file) 
  # fit = readRDS(temp_rds_file)
  # file.remove(temp_rds_file)
  
  estimate_tibble = 
    # Create a dummy tibble
    tibble() |>
    # Attach association mean concentration
    add_attr(fit, "fit") %>%
    add_attr(data_for_model, "model_input") |> 

    # Save data only taking the columns essential, including the ones use for the formulas 
    add_attr(.data |> select(
      !!.sample, !!.cell_group, !!.count, 
      all_of(parse_formula(formula_composition)),
      all_of(random_effect_elements |> pull(grouping) |> unique())
      ), "count_data") |>
    
    add_attr(.sample |> drop_environment(), ".sample") |>
    add_attr(.cell_group |> drop_environment(), ".cell_group") |>
    add_attr(.count |> drop_environment(), ".count") |>
    add_attr(check_outliers, "check_outliers") |>
    add_attr(formula_composition |> drop_environment(), "formula_composition") |>
    add_attr(formula_variability |> drop_environment(), "formula_variability") |>
    add_attr(parse_formula(formula_composition), "factors" ) |> 
    add_attr(inference_method, "inference_method" ) |> 
    
    # Add class to the tbl
    add_class("sccomp_tbl") |> 
    
    # Print estimates
    sccomp_test() |>
    
    # drop hypothesis testing as the estimation exists without probabilities.
    # For hypothesis testing use sccomp_test
    select(-contains("_FDR"), -contains("_pH0")) 
  
  
  if(inference_method %in% c("variational") && max(na.omit(estimate_tibble$c_R_k_hat)) > 4)
    warning("sccomp says: using variational inference, c_R_k_hat resulted too high for some parameters, indicating lack of convergence of the model. We reccomend using inference_method = \"hmc\" to use the state-of-the-art (although slower) HMC sampler.")
  
  estimate_tibble
}

#' Check if data frame is rectangular
#'
#' @description
#' Checks if the input data frame has the same number of samples for each cell group
#' and vice versa. If not, it makes the data frame rectangular by adding zeros
#' for missing sample/cell group pairs.
#'
#' @param .data A tibble containing the data
#' @param .sample Column containing sample identifiers
#' @param .cell_group Column containing cell group identifiers
#' @param .count Column containing count data
#' @param formula_composition Formula for composition
#'
#' @return A rectangular data frame with zeros added for missing combinations
#' @keywords internal
#' @noRd
make_rectangular_data = function(.data, .sample, .cell_group, .count, formula_composition) {
  
  .sample = enquo(.sample)
  .cell_group = enquo(.cell_group)
  .count = enquo(.count)
  
  if(
    .data |> count(!!.sample) |> distinct(n) |> nrow() > 1 || 
    .data |> count(!!.cell_group) |> distinct(n) |> nrow() > 1 
  ){
    warning(sprintf("sccomp says: the input data frame does not have the same number of `%s`, for all `%s`. We have made it so, adding 0s for the missing sample/feature pairs.", quo_name(.cell_group), quo_name(.sample)))
    
    .data |> 
      # I need renaming trick because complete list(...) cannot accept quosures
      select(!!.sample, !!.cell_group, count := !!.count) |> 
      distinct() |> 
      complete( !!.sample, !!.cell_group, fill = list(count = 0) ) %>%
      rename(!!.count := count) |> 
      mutate(!!.count := as.integer(!!.count)) |> 
      
      # Add formula_composition information
      add_formula_columns(.data, !!.sample, formula_composition)
  } else {
    .data
  }
}

#' @importFrom rlang ensym
#' @noRd
class_list_to_counts = function(.data, .sample, .cell_group){
  
  .sample_for_tidyr = ensym(.sample)
  .cell_group_for_tidyr = ensym(.cell_group)
  
  .sample = enquo(.sample)
  .cell_group = enquo(.cell_group)
  
  
  .data %>%
    count(!!.sample,
          !!.cell_group,
          name = "count") %>%
    
    complete(
      !!.sample_for_tidyr,!!.cell_group_for_tidyr,
      fill = list(count = 0)
    ) %>%
    mutate(count = as.integer(count))
}

add_formula_columns = function(.data, .original_data, .sample,  formula_composition){
  
  .sample = enquo(.sample)
  
  formula_elements = parse_formula(formula_composition)
  
  # If no formula return the input
  if(length(formula_elements) == 0) return(.data)
  
  # Get random intercept
  .grouping_for_random_effect = parse_formula_random_effect(formula_composition) |> pull(grouping) |> unique()
  
  data_frame_formula =
    .original_data %>%
    as_tibble() |>
    select( !!.sample, all_of(formula_elements), any_of(.grouping_for_random_effect) ) %>%
    distinct()
  
  .data |>
    left_join(data_frame_formula, by = quo_name(.sample) )
  
}

library(testthat)
library(dplyr)
library(sccomp)
library(rlang)

test_that("warnings when symbols are provided for key columns", {
  
  skip_cmdstan()
  
  # Create test data
  test_data <- tibble(
    donor = rep(c("sample1", "sample2", "sample3"), each = 3),
    cell_group = rep(c("A", "B", "C"), times = 3),
    count = c(10L, 20L, 30L, 15L, 25L, 35L, 12L, 22L, 32L),
    type = rep(c("healthy", "healthy", "cancer"), each = 3)
  )
  
  # Test with symbol for sample column
  expect_error(
    test_data |>
      sccomp_estimate(
        formula_composition = ~ type,
        sample = donor,
        cell_group = "cell_group",
        abundance = "count"
      ),
    "object 'donor' not found"
  )
  
  # Test with symbol for cell_group column
  expect_error(
    test_data |>
      sccomp_estimate(
        formula_composition = ~ type,
        sample = "donor",
        cell_group = cell_group,
        abundance = "count"
      ),
    "object 'cell_group' not found"
  )
  
  # Test with symbol for abundance column
  expect_error(
    test_data |>
      sccomp_estimate(
        formula_composition = ~ type,
        sample = "donor",
        cell_group = "cell_group",
        abundance = count
      ),
    "sccomp says: abundance must be of character type"
  )
  
  # Test with correct character strings (should not warn)
  expect_no_warning(
    test_data |>
      sccomp_estimate(
        formula_composition = ~ type,
        sample = "donor",
        cell_group = "cell_group",
        abundance = "count"
      )
  )
})

test_that("errors when non-character values are provided for column arguments", {
  
  skip_cmdstan()
  
  # Create test data
  test_data <- tibble(
    donor = c("sample1", "sample2", "sample3"),
    cell_group = c("A", "B", "C"),
    count = c(10L, 20L, 30L),
    type = c("healthy", "healthy", "cancer")
  )
  
  # Test with non-character sample
  expect_error(
    test_data |>
      sccomp_estimate(
        formula_composition = ~ type,
        sample = 123,
        cell_group = "cell_group",
        abundance = "count"
      ),
    "sccomp says: sample must be of character type"
  )
  
  # Test with non-character cell_group
  expect_error(
    test_data |>
      sccomp_estimate(
        formula_composition = ~ type,
        sample = "donor",
        cell_group = 456,
        abundance = "count"
      ),
    "sccomp says: cell_group must be of character type"
  )
  
  # Test with non-character abundance
  expect_error(
    test_data |>
      sccomp_estimate(
        formula_composition = ~ type,
        sample = "donor",
        cell_group = "cell_group",
        abundance = 789
      ),
    "sccomp says: abundance must be of character type"
  )
})

test_that("warnings when using deprecated column names", {
  
  skip_cmdstan()
  
  # Create test data
  test_data <- tibble(
    donor = rep(c("sample1", "sample2", "sample3"), each = 3),
    cell_group = rep(c("A", "B", "C"), times = 3),
    count = c(10L, 20L, 30L, 15L, 25L, 35L, 12L, 22L, 32L),
    type = rep(c("healthy", "healthy", "cancer"), each = 3)
  )
  
  # Test with deprecated .sample
  test_data |>
    sccomp_estimate(
      formula_composition = ~ type,
      .sample = "donor",
      cell_group = "cell_group",
      abundance = "count"
    ) |>
    expect_warning("The `.sample` argument of*")
  
  # Test with deprecated .cell_group
  test_data |>
    sccomp_estimate(
      formula_composition = ~ type,
      sample = "donor",
      .cell_group = "cell_group",
      abundance = "count"
    ) |>
    expect_warning()
  
  # Test with deprecated .abundance
  test_data |>
    sccomp_estimate(
      formula_composition = ~ type,
      sample = "donor",
      cell_group = "cell_group",
      .abundance = "count"
    ) |>
    expect_warning()
})

#' sccomp_replicate
#'
#' @description This function replicates counts from a real-world dataset.
#'
#' @param fit The result of sccomp_estimate.
#' @param formula_composition A formula. The formula describing the model for differential abundance, for example ~treatment. This formula can be a sub-formula of your estimated model; in this case all other factor will be factored out.
#' @param formula_variability A formula. The formula describing the model for differential variability, for example ~treatment. In most cases, if differentially variability is of interest, the formula should only include the factor of interest as a large anount of data is needed to define variability depending to each factors. This formula can be a sub-formula of your estimated model; in this case all other factor will be factored out.
#' @param number_of_draws An integer. How may copies of the data you want to draw from the model joint posterior distribution.
#' @param mcmc_seed An integer. Used for Markov-chain Monte Carlo reproducibility. By default a random number is sampled from 1 to 999999. This itself can be controlled by set.seed()
#' @param cache_stan_model A character string specifying the cache directory for compiled Stan models. 
#'                        The sccomp version will be automatically appended to ensure version isolation.
#'                        Default is `sccomp_stan_models_cache_dir` which points to `~/.sccomp_models`.
#'
#' @return A tibble `tbl` with cell_group-wise statistics
#'
#' @return A tibble (`tbl`), with the following columns:
#' \itemize{
#'   \item \strong{cell_group} - A character column representing the cell group being tested.
#'   \item \strong{sample} - A factor column representing the sample name from which data was generated.
#'   \item \strong{generated_proportions} - A numeric column representing the proportions generated from the model.
#'   \item \strong{generated_counts} - An integer column representing the counts generated from the model.
#'   \item \strong{replicate} - An integer column representing the replicate number, where each row corresponds to a different replicate of the data.
#' }
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
#' @importFrom tibble deframe
#' @importFrom tibble column_to_rownames
#' @export
#'
#' @examples
#'
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists() && .Platform$OS.type == "unix") {
#'     data("counts_obj")
#'
#'     sccomp_estimate(
#'       counts_obj,
#'       ~ type, ~1, "sample", "cell_group", "count",
#'       cores = 1
#'     ) |>
#'     sccomp_replicate()
#'   }
#' }
sccomp_replicate <- function(fit,
                             formula_composition = NULL,
                             formula_variability = NULL,
                             number_of_draws = 1,
                             mcmc_seed = sample_seed(),
                             cache_stan_model = sccomp_stan_models_cache_dir) {
  
  # Run the function
  check_and_install_cmdstanr()
  
  UseMethod("sccomp_replicate", fit)
}

#' @export
#'
sccomp_replicate.sccomp_tbl = function(fit,
                                       formula_composition = NULL,
                                       formula_variability = NULL,
                                       number_of_draws = 1,
                                       mcmc_seed = sample_seed(),
                                       cache_stan_model = sccomp_stan_models_cache_dir){
  
  .sample = attr(fit, ".sample")
  .cell_group = attr(fit, ".cell_group")
  
  sample_names =
    fit |>
    attr("count_data") |>
    distinct(!!.sample) |> 
    pull(!!.sample)
  
  rng =
    replicate_data(
      fit,
      formula_composition = formula_composition,
      formula_variability = formula_variability,
      number_of_draws = number_of_draws,
      mcmc_seed = mcmc_seed,
      cache_stan_model = cache_stan_model
    )
  
  model_input = attr(fit, "model_input")
  
  # mean generated
  rng |>
    
    # Parse
    parse_generated_quantities(number_of_draws = number_of_draws) |>
    
    # Get sample name
    nest(data = -N) |>
    arrange(N) |>
    mutate(!!.sample := sample_names) |>
    unnest(data) |>
    
    # get cell type name
    nest(data = -M) |>
    mutate(!!.cell_group := colnames(model_input$y)) |>
    unnest(data) |>
    
    select(-N, -M) |>
    select(!!.cell_group, !!.sample, everything())
  
}


#' Prepare data for replicate_data function
#' 
#' @description
#' Internal function that prepares the data for the replicate_data function. It handles:
#' - Data validation and preprocessing
#' - Design matrix creation
#' - Random effects handling
#' - Unseen group handling
#' 
#' @param X Original design matrix
#' @param Xa Original variability design matrix
#' @param N Original number of samples
#' @param intercept_in_design Whether intercept is in design
#' @param X_random_effect Original random effect design matrix
#' @param X_random_effect_2 Original second random effect design matrix
#' @param .sample Quosure for the sample identifier column
#' @param .cell_group Quosure for the cell group column
#' @param .count Quosure for the count column
#' @param formula_composition Formula for the composition model
#' @param formula_variability Formula for the variability model
#' @param new_data New data to generate predictions for. If NULL, uses the original data
#' @param original_count_data Original count data from the model
#' 
#' @return A list containing:
#' - model_input: The prepared model input data
#' - X_which: Indices for the composition design matrix
#' - XA_which: Indices for the variability design matrix
#' - X_random_effect_which: Indices for the first random effect design matrix
#' - X_random_effect_which_2: Indices for the second random effect design matrix
#' - create_intercept: Boolean indicating if intercept should be created
#' 
#' @noRd
prepare_replicate_data = function(X,
                                  Xa,
                                  N,
                                  intercept_in_design,
                                  X_random_effect,
                                  X_random_effect_2,
                                  .sample,
                                  .cell_group,
                                  .count,
                                  formula_composition,
                                  original_formula_composition,
                                  formula_variability,
                                  new_data = NULL,
                                  original_count_data) {
  
  
  .sample = enquo(.sample)
  .count = enquo(.count)
  
  # New data
  if(new_data |> is.null())
    new_data = original_count_data 
  
  # Check that original_count_data dont have duplicated sample names
  if(original_count_data |> count(!!.sample) |> pull(n) |> max() > 1)
    stop("sccomp says: your original_count_data has duplicated sample names. Please ensure that the sample names are unique.") 
  
  # Check that new_data dont have duplicated sample names
  if(new_data |> count(!!.sample) |> pull(n) |> max() > 1)
    stop("sccomp says: your new_data has duplicated sample names. Please ensure that the sample names are unique.") 
  
  
  # If seurat
  else if(new_data |> is("Seurat")) new_data = new_data[[]]
  
  # Check if the input new data is not suitable
  if(!parse_formula(formula_composition) %in% colnames(new_data) |> all())
    stop("sccomp says: your `new_data` might be malformed. It might have the covariate columns with multiple values for some element of the \"%s\" column. As a generic example, a sample identifier (\"Sample_123\") might be associated with multiple treatment values, or age values.")
  
  # Match factors with old data
  nrow_new_data = nrow(new_data)
  
  new_exposure = new_data |>
    nest(data = -!!.sample) |>
    mutate(exposure = map_dbl(
      data,
      ~{
        if (quo_name(.count) %in% colnames(.x)) .x |> pull(!!.count) |> sum()
        else 5000
      })) |>
    select(!!.sample, exposure) |>
    deframe() |>
    as.array()
  
  # Update data, merge with old data because
  # I need the same ordering of the design matrix
  old_data = original_count_data |>
    
    # Change sample names to make unique
    mutate(dummy = "OLD") |>
    tidyr::unite(!!.sample, c(!!.sample, dummy), sep="___")
  
  # Harmonise factors
  new_data = new_data |> as_tibble() |> harmonise_factor_levels(old_data)
  
  # check that for each column of the old data. The new data has values that are found in the old data, omit NA , ignore !!.sample column
  map(
    old_data %>%
      # Just apply to categorical
      select(where(~ is.factor(.) || is.character(.))) %>%
      names() %>%
      setdiff(quo_name(.sample)),
    ~ if (any(!new_data[[.x]][!is.na(new_data[[.x]])] %in% old_data[[.x]])) {
      stop(
        paste(
          "sccomp says: The values for column `",.x,"` in the new data must be among the factor levels in the original data. Please ensure that the factor levels are consistent between the two datasets."
        )
      )
    }
  )
  
  new_data =  old_data |> bind_rows( new_data ) 
  
  new_X =
    new_data |>
    get_design_matrix(
      # Drop random intercept
      formula_composition |>
        as.character() |>
        str_remove_all("\\+ ?\\(.+\\|.+\\)") |>
        paste(collapse="") |>
        as.formula(),
      !!.sample, 
      accept_NA_as_average_effect = TRUE
    ) |>
    tail(nrow_new_data) %>%
    # Remove columns that are not in the original design matrix
    .[,colnames(.) %in% colnames(X), drop=FALSE]
  
  # Check that all effect combination were present when the model was fitted
  check_missing_parameters(
    new_X |> colnames(), 
    X |> colnames()
  ) 
  
  X_which =
    colnames(new_X) |>
    match(
      X %>%
        colnames()
    ) |>
    na.omit() |>
    as.array()
  
  # Variability
  new_Xa =
    new_data |>
    get_design_matrix(
      # Drop random intercept
      formula_variability |>
        as.character() |>
        str_remove_all("\\+ ?\\(.+\\|.+\\)") |>
        paste(collapse="") |>
        as.formula(),
      !!.sample, 
      accept_NA_as_average_effect = TRUE
    ) |>
    tail(nrow_new_data) %>%
    # Remove columns that are not in the original design matrix
    .[,colnames(.) %in% colnames(Xa), drop=FALSE]
  
  XA_which =
    colnames(new_Xa) |>
    match(
      Xa %>%
        colnames()
    ) |>
    na.omit() |>
    as.array()
  
  # If I want to replicate data with intercept and I don't have intercept in my fit
  create_intercept =
    !intercept_in_design &
    "(Intercept)" %in% colnames(new_X)
  if(create_intercept) warning("sccomp says: your estimated model is intercept free, while your desired replicated data do have an intercept term. The intercept estimate will be calculated averaging your first factor in your formula ~ 0 + <factor>. If you don't know the meaning of this warning, this is likely undesired, and please reconsider your formula for replicate_data()")
  
  # Original grouping
  original_grouping_names = original_formula_composition |> formula_to_random_effect_formulae() |> pull(grouping)
  
  # Random intercept
  random_effect_elements = parse_formula_random_effect(formula_composition)
  
  # Initialize unseen random effect variables
  new_X_random_effect_unseen = matrix(rep(0, nrow_new_data))[,0, drop=FALSE]
  new_X_random_effect_2_unseen = matrix(rep(0, nrow_new_data))[,0, drop=FALSE]
  
  # Set default random intercept
  X_random_effect_which = array()[0]
  new_X_random_effect = matrix(rep(0, nrow_new_data))[,0, drop=FALSE]
  
  # setup default unknown_grouping variable for generated quantities
  unknown_grouping = c(FALSE, FALSE)
  
  #check_random_effect_design(.data_spread, any_of(factor_names), random_effect_elements, formula, X)
  random_effect_grouping = 
    formula_composition |>
    formula_to_random_effect_formulae() |>
    mutate(design = map2(
      formula, grouping,
      ~  get_random_effect_design3(new_data, .x, .y, !!.sample,
                                   accept_NA_as_average_effect = TRUE )
    ))
  
  
  
  if((random_effect_grouping$grouping %in% original_grouping_names[1]) |> any() && !unknown_grouping[1]) {
    new_X_random_effect =
      random_effect_grouping |>
      filter(grouping==original_grouping_names[1]) |> 
      mutate(design_matrix = map(
        design,
        ~ ..1 |>
          select(!!.sample, group___label, value) |>
          
          # Some combinations might not have been present in a specific group so the parameter does not exist
          filter(group___label %in% colnames(X_random_effect)) |> 
          
          pivot_wider(names_from = group___label, values_from = value) |>
          mutate(across(everything(), ~ .x |> replace_na(0)))
      )) |>
      # Merge
      pull(design_matrix) |> 
      _[[1]] |> 
      column_to_rownames(quo_name(.sample))  |>
      tail(nrow_new_data) 
    
    # Separate NA group column into new_X_random_effect_unseen
    new_X_random_effect_unseen = new_X_random_effect[, colnames(new_X_random_effect) |> str_detect("___NA$"), drop = FALSE]
    new_X_random_effect = new_X_random_effect[, !colnames(new_X_random_effect) |> str_detect("___NA$"), drop = FALSE]
    
    # Check that all effect combination were present when the model was fitted
    check_missing_parameters(
      new_X_random_effect |> colnames(), 
      X_random_effect |> colnames()
    ) 
    
    X_random_effect_which =
      colnames(new_X_random_effect) |>
      match(
        X_random_effect %>%
          colnames()
      ) |>
      as.array()
  }
  
  # Set default X random intercept
  X_random_effect_which_2 = array()[0]
  new_X_random_effect_2 = matrix(rep(0, nrow_new_data))[,0, drop=FALSE]
  
  if((random_effect_grouping$grouping %in% original_grouping_names[2]) |> any()){
    new_X_random_effect_2 =
      random_effect_grouping |>
      filter(grouping==original_grouping_names[2]) |> 
      mutate(design_matrix = map(
        design,
        ~ ..1 |>
          select(!!.sample, group___label, value) |>
          
          # Some combinations might not have been present in a specific group so the parameter does not exist
          filter(group___label %in% colnames(X_random_effect_2)) |> 
          
          pivot_wider(names_from = group___label, values_from = value) |>
          mutate(across(everything(), ~ .x |> replace_na(0)))
      )) |>
      # Merge
      pull(design_matrix) |> 
      _[[1]] |> 
      column_to_rownames(quo_name(.sample))  |>
      tail(nrow_new_data)
    
    # Separate NA group column into new_X_random_effect_2_unseen
    new_X_random_effect_2_unseen = new_X_random_effect_2[, colnames(new_X_random_effect_2) |> str_detect("___NA$"), drop = FALSE]
    new_X_random_effect_2 = new_X_random_effect_2[, !colnames(new_X_random_effect_2) |> str_detect("___NA$"), drop = FALSE]
    
    # Check that all effect combination were present when the model was fitted
    check_missing_parameters(
      new_X_random_effect_2 |> colnames(), 
      X_random_effect_2 |> colnames()
    )
    
    X_random_effect_which_2 =
      colnames(new_X_random_effect_2) |>
      match(
        X_random_effect_2 %>%
          colnames()
      ) |>
      as.array()
  }
  
  # Prepare the list of inputs to the model
  list(
    X = new_X,
    Xa = new_Xa,
    N = nrow_new_data,  
    exposure = new_exposure,
    X_random_effect = new_X_random_effect,
    X_random_effect_2 = new_X_random_effect_2,
    X_random_effect_unseen = new_X_random_effect_unseen,
    X_random_effect_2_unseen = new_X_random_effect_2_unseen,
    ncol_X_random_eff_new = c(ncol(new_X_random_effect), ncol(new_X_random_effect_2)),  
    unknown_grouping = unknown_grouping,
    ncol_X_random_eff_unseen = c(ncol(new_X_random_effect_unseen), ncol(new_X_random_effect_2_unseen)),
    
    X_which = X_which,
    XA_which = XA_which,
    X_random_effect_which = X_random_effect_which,
    X_random_effect_which_2 = X_random_effect_which_2,
    create_intercept = create_intercept
  )
  
}

#' Generate replicated data from a fitted sccomp model
#' 
#' @description
#' This function generates replicated data from a fitted sccomp model. It can be used to:
#' - Generate predictions for new data
#' - Simulate data from the fitted model
#' - Generate posterior predictive samples
#' 
#' @param .data A sccomp model object
#' @param formula_composition Formula for the composition model. If NULL, uses the formula from .data
#' @param formula_variability Formula for the variability model. If NULL, uses the formula from .data
#' @param new_data New data to generate predictions for. If NULL, uses the original data
#' @param number_of_draws Number of posterior draws to use for generation
#' @param mcmc_seed Random seed for reproducibility
#' @param cores Number of CPU cores to use
#' 
#' @return A cmdstanr model object containing the generated quantities
#' 
#' @examples
#' # Generate predictions for new data
#' replicate_data(fitted_model, new_data = new_samples)
#' 
#' # Generate 1000 posterior predictive samples
#' replicate_data(fitted_model, number_of_draws = 1000)
#' 
#' @noRd
replicate_data = function(.data,
                          formula_composition = NULL,
                          formula_variability = NULL,
                          new_data = NULL,
                          number_of_draws = 1,
                          mcmc_seed = sample(1e5, 1),
                          cores = detectCores(),
                          cache_stan_model = sccomp_stan_models_cache_dir){
  
  # Extract required components from .data
  .sample = attr(.data, ".sample")
  .cell_group = attr(.data, ".cell_group")
  .count = attr(.data, ".count")
  
  # Get formulas if not provided
  if(is.null(formula_composition)) formula_composition = attr(.data, "formula_composition")
  if(is.null(formula_variability)) formula_variability = attr(.data, "formula_variability")
  
  # create model input 
  model_input = attr(.data, "model_input")
  
  # Prepare data
  prepared_data = prepare_replicate_data(
    X = model_input$X,
    Xa = model_input$Xa,
    N = model_input$N,
    intercept_in_design = model_input$intercept_in_design,
    X_random_effect = model_input$X_random_effect,
    X_random_effect_2 = model_input$X_random_effect_2,
    .sample = !!.sample,
    .cell_group = !!.cell_group,
    .count = !!.count,
    formula_composition = formula_composition,
    original_formula_composition = .data |> attr("formula_composition"),
    formula_variability = formula_variability,
    new_data = new_data,
    original_count_data =
      .data |>
      attr("count_data") |>
      .subset(!!.sample) 
  )
  
  # Original input 
  model_input$X_original = model_input$X
  model_input$N_original = model_input$N
  
  # New input
  model_input$X = prepared_data$X
  model_input$Xa = prepared_data$Xa 
  model_input$N = prepared_data$N
  model_input$exposure = prepared_data$exposure
  model_input$X_random_effect = prepared_data$X_random_effect
  model_input$X_random_effect_2 = prepared_data$X_random_effect_2
  model_input$X_random_effect_unseen = prepared_data$X_random_effect_unseen
  model_input$X_random_effect_2_unseen = prepared_data$X_random_effect_2_unseen
  model_input$ncol_X_random_eff_new = prepared_data$ncol_X_random_eff_new
  model_input$unknown_grouping = prepared_data$unknown_grouping
  model_input$ncol_X_random_eff_unseen = prepared_data$ncol_X_random_eff_unseen
  
  # Add subset of coefficients
  # Add subset of coefficients
  model_input$length_X_which = length(prepared_data$X_which)
  model_input$length_XA_which = length(prepared_data$XA_which)
  model_input$X_which = prepared_data$X_which
  model_input$XA_which = prepared_data$XA_which
  
  # Add random effect coefficients
  model_input$X_random_effect_which = prepared_data$X_random_effect_which
  model_input$X_random_effect_which_2 = prepared_data$X_random_effect_which_2
  model_input$length_X_random_effect_which = c(
    length(prepared_data$X_random_effect_which),
    length(prepared_data$X_random_effect_which_2)
  )
  
  # Should I create an intercept for generate quantities?
  model_input$create_intercept = prepared_data$create_intercept
  
  number_of_draws_in_the_fit = attr(.data, "fit") |>  get_output_samples()
  
  # To avoid error in case of a NULL posterior sample
  number_of_draws = min(number_of_draws, number_of_draws_in_the_fit)
  
  # Load model
  mod_rng = load_model("glm_multi_beta_binomial_generate_data", threads = cores, cache_dir = cache_stan_model)

  draws_matrix <- attr(.data, "fit")$draws(format = "matrix")
  
  if(number_of_draws > nrow(draws_matrix)) {
    number_of_draws <- nrow(draws_matrix)
  }
  
  draws_matrix <- draws_matrix[sample(seq_len(nrow(draws_matrix)), size=number_of_draws),, drop=FALSE]

  # Generate quantities
  mod_rng |> sample_safe(
    generate_quantities_fx,
    draws_matrix,
    data = model_input,
    seed = mcmc_seed, 
    threads_per_chain = 1
  )
}

#' @keywords internal
#' @noRd
#'
parse_generated_quantities = function(rng, number_of_draws = 1){
  
  # Define the variables as NULL to avoid CRAN NOTES
  .draw <- NULL
  N <- NULL
  .value <- NULL
  generated_counts <- NULL
  M <- NULL
  generated_proportions <- NULL
  
  draws_to_tibble_x_y(rng, "counts", "N", "M", number_of_draws) %>%
    with_groups(c(.draw, N), ~ .x %>% mutate(generated_proportions = .value/max(1, sum(.value)))) %>%
    filter(.draw<= number_of_draws) %>%
    rename(generated_counts = .value, replicate = .draw) %>%
    
    mutate(generated_counts = as.integer(generated_counts)) %>%
    select(M, N, generated_proportions, generated_counts, replicate)
  
}

#' harmonise_factor_levels
#'
#' @description
#' A helper function to make sure that factor levels in new data match the old data
#'
#' @param new_data A data frame containing potential factor variables
#' @param old_data A data frame containing the reference factor levels
#'
#' @return A data frame with the same dimensions as `new_data`
#' @noRd
#'
harmonise_factor_levels <- function(new_data, old_data) {
  if (!is.data.frame(new_data) || !is.data.frame(old_data)) {
    stop("Both new_data and old_data must be data frames")
  }
  
  # Ensure arguments are in the correct order
  if (!identical(names(formals(harmonise_factor_levels))[1:2], c("new_data", "old_data"))) {
    warning("Arguments appear to be in the wrong order. 'new_data' should be the data to be harmonized, 'old_data' is the reference.")
  }
  
  # Original implementation follows
  f_old <- sapply(old_data, is.factor)
  f_new <- sapply(new_data, is.factor)
  
  # Get the common factor column names
  common_f <- intersect(names(old_data)[f_old], names(new_data)[f_new])
  
  # If there are no common factor columns, return the new_data as is
  if (length(common_f) == 0) {
    return(new_data)
  }
  
  # For each common factor column
  for (col in common_f) {
    # Get all unique levels from both datasets
    all_levels <- unique(c(levels(old_data[[col]]), levels(new_data[[col]])))
    
    # Check if there are new levels in new_data that don't exist in old_data
    new_levels <- setdiff(levels(new_data[[col]]), levels(old_data[[col]]))
    if (length(new_levels) > 0) {
      message(paste("sccomp says: New levels found in column", col, ":", paste(new_levels, collapse = ", ")))
    }
    
    # Set levels of new_data to match old_data, adding any missing levels
    new_data[[col]] <- factor(new_data[[col]], levels = levels(old_data[[col]]))
  }
  
  # Also check for character columns in new_data that are factors in old_data
  char_new <- sapply(new_data, is.character)
  factor_cols_in_old <- names(old_data)[f_old]
  
  char_to_factor <- intersect(names(new_data)[char_new], factor_cols_in_old)
  
  for (col in char_to_factor) {
    # Convert character to factor with the same levels as in old_data
    new_data[[col]] <- factor(new_data[[col]], levels = levels(old_data[[col]]))
    
    # Check if there are values in new_data that don't exist in old_data's levels
    invalid_values <- setdiff(unique(as.character(new_data[[col]])), levels(old_data[[col]]))
    if (length(invalid_values) > 0 && !all(is.na(invalid_values))) {
      warning(paste("sccomp says: Values in column", col, "not found in reference levels:", paste(invalid_values[!is.na(invalid_values)], collapse = ", ")))
    }
  }
  
  return(new_data)
}

#' Get Output Samples from a Stan Fit Object
#'
#' This function retrieves the number of output samples from a Stan fit object, 
#' supporting different methods (MHC and Variational) based on the available data within the object.
#'
#' @param fit A `stanfit` object, which is the result of fitting a model via Stan.
#' @return The number of output samples used in the Stan model. 
#'         Returns from MHC if available, otherwise from Variational inference.
#' @examples
#' # Assuming 'fit' is a stanfit object obtained from running a Stan model
#' print("samples_count = get_output_samples(fit)")
#'
#' @noRd
#' 
get_output_samples = function(fit){
  
  # Check if the output_samples field is present in the metadata of the fit object
  # This is generally available when the model is fit using MHC (Markov chain Monte Carlo)
  if(!is.null(fit$metadata()$output_samples)) {
    # Return the output_samples from the metadata
    fit$metadata()$output_samples
  }
  
  # If the output_samples field is not present, check for iter_sampling
  # This occurs typically when the model is fit using Variational inference methods
  else if(!is.null(fit$metadata()$iter_sampling)) {
    # Return the iter_sampling from the metadata
    fit$metadata()$iter_sampling
  }
  else
    fit$metadata()$num_psis_draws
}

#' sccomp_remove_outliers main
#'
#' @description 
#' The `sccomp_remove_outliers` function takes as input a table of cell counts with columns for cell-group identifier, sample identifier, integer count, and factors (continuous or discrete). The user can define a linear model using an input R formula, where the first factor is the factor of interest. Alternatively, `sccomp` accepts single-cell data containers (e.g., Seurat, SingleCellExperiment, cell metadata, or group-size) and derives the count data from cell metadata.
#'
#' @import dplyr
#' @importFrom magrittr %$% divide_by multiply_by equals
#' @importFrom rlang quo_is_null quo_is_symbolic inform
#' @importFrom SingleCellExperiment colData
#' @importFrom parallel detectCores
#' @importFrom tidyr unnest nest
#' @importFrom rlang :=
#' @importFrom dplyr select
#' @importFrom tibble column_to_rownames
#'
#' @param .estimate A tibble including a cell_group name column, sample name column, read counts column (optional depending on the input class), and factor columns.
#' @param percent_false_positive A real number between 0 and 100 (not inclusive), used to identify outliers with a specific false positive rate.
#' @param cores Integer, the number of cores to be used for parallel calculations.
#' @param inference_method Character string specifying the inference method to use ('pathfinder', 'hmc', or 'variational').
#' @param output_directory A character string specifying the output directory for Stan draws.
#' @param verbose Logical, whether to print progression details.
#' @param mcmc_seed Integer, used for Markov-chain Monte Carlo reproducibility. By default, a random number is sampled from 1 to 999999.
#' @param max_sampling_iterations Integer, limits the maximum number of iterations in case a large dataset is used, to limit computation time.
#' @param enable_loo Logical, whether to enable model comparison using the R package LOO. This is useful for comparing fits between models, similar to ANOVA.
#' @param sig_figs Number of significant figures to use for Stan model output. Default is 9.
#' @param cache_stan_model A character string specifying the cache directory for compiled Stan models. 
#'                        The sccomp version will be automatically appended to ensure version isolation.
#'                        Default is `sccomp_stan_models_cache_dir` which points to `~/.sccomp_models`.
#' @param approximate_posterior_inference DEPRECATED, use the `variational_inference` argument.
#' @param variational_inference DEPRECATED Logical, whether to use variational Bayes for posterior inference. It is faster and convenient. Setting this argument to `FALSE` runs full Bayesian (Hamiltonian Monte Carlo) inference, which is slower but the gold standard.
#' @param ... Additional arguments passed to the `cmdstanr::sample` function.
#' 
#' @return A tibble (`tbl`), with the following columns:
#' \itemize{
#'   \item cell_group - The cell groups being tested.
#'   \item parameter - The parameter being estimated from the design matrix described by the input formula_composition and formula_variability.
#'   \item factor - The covariate factor in the formula, if applicable (e.g., not present for Intercept or contrasts).
#'   \item c_lower - Lower (2.5%) quantile of the posterior distribution for a composition (c) parameter.
#'   \item c_effect - Mean of the posterior distribution for a composition (c) parameter.
#'   \item c_upper - Upper (97.5%) quantile of the posterior distribution for a composition (c) parameter.
#'   \item c_pH0 - Probability of the c_effect being smaller or bigger than the `test_composition_above_logit_fold_change` argument.
#'   \item c_FDR - False discovery rate of the c_effect being smaller or bigger than the `test_composition_above_logit_fold_change` argument. False discovery rate for Bayesian models is calculated differently from frequentists models, as detailed in Mangiola et al, PNAS 2023. 
#'   \item c_n_eff - Effective sample size, the number of independent draws in the sample. The higher, the better.
#'   \item c_R_k_hat - R statistic, a measure of chain equilibrium, should be within 0.05 of 1.0.
#'   \item v_lower - Lower (2.5%) quantile of the posterior distribution for a variability (v) parameter.
#'   \item v_effect - Mean of the posterior distribution for a variability (v) parameter.
#'   \item v_upper - Upper (97.5%) quantile of the posterior distribution for a variability (v) parameter.
#'   \item v_pH0 - Probability of the v_effect being smaller or bigger than the `test_composition_above_logit_fold_change` argument.
#'   \item v_FDR - False discovery rate of the v_effect being smaller or bigger than the `test_composition_above_logit_fold_change` argument. False discovery rate for Bayesian models is calculated differently from frequentists models, as detailed in Mangiola et al, PNAS 2023. 
#'   \item v_n_eff - Effective sample size for a variability (v) parameter.
#'   \item v_R_k_hat - R statistic for a variability (v) parameter, a measure of chain equilibrium.
#' }
#'
#' The function also attaches several attributes to the result:
#' \itemize{
#'   \item count_data - The original count data used in the analysis, stored as an attribute for efficient access.
#'   \item model_input - The model input data used for fitting.
#'   \item formula_composition - The formula used for composition modeling.
#'   \item formula_variability - The formula used for variability modeling.
#'   \item fit - The Stan fit object (if pass_fit = TRUE).
#' }
#'
#' @examples
#'
#' print("cmdstanr is needed to run this example.")
#' # Note: Before running the example, ensure that the 'cmdstanr' package is installed:
#' # install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))
#'
#' \donttest{
#'   if (instantiate::stan_cmdstan_exists()) {
#'     data("counts_obj")
#'     
#'     estimate = sccomp_estimate(
#'       counts_obj,
#'       ~ type,
#'       ~1,
#'       "sample",
#'       "cell_group",
#'       "count",
#'       cores = 1
#'     ) |>
#'     sccomp_remove_outliers(cores = 1)
#'   }
#' }
#'
#' @references
#' S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
#'
#' @export
sccomp_remove_outliers <- function(.estimate,
                                   percent_false_positive = 5,
                                   cores = detectCores(),
                                   inference_method = .estimate |> attr("inference_method"),
                                   output_directory = "sccomp_draws_files",
                                   verbose = TRUE,
                                   mcmc_seed = sample_seed(),
                                   max_sampling_iterations = 20000,
                                   enable_loo = FALSE,
                                   sig_figs = 9,
                                   cache_stan_model = sccomp_stan_models_cache_dir,
                                   
                                   # DEPRECATED
                                   approximate_posterior_inference = NULL,
                                   variational_inference = NULL,
                                   ...
) {
  if(inference_method == "variational") 
    rlang::inform(
      message = "sccomp says: From version 1.7.7 the model by default is fit with the variational inference method (inference_method = \"variational\"; much faster). For a full Bayesian inference (HMC method; the gold standard) use inference_method = \"hmc\".", 
      .frequency = "once", 
      .frequency_id = "variational_message"
    )
  
  # Run the function
  check_and_install_cmdstanr()
  
  UseMethod("sccomp_remove_outliers", .estimate)
}

#' @importFrom readr write_file
#' @export
sccomp_remove_outliers.sccomp_tbl = function(.estimate,
                                             percent_false_positive = 5,
                                             cores = detectCores(),
                                             inference_method = .estimate |> attr("inference_method"),
                                             output_directory = "sccomp_draws_files",
                                             verbose = TRUE,
                                             mcmc_seed = sample_seed(),
                                             max_sampling_iterations = 20000,
                                             enable_loo = FALSE,
                                             sig_figs = 9,
                                             cache_stan_model = sccomp_stan_models_cache_dir,
                                             
                                             # DEPRECATED
                                             approximate_posterior_inference = NULL,
                                             variational_inference = NULL,
                                             ...
) {
  
  
  # DEPRECATION OF approximate_posterior_inference
  if (is_present(approximate_posterior_inference) & !is.null(approximate_posterior_inference)) {
    deprecate_warn("1.7.7", "sccomp::sccomp_estimate(approximate_posterior_inference = )", details = "The argument approximate_posterior_inference is now deprecated please use variational_inference. By default variational_inference value is inferred from approximate_posterior_inference.")
    inference_method = ifelse(approximate_posterior_inference == "all", "variational","hmc")
  }
  
  # DEPRECATION OF variational_inference
  if (is_present(variational_inference) & !is.null(variational_inference)) {
    deprecate_warn("1.7.11", "sccomp::sccomp_estimate(variational_inference = )", details = "The argument variational_inference is now deprecated please use inference_method. By default inference_method value is inferred from variational_inference")
    
    inference_method = ifelse(variational_inference, "variational","hmc")
  }
  
  # Prepare column same enquo
  .sample = .estimate |>  attr(".sample")
  .cell_group = .estimate |>  attr(".cell_group")
  .count = .estimate |>  attr(".count")
  .sample_cell_group_pairs_to_exclude = .estimate |> attr(".sample_cell_group_pairs_to_exclude")
  
  # Formulae
  formula_composition = .estimate |> attr("formula_composition")
  formula_variability = .estimate |> attr("formula_variability")
  
  noise_model = .estimate |> attr("noise_model")
  
  # Get model input
  data_for_model = .estimate |> attr("model_input")
  
  # Credible interval
  CI = 1 - (percent_false_positive/100)
  
  # Count data
  .data = 
    .estimate |> 
    attr("count_data") |>
    distinct() |> 
    
    # Drop previous outlier estimation for the new one
    select(-any_of(c(
      ".lower" ,  ".median" ,  ".upper" , "Rhat" ,  "truncation_down" , 
      "truncation_up"   , "outlier"    ,   "contains_outliers"
    )))
  
  # Random intercept
  random_effect_elements = .estimate |> attr("formula_composition") |> parse_formula_random_effect()
  
  # Load model
  mod_rng = load_model("glm_multi_beta_binomial_generate_data", threads = cores, cache_dir = cache_stan_model)
  
  rng = mod_rng |> sample_safe(
    generate_quantities_fx,
    attr(.estimate , "fit")$draws(format = "matrix"),
    
    # This is for the new data generation with selected factors to do adjustment
    data = 
      .estimate |>
      attr("model_input") |> 
      c(list(
        
        # Add subset of coefficients
        X_original = data_for_model$X,
        N_original = data_for_model$N,
        length_X_which = ncol(data_for_model$X),
        length_XA_which = ncol(data_for_model$XA),
        X_which = seq_len(ncol(data_for_model$X)) |> as.array(),
        XA_which = seq_len(ncol(data_for_model$Xa)) |> as.array(),
        
        # Random intercept common variable between grouping 1 and 2
        ncol_X_random_eff_new = ncol(data_for_model$X_random_effect) |> c(ncol(data_for_model$X_random_effect_2) ), # I could put this in the intial data
        length_X_random_effect_which = ncol(data_for_model$X_random_effect) |> c(ncol(data_for_model$X_random_effect_2)),
        
        # Grouping 1
        X_random_effect_which = seq_len(ncol(data_for_model$X_random_effect)) |> as.array(),
        
        # Grouping 2 - Random intercept DUPLICATED
        X_random_effect_which_2 = seq_len(ncol(data_for_model$X_random_effect_2)) |> as.array(),
        
        # Initialize unseen random effect variables
        ncol_X_random_eff_unseen = c(0, 0),
        X_random_effect_unseen = matrix(0, nrow = nrow(data_for_model$X), ncol = 0),
        X_random_effect_2_unseen = matrix(0, nrow = nrow(data_for_model$X), ncol = 0),
        
        create_intercept = FALSE
      )),
    
    parallel_chains = ifelse(
      inference_method %in% c("variational", "pathfinder") | 
        attr(.estimate , "fit") |> is("CmdStanPathfinder"),
      1, 
      attr(.estimate , "fit")$num_chains()
    ), 
    threads_per_chain = cores,
    sig_figs = sig_figs
    
    
  )
  
  # Free memory
  rm(.estimate)
  
  # Detect outliers
  truncation_df =
    .data |>
    left_join(
      summary_to_tibble(rng, "counts", "N", "M", probs = c(0.05, 0.95)) |>
        nest(data = -N) |>
        mutate(!!.sample := rownames(data_for_model$X)) |>
        unnest(data) |>
        nest(data = -M) |>
        mutate(!!.cell_group := colnames(data_for_model$y)) |>
        unnest(data) ,
      
      by = c(quo_name(.sample), quo_name(.cell_group))
    ) |>
    
    # Add truncation
    mutate(   truncation_down = `5%`,   truncation_up =  `95%`) |>
    
    # Add outlier stats
    mutate( outlier = !(!!.count >= `5%` & !!.count <= `95%`) ) |>
    nest(data = -M) |>
    mutate(contains_outliers = map_lgl(data, ~ .x |> filter(outlier) |> nrow() > 0)) |>
    unnest(data) |>
    
    mutate(
      truncation_down = case_when( outlier ~ -1, TRUE ~ truncation_down),
      truncation_up = case_when(outlier ~ -1, TRUE ~ truncation_up),
    )
  
  # Add censoring
  data_for_model$is_truncated = 1
  data_for_model$truncation_up = truncation_df |> 
    select(N, M, truncation_up) |> 
    pivot_wider(names_from = M, values_from = truncation_up) |> 
    column_to_rownames("N") |> 
    as.matrix() |> 
    apply(2, as.integer)
  data_for_model$truncation_down = truncation_df |> 
    select(N, M, truncation_down) |> 
    pivot_wider(names_from = M, values_from = truncation_down) |> 
    column_to_rownames("N") |> 
    as.matrix() |> 
    apply(2, as.integer)
  data_for_model$truncation_not_idx = 
    (data_for_model$truncation_down >= 0) |> 
    t() |> 
    as.vector()  |> 
    which() |>
    intersect(data_for_model$user_forced_truncation_not_idx) |>
    sort()
  data_for_model$TNS = length(data_for_model$truncation_not_idx)
  
  data_for_model$truncation_not_idx_minimal = 
    truncation_df |> 
    select(N, M, truncation_down) |> 
    spread(M, truncation_down) |>
    mutate(row = row_number()) |>
    pivot_longer(
      cols = -c(N, row),
      names_to = "columns",
      values_to = "value"
    ) |>
    filter(value == -1) |>
    select(row, columns) |>
    mutate(columns = as.integer(columns)) |> 
    as.matrix()
  
  data_for_model$TNIM = nrow(data_for_model$truncation_not_idx_minimal)
  
  message("sccomp says: outlier identification - step 1/2")
  
  my_quantile_step_2 = 1 - (0.1 / data_for_model$N)
  
  # This step gets the credible interval to control for within-category false positive rate
  # We want a category-wise false positive rate of 0.1, and we have to correct for how many samples we have in each category
  CI_step_2 = (1-my_quantile_step_2) / 2 * 2
  
  fit2 =
    data_for_model |>
    fit_model(
      "glm_multi_beta_binomial",
      cores = cores,
      quantile = my_quantile_step_2,
      inference_method = inference_method,
      output_directory = output_directory,
      verbose = verbose,
      seed = mcmc_seed,
      max_sampling_iterations = max_sampling_iterations,
      pars = c("beta", "alpha", "prec_coeff", "prec_sd", "alpha_normalised", "random_effect", "random_effect_2"),
      sig_figs = sig_figs,
      cache_stan_model = cache_stan_model,
      ...
    )
  
  rng2 = mod_rng |> sample_safe(
    
    generate_quantities_fx,
    fit2$draws(format = "matrix"),
    
    # This is for the new data generation with selected factors to do adjustment
    data = data_for_model |> c(list(
      
      # Add subset of coefficients
      X_original = data_for_model$X,
      N_original = data_for_model$N,
      length_X_which = ncol(data_for_model$X),
      length_XA_which = ncol(data_for_model$XA),
      X_which = seq_len(ncol(data_for_model$X)) |> as.array(),
      XA_which = seq_len(ncol(data_for_model$Xa)) |> as.array(),
      
      # Random intercept common variable between grouping 1 and 2
      ncol_X_random_eff_new = ncol(data_for_model$X_random_effect) |> c(ncol(data_for_model$X_random_effect_2) ), # I could put this in the intial data
      length_X_random_effect_which = ncol(data_for_model$X_random_effect) |> c(ncol(data_for_model$X_random_effect_2)),
      
      # Grouping 1
      X_random_effect_which = seq_len(ncol(data_for_model$X_random_effect)) |> as.array(),
      
      # Grouping 2 - Random intercept DUPLICATED
      X_random_effect_which_2 = seq_len(ncol(data_for_model$X_random_effect_2)) |> as.array(),
      
      # Initialize unseen random effect variables
      ncol_X_random_eff_unseen = c(0, 0),
      X_random_effect_unseen = matrix(0, nrow = nrow(data_for_model$X), ncol = 0),
      X_random_effect_2_unseen = matrix(0, nrow = nrow(data_for_model$X), ncol = 0),
      
      create_intercept = FALSE
      
    )),
    
    parallel_chains = ifelse(inference_method %in% c("variational", "pathfinder"), 1, fit2$num_chains()), 
    threads_per_chain = cores,
    sig_figs = sig_figs
    
  )
  
  rng2_summary = 
    summary_to_tibble(rng2, "counts", "N", "M", probs = c(CI_step_2, 0.5, 1-CI_step_2)) 
  
  column_quantile_names = rng2_summary |> colnames() |> str_subset("\\%") |> _[c(1,3)]
  
  rng2_summary = 
    rng2_summary |>
    
    # !!! THIS COMMAND RELIES ON POSITION BECAUSE IT'S NOT TRIVIAL TO MATCH
    # !!! COLUMN NAMES BASED ON LIMITED PRECISION AND/OR PERIODICAL QUANTILES
    rename(
      .lower := !!as.symbol(column_quantile_names[1]) ,
      .median = `50%`,
      .upper := !!as.symbol(column_quantile_names[2])
    ) |>
    nest(data = -N) |>
    mutate(!!.sample := rownames(data_for_model$X)) |>
    unnest(data) |>
    nest(data = -M) |>
    mutate(!!.cell_group := colnames(data_for_model$y)) |>
    unnest(data) 
  
  # Detect outliers
  truncation_df2 =
    .data |>
    left_join(rng2_summary,
              by = c(quo_name(.sample), quo_name(.cell_group))
    ) |>
    
    # Add truncation
    mutate(   truncation_down = .lower,   truncation_up =  .upper) |>
    
    # Add outlier stats
    mutate( outlier = !(!!.count >= .lower & !!.count <= .upper) ) |>
    nest(data = -M) |>
    mutate(contains_outliers = map_lgl(data, ~ .x |> filter(outlier) |> nrow() > 0)) |>
    unnest(data) |>
    
    mutate(
      truncation_down = case_when( outlier ~ -1, TRUE ~ truncation_down),
      truncation_up = case_when(outlier ~ -1, TRUE ~ truncation_up)
    )
  
  data_for_model$truncation_up = truncation_df2 |> 
    select(N, M, truncation_up) |> 
    pivot_wider(names_from = M, values_from = truncation_up) |> 
    column_to_rownames("N") |> 
    as.matrix() |> 
    apply(2, as.integer)
  data_for_model$truncation_down = truncation_df2 |> 
    select(N, M, truncation_down) |> 
    pivot_wider(names_from = M, values_from = truncation_down) |> 
    column_to_rownames("N") |> 
    as.matrix() |> 
    apply(2, as.integer)
  data_for_model$truncation_not_idx = 
    (data_for_model$truncation_down >= 0) |> 
    t() |> 
    as.vector()  |> 
    which() |>
    intersect(data_for_model$user_forced_truncation_not_idx) |>
    sort()
  data_for_model$TNS = length(data_for_model$truncation_not_idx)
  
  # LOO
  data_for_model$enable_loo = TRUE & enable_loo
  
  message("sccomp says: outlier-free model fitting - step 2/2")
  
  # Print design matrix
  message(sprintf("sccomp says: the composition design matrix has columns: %s", data_for_model$X |> colnames() |> paste(collapse=", ")))
  message(sprintf("sccomp says: the variability design matrix has columns: %s", data_for_model$Xa |> colnames() |> paste(collapse=", ")))
  
  fit3 =
    data_for_model |>
    # Run the first discovery phase with permissive false discovery rate
    fit_model(
      "glm_multi_beta_binomial",
      cores = cores,
      quantile = CI,
      inference_method = inference_method,
      output_directory = output_directory,
      verbose = verbose, 
      seed = mcmc_seed,
      max_sampling_iterations = max_sampling_iterations,
      pars = c("beta", "alpha", "prec_coeff","prec_sd",   "alpha_normalised", "random_effect", "random_effect_2", "log_lik"),
      cache_stan_model = cache_stan_model,
      ...
    )
  
  # # Make the fit standalone
  # temp_rds_file <- tempfile(fileext = ".rds")
  # fit3$save_object(file = temp_rds_file) 
  # fit3 = readRDS(temp_rds_file)
  # file.remove(temp_rds_file)
  
  # Create a dummy tibble
  tibble() |>
    # Attach association mean concentration
    add_attr(fit3, "fit") |>
    add_attr(data_for_model, "model_input") |>
    add_attr(.sample, ".sample") |>
    add_attr(.cell_group, ".cell_group") |>
    add_attr(.count, ".count") |>
    
    add_attr(formula_composition, "formula_composition") |>
    add_attr(formula_variability, "formula_variability") |>
    add_attr(parse_formula(formula_composition), "factors" ) |> 
    add_attr(inference_method, "inference_method" ) |> 
    
    # Add count data as attribute
    add_attr(.data, "count_data") |>
    
    # Add class to the tbl
    add_class("sccomp_tbl") |> 
    
    # Print estimates
    sccomp_test() |>
    
    # drop hypothesis testing as the estimation exists without probabilities.
    # For hypothesis testing use sccomp_test
    select(-contains("_FDR"), -contains("_pH0")) |> 
    
    add_attr(noise_model, "noise_model") 
  
  
}

---
title: "sccomp: Differential Composition and Variability Analysis for Single-Cell Data"
author: "Stefano Mangiola"
date: "`r Sys.Date()`"
package: sccomp
output:
  prettydoc::html_pretty:
    theme: cayman
    toc: yes
    toc_depth: 2
    number_sections: yes
    fig_caption: yes
    df_print: paged
abstract: > 
  Sccomp is a comprehensive R package for differential composition and variability analysis in single-cell RNA sequencing, CyTOF, and microbiome data. It provides robust Bayesian modeling with outlier detection, random effects, and advanced statistical methods for cell type proportion analysis. Perfect for cancer research, immunology, and single-cell genomics.
keywords: "single-cell RNA-seq, differential composition analysis, cell type proportions, Bayesian modeling, scRNA-seq, CyTOF, microbiome analysis, statistical modeling, R package, bioinformatics, genomics, cell type variability, outlier detection, random effects modeling"
vignette: >
  %\VignetteIndexEntry{sccomp: Differential Composition and Variability Analysis for Single-Cell Data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
knit: >
    (function(x, ...){
        proj_root <- rprojroot::find_package_root_file() |> normalizePath()
        
        # Set knitr options for both renders
        knitr::opts_knit$set(root.dir = proj_root)
        
        rmarkdown::render(
            x,
            output_file = "README.md",
            output_format = "github_document",
            output_dir = proj_root,
            knit_root_dir = proj_root,
            params = list(
                demo_metadata = FALSE
            )
        )
    })
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
  fig.path = ifelse(knitr::pandoc_to() %in% c('html', 'html4'), 'inst/figures/', 'inst/figures/')
)
```

<!-- badges: start -->
[![Lifecycle:maturing](https://img.shields.io/badge/lifecycle-maturing-blue.svg)](https://www.tidyverse.org/lifecycle/#maturing) [![R build status](https://github.com/stemangiola/sccomp/workflows/R-CMD-check/badge.svg)](https://github.com/stemangiola/sccomp/actions/)
<!-- badges: end -->

# <img src="`r ifelse(knitr::pandoc_to() %in% c('html', 'html4'), '../inst/logo-01.png', 'inst/logo-01.png')`" height="139px" width="120px"/>

**sccomp** is a powerful R package designed for comprehensive differential composition and variability analysis in single-cell genomics, proteomics, and microbiomics data. 

## Why sccomp?

For cellular omic data, no method for differential variability analysis exists, and methods for differential composition analysis only take a few fundamental data properties into account. Here we introduce **sccomp**, a generalised method for differential composition and variability analyses capable of jointly modelling data count distribution, compositionality, group-specific variability, and proportion mean-variability association, while being robust to outliers.

<img src="`r ifelse(knitr::pandoc_to() == 'html', '../inst/cartoon_methods.png', 'inst/cartoon_methods.png')`" width="100%"/>

### Comprehensive Method Comparison

- **I**: Data are modelled as counts.
- **II**: Group proportions are modelled as compositional.
- **III**: The proportion variability is modelled as cell-type specific.
- **IV**: Information sharing across cell types, mean–variability association.
- **V**: Outlier detection or robustness.
- **VI**: Differential variability analysis.
- **VII** Mixed effect modelling
- **VIII** Removal unwanted effects

| Method       | Year | Model                        | I | II | III | IV | V | VI | VII | VIII | 
|--------------|------|------------------------------|---|----|-----|----|---|----|----|----|
| **sccomp**   | 2023 | Sum-constrained Beta-binomial | ● | ●  | ●   | ●  | ● | ●  | ●  | ●  | 
| **scCODA**   | 2021 | Dirichlet-multinomial         | ● | ●  |     |    |   |    |    |   |
| **quasi-binom.** | 2021 | Quasi-binomial            | ● |    | ●   |    |   |    |    |    |
| **rlm**      | 2021 | Robust-log-linear            |   | ●  |     |    | ● |    |    |   | 
| **propeller** | 2021 | Logit-linear + limma        |   | ●  | ●   | ●  |   |    |    |   |
| **ANCOM-BC** | 2020 | Log-linear                   |   | ●  | ●   |    |   |    |    |   |
| **corncob**  | 2020 | Beta-binomial                | ● |    | ●   |    |   |    |    |   |
| **scDC**     | 2019 | Log-linear                   |   | ●  | ●   |    |   |    |    |   |
| **dmbvs**    | 2017 | Dirichlet-multinomial        | ● | ●  |     |    |   |    |    |   |
| **MixMC**    | 2016 | Zero-inflated Log-linear     |   | ●  | ●   |    |   |    |    |   |
| **ALDEx2**   | 2014 | Dirichlet-multinomial        | ● | ●  |     |    |   |    |    |   |

### Scientific Citation

Mangiola, Stefano, Alexandra J. Roth-Schulze, Marie Trussart, Enrique Zozaya-Valdés, Mengyao Ma, Zijie Gao, Alan F. Rubin, Terence P. Speed, Heejung Shim, and Anthony T. Papenfuss. 2023. "Sccomp: Robust Differential Composition and Variability Analysis for Single-Cell Data." Proceedings of the National Academy of Sciences of the United States of America 120 (33): e2203828120. https://doi.org/10.1073/pnas.2203828120
[PNAS - sccomp: Robust differential composition and variability analysis for single-cell data](https://www.pnas.org/doi/full/10.1073/pnas.2203828120)

### Talk

<a href="https://www.youtube.com/watch?v=R_lt58We9nA&ab_channel=RConsortium" target="_blank">
 <img src="https://img.youtube.com/vi/R_lt58We9nA/mqdefault.jpg" alt="Watch the video" width="280" height="180" border="10" />
</a>


# Installation Guide

`sccomp` is based on `cmdstanr` which provides the latest version of `cmdstan` the Bayesian modelling tool. `cmdstanr` is not on CRAN, so we need to have 3 simple step process (that will be prompted to the user is forgot).

1. R installation of `sccomp`
2. R installation of `cmdstanr`
3. `cmdstanr` call to `cmdstan` installation

**Bioconductor**

```{r eval=FALSE, message=FALSE}
if (!requireNamespace("BiocManager")) install.packages("BiocManager")

# Step 1
BiocManager::install("sccomp")

# Step 2
install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

# Step 3
cmdstanr::check_cmdstan_toolchain(fix = TRUE) # Just checking system setting
cmdstanr::install_cmdstan()
```

**Github**

```{r eval=FALSE, message=FALSE}

# Step 1
devtools::install_github("MangiolaLaboratory/sccomp")

# Step 2
install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

# Step 3
cmdstanr::check_cmdstan_toolchain(fix = TRUE) # Just checking system setting
cmdstanr::install_cmdstan()
```

## Core Functions

Function | Description
------------ | -------------
`sccomp_estimate` | Fit the model onto the data, and estimate the coefficients
`sccomp_remove_outliers` | Identify outliers probabilistically based on the model fit, and exclude them from the estimation
`sccomp_test` | Calculate the probability that the coefficients are outside the H0 interval (i.e. test_composition_above_logit_fold_change)
`sccomp_replicate` | Simulate data from the model, or part of the model
`sccomp_predict` | Predicts proportions, based on the model, or part of the model
`sccomp_remove_unwanted_effects` | Removes the variability for unwanted factors
`plot` | Plots summary plots to assess significance 

# Analysis Tutorial

```{r message=FALSE, warning=FALSE}
library(dplyr)
library(sccomp)
library(ggplot2)
library(forcats)
library(tidyr)
data("seurat_obj")
data("sce_obj")
data("counts_obj")
```


## Binary Factor Analysis

Of the output table, the estimate columns start with the prefix `c_` indicate `composition`, or with `v_` indicate `variability` (when formula_variability is set).

### From Seurat, SingleCellExperiment, metadata objects

```{r eval=FALSE, message=FALSE}

sccomp_result = 
  sce_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample", 
    cell_group = "cell_group", 
    cores = 1,
    verbose = FALSE
  ) |> 
  sccomp_test()

```

### From counts

```{r, message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()}

sccomp_result = 
  counts_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample",
    cell_group = "cell_group",
    abundance = "count", 
    cores = 1, verbose = FALSE
  ) |> 
  sccomp_test()
```


Here you see the results of the fit, the effects of the factor on composition and variability. You also can see the uncertainty around those effects.

The output is a tibble containing the **Following columns** 

- `cell_group` - The cell groups being tested.
- `parameter` - The parameter being estimated from the design matrix described by the input `formula_composition` and `formula_variability`.
- `factor` - The covariate factor in the formula, if applicable (e.g., not present for Intercept or contrasts).
- `c_lower` - Lower (2.5%) quantile of the posterior distribution for a composition (c) parameter.
- `c_effect` - Mean of the posterior distribution for a composition (c) parameter.
- `c_upper` - Upper (97.5%) quantile of the posterior distribution for a composition (c) parameter.
- `c_pH0` - Probability of the null hypothesis (no difference) for a composition (c). This is not a p-value.
- `c_FDR` - False-discovery rate of the null hypothesis for a composition (c).
- `v_lower` - Lower (2.5%) quantile of the posterior distribution for a variability (v) parameter.
- `v_effect` - Mean of the posterior distribution for a variability (v) parameter.
- `v_upper` - Upper (97.5%) quantile of the posterior distribution for a variability (v) parameter.
- `v_pH0` - Probability of the null hypothesis for a variability (v).
- `v_FDR` - False-discovery rate of the null hypothesis for a variability (v).
- `count_data` - Nested input count data.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
sccomp_result
```

## Outlier Identification

`sccomp` can identify outliers probabilistically and exclude them from the estimation. 

```{r, message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()}

sccomp_result = 
  counts_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample",
    cell_group = "cell_group",
    abundance = "count", 
    cores = 1, verbose = FALSE
  ) |> 
  
  # max_sampling_iterations is used her to not exceed the maximum file size for GitHub action of 100Mb
  sccomp_remove_outliers(cores = 1, verbose = FALSE, max_sampling_iterations = 2000) |> # Optional
  sccomp_test()
```

## Visualization and Summary Plots

A plot of group proportions, faceted by groups. The blue boxplots represent the posterior predictive check. If the model is descriptively adequate for the data, the blue boxplots should roughly overlay the black boxplots, which represent the observed data. The outliers are coloured in red. A boxplot will be returned for every (discrete) covariate present in formula_composition. The colour coding represents the significant associations for composition and/or variability.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
sccomp_result |> 
  sccomp_boxplot(factor = "type")
```

You can plot proportions adjusted for unwanted effects. This is helpful especially for complex models, where multiple factors can significantly impact the proportions.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
sccomp_result |> 
  sccomp_boxplot(factor = "type", remove_unwanted_effects = TRUE)
```

A plot of estimates of differential composition (c_) on the x-axis and differential variability (v_) on the y-axis. The error bars represent 95% credible intervals. The dashed lines represent the minimal effect that the hypothesis test is based on. An effect is labelled as significant if it exceeds the minimal effect according to the 95% credible interval. Facets represent the covariates in the model.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
sccomp_result |> 
  plot_1D_intervals()
```


We can plot the relationship between abundance and variability. As we can see below, they are positively correlated. sccomp models this relationship to obtain a shrinkage effect on the estimates of both the abundance and the variability. This shrinkage is adaptive as it is modelled jointly, thanks to Bayesian inference.


```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
sccomp_result |> 
  plot_2D_intervals()
```

You can produce the series of plots calling the `plot` method.

```{r, out.height="200%", eval=FALSE, message=FALSE}
sccomp_result |> plot() 
```


## Model Proportions Directly (e.g. from deconvolution)

**Note:** If counts are available, we strongly discourage the use of proportions, as an important source of uncertainty (i.e., for rare groups/cell types) is not modeled.

The use of proportions is better suited for modelling deconvolution results (e.g., of bulk RNA data), in which case counts are not available.

Proportions should be greater than 0. Assuming that zeros derive from a precision threshold (e.g., deconvolution), zeros are converted to the smallest non-zero value.

```{r, message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()}

sccomp_result = 
  counts_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample",
    cell_group = "cell_group",
    abundance = "proportion", 
    cores = 1, verbose = FALSE
  ) |> 
  sccomp_test()
```

## Continuous Factor Analysis

`sccomp` is able to fit arbitrary complex models. In this example we have a continuous and binary covariate.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}

res =
    seurat_obj |>
    sccomp_estimate(
      formula_composition = ~ type + continuous_covariate, 
      sample = "sample", 
      cell_group = "cell_group",
      cores = 1, verbose=FALSE
    )

res
```

## Random Effect Modeling (Mixed-Effect Modeling)

`sccomp` supports multilevel modeling by allowing the inclusion of random effects in the compositional and variability formulas. This is particularly useful when your data has hierarchical or grouped structures, such as measurements nested within subjects, batches, or experimental units. By incorporating random effects, sccomp can account for variability at different levels of your data, improving model fit and inference accuracy.

### Random Intercept Model

In this example, we demonstrate how to fit a random intercept model using sccomp. We'll model the cell-type proportions with both fixed effects (e.g., treatment) and random effects (e.g., subject-specific variability).

Here is the input data

```{r, message=FALSE}
seurat_obj[[]] |> as_tibble()
```

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
res = 
  seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ type + (1 | group__), 
    sample = "sample",
    cell_group = "cell_group",
    bimodal_mean_variability_association = TRUE,
    cores = 1, verbose = FALSE
  ) 

res
```

### Random Effect Model (random slopes)

`sccomp` can model random slopes. We provide an example below.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
res = 
  seurat_obj |>
  sccomp_estimate(
      formula_composition = ~ type + (type | group__),
      sample = "sample",
      cell_group = "cell_group",
      bimodal_mean_variability_association = TRUE,
      cores = 1, verbose = FALSE
    )

res
```

### Nested Random Effects

If you have a more complex hierarchy, such as measurements nested within subjects and subjects nested within batches, you can include multiple grouping variables. Here `group2__` is nested within `group__`.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
res = 
  seurat_obj |>
  sccomp_estimate(
      formula_composition = ~ type + (type | group__) + (1 | group2__),
      sample = "sample",
      cell_group = "cell_group",
      bimodal_mean_variability_association = TRUE,
      cores = 1, verbose = FALSE
    )

res
```

## Result Interpretation and Communication

The estimated effects are expressed in the unconstrained space of the parameters, similar to differential expression analysis that expresses changes in terms of log fold change. However, for differences in proportion, logit fold change must be used, which is harder to interpret and understand.

Therefore, we provide a more intuitive proportional fold change that can be more easily understood. However, these cannot be used to infer significance (use sccomp_test() instead), and a lot of care must be taken given the nonlinearity of these measures (a 1-fold increase from 0.0001 to 0.0002 carries a different weight than a 1-fold increase from 0.4 to 0.8).

From your estimates, you can specify which effects you are interested in (this can be a subset of the full model if you wish to exclude unwanted effects), and the two points you would like to compare.

In the case of a categorical variable, the starting and ending points are categories.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
res |> 
   sccomp_proportional_fold_change(
     formula_composition = ~  type,
     from =  "healthy", 
     to = "cancer"
    ) |> 
  select(cell_group, statement)
```


## Contrasts Analysis

```{r, message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()}

seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ 0 + type, 
    sample = "sample",
    cell_group = "cell_group", 
    cores = 1, verbose = FALSE
  ) |> 
  sccomp_test( contrasts =  c("typecancer - typehealthy", "typehealthy - typecancer"))


```


## Categorical Factor Analysis (Bayesian ANOVA)

This is achieved through model comparison with `loo`. In the following example, the model with association with factors better fits the data compared to the baseline model with no factor association. For model comparisons `sccomp_remove_outliers()` must not be executed as the leave-one-out must work with the same amount of data, while outlier elimination does not guarantee it.

If `elpd_diff` is away from zero of \> 5 `se_diff` difference of 5, we are confident that a model is better than the other [reference](https://discourse.mc-stan.org/t/interpreting-elpd-diff-loo-package/1628/2?u=stemangiola).
In this case, -79.9 / 11.5 = -6.9, therefore we can conclude that model one, the one with factor association, is better than model two.

```{r, message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()}
library(loo)

# Fit first model
model_with_factor_association = 
  seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    sample = "sample", 
    cell_group = "cell_group", 
    inference_method = "hmc",
    enable_loo = TRUE,
    verbose = FALSE
  )

# Fit second model
model_without_association = 
  seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ 1, 
    sample = "sample", 
    cell_group = "cell_group", 
    inference_method = "hmc",
    enable_loo = TRUE,
    verbose = FALSE
  )

# Compare models
loo_compare(
   attr(model_with_factor_association, "fit")$loo(),
   attr(model_without_association, "fit")$loo()
)

```

## Differential Variability Analysis

We can model the cell-group variability also dependent on the type, and so test differences in variability

```{r, message=FALSE, warning=FALSE, eval = instantiate::stan_cmdstan_exists()}

res = 
  seurat_obj |>
  sccomp_estimate( 
    formula_composition = ~ type, 
    formula_variability = ~ type,
    sample = "sample",
    cell_group = "cell_group",
    cores = 1, verbose = FALSE
  )

res

```

**Plot 1D significance plot**

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
plots = res |> sccomp_test() |> plot()

plots$credible_intervals_1D
```

**Plot 2D significance plot** Data points are cell groups. Error bars are the 95% credible interval. The dashed lines represent the default threshold fold change for which the probabilities (c_pH0, v_pH0) are calculated. pH0 of 0 represent the rejection of the null hypothesis that no effect is observed.

This plot is provided only if differential variability has been tested. The differential variability estimates are reliable only if the linear association between mean and variability for `(intercept)` (left-hand side facet) is satisfied. A scatterplot (besides the Intercept) is provided for each category of interest. For each category of interest, the composition and variability effects should be generally uncorrelated.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE}
plots$credible_intervals_2D
```

# Recommended Settings for Different Data Types

## For Single-Cell RNA Sequencing

We recommend setting `bimodal_mean_variability_association  = TRUE`. The bimodality of the mean-variability association can be confirmed from the plots\$credible_intervals_2D (see below).

## For CyTOF and Microbiome Data 

We recommend setting `bimodal_mean_variability_association  = FALSE` (Default).

## MCMC Chain Visualization

It is possible to directly evaluate the posterior distribution. In this example, we plot the Monte Carlo chain for the slope parameter of the
first cell type. We can see that it has converged and is negative with probability 1.

```{r, eval = instantiate::stan_cmdstan_exists(), message=FALSE, warning=FALSE}

library(cmdstanr)
library(posterior)
library(bayesplot)

# Assuming res contains the fit object from cmdstanr
fit <- res |> attr("fit")

# Extract draws for 'beta[2,1]'
draws <- as_draws_array(fit$draws("beta[2,1]"))

# Create a traceplot for 'beta[2,1]'
mcmc_trace(draws, pars = "beta[2,1]") + theme_bw()

```


```{r, message=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plot_2D_intervals}
\alias{plot_2D_intervals}
\title{Plot 2D Intervals for Mean-Variance Association}
\usage{
plot_2D_intervals(
  .data,
  significance_threshold = 0.05,
  test_composition_above_logit_fold_change = attr(.data,
    "test_composition_above_logit_fold_change"),
  show_fdr_message = TRUE,
  significance_statistic = c("FDR", "pH0")
)
}
\arguments{
\item{.data}{Data frame containing the main data.}

\item{significance_threshold}{Numeric value specifying the significance threshold for highlighting differences. Default is 0.025.}

\item{test_composition_above_logit_fold_change}{A positive integer. It is the effect threshold used for the hypothesis test. A value of 0.2 correspond to a change in cell proportion of 10\% for a cell type with baseline proportion of 50\%. That is, a cell type goes from 45\% to 50\%. When the baseline proportion is closer to 0 or 1 this effect thrshold has consistent value in the logit uncontrained scale.}

\item{show_fdr_message}{Logical. Whether to show the Bayesian FDR interpretation message on the plot. Default is TRUE.}

\item{significance_statistic}{Character vector indicating which statistic to highlight. Default is "FDR".}
}
\value{
A ggplot object representing the 2D interval plot.
}
\description{
This function creates a 2D interval plot for mean-variance association, highlighting significant differences based on a given significance threshold.
}
\examples{

print("cmdstanr is needed to run this example.")

\donttest{
  if (instantiate::stan_cmdstan_exists()) {
    data("counts_obj")

    estimate <- sccomp_estimate(
      counts_obj,
      ~ type,
      ~type,
      "sample",
      "cell_group",
      "count",
      cores = 1
    ) |> 
    sccomp_test()
    
  # Example usage:
  my_plot = plot_2D_intervals(estimate)
    
  }
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{seurat_obj}
\alias{seurat_obj}
\title{seurat_obj}
\format{
A \code{Seurat} object with the following structure:
\itemize{
\item \strong{assays}: Contains gene expression data. The active assay is \code{RNA}, with 1 feature and no variable features.
\item \strong{layers}: Two layers: counts and data, representing raw and processed RNA expression values, respectively.
\item \strong{samples}: 106,297 samples (cells) within the RNA assay.
}
}
\usage{
data(seurat_obj)
}
\value{
A \code{Seurat} object containing single-cell RNA expression data.
}
\description{
Example \code{Seurat} object containing gene expression data for 106,297 cells across a single assay. The object includes RNA counts and data layers, but no variable features are defined. This dataset can be directly used with functions like \code{sccomp_glm} for differential abundance analysis.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sccomp_calculate_residuals.R
\name{sccomp_calculate_residuals}
\alias{sccomp_calculate_residuals}
\title{Calculate Residuals Between Observed and Predicted Proportions}
\usage{
sccomp_calculate_residuals(.data)
}
\arguments{
\item{.data}{A tibble of class \code{sccomp_tbl}, which is the result of \code{sccomp_estimate()}. This tibble contains the fitted model and associated data necessary for calculating residuals.}
}
\value{
A tibble (\code{tbl}) with the following columns:
\itemize{
\item \strong{sample} - A character column representing the sample identifiers.
\item \strong{cell_group} - A character column representing the cell group identifiers.
\item \strong{residuals} - A numeric column representing the residuals, calculated as the difference between observed and predicted proportions.
\item \strong{exposure} - A numeric column representing the total counts (sum of counts across cell groups) for each sample.
}
}
\description{
\code{sccomp_calculate_residuals} computes the residuals between observed cell group proportions and the predicted proportions from a fitted \code{sccomp} model. This function is useful for assessing model fit and identifying cell groups or samples where the model may not adequately capture the observed data. The residuals are calculated as the difference between the observed proportions and the predicted mean proportions from the model.
}
\details{
The function performs the following steps:
\enumerate{
\item Extracts the predicted mean proportions for each cell group and sample using \code{sccomp_predict()}.
\item Calculates the observed proportions from the original count data.
\item Computes residuals by subtracting the predicted proportions from the observed proportions.
\item Returns a tibble containing the sample, cell group, residuals, and exposure (total counts per sample).
}
}
\examples{
\donttest{
  if (instantiate::stan_cmdstan_exists() && .Platform$OS.type == "unix") {
# Load example data
data("counts_obj")

# Fit the sccomp model
estimates <- sccomp_estimate(
  counts_obj,
  formula_composition = ~ type,
  formula_variability = ~1,
  sample = "sample",
  cell_group = "cell_group",
  abundance = "count",
  approximate_posterior_inference = "all",
  cores = 1
)

# Calculate residuals
residuals <- sccomp_calculate_residuals(estimates)

# View the residuals
print(residuals)
}}

}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulate_data.R
\name{simulate_data}
\alias{simulate_data}
\title{simulate_data}
\usage{
simulate_data(
  .data,
  .estimate_object,
  formula_composition,
  formula_variability = NULL,
  .sample = NULL,
  .cell_group = NULL,
  .coefficients = NULL,
  variability_multiplier = 5,
  number_of_draws = 1,
  mcmc_seed = sample_seed(),
  cores = detectCores(),
  sig_figs = 9,
  cache_stan_model = sccomp_stan_models_cache_dir
)
}
\arguments{
\item{.data}{A tibble including a cell_group name column | sample name column | read counts column | factor columns | Pvalue column | a significance column}

\item{.estimate_object}{The result of sccomp_estimate execution. This is used for sampling from real-data properties.}

\item{formula_composition}{A formula. The formula describing the model for differential abundance, for example ~treatment}

\item{formula_variability}{A formula. The formula describing the model for differential variability, for example ~treatment}

\item{.sample}{A column name as symbol. The sample identifier}

\item{.cell_group}{A column name as symbol. The cell_group identifier}

\item{.coefficients}{The column names for coefficients, for example, c(b_0, b_1)}

\item{variability_multiplier}{A real scalar. This can be used for artificially increasing the variability of the simulation for benchmarking purposes.}

\item{number_of_draws}{An integer. How may copies of the data you want to draw from the model joint posterior distribution.}

\item{mcmc_seed}{An integer. Used for Markov-chain Monte Carlo reproducibility. By default a random number is sampled from 1 to 999999. This itself can be controlled by set.seed()#' @param cores Integer, the number of cores to be used for parallel calculations.}

\item{cores}{Integer, the number of cores to be used for parallel calculations.}

\item{sig_figs}{Number of significant figures to use for Stan model output. Default is 9.}

\item{cache_stan_model}{A character string specifying the cache directory for compiled Stan models.
The sccomp version will be automatically appended to ensure version isolation.
Default is \code{sccomp_stan_models_cache_dir} which points to \verb{~/.sccomp_models}.}
}
\value{
A tibble (\code{tbl}) with the following columns:
\itemize{
\item \strong{sample} - A character column representing the sample name.
\item \strong{type} - A factor column representing the type of the sample.
\item \strong{phenotype} - A factor column representing the phenotype in the data.
\item \strong{count} - An integer column representing the original cell counts.
\item \strong{cell_group} - A character column representing the cell group identifier.
\item \strong{b_0} - A numeric column representing the first coefficient used for simulation.
\item \strong{b_1} - A numeric column representing the second coefficient used for simulation.
\item \strong{generated_proportions} - A numeric column representing the generated proportions from the simulation.
\item \strong{generated_counts} - An integer column representing the generated cell counts from the simulation.
\item \strong{replicate} - An integer column representing the replicate number for each draw from the posterior distribution.
}
}
\description{
This function simulates data from a fitted model.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
  if (instantiate::stan_cmdstan_exists()) {
    data("counts_obj")
    library(dplyr)

    estimate = sccomp_estimate(
      counts_obj,
      ~ type, ~1, "sample", "cell_group", "count",
      cores = 1
    )

    # Set coefficients for cell_groups. In this case all coefficients are 0 for simplicity.
    counts_obj = counts_obj |> mutate(b_0 = 0, b_1 = 0)

    # Simulate data
    simulate_data(counts_obj, estimate, ~type, ~1, sample, cell_group, c(b_0, b_1))
  }
}

}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sccomp_predict.R
\name{sccomp_predict}
\alias{sccomp_predict}
\title{sccomp_predict}
\usage{
sccomp_predict(
  fit,
  formula_composition = NULL,
  new_data = NULL,
  number_of_draws = 500,
  mcmc_seed = sample_seed(),
  summary_instead_of_draws = TRUE,
  robust = FALSE
)
}
\arguments{
\item{fit}{The result of sccomp_estimate.}

\item{formula_composition}{A formula. The formula describing the model for differential abundance, for example ~treatment. This formula can be a sub-formula of your estimated model; in this case all other factor will be factored out.}

\item{new_data}{A sample-wise data frame including the column that represent the factors in your formula. If you want to predict proportions for 10 samples, there should be 10 rows. T}

\item{number_of_draws}{An integer. How may copies of the data you want to draw from the model joint posterior distribution.}

\item{mcmc_seed}{An integer. Used for Markov-chain Monte Carlo reproducibility. By default a random number is sampled from 1 to 999999. This itself can be controlled by set.seed()}

\item{summary_instead_of_draws}{Return the summary values (i.e. mean and quantiles) of the predicted proportions, or return single draws. Single draws can be helful to better analyse the uncertainty of the prediction.}

\item{robust}{A logical. If TRUE, use robust statistics (median and median absolute deviation) instead of classical statistics (mean and standard deviation) for the summary calculations.}
}
\value{
A tibble (\code{tbl}) with the following columns:
\itemize{
\item \strong{cell_group} - A character column representing the cell group being tested.
\item \strong{sample} - A factor column representing the sample name for which the predictions are made.
\item \strong{proportion_mean} - A numeric column representing the predicted mean (or median when robust=TRUE) proportions from the model.
\item \strong{proportion_lower} - A numeric column representing the lower bound (2.5\%) of the 95\% credible interval for the predicted proportions.
\item \strong{proportion_upper} - A numeric column representing the upper bound (97.5\%) of the 95\% credible interval for the predicted proportions.
}
}
\description{
This function replicates counts from a real-world dataset.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
  if (instantiate::stan_cmdstan_exists() && .Platform$OS.type == "unix") {
    data("counts_obj")

    sccomp_estimate(
      counts_obj,
      ~ type, ~1, "sample", "cell_group", "count",
      cores = 1
    ) |>
    sccomp_predict()
  }
}


}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sccomp_test.R
\name{sccomp_test}
\alias{sccomp_test}
\title{sccomp_test}
\usage{
sccomp_test(
  .data,
  contrasts = NULL,
  percent_false_positive = 5,
  test_composition_above_logit_fold_change = 0.1,
  pass_fit = TRUE
)
}
\arguments{
\item{.data}{A tibble. The result of sccomp_estimate.}

\item{contrasts}{A vector of character strings. For example if your formula is \code{~ 0 + treatment} and the factor treatment has values \code{yes} and \code{no}, your contrast could be "constrasts = c(treatmentyes - treatmentno)".}

\item{percent_false_positive}{A real between 0 and 100 non included. This used to identify outliers with a specific false positive rate.}

\item{test_composition_above_logit_fold_change}{A positive integer. It is the effect threshold used for the hypothesis test. A value of 0.2 correspond to a change in cell proportion of 10\% for a cell type with baseline proportion of 50\%. That is, a cell type goes from 45\% to 50\%. When the baseline proportion is closer to 0 or 1 this effect thrshold has consistent value in the logit uncontrained scale.}

\item{pass_fit}{A boolean. Whether to pass the Stan fit as attribute in the output. Because the Stan fit can be very large, setting this to FALSE can be used to lower the memory imprint to save the output.}
}
\value{
A tibble (\code{tbl}), with the following columns:
\itemize{
\item cell_group - The cell groups being tested.
\item parameter - The parameter being estimated from the design matrix described by the input formula_composition and formula_variability.
\item factor - The covariate factor in the formula, if applicable (e.g., not present for Intercept or contrasts).
\item c_lower - Lower (2.5\%) quantile of the posterior distribution for a composition (c) parameter.
\item c_effect - Mean of the posterior distribution for a composition (c) parameter.
\item c_upper - Upper (97.5\%) quantile of the posterior distribution for a composition (c) parameter.
\item c_pH0 - Probability of the c_effect being smaller or bigger than the \code{test_composition_above_logit_fold_change} argument.
\item c_FDR - False-discovery rate of the null hypothesis (no difference) for a composition (c).
\item c_n_eff - Effective sample size - the number of independent draws in the sample, the higher the better.
\item c_R_k_hat - R statistic, a measure of chain equilibrium, should be within 0.05 of 1.0.
\item v_lower - Lower (2.5\%) quantile of the posterior distribution for a variability (v) parameter.
\item v_effect - Mean of the posterior distribution for a variability (v) parameter.
\item v_upper - Upper (97.5\%) quantile of the posterior distribution for a variability (v) parameter.
\item v_pH0 - Probability of the null hypothesis (no difference) for a variability (v).
\item v_FDR - False-discovery rate of the null hypothesis (no difference) for a variability (v).
\item v_n_eff - Effective sample size for a variability (v) parameter.
\item v_R_k_hat - R statistic for a variability (v) parameter.
\item count_data - Nested input count data.
}
}
\description{
This function test contrasts from a sccomp result.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
  if (instantiate::stan_cmdstan_exists()) {
    data("counts_obj")

    estimates = sccomp_estimate(
      counts_obj,
      ~ 0 + type, ~1, "sample", "cell_group", "count",
      cores = 1
    ) |>
    sccomp_test("typecancer - typebenign")
  }
}

}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sccomp_remove_outliers.R
\name{sccomp_remove_outliers}
\alias{sccomp_remove_outliers}
\title{sccomp_remove_outliers main}
\usage{
sccomp_remove_outliers(
  .estimate,
  percent_false_positive = 5,
  cores = detectCores(),
  inference_method = attr(.estimate, "inference_method"),
  output_directory = "sccomp_draws_files",
  verbose = TRUE,
  mcmc_seed = sample_seed(),
  max_sampling_iterations = 20000,
  enable_loo = FALSE,
  sig_figs = 9,
  cache_stan_model = sccomp_stan_models_cache_dir,
  approximate_posterior_inference = NULL,
  variational_inference = NULL,
  ...
)
}
\arguments{
\item{.estimate}{A tibble including a cell_group name column, sample name column, read counts column (optional depending on the input class), and factor columns.}

\item{percent_false_positive}{A real number between 0 and 100 (not inclusive), used to identify outliers with a specific false positive rate.}

\item{cores}{Integer, the number of cores to be used for parallel calculations.}

\item{inference_method}{Character string specifying the inference method to use ('pathfinder', 'hmc', or 'variational').}

\item{output_directory}{A character string specifying the output directory for Stan draws.}

\item{verbose}{Logical, whether to print progression details.}

\item{mcmc_seed}{Integer, used for Markov-chain Monte Carlo reproducibility. By default, a random number is sampled from 1 to 999999.}

\item{max_sampling_iterations}{Integer, limits the maximum number of iterations in case a large dataset is used, to limit computation time.}

\item{enable_loo}{Logical, whether to enable model comparison using the R package LOO. This is useful for comparing fits between models, similar to ANOVA.}

\item{sig_figs}{Number of significant figures to use for Stan model output. Default is 9.}

\item{cache_stan_model}{A character string specifying the cache directory for compiled Stan models.
The sccomp version will be automatically appended to ensure version isolation.
Default is \code{sccomp_stan_models_cache_dir} which points to \verb{~/.sccomp_models}.}

\item{approximate_posterior_inference}{DEPRECATED, use the \code{variational_inference} argument.}

\item{variational_inference}{DEPRECATED Logical, whether to use variational Bayes for posterior inference. It is faster and convenient. Setting this argument to \code{FALSE} runs full Bayesian (Hamiltonian Monte Carlo) inference, which is slower but the gold standard.}

\item{...}{Additional arguments passed to the \code{cmdstanr::sample} function.}
}
\value{
A tibble (\code{tbl}), with the following columns:
\itemize{
\item cell_group - The cell groups being tested.
\item parameter - The parameter being estimated from the design matrix described by the input formula_composition and formula_variability.
\item factor - The covariate factor in the formula, if applicable (e.g., not present for Intercept or contrasts).
\item c_lower - Lower (2.5\%) quantile of the posterior distribution for a composition (c) parameter.
\item c_effect - Mean of the posterior distribution for a composition (c) parameter.
\item c_upper - Upper (97.5\%) quantile of the posterior distribution for a composition (c) parameter.
\item c_pH0 - Probability of the c_effect being smaller or bigger than the \code{test_composition_above_logit_fold_change} argument.
\item c_FDR - False discovery rate of the c_effect being smaller or bigger than the \code{test_composition_above_logit_fold_change} argument. False discovery rate for Bayesian models is calculated differently from frequentists models, as detailed in Mangiola et al, PNAS 2023.
\item c_n_eff - Effective sample size, the number of independent draws in the sample. The higher, the better.
\item c_R_k_hat - R statistic, a measure of chain equilibrium, should be within 0.05 of 1.0.
\item v_lower - Lower (2.5\%) quantile of the posterior distribution for a variability (v) parameter.
\item v_effect - Mean of the posterior distribution for a variability (v) parameter.
\item v_upper - Upper (97.5\%) quantile of the posterior distribution for a variability (v) parameter.
\item v_pH0 - Probability of the v_effect being smaller or bigger than the \code{test_composition_above_logit_fold_change} argument.
\item v_FDR - False discovery rate of the v_effect being smaller or bigger than the \code{test_composition_above_logit_fold_change} argument. False discovery rate for Bayesian models is calculated differently from frequentists models, as detailed in Mangiola et al, PNAS 2023.
\item v_n_eff - Effective sample size for a variability (v) parameter.
\item v_R_k_hat - R statistic for a variability (v) parameter, a measure of chain equilibrium.
}

The function also attaches several attributes to the result:
\itemize{
\item count_data - The original count data used in the analysis, stored as an attribute for efficient access.
\item model_input - The model input data used for fitting.
\item formula_composition - The formula used for composition modeling.
\item formula_variability - The formula used for variability modeling.
\item fit - The Stan fit object (if pass_fit = TRUE).
}
}
\description{
The \code{sccomp_remove_outliers} function takes as input a table of cell counts with columns for cell-group identifier, sample identifier, integer count, and factors (continuous or discrete). The user can define a linear model using an input R formula, where the first factor is the factor of interest. Alternatively, \code{sccomp} accepts single-cell data containers (e.g., Seurat, SingleCellExperiment, cell metadata, or group-size) and derives the count data from cell metadata.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
  if (instantiate::stan_cmdstan_exists()) {
    data("counts_obj")
    
    estimate = sccomp_estimate(
      counts_obj,
      ~ type,
      ~1,
      "sample",
      "cell_group",
      "count",
      cores = 1
    ) |>
    sccomp_remove_outliers(cores = 1)
  }
}

}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sce_obj}
\alias{sce_obj}
\title{sce_obj}
\format{
A \code{SingleCellExperiment} object with the following structure:
\itemize{
\item \strong{assays}: Two assays: counts (raw RNA counts) and logcounts (log-transformed counts).
\item \strong{rowData}: No additional row-level metadata is present.
\item \strong{colData}: Metadata for each cell, including six fields: sample, type, nFeature_RNA, ident, and others.
\item \strong{dim}: 1 feature and 106,297 cells.
\item \strong{colnames}: Cell identifiers for all 106,297 cells.
}
}
\usage{
data(sce_obj)
}
\value{
A \code{SingleCellExperiment} object containing single-cell RNA expression data.
}
\description{
Example \code{SingleCellExperiment} object containing gene expression data for 106,297 cells across two assays: counts and logcounts. The object includes metadata and assay data for RNA expression, which can be used directly in differential analysis functions like \code{sccomp_glm}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/print_method.R
\name{print.sccomp_tbl}
\alias{print.sccomp_tbl}
\title{Print method for sccomp objects}
\usage{
\method{print}{sccomp_tbl}(x, ...)
}
\arguments{
\item{x}{A sccomp object}

\item{...}{Additional arguments passed to print}
}
\value{
The printed object
}
\description{
Print method for sccomp objects.

The print method for sccomp objects provides a summary of the model specifications,
data dimensions, and convergence diagnostics.

The output is formatted to be easy to read and understand.
}
\examples{

# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
if (instantiate::stan_cmdstan_exists()) {
  # Create a sccomp object
  data("counts_obj") 
  estimate <- sccomp_estimate(
    counts_obj,
    ~ type,
    ~1,
    "sample",
    "cell_group",
    "count",
    cores = 1
  )
  print(estimate)
}
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sccomp_replicate.R
\name{sccomp_replicate}
\alias{sccomp_replicate}
\title{sccomp_replicate}
\usage{
sccomp_replicate(
  fit,
  formula_composition = NULL,
  formula_variability = NULL,
  number_of_draws = 1,
  mcmc_seed = sample_seed(),
  cache_stan_model = sccomp_stan_models_cache_dir
)
}
\arguments{
\item{fit}{The result of sccomp_estimate.}

\item{formula_composition}{A formula. The formula describing the model for differential abundance, for example ~treatment. This formula can be a sub-formula of your estimated model; in this case all other factor will be factored out.}

\item{formula_variability}{A formula. The formula describing the model for differential variability, for example ~treatment. In most cases, if differentially variability is of interest, the formula should only include the factor of interest as a large anount of data is needed to define variability depending to each factors. This formula can be a sub-formula of your estimated model; in this case all other factor will be factored out.}

\item{number_of_draws}{An integer. How may copies of the data you want to draw from the model joint posterior distribution.}

\item{mcmc_seed}{An integer. Used for Markov-chain Monte Carlo reproducibility. By default a random number is sampled from 1 to 999999. This itself can be controlled by set.seed()}

\item{cache_stan_model}{A character string specifying the cache directory for compiled Stan models.
The sccomp version will be automatically appended to ensure version isolation.
Default is \code{sccomp_stan_models_cache_dir} which points to \verb{~/.sccomp_models}.}
}
\value{
A tibble \code{tbl} with cell_group-wise statistics

A tibble (\code{tbl}), with the following columns:
\itemize{
\item \strong{cell_group} - A character column representing the cell group being tested.
\item \strong{sample} - A factor column representing the sample name from which data was generated.
\item \strong{generated_proportions} - A numeric column representing the proportions generated from the model.
\item \strong{generated_counts} - An integer column representing the counts generated from the model.
\item \strong{replicate} - An integer column representing the replicate number, where each row corresponds to a different replicate of the data.
}
}
\description{
This function replicates counts from a real-world dataset.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
  if (instantiate::stan_cmdstan_exists() && .Platform$OS.type == "unix") {
    data("counts_obj")

    sccomp_estimate(
      counts_obj,
      ~ type, ~1, "sample", "cell_group", "count",
      cores = 1
    ) |>
    sccomp_replicate()
  }
}
}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plot.sccomp_tbl}
\alias{plot.sccomp_tbl}
\title{plot}
\usage{
\method{plot}{sccomp_tbl}(
  x,
  significance_threshold = 0.05,
  test_composition_above_logit_fold_change = attr(.data,
    "test_composition_above_logit_fold_change"),
  significance_statistic = c("FDR", "pH0"),
  show_fdr_message = TRUE,
  ...
)
}
\arguments{
\item{x}{A tibble including a cell_group name column | sample name column | read counts column | factor columns | Pvalue column | a significance column}

\item{significance_threshold}{Numeric value specifying the significance threshold for highlighting differences. Default is 0.025.}

\item{test_composition_above_logit_fold_change}{A positive integer. It is the effect threshold used for the hypothesis test. A value of 0.2 correspond to a change in cell proportion of 10\% for a cell type with baseline proportion of 50\%. That is, a cell type goes from 45\% to 50\%. When the baseline proportion is closer to 0 or 1 this effect thrshold has consistent value in the logit uncontrained scale.}

\item{significance_statistic}{Character vector indicating which statistic to highlight. Default is "FDR".}

\item{show_fdr_message}{Logical. Whether to show the Bayesian FDR interpretation message on the plot. Default is TRUE.}

\item{...}{For internal use}
}
\value{
A \code{ggplot}
}
\description{
This function plots a summary of the results of the model.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
  if (instantiate::stan_cmdstan_exists()) {
    data("counts_obj")

    estimate = sccomp_estimate(
      counts_obj,
      ~ type, ~1, "sample", "cell_group", "count",
      cores = 1
    )

    # estimate |> plot()
  }
}

}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sccomp_estimate.R
\name{sccomp_estimate}
\alias{sccomp_estimate}
\title{Main Function for SCCOMP Estimate}
\usage{
sccomp_estimate(
  .data,
  formula_composition = ~1,
  formula_variability = ~1,
  sample,
  cell_group,
  abundance = NULL,
  cores = detectCores(),
  bimodal_mean_variability_association = FALSE,
  percent_false_positive = 5,
  inference_method = "pathfinder",
  prior_mean = list(intercept = c(0, 1), coefficients = c(0, 1)),
  prior_overdispersion_mean_association = list(intercept = c(5, 2), slope = c(0, 0.6),
    standard_deviation = c(10, 20)),
  .sample_cell_group_pairs_to_exclude = NULL,
  output_directory = "sccomp_draws_files",
  verbose = TRUE,
  enable_loo = FALSE,
  noise_model = "multi_beta_binomial",
  exclude_priors = FALSE,
  use_data = TRUE,
  mcmc_seed = sample_seed(),
  max_sampling_iterations = 20000,
  pass_fit = TRUE,
  sig_figs = 9,
  cache_stan_model = sccomp_stan_models_cache_dir,
  ...,
  .count = NULL,
  approximate_posterior_inference = NULL,
  variational_inference = NULL,
  .sample = NULL,
  .cell_group = NULL,
  .abundance = NULL
)
}
\arguments{
\item{.data}{A tibble including cell_group name column, sample name column,
abundance column (counts or proportions), and factor columns.}

\item{formula_composition}{A formula describing the model for differential abundance.}

\item{formula_variability}{A formula describing the model for differential variability.}

\item{sample}{A column name as a character string for the sample identifier. Replaces the deprecated \code{.sample}.}

\item{cell_group}{A column name as a character string for the cell-group identifier. Replaces the deprecated \code{.cell_group}.}

\item{abundance}{A column name as a character string for the cell-group abundance, which can be counts (> 0) or proportions (between 0 and 1, summing to 1 across \code{cell_group}). Replaces the deprecated \code{.abundance} and \code{.count}.}

\item{cores}{Number of cores to use for parallel calculations.}

\item{bimodal_mean_variability_association}{Logical, whether to model mean-variability as bimodal.}

\item{percent_false_positive}{A real number between 0 and 100 for outlier identification.}

\item{inference_method}{Character string specifying the inference method to use ('pathfinder', 'hmc', or 'variational'). Replaces the deprecated \code{approximate_posterior_inference} and \code{variational_inference}.}

\item{prior_mean}{A list specifying prior knowledge about the mean distribution, including intercept and coefficients.}

\item{prior_overdispersion_mean_association}{A list specifying prior knowledge about mean/variability association.}

\item{.sample_cell_group_pairs_to_exclude}{A column name indicating sample/cell-group pairs to exclude.}

\item{output_directory}{A character string specifying the output directory for Stan draws.}

\item{verbose}{Logical, whether to print progression details.}

\item{enable_loo}{Logical, whether to enable model comparison using the LOO package.}

\item{noise_model}{A character string specifying the noise model (e.g., 'multi_beta_binomial').}

\item{exclude_priors}{Logical, whether to run a prior-free model.}

\item{use_data}{Logical, whether to run the model data-free.}

\item{mcmc_seed}{An integer seed for MCMC reproducibility.}

\item{max_sampling_iterations}{Integer to limit the maximum number of iterations for large datasets.}

\item{pass_fit}{Logical, whether to include the Stan fit as an attribute in the output.}

\item{sig_figs}{Number of significant figures to use for Stan model output. Default is 9.}

\item{cache_stan_model}{A character string specifying the cache directory for compiled Stan models.
The sccomp version will be automatically appended to ensure version isolation.
Default is \code{sccomp_stan_models_cache_dir} which points to \verb{~/.sccomp_models}.}

\item{...}{Additional arguments passed to the \code{cmdstanr::sample} function.}

\item{.count}{\strong{DEPRECATED}. Use \code{abundance} instead.}

\item{approximate_posterior_inference}{\strong{DEPRECATED}. Use \code{inference_method} instead.}

\item{variational_inference}{\strong{DEPRECATED}. Use \code{inference_method} instead.}

\item{.sample}{\strong{DEPRECATED}. Use \code{sample} instead.}

\item{.cell_group}{\strong{DEPRECATED}. Use \code{cell_group} instead.}

\item{.abundance}{\strong{DEPRECATED}. Use \code{abundance} instead.}
}
\value{
A tibble (\code{tbl}), with the following columns:
\itemize{
\item cell_group - The cell groups being tested.
\item parameter - The parameter being estimated from the design matrix described by the input formula_composition and formula_variability.
\item factor - The covariate factor in the formula, if applicable (e.g., not present for Intercept or contrasts).
\item c_lower - Lower (2.5\%) quantile of the posterior distribution for a composition (c) parameter.
\item c_effect - Mean of the posterior distribution for a composition (c) parameter.
\item c_upper - Upper (97.5\%) quantile of the posterior distribution for a composition (c) parameter.
\item c_pH0 - Probability of the c_effect being smaller or bigger than the \code{test_composition_above_logit_fold_change} argument.
\item c_FDR - False discovery rate of the c_effect being smaller or bigger than the \code{test_composition_above_logit_fold_change} argument. False discovery rate for Bayesian models is calculated differently from frequentists models, as detailed in Mangiola et al, PNAS 2023.
\item c_n_eff - Effective sample size, the number of independent draws in the sample. The higher, the better.
\item c_R_k_hat - R statistic, a measure of chain equilibrium, should be within 0.05 of 1.0.
\item v_lower - Lower (2.5\%) quantile of the posterior distribution for a variability (v) parameter.
\item v_effect - Mean of the posterior distribution for a variability (v) parameter.
\item v_upper - Upper (97.5\%) quantile of the posterior distribution for a variability (v) parameter.
\item v_pH0 - Probability of the v_effect being smaller or bigger than the \code{test_composition_above_logit_fold_change} argument.
\item v_FDR - False discovery rate of the v_effect being smaller or bigger than the \code{test_composition_above_logit_fold_change} argument. False discovery rate for Bayesian models is calculated differently from frequentists models, as detailed in Mangiola et al, PNAS 2023.
\item v_n_eff - Effective sample size for a variability (v) parameter.
\item v_R_k_hat - R statistic for a variability (v) parameter, a measure of chain equilibrium.
}

The function also attaches several attributes to the result:
\itemize{
\item count_data - The original count data used in the analysis, stored as an attribute for efficient access.
\item model_input - The model input data used for fitting.
\item formula_composition - The formula used for composition modeling.
\item formula_variability - The formula used for variability modeling.
\item fit - The Stan fit object (if pass_fit = TRUE).
}
}
\description{
The \code{sccomp_estimate} function performs linear modeling on a table of cell counts or proportions,
which includes a cell-group identifier, sample identifier, abundance (counts or proportions), and factors
(continuous or discrete). The user can define a linear model using an R formula,
where the first factor is the factor of interest. Alternatively, \code{sccomp} accepts
single-cell data containers (e.g., Seurat, SingleCellExperiment, cell metadata, or
group-size) and derives the count data from cell metadata.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
  if (instantiate::stan_cmdstan_exists()) {
    data("counts_obj")

    estimate <- sccomp_estimate(
      counts_obj,
      ~ type,
      ~1,
      "sample",
      "cell_group",
      "count",
      cores = 1
    )
    
   # Note! 
   # If counts are available, do not use proportion.
   # Using proportion ignores the high uncertainty of low counts
   
   estimate_proportion <- sccomp_estimate(
      counts_obj,
      ~ type,
      ~1,
      "sample",
      "cell_group",
      "proportion",
      cores = 1
    )
    
  }
}

}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{sccomp_theme}
\alias{sccomp_theme}
\title{Create a multipanel theme compatible with ggplot2 4.0.0 S7 system}
\usage{
sccomp_theme()
}
\value{
A \code{ggplot2} theme object compatible with ggplot2 4.0.0
}
\description{
Creates a multipanel theme that is compatible with the new ggplot2 4.0.0 S7 system.
This function creates a fresh theme object using the new S7 system instead of relying
on the saved S3 theme object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sccomp_remove_unwanted_variation.R
\name{sccomp_remove_unwanted_variation}
\alias{sccomp_remove_unwanted_variation}
\title{DEPRECATED: Remove Unwanted Variation from sccomp Estimates}
\usage{
sccomp_remove_unwanted_variation(
  .data,
  formula_composition_keep = NULL,
  formula_composition = NULL,
  formula_variability = NULL,
  cores = detectCores()
)
}
\arguments{
\item{.data}{A tibble. The result of \code{sccomp_estimate}.}

\item{formula_composition_keep}{A formula. The formula describing the model for differential abundance, for example \code{~type}. In this case, only the effect of the \code{type} factor will be preserved, while all other factors will be factored out.}

\item{formula_composition}{DEPRECATED. Use \code{formula_composition_keep} instead.}

\item{formula_variability}{DEPRECATED. Use \code{formula_variability_keep} instead.}

\item{cores}{Integer, the number of cores to be used for parallel calculations.}
}
\value{
A tibble (\code{tbl}) with the following columns:
\itemize{
\item \strong{sample} - A character column representing the sample name for which data was adjusted.
\item \strong{cell_group} - A character column representing the cell group being tested.
\item \strong{adjusted_proportion} - A numeric column representing the adjusted proportion after removing unwanted variation.
\item \strong{adjusted_counts} - A numeric column representing the adjusted counts after removing unwanted variation.
\item \strong{logit_residuals} - A numeric column representing the logit residuals calculated after adjustment.
}
}
\description{
This function is DEPRECATED. Please use \code{\link{sccomp_remove_unwanted_effects}} instead.
This function uses the model to remove unwanted variation from a dataset using the estimates of the model.
For example, if you fit your data with the formula \code{~ factor_1 + factor_2} and use the formula \code{~ factor_1}
to remove unwanted variation, the \code{factor_2} effect will be factored out.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
  if (instantiate::stan_cmdstan_exists()) {
    data("counts_obj")

    estimates = sccomp_estimate(
      counts_obj,
      ~ type, ~1, "sample", "cell_group", "count",
      cores = 1
    ) |>
    sccomp_remove_unwanted_variation()
  }
}

}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{handle_missing_values}
\alias{handle_missing_values}
\title{Handle missing values in a data frame}
\usage{
handle_missing_values(data)
}
\arguments{
\item{data}{A data frame to process}
}
\value{
A data frame with missing values handled:
\itemize{
\item For categorical variables (factor/character): NA values are converted to a factor level "NA"
\item For numeric variables: NA values are replaced with the mean of the column
}
}
\description{
Handle missing values in a data frame
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sccomp_proportional_fold_change.R
\name{sccomp_proportional_fold_change}
\alias{sccomp_proportional_fold_change}
\title{Calculate Proportional Fold Change from sccomp Estimated Effects}
\usage{
sccomp_proportional_fold_change(.data, formula_composition, from, to)
}
\arguments{
\item{.data}{A sccomp estimate object (of class 'sccomp_tbl') obtained from running sccomp_estimate().
This object contains the fitted model and estimated effects.}

\item{formula_composition}{The formula specifying which model effects to use for calculating fold changes.
This should match or be a subset of the formula used in the original sccomp_estimate() call.}

\item{from}{Character string specifying the reference/control condition (e.g., "benign").}

\item{to}{Character string specifying the comparison condition (e.g., "cancer").}
}
\value{
A tibble with the following columns:
\itemize{
\item cell_group - The cell group identifier
\item proportion_fold_change - The estimated fold change in proportions between conditions.
Positive values indicate increases, negative values indicate decreases.
\item average_uncertainty - The average uncertainty in the fold change estimate, derived from the credible intervals
\item statement - A text description of the fold change, including the direction and the estimated proportions
}
}
\description{
This function calculates the proportional fold change between two conditions using the estimated effects from a sccomp model.
The fold changes are derived from the model's posterior predictions rather than raw counts, providing a more robust estimate
that accounts for the model's uncertainty and covariate effects.

Note! This statistic is descriptive and should not be used to define significance - use sccomp_test() for that.
While fold changes in proportions are easier to interpret than changes in logit space, they are not linear
(the same proportional change has different meaning for rare vs abundant cell types). In contrast,
the logit scale used internally by sccomp provides linear effects that are more appropriate for statistical inference.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))


\donttest{
if (instantiate::stan_cmdstan_exists()) {
  # Load example data
  data("counts_obj")

  # First estimate the composition effects
  estimate <- sccomp_estimate(
      counts_obj,
      ~ type,
      ~1,
      "sample",
      "cell_group",
      "count",
      cores = 1
  )
 
  # Calculate proportional fold changes from the estimated effects
  estimate |> 
  sccomp_proportional_fold_change(
    formula_composition = ~  type, 
    from = "benign", 
    to = "cancer"
  ) 
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\docType{data}
\name{sccomp_stan_models_cache_dir}
\alias{sccomp_stan_models_cache_dir}
\title{Default cache directory for Stan models}
\format{
An object of class \code{character} of length 1.
}
\usage{
sccomp_stan_models_cache_dir
}
\value{
A character string containing the path to the default cache directory.
}
\description{
A global variable that defines the default cache directory for Stan models used by the sccomp package.
This directory is used to store compiled Stan models to avoid recompilation on subsequent runs.
}
\details{
The cache directory is set to \code{~/.sccomp_models} by default. This location is used by
various sccomp functions to store and retrieve compiled Stan models, improving performance
by avoiding unnecessary recompilation of models that have already been compiled.

Users can override this default by specifying a different cache directory in function calls
that accept a \code{cache_stan_model} parameter.
}
\examples{
# View the default cache directory
sccomp_stan_models_cache_dir

# Use a custom cache directory in a function call
# sccomp_estimate(data, cache_stan_model = "/path/to/custom/cache")

}
\seealso{
\code{\link{sccomp_estimate}}, \code{\link{sccomp_replicate}}, \code{\link{clear_stan_model_cache}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plot_scatterplot}
\alias{plot_scatterplot}
\title{Plot Scatterplot of Cell-group Proportion}
\usage{
plot_scatterplot(
  .data,
  data_proportion,
  factor_of_interest,
  .cell_group,
  .sample,
  significance_threshold = 0.05,
  my_theme
)
}
\arguments{
\item{.data}{Data frame containing the main data.}

\item{data_proportion}{Data frame containing proportions of cell groups.}

\item{factor_of_interest}{A factor indicating the biological condition of interest.}

\item{.cell_group}{The cell group to be analysed.}

\item{.sample}{The sample identifier.}

\item{significance_threshold}{Numeric value specifying the significance threshold for highlighting differences. Default is 0.025.}

\item{my_theme}{A ggplot2 theme object to be applied to the plot.}
}
\value{
A ggplot object representing the scatterplot.
}
\description{
This function creates a scatterplot of cell-group proportions, optionally highlighting significant differences based on a given significance threshold.
}
\examples{
# Example usage:
# plot_scatterplot(.data, data_proportion, "condition", "cell_group", "sample", 0.025, theme_minimal())
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sccomp_boxplot.R
\name{sccomp_boxplot}
\alias{sccomp_boxplot}
\title{sccomp_boxplot}
\usage{
sccomp_boxplot(
  .data,
  factor,
  significance_threshold = 0.05,
  test_composition_above_logit_fold_change = attr(.data,
    "test_composition_above_logit_fold_change"),
  remove_unwanted_effects = FALSE
)
}
\arguments{
\item{.data}{A tibble containing the results from \code{sccomp_estimate} and \code{sccomp_test}, including the columns: cell_group name, sample name, read counts, factor(s), p-values, and significance indicators.}

\item{factor}{A character string specifying the factor of interest included in the model for stratifying the boxplot.}

\item{significance_threshold}{A numeric value indicating the False Discovery Rate (FDR) threshold for labeling significant cell-groups. Defaults to 0.05.}

\item{test_composition_above_logit_fold_change}{A positive numeric value representing the effect size threshold used in the hypothesis test. A value of 0.2 corresponds to a change in cell proportion of approximately 10\% for a cell type with a baseline proportion of 50\% (e.g., from 45\% to 55\%). This threshold is consistent on the logit-unconstrained scale, even when the baseline proportion is close to 0 or 1.}

\item{remove_unwanted_effects}{A logical value indicating whether to remove unwanted variation from the data before plotting. Defaults to \code{FALSE}.}
}
\value{
A \code{ggplot} object representing the boxplot of cell proportions across samples, stratified by the specified factor.
}
\description{
Creates a boxplot visualization of the model results from \code{sccomp}. This function plots the estimated cell proportions across samples, highlighting significant changes in cell composition according to a specified factor.
}
\examples{

print("cmdstanr is needed to run this example.")
# Note: Before running the example, ensure that the 'cmdstanr' package is installed:
# install.packages("cmdstanr", repos = c("https://stan-dev.r-universe.dev/", getOption("repos")))

\donttest{
if (instantiate::stan_cmdstan_exists()) {
    data("counts_obj")

    estimate <- sccomp_estimate(
      counts_obj,
      formula_composition = ~ type,
      formula_variability = ~ 1,
      sample = "sample",
      cell_group = "cell_group",
      abundance = "count",
      cores = 1
    ) |>
    sccomp_test()

    # Plot the boxplot of estimated cell proportions
    sccomp_boxplot(
        .data = estimate,
        factor = "type",
        significance_threshold = 0.05
    )
}
}
}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clear_stan_model_cache.R
\name{clear_stan_model_cache}
\alias{clear_stan_model_cache}
\title{Clear Stan Model Cache}
\usage{
clear_stan_model_cache(cache_dir = sccomp_stan_models_cache_dir)
}
\arguments{
\item{cache_dir}{A character string representing the path of the cache directory to delete.
Defaults to \code{sccomp_stan_models_cache_dir}, which is the default cache location used by sccomp.}
}
\value{
NULL invisibly. The function is called for its side effect of removing the cache directory.
}
\description{
This function removes the Stan model cache directory and all its contents. The cache is used by cmdstanr to store compiled Stan models.
Clearing the cache can be useful when:
\itemize{
\item You're experiencing issues with cached models
\item You want to force recompilation of models
\item You're switching between different versions of Stan
}
}
\details{
The function uses \code{unlink()} with \code{recursive = TRUE} to remove the directory and all its contents.
If the cache directory doesn't exist, the function will simply print a message and continue.
This is a safe operation as cmdstanr will recreate the cache directory when needed.
}
\examples{
# Clear the default sccomp cache directory
clear_stan_model_cache()

# Clear a specific cache directory
clear_stan_model_cache("path/to/custom/cache")

# Example of when you might want to clear the cache
\dontrun{
# If you're experiencing issues with model compilation
clear_stan_model_cache()
# Then try running your model again
}

}
\references{
S. Mangiola, A.J. Roth-Schulze, M. Trussart, E. Zozaya-Valdés, M. Ma, Z. Gao, A.F. Rubin, T.P. Speed, H. Shim, & A.T. Papenfuss, sccomp: Robust differential composition and variability analysis for single-cell data, Proc. Natl. Acad. Sci. U.S.A. 120 (33) e2203828120, https://doi.org/10.1073/pnas.2203828120 (2023).
}
\seealso{
\itemize{
\item \code{\link[cmdstanr]{cmdstan_path}} for information about cmdstanr's cache management
\item \code{\link[base]{unlink}} for details about the underlying file removal function
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{counts_obj}
\alias{counts_obj}
\title{counts_obj}
\format{
A tidy data frame with the following columns:
\itemize{
\item \strong{sample}: Factor, representing the sample identifier.
\item \strong{type}: Factor, indicating the sample type (e.g., benign, cancerous).
\item \strong{phenotype}: Factor, representing the cell phenotype (e.g., B_cell, HSC, etc.).
\item \strong{count}: Integer, representing the number of cells for each cell group within each sample.
\item \strong{cell_group}: Factor, representing the cell group (e.g., BM, B1, Dm, etc.).
}
}
\usage{
data(counts_obj)
}
\value{
A \code{tibble} representing cell counts per cluster, with columns for sample, type, phenotype, cell group, and counts.
}
\description{
A tidy example dataset containing cell counts per cell group (cluster), sample, and phenotype for differential analysis. This dataset represents the counts of cells in various phenotypes and cell groups across multiple samples.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{no_significance_df}
\alias{no_significance_df}
\title{no_significance_df}
\format{
A tibble with the following columns:
\itemize{
\item \strong{sample}: Character. Identifier for each sample.
\item \strong{condition}: Character. Experimental condition or group (e.g., "X" or "Y").
\item \strong{cell_group}: Character. Cell group or cell type (e.g., "A", "B").
\item \strong{count}: Numeric. Count of cells in the given sample, condition, and cell group.
}
}
\usage{
data(no_significance_df)
}
\value{
A tibble with 34 rows and 4 columns: \code{sample}, \code{condition}, \code{cell_group}, and \code{count}.
}
\description{
A small example dataset containing cell counts across samples, conditions, and cell groups. This dataset is used to demonstrate the use of \code{sccomp} functions in scenarios where there is no significant difference in cell composition between conditions.
}
\examples{
data(no_significance_df)
head(no_significance_df)

}
\keyword{datasets}
